//*****************************************************************************
//*
//*
//*		rar_options.cpp
//*
//*
//*****************************************************************************
#include	"rar_main.h"

//*****************************************************************************
//*
//*		RarOptions
//*
//*****************************************************************************
RarOptions::RarOptions()
{
	Init();
}


//*****************************************************************************
//*
//*		RarOptions
//*
//*****************************************************************************
RarOptions::~RarOptions()
{
	// It is important for security reasons, so we do not have the unnecessary
	// password data left in memory.
	memset(this,0,sizeof(RarOptions));
}


//*****************************************************************************
//*
//*		Init
//*
//*****************************************************************************
void RarOptions::Init()
{
	memset(this,0,sizeof(RarOptions));
	WinSize 		= 0x02000000;
	Overwrite		= OVERWRITE_DEFAULT;
	Method			= 3;
	MsgStream		= MSG_STDOUT;
	ConvertNames	= NAMES_ORIGINALCASE;
	xmtime			= EXTTIME_HIGH3;
	FileSizeLess	= INT64NDF;
	FileSizeMore	= INT64NDF;
	HashType		= HASH_CRC32;
	#ifdef		RAR_SMP 				
	Threads=GetNumberOfThreads();
	#endif
	#ifdef		USE_QOPEN				
	QOpenMode=QOPEN_AUTO;
	#endif
}
