//*****************************************************************************
//*
//*
//*		AfxUtility.h
//*
//*
//*****************************************************************************
#ifndef 	__AFXUTILITY_H__
#define     __AFXUTILITY_H__
    
#if _MSC_VER >= 1000 		 
#pragma once		    
#endif	 

#include	<Afx.h>
#include	<AfxExt.h>
#include	"oledb.h"
#include	"../ProcPrintf.h"
#include	"../WinExtension.h"

#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501				 
#endif
#endif
				    
#ifndef	   _WIN64
#ifndef		SetWindowLongPtr
#define		SetWindowLongPtr		SetWindowLong
#endif
#ifndef		GetWindowLongPtr
#define		GetWindowLongPtr		GetWindowLong
#endif
#ifndef 	DWORD_PTR
#define 	DWORD_PTR				DWORD
#endif
#ifndef		ULONG_PTR
#define		ULONG_PTR				ULONG
#endif
#ifndef		LONG_PTR
#define		LONG_PTR				LONG
#endif
#ifndef 	UINT_PTR
#define 	UINT_PTR				UINT
#endif
#ifndef 	INT_PTR
#define 	INT_PTR					INT
#endif
#else
#ifdef		GWL_WNDPROC
#undef		GWL_WNDPROC
#endif
#define		GWL_WNDPROC				GWLP_WNDPROC
#ifdef		GWL_HINSTANCE
#undef		GWL_HINSTANCE
#endif
#define		GWL_HINSTANCE			GWLP_HINSTANCE
#ifdef		GWL_HWDPARENT
#undef		GWL_HWDPARENT
#endif
#define		GWL_HWDPARENT			GWLP_HWDPARENT
#ifdef		GWL_USERDATA
#undef		GWL_USERDATA
#endif
#define		GWL_USERDATA			GWLP_USERDATA
#ifdef		DWL_DLGPROC
#undef		DWL_DLGPROC
#endif
#define		DWL_DLGPROC				DWLP_DLGPROC
#endif
#ifndef		DC_BRUSH
#define 	DC_BRUSH				18
#endif
#ifndef		DC_PEN
#define		DC_PEN					19
#endif
#ifndef		BP_BUTTON
#define 	BP_BUTTON    			1
#endif
#ifndef 	BP_RADIO
#define 	BP_RADIO     			2
#endif
#ifndef 	BP_CHECKBOX
#define 	BP_CHECKBOX  			3
#endif
#ifndef 	PBS_NORMAL
#define 	PBS_NORMAL      		1
#endif
#ifndef 	PBS_HOT
#define 	PBS_HOT         		2
#endif
#ifndef 	PBS_PRESSED
#define 	PBS_PRESSED     		3
#endif
#ifndef 	PBS_DISABLED
#define 	PBS_DISABLED    		4
#endif
#ifndef 	PBS_DEFAULTED
#define 	PBS_DEFAULTED   		5
#endif

#ifndef		GET_X_LPARAM
#define		GET_X_LPARAM(lp)		((int)(short)LOWORD(lp))
#endif
#ifndef		GET_Y_LPARAM
#define		GET_Y_LPARAM(lp)		((int)(short)HIWORD(lp))
#endif

#define 	OFN_COMBOAUTO			0x00000000			// Die ComboBox automtisch erstellen (nur Pfade)
#define 	OFN_COMBOAUTOALL		0x10000000			// Die ComboBox automtisch erstellen (Pfade+Dateien)
#define 	OFN_COMBOAUTOFILES		0x20000000			// Die ComboBox automtisch erstellen (nur Dateien)
#define 	OFN_COMBOLIST			0x30000000			// Eine Liste mit Dateien in lpstrCustomFilter bergeben
#define 	OFN_COMBOREG			0x40000000			// Die ComboBox via Registry erstellen (nur Pfade)
#define 	OFN_COMBOREGALL			0x50000000			// Die ComboBox via Registry erstellen (Pfade+Dateien)
#define 	OFN_COMBOREGFILES		0x60000000			// Die ComboBox via Registry erstellen (nur Dateien)
#define 	OFN_COMBONONE			0x70000000			// Keine ComboBox erstellen
#define 	OFN_RENAMERO			0x80000000			// Das Read-Only Flag umbennenen

#define 	DEFAULT_POINT			CPoint(12345,12345)
#define 	DEFAULT_OFFSET			12345

#define 	GSB_CACHE				0x01000000			// Quelle cachen
#define 	GSB_AUTODELETE			0x02000000			// Das Ergebnis cachen
#define 	GSB_TRANSPARENT			0x04000000			// Transparent zeichnen
#define 	GSB_TRANSFIRST			0x08000000			// Transparent zeichnen mit Pixel links/oben
#define 	GSB_BITMAP				0x00000000			// Ist ein HBITMAP-Handle
#define 	GSB_RECOURCE			0x40000000			// Ist ein Resourcen-Name
#define 	GSB_TOOLBAR				0x80000000			// Ist ein Toolbar-Item
#define 	GSB_HDC					0xC0000000			// Ist ein Device-Context
#define 	GSB_TYPEMASK			0xC0000000			// Maske fr die Typen
#define 	GSB_SIZEFROMSRC			0x0000FFFF			// Hhe von der Quelle benutzen
#define 	GSB_COLOR(r,g,b)		RGB(r,g,b)			// Farbe fr Transparenz

extern "C"  DECLSPEC_IMPORT	COLORREF WINAPI SetDCPenColor  (HDC,COLORREF);
extern "C"  DECLSPEC_IMPORT	COLORREF WINAPI SetDCBrushColor(HDC,COLORREF);

class		CRegKeys;


void AFXAPI DDX_Float  (CDataExchange *pDX,int nIDC,float       &dValue   ,int     iComma,double dFact);
void AFXAPI DDX_Float  (CDataExchange *pDX,int nIDC,float       &dValue   ,int     iComma=3);
void AFXAPI DDX_Float  (CDataExchange *pDX,int nIDC,double      &dValue   ,int     iComma,double dFact);
void AFXAPI DDX_Float  (CDataExchange *pDX,int nIDC,double      &dValue   ,int     iComma=3);
void AFXAPI DDX_MinMax (CDataExchange *pDX,int nIDC,int         &iMin     ,int    &iMax,int &iMode,             int iFlags=0x3F);
void AFXAPI DDX_MinMax (CDataExchange *pDX,int nIDC,double      &iMin     ,double &dMax,int &iMode,int iComas=3,int iFlags=0x3F);
void AFXAPI DDX_Date   (CDataExchange *pDX,int nIDC,DBDATE		&sDate    ,int iMode=0);
void AFXAPI DDX_Date   (CDataExchange *pDX,int nIDC,DBTIMESTAMP	&sDateTime,int iMode=0);
void AFXAPI DDX_Date   (CDataExchange *pDX,int nIDC,CTime		&sDateTime,int iMode=0);
void AFXAPI DDX_Time   (CDataExchange *pDX,int nIDC,DBTIME		&sTime    ,int iMode=0);
void AFXAPI DDX_Time   (CDataExchange *pDX,int nIDC,DBTIMESTAMP	&sDateTime,int iMode=0);
void AFXAPI DDX_Time   (CDataExchange *pDX,int nIDC,CTime		&sDateTime,int iMode=0);
void AFXAPI DDX_TStamp (CDataExchange *pDX,int nIDC,DBTIMESTAMP	&sDateTime,int iMode=0);
void AFXAPI DDX_TStamp (CDataExchange *pDX,int nIDC,CTime		&sDateTime,int iMode=0);
void AFXAPI DDX_Text_  (CDataExchange *pDX,int nIDC,int         &iValue);
void AFXAPI DDX_Text_  (CDataExchange *pDX,int nIDC,unsigned    &uValue);
void AFXAPI DDX_Text   (CDataExchange *pDX,int nIDC,TCHAR       *pText,int iMax);
void AFXAPI DDX_ComboEx(CDataExchange *pDX,int nIDC,CString     &sText);

	    int   AFXAPI  CheckReframe (CRect   &sFrame,CPoint sOffset,int iFrame=4,int iMask=0,HCURSOR *pCursorId=0);
		BOOL  AFXAPI  ScrollCursor (CWnd    *pWnd,CPoint sPos  ,int    iMode=3);
		int	  AFXAPI  Resize       (CWnd    *pWnd,int    iMode ,CRect &sMax,int iStart,CPoint sOffset=DEFAULT_POINT,int iWidth=4,int iGridWidth=0,int iGridOff=DEFAULT_OFFSET);
		POINT AFXAPI  Remove       (CWnd    *pWnd,              CRect &sRect,          CPoint sOffset);
		BOOL  AFXAPI  Reframe	   (CWnd    *pWnd,CRect &sFrame,CPoint sOffset,CSize sMin=CSize(0,0));

      #define         GetRectView(pRect)    {GetClientRect(pRect);ClientToScreen(pRect);}
		POINT AFXAPI  GetWindowPt  (CWnd    *pWnd		   		                );
		BOOL  AFXAPI  GetPosRect   (HWND     hWnd				 ,LPRECT pRect  );
inline	BOOL  AFXAPI  GetPosRect   (CWnd    *pWnd                ,LPRECT pRect  ){ASSERT(pWnd);return GetPosRect(pWnd->m_hWnd,pRect);}
		BOOL  AFXAPI  GetDlgPosRect(CDialog *pDlg,int     iId    ,LPRECT pRect  );
		BOOL  AFXAPI  MoveWindow   (CDialog *pDlg,int     iIdMove,int    iIdFrom);
		BOOL  AFXAPI  MoveWindow   (HWND     hWnd,int     iSizeX ,int    iSizeY,BOOL bDelta=0);
inline	BOOL  AFXAPI  MoveWindow   (HWND     hWnd,LPPOINT pPoint ,              BOOL bDelta=0){             return MoveWindow(        hWnd,pPoint->x,pPoint->y,bDelta);}
inline	BOOL  AFXAPI  MoveWindow   (CWnd    *pWnd,int     iSizeX ,int    iSizeY,BOOL bDelta=0){ASSERT(pWnd);return MoveWindow(pWnd->m_hWnd,iSizeX   ,iSizeY   ,bDelta);}
inline	BOOL  AFXAPI  MoveWindow   (CWnd    *pWnd,LPPOINT pPoint ,              BOOL bDelta=0){ASSERT(pWnd);return MoveWindow(pWnd->m_hWnd,pPoint->x,pPoint->y,bDelta);}
		BOOL  AFXAPI  SizeWindow   (HWND     hWnd,int     iSizeX ,int    iSizeY,BOOL bDelta=0);
inline	BOOL  AFXAPI  SizeWindow   (HWND     hWnd,LPSIZE  pSize  ,              BOOL bDelta=0){             return SizeWindow(        hWnd,pSize->cx,pSize->cy,bDelta);}
inline	BOOL  AFXAPI  SizeWindow   (CWnd    *pWnd,int     iSizeX ,int    iSizeY,BOOL bDelta=0){ASSERT(pWnd);return SizeWindow(pWnd->m_hWnd,iSizeX   ,iSizeY   ,bDelta);}
inline	BOOL  AFXAPI  SizeWindow   (CWnd    *pWnd,LPSIZE  pSize  ,              BOOL bDelta=0){ASSERT(pWnd);return SizeWindow(pWnd->m_hWnd,pSize->cx,pSize->cy,bDelta);}

		CWnd *AFXAPI  FindWindowPtr(LPPOINT	pPoint,CWnd *pBaseWnd=0,BOOL bVisible=1);
		HWND  AFXAPI  FindWindowPtr(LPPOINT	pPoint,HWND  hBaseWnd  ,BOOL bVisible=1);

		void  AFXAPI  GetCharWidths(HDC     hDc  ,BYTE *pSize   );
		void  AFXAPI  GetCharWidths(BYTE   *pSize,HFONT hFont   );
		void  AFXAPI  GetCharWidths(BYTE   *pSize,int   iFont=-1);
		int   AFXAPI  GetTextWidth (LPCTSTR pText,const BYTE *pSize,int iMax=1024);
		int   AFXAPI  GetTextWidth (LPCTSTR pText,HWND  hWnd ,int iMax=-1,int *pHeight=0);
		int   AFXAPI  GetTextWidth (LPCTSTR pText,HFONT hFont,int iMax=-1,int *pHeight=0);
inline	int   AFXAPI  GetTextWidth (LPCTSTR pText,int   iFont,int iMax=-1,int *pHeight=0){return GetTextWidth(pText,(HFONT)GetStockObject(iFont),iMax,pHeight);}
inline	int   AFXAPI  GetTextWidth (LPCTSTR pText,CWnd *pWnd ,int iMax=-1,int *pHeight=0){ASSERT(pWnd); return GetTextWidth(pText,pWnd->m_hWnd,iMax,pHeight);}
inline	int   AFXAPI  GetTextWidth (LPCTSTR pText,CDialog *pDlg,int iId,int iMax=-1,int *pHeight=0){CWnd *pWnd;ASSERT(pDlg); pWnd=pDlg->GetDlgItem(iId); ASSERT(pWnd); return GetTextWidth(pText,pWnd->m_hWnd,iMax,pHeight);}
		int	  AFXAPI  CommpressFileName(LPCTSTR pFilename,TCHAR *pTarget,int iLen,int iMax,unsigned char *pSize=NULL,int iBase=2);
		int	  AFXAPI  CommpressFileName(LPCTSTR pFilename,TCHAR *pTarget,int iLen,int iMax,unsigned char *pSize     ,int iBase,LPCTSTR pPreText,LPCTSTR pPostText=0,int iPostLen=1024,int iPreLen=1024);

		int   AFXAPI  DrawSeparator(         HDC  hDc,int iPos,int iSize=10000,BOOL bHorz=FALSE);
inline	int   AFXAPI  DrawSeparator(         CDC *pDc,int iPos,int iSize=10000,BOOL bHorz=FALSE){return DrawSeparator(     pDc->m_hDC,iPos,iSize,bHorz);}
		int   AFXAPI  DrawSeparator(int iOff,HDC  hDc,int iPos,int iSize=10000,BOOL bHorz=FALSE);
inline	int   AFXAPI  DrawSeparator(int iOff,CDC *pDc,int iPos,int iSize=10000,BOOL bHorz=FALSE){return DrawSeparator(iOff,pDc->m_hDC,iPos,iSize,bHorz);}
		void  AFXAPI  DrawShifterV (HDC  hDc,int iPos,int iSize,unsigned uMode);
inline	void  AFXAPI  DrawShifterV (CDC *pDc,int iPos,int iSize,unsigned uMode){DrawShifterV(pDc->m_hDC,iPos,iSize,uMode);}
		void  AFXAPI  DrawShifterH (HDC  hDc,int iPos,int iSize,unsigned uMode);
inline	void  AFXAPI  DrawShifterH (CDC *pDc,int iPos,int iSize,unsigned uMode){DrawShifterH(pDc->m_hDC,iPos,iSize,uMode);}
		int	  AFXAPI  CheckShifterV(         int iPos,int iSize,unsigned uMode,CPoint sPoint);
		int	  AFXAPI  CheckShifterH(         int iPos,int iSize,unsigned uMode,CPoint sPoint);

		BOOL  AFXAPI  DragText(const void    *pText,int iSize,int iMode);
inline  BOOL  AFXAPI  DragText(const char    *pText,int iSize=-1){return DragText(pText,iSize,0);}
inline  BOOL  AFXAPI  DragText(const wchar_t *pText,int iSize=-1){return DragText(pText,iSize,2);}
		BOOL  AFXAPI  DragFile(LPCTSTR pFileName);

		int	  AFXAPI  strtodate(LPCTSTR pText,DBDATE &sDate);
		int	  AFXAPI  datetostr(LPTSTR  pText,DBDATE &sDate,int iMode=0);
		int	  AFXAPI  strtotime(LPCTSTR pText,DBTIME &sTime,int iPos =0);
		int	  AFXAPI  timetostr(LPTSTR  pText,DBTIME &sTime,int iMode=0);

		BOOL  AFXAPI  ClearFile(LPCTSTR pFilename);
		int	  AFXAPI  AfxUtilityInit(LPCTSTR pModuleName=0);
		int	  AFXAPI  AfxUtilityExit();
		void  AFXAPI  ShowConsole();
		void  AFXAPI  ForceWindowToTop (HWND  hWnd);
inline	void  AFXAPI  ForceWindowToTop (CWnd *pWnd){ASSERT(pWnd); if(pWnd)ForceWindowToTop(pWnd->m_hWnd);};


//*****************************************************************************
//*
//*		MessageBox Funktionen
//*
//*****************************************************************************

		int   AFXAPI  MessageBoxSpecial(HWND  hWnd,LPCTSTR pText,LPCTSTR pCaption=NULL,UINT uType=0);
inline	int   AFXAPI  MessageBoxSpecial(CWnd *pWnd,LPCTSTR pText,LPCTSTR pCaption=NULL,UINT uType=0){return MessageBoxSpecial((pWnd)? pWnd->m_hWnd:NULL,pText,pCaption,uType);}

inline	int   AFXAPI  MessageError     (CWnd *pWnd,UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,NULL,uType|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (HWND  hWnd,UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,NULL,uType|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (           UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,NULL,uType|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (                      LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,NULL,MB_OK|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (CWnd *pWnd,UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,NULL,uType|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (HWND  hWnd,UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,NULL,uType|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (           UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,NULL,uType|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (                      LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,NULL,MB_OK|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (CWnd *pWnd,UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,NULL,uType|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (HWND  hWnd,UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,NULL,uType|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (           UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,NULL,uType|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (                      LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,NULL,MB_OK|MB_ICONERROR);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageError     (CWnd *pWnd,UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial(pWnd   ,pText,NULL,uType|MB_ICONERROR);}
inline	int   AFXAPI  MessageError     (HWND  hWnd,UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial(hWnd   ,pText,NULL,uType|MB_ICONERROR);}
inline	int   AFXAPI  MessageError     (           UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial((HWND)0,pText,NULL,uType|MB_ICONERROR);}
inline	int   AFXAPI  MessageError     (                      LPCTSTR pText                       ){return MessageBoxSpecial((HWND)0,pText,NULL,MB_OK|MB_ICONERROR);}

inline	int   AFXAPI  MessageWarning   (CWnd *pWnd,UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (HWND  hWnd,UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (           UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (                      LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),MB_OK|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (CWnd *pWnd,UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (HWND  hWnd,UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (           UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (                      LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),MB_OK|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (CWnd *pWnd,UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (HWND  hWnd,UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (           UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (                      LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),MB_OK|MB_ICONWARNING);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageWarning   (CWnd *pWnd,UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial(pWnd   ,pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);}
inline	int   AFXAPI  MessageWarning   (HWND  hWnd,UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial(hWnd   ,pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);}
inline	int   AFXAPI  MessageWarning   (           UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial((HWND)0,pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),uType|MB_ICONWARNING);}
inline	int   AFXAPI  MessageWarning   (                      LPCTSTR pText                       ){return MessageBoxSpecial((HWND)0,pText,LoadDefaultStrings(0,IDS_TEXT_WARNING),MB_OK|MB_ICONWARNING);}

inline	int   AFXAPI  MessageQuestion  (CWnd *pWnd,UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (HWND  hWnd,UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (           UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (                      LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),MB_OK|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (CWnd *pWnd,UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (HWND  hWnd,UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (           UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (                      LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),MB_OK|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (CWnd *pWnd,UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (HWND  hWnd,UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (           UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (                      LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),MB_OK|MB_ICONQUESTION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageQuestion  (CWnd *pWnd,UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial(pWnd   ,pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);}
inline	int   AFXAPI  MessageQuestion  (HWND  hWnd,UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial(hWnd   ,pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);}
inline	int   AFXAPI  MessageQuestion  (           UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial((HWND)0,pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),uType|MB_ICONQUESTION);}
inline	int   AFXAPI  MessageQuestion  (                      LPCTSTR pText                       ){return MessageBoxSpecial((HWND)0,pText,LoadDefaultStrings(0,IDS_TEXT_QUESTION),MB_OK|MB_ICONQUESTION);}

inline	int   AFXAPI  MessageInfo      (CWnd *pWnd,UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (HWND  hWnd,UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (           UINT uType,LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (                      LPCTSTR pFormat,const void *pVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),MB_OK|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (CWnd *pWnd,UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (HWND  hWnd,UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (           UINT uType,LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (                      LPCTSTR pFormat,    __int64 iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),MB_OK|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (CWnd *pWnd,UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(pWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (HWND  hWnd,UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial(hWnd   ,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (           UINT uType,LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (                      LPCTSTR pFormat,      int   iVal,...){HeapString sData={0};va_list pArgs;int iRet;va_start(pArgs,pFormat);xsmprintfv(&sData,pFormat,pArgs);va_end(pArgs);iRet=MessageBoxSpecial((HWND)0,sData.pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),MB_OK|MB_ICONINFORMATION);delete sData.pText;return iRet;}
inline	int   AFXAPI  MessageInfo      (CWnd *pWnd,UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial(pWnd   ,pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);}
inline	int   AFXAPI  MessageInfo      (HWND  hWnd,UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial(hWnd   ,pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);}
inline	int   AFXAPI  MessageInfo      (           UINT uType,LPCTSTR pText                       ){return MessageBoxSpecial((HWND)0,pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),uType|MB_ICONINFORMATION);}
inline	int   AFXAPI  MessageInfo      (                      LPCTSTR pText                       ){return MessageBoxSpecial((HWND)0,pText,LoadDefaultStrings(0,IDS_TEXT_INFORMATION),MB_OK|MB_ICONINFORMATION);}


//*****************************************************************************
//*
//*		Bitmap Funktionen
//*
//*****************************************************************************
	  	
	   BOOL    AFXAPI AddMenuBitmap(CMenu *pMenu,UINT uCommand,int iBitmapId,int iIndex,int iSizeX=13);
inline BOOL    AFXAPI AddMenuBitmap(CMenu &sMenu,UINT uCommand,int iBitmapId,int iIndex,int iSizeX=13){return AddMenuBitmap(&sMenu,uCommand,iBitmapId,iIndex,iSizeX);}
	   HBITMAP AFXAPI DibToBitmap (const void *pDib,unsigned uFlags=0,HWND hWnd=0);
       HBITMAP AFXAPI GetSubBitmap(HBITMAP hSource,int iPosX,int iPosY,int iSizeX,int iSizeY,unsigned uFlags=0,COLORREF uBkColor=0);
inline HBITMAP AFXAPI GetSubBitmap(LPCSTR  pSource,int iPosX,int iPosY,int iSizeX,int iSizeY,unsigned uFlags=0,COLORREF uBkColor=0){return GetSubBitmap((HBITMAP)pSource,iPosX,iPosY,iSizeX,iSizeY,uFlags|GSB_RECOURCE,uBkColor);}
inline HBITMAP AFXAPI GetSubBitmap(int	   iSource,int iPosX,int iPosY,int iSizeX,int iSizeY,unsigned uFlags=0,COLORREF uBkColor=0){return GetSubBitmap((HBITMAP)iSource,iPosX,iPosY,iSizeX,iSizeY,uFlags|GSB_RECOURCE,uBkColor);}
inline HBITMAP AFXAPI GetSubBitmap(int     iId,LPCSTR pSource                               ,unsigned uFlags=0,COLORREF uBkColor=0){return GetSubBitmap((HBITMAP)pSource,iId,0,1,1                ,uFlags|GSB_TOOLBAR ,uBkColor);}
inline HBITMAP AFXAPI GetSubBitmap(int     iId,int    iSource                               ,unsigned uFlags=0,COLORREF uBkColor=0){return GetSubBitmap((HBITMAP)iSource,iId,0,1,1                ,uFlags|GSB_TOOLBAR ,uBkColor);}

//*****************************************************************************
//*
//*		Button Funktionen
//*
//*****************************************************************************

		void  AFXAPI  DelButtonBitmap(HWND     hWnd);
inline	void  AFXAPI  DelButtonBitmap(CWnd    *pWnd,UINT uItem){ASSERT(pWnd);DelButtonBitmap(pWnd->m_hWnd);}
inline	void  AFXAPI  DelButtonBitmap(CDialog *pDlg,UINT uItem){ASSERT(pDlg);DelButtonBitmap(GetDlgItem(pDlg->m_hWnd,uItem));}


		BOOL  AFXAPI  SetButtonBitmap(HWND     hWnd           ,LPARAM  uId);
inline	BOOL  AFXAPI  SetButtonBitmap(HWND     hWnd           ,LPCVOID hBm){             return SetButtonBitmap(hWnd,(LPARAM)hBm);}
inline	BOOL  AFXAPI  SetButtonBitmap(CWnd    *pWnd           ,LPARAM  uId){ASSERT(pWnd);return SetButtonBitmap(pWnd->m_hWnd,uId);}
inline	BOOL  AFXAPI  SetButtonBitmap(CWnd    *pWnd           ,LPCVOID hBm){ASSERT(pWnd);return SetButtonBitmap(pWnd->m_hWnd,(LPARAM)hBm);}
inline	BOOL  AFXAPI  SetButtonBitmap(CDialog *pDlg,UINT uItem,LPARAM  uId){ASSERT(pDlg);return SetButtonBitmap(GetDlgItem(pDlg->m_hWnd,uItem),uId);}
inline	BOOL  AFXAPI  SetButtonBitmap(CDialog *pDlg,UINT uItem,LPCVOID hBm){ASSERT(pDlg);return SetButtonBitmap(GetDlgItem(pDlg->m_hWnd,uItem),(LPARAM)hBm);}

//*****************************************************************************
//*
//*		Icon Funktionen
//*
//*****************************************************************************

HIMAGELIST	  AFXAPI  GetIconList (int iLarge=0);
		int	  AFXAPI  GetIconNr   (LPCTSTR pFile,int iMode=0);
inline	int	  AFXAPI  GetSmallIcon(LPCTSTR pFile,int iMode=0){return GetIconNr(pFile,iMode|SHGFI_SMALLICON);}
inline	int	  AFXAPI  GetLargeIcon(LPCTSTR pFile,int iMode=0){return GetIconNr(pFile,iMode|SHGFI_LARGEICON);}


//*****************************************************************************
//*
//*		Clipboard Funktionen
//*
//*****************************************************************************

		int    AFXAPI  SetClipboardText(LPCTSTR  pText,int iSize=-1);
		TCHAR *AFXAPI  GetClipboardText(int     *pLen=NULL);
		int    AFXAPI  GetClipboardText(LPTSTR   pText ,int iSize);
inline	int    AFXAPI  GetClipboardText(LPTSTR  *pText){int iLen;*pText=GetClipboardText(&iLen);return iLen;}


//*****************************************************************************
//*
//*		Subclass Funktionen
//*
//*****************************************************************************

LRESULT __stdcall ColorComboProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
LRESULT __stdcall ColorEditProc (HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

LRESULT __stdcall SCProcEd1(HWND,UINT,WPARAM,LPARAM);
LRESULT __stdcall SCProcEd2(HWND,UINT,WPARAM,LPARAM);
LRESULT __stdcall SCProcEd3(HWND,UINT,WPARAM,LPARAM);
LRESULT __stdcall SCProcEd4(HWND,UINT,WPARAM,LPARAM);
LRESULT __stdcall SCProcEd5(HWND,UINT,WPARAM,LPARAM);
LRESULT __stdcall SCProcEd6(HWND,UINT,WPARAM,LPARAM);
LRESULT __stdcall SCProcCb1(HWND,UINT,WPARAM,LPARAM);
LRESULT __stdcall SCProcCb2(HWND,UINT,WPARAM,LPARAM);
LRESULT __stdcall SCProcCb3(HWND,UINT,WPARAM,LPARAM);
LRESULT __stdcall SCProcCb4(HWND,UINT,WPARAM,LPARAM);

#define SCE_COLOR		SCProcEd1					// Farbkorektur
#define SCE_TABENTER	SCProcEd2					// TAB+ENTER an Eltern Fenster
#define SCE_EDITCHANGE	SCProcEd3					// Textnderung ein/aus
#define SCE_DROPFILE	SCProcEd4					// Dateien fallenlassen
#define SCE_NOCHANGE	SCProcEd5					// Nur auswhlen im Fenster
#define SCE_REDIRECT	SCProcEd6					// Weiterleiten von Nachrichten
#define SCE_TEXTCOLOR	ColorEditProc				// Buchstabenfarben einstellbar

#define SCB_COLORMSG	SCProcCb1					// Hintergrundfarben via WM_CTLCOLOREDIT 
#define SCB_TABENTER	SCProcCb2					// TAB+ENTER an Eltern Fenster weiterleiten
#define SCB_EDITCOMBO	SCProcCb3					// ComboBox verhlt sich wie EDIT
#define SCB_DROPFILE	SCProcCb4					// Dateien fallenlassen
#define SCB_TEXTCOLOR	ColorComboProc				// Buchstabenfarben einstellbar 


// Konstanden fr SCE_TEXTCOLOR Edit-Fenster
#ifndef EM_SETCOLOR	
#define	EM_SETCOLOR		0x00E0						// Farben fr Buchstaben einstellen
#endif 	
#ifndef EM_SETCOLORMODE	
#define	EM_SETCOLORMODE	0x00E1						// Optione fr Farben einstellen (fr fr ExtTextColor())
#endif 	
#ifndef EM_SETCOLORITEM	
#define	EM_SETCOLORITEM	0x00E2						// Farbe in der Farbtabelle einstellen
#endif 	
#ifndef EM_SETIMAGELIST	
#define	EM_SETIMAGELIST	0x00E3						// Die Iconliste einstellen
#endif 	
#ifndef EM_SETIMAGE	
#define	EM_SETIMAGE		0x00E4						// Das Icon einstellen
#endif 	




		BOOL AFXAPI  	SubclassComboBox(HWND  hBox,WNDPROC pProc);
inline	BOOL AFXAPI  	SubclassComboBox(CWnd *pBox,WNDPROC pProc)
		{
		ASSERT(pBox!=NULL);
		return SubclassComboBox(pBox->m_hWnd,pProc);
		}
inline	BOOL AFXAPI     SubclassComboBox(CWnd *pDlg,int iId,WNDPROC pProc)
		{
		ASSERT(pDlg!=NULL);
		CWnd *pBox=pDlg->GetDlgItem(iId);
		ASSERT(pBox!=NULL);
		return SubclassComboBox(pBox->m_hWnd,pProc);
		}

		BOOL AFXAPI     SubclassEdit(HWND  hEdit,WNDPROC  pProc);
inline	BOOL AFXAPI     SubclassEdit(CWnd *pEdit,WNDPROC  pProc)
		{
		ASSERT(pEdit!= NULL);
		return  SubclassEdit(pEdit->m_hWnd,pProc);
		}
inline	BOOL AFXAPI     SubclassEdit(CWnd *pDlg,int iId,WNDPROC pProc)
		{
		ASSERT(pDlg != NULL);
		CWnd  *pEdit = pDlg->GetDlgItem(iId);
		ASSERT(pEdit!= NULL);
		return SubclassEdit(pEdit->m_hWnd,pProc);
		}

		BOOL AFXAPI     SubclassWnd(HWND  hEdit,WNDPROC  pProc);
inline	BOOL AFXAPI     SubclassWnd(CWnd *pEdit,WNDPROC  pProc)
		{
		ASSERT(pEdit!= NULL);
		return  SubclassWnd(pEdit->m_hWnd,pProc);
		}
inline	BOOL AFXAPI     SubclassWnd(CWnd *pDlg,int iId,WNDPROC pProc)
		{
		ASSERT(pDlg != NULL);
		CWnd  *pEdit = pDlg->GetDlgItem(iId);
		ASSERT(pEdit!= NULL);
		return SubclassWnd(pEdit->m_hWnd,pProc);
		}

//*****************************************************************************
//*
//*		ComboBox Funktionen
//*
//*****************************************************************************

		int  AFXAPI  ListAdd       (HWND       hWnd,        LPCTSTR pText,int iMax=16,BOOL iCase=1);
inline	int  AFXAPI  ListAdd       (CWnd      *pWnd,        LPCTSTR pText,int iMax=16,BOOL iCase=1){return ListAdd(pWnd->m_hWnd,pText,iMax,iCase);}
inline	int  AFXAPI  ListAdd       (CWnd      *pWnd,int iId,LPCTSTR pText,int iMax=16,BOOL iCase=1){return ListAdd(GetDlgItem(pWnd->m_hWnd,iId),pText,iMax,iCase);}

		int  AFXAPI  ListInsert    (HWND       hWnd,        LPCTSTR pText,TCHAR cDivide=0,BOOL bClear=1);
inline	int  AFXAPI  ListInsert    (CWnd      *pWnd,        LPCTSTR pText,TCHAR cDivide=0,BOOL bClear=1){return ListInsert(pWnd->m_hWnd,pText,cDivide,bClear);}
inline	int  AFXAPI  ListInsert    (CWnd      *pWnd,int iId,LPCTSTR pText,TCHAR cDivide=0,BOOL bClear=1){return ListInsert(GetDlgItem(pWnd->m_hWnd,iId),pText,cDivide,bClear);}

		int  AFXAPI  ComboBoxSave  (CDialog   *pDlg,int iId,LPCTSTR pEntry,LPCTSTR  pPath=NULL);
		int  AFXAPI  ComboBoxSave  (CDialog   *pDlg,int iId,LPCTSTR pEntry,CRegKeys &sKey);
		int  AFXAPI  ComboBoxLoad  (CDialog   *pDlg,int iId,LPCTSTR pEntry,LPCTSTR  pPath=NULL,LPTSTR pBuffer=NULL,int iSize=0);
		int  AFXAPI  ComboBoxLoad  (CDialog   *pDlg,int iId,LPCTSTR pEntry,CRegKeys &sKey     ,LPTSTR pBuffer=NULL,int iSize=0);
		int  AFXAPI  ComboBoxLoad  (CDialog   *pDlg,int iId,LPCTSTR pEntry,LPCTSTR  pPath,CString &sTextField);
		int  AFXAPI  ComboBoxLoad  (CDialog   *pDlg,int iId,LPCTSTR pEntry,CRegKeys &sKey,CString &sTextField);

        void AFXAPI  ComboBoxChange(CComboBox *pCombo);
inline	void AFXAPI  ComboBoxChange(CComboBox &sCombo){ComboBoxChange(&sCombo);}
inline	void AFXAPI  ComboBoxChange(CDialog   *pDlg,int iId){ComboBoxChange((CComboBox*)(pDlg->GetDlgItem(iId)));}
inline	int  AFXAPI  ComboBoxInsert(CDialog   *pDlg,int iId,LPCTSTR pText,int iMax=16){return ListAdd(pDlg,iId,pText,iMax,1);}


//*****************************************************************************
//*
//*		Diverse MFC Vernderungen
//*
//*****************************************************************************

#if    _MFC_VER >= 0x0700
#ifndef Enable3dControls
#define	Enable3dControls()
#endif
#ifndef Enable3dControlsStatic
#define	Enable3dControlsStatic()
#endif
#endif

#if    _MFC_VER >= 0x0700

#ifdef	CToolBar
#undef	CToolBar
#endif

	class CToolBarEx : public CToolBar
	{
	public:

		BOOL LoadToolBar(LPCTSTR pResourceName);
		BOOL LoadToolBar(UINT    nIDResource){return LoadToolBar(MAKEINTRESOURCE(nIDResource));};

	};

#define	CToolBar	CToolBarEx
#endif


#endif
