//*****************************************************************************
//*
//*
//*		DriveDlg.cpp: Implementierungsdatei
//*
//*
//*****************************************************************************
#include	<Afx.h>
#include	<AfxCmn.h>
#include	<Controls/AfxMacros.h>
#include	<Controls/AfxUtility.h>
#include	"DiskIO.h"
#include	"DriveDlg.h"
#include	"WinExtension.h"
#include	"StringFunctions.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#ifndef		 IDC_LIST1
#define		 IDC_LIST1		1082
#endif 	

BEGIN_MESSAGE_MAP(CDriveDlg, CDialog)
	//{{AFX_MSG_MAP(CDriveDlg)
	ON_WM_DRAWITEM()
	ON_LBN_DBLCLK(IDC_LIST1, OnDoubleClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL	CDriveDlg::bFirstInit=FALSE;
BYTE	CDriveDlg::aLogicToPhysical[32];
CBrush	CDriveDlg::cBrush1(RGB(255,255,255));
CBrush	CDriveDlg::cBrush2(RGB(200,200,200));
CBrush	CDriveDlg::cBrush3(RGB(150,150,255));

WORD CDriveDlg::wDlgData[] =
	{
	0x00C0,0x80C8,0x0000,0x0000,0x0003,0x0000,0x0000,0x00B5,0x00F5,0x0000,0x0000,0x004C,0x0061,0x0075,0x0066,0x0077,
	0x0065,0x0072,0x006B,0x0020,0x0061,0x0075,0x0073,0x0077,0x00E4,0x0068,0x006C,0x0065,0x006E,0x0000,0x0008,0x004D,
	0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,0x0066,0x0000,0x0000,0x0111,0x50A1,
	0x0000,0x0000,0x0000,0x0000,0x00B4,0x00DC,0x043A,0xFFFF,0x0083,0x0000,0x0000,0x0000,0x0001,0x5001,0x0000,0x0000,
	0x0041,0x00E1,0x0032,0x000E,0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,
	0x007D,0x00E1,0x0032,0x000E,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,
	0x0000,0x0000,
	};



//*****************************************************************************
//*
//*		Dialogfeld CDriveDlg
//*
//*****************************************************************************
CDriveDlg::CDriveDlg(CWnd *pParent)	: CDialog((UINT)0,pParent)
{

	//{{AFX_DATA_INIT(CDriveDlg)
	//}}AFX_DATA_INIT

	dwDrive		= 0xFFFFFFFF;				// Aktuelles Laufwerk
	dwSize		= 0;						// Gre des gewhlten Laufwerks in MB
	dwMaxSize	= 0;						// Maximale Gre eines Laufwerkes
	iTargets	= 0;						// 0=alles  1=nur Physisch 2=nur Logische LW
	bAddImage	= 0;						// Auch Images auswhlen
	bNoCdRom	= 0;						// Keine CD-Laufwerke
	bOnlyFat	= 0;						// Nur FAT-Laufwerke

	CDialog::InitModalIndirect((LPCDLGTEMPLATE)(wDlgData));

}



//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CDriveDlg::DoDataExchange(CDataExchange *pDX)
{

	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CDriveDlg)
	//}}AFX_DATA_MAP

}


//*****************************************************************************
//*
//*		Filter
//*
//*****************************************************************************
void CDriveDlg::Filter(char *pStr)
{
BYTE	cLast,c;
int		y,z;



	z=0;

	for(y=0;c=pStr[y];y++)
		{
		if((c>='a')&&(c<='z'))z|=1;
		if((c>='A')&&(c<='Z'))z|=2;
		if((c>=224)&&(c<=253))z|=1;
		if((c>=192)&&(c<=221))z|=2;
		if(z==3)break;
		}

	if(!z||(z==3))return;

	for(y=0,cLast=' ';c=pStr[y];y++)
		{
		z=0;

		if((c>='a')&&(c<='z'))z=1;
		if((c>='A')&&(c<='Z'))z=2;
		if((c>=224)&&(c<=253))z=1;
		if((c>=192)&&(c<=221))z=2;

		if((cLast>=' ' && cLast<='/')||
		   (cLast>=':' && cLast<='?')||
		   (cLast>='[' && cLast<=96 ))
			{
			if(z==1)pStr[y]-=32;
			}
		else{
			if(z==2)pStr[y]+=32;
			}

		cLast=c;
		}

}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CDriveDlg::OnInitDialog()
{
char		    cText[32]="\\\\.\\A:\\";
char		    cBuffer[256];
IMAGEINFO		sInfo;
SHFILEINFO		sSfi;
QWORD			qwSize;
DWORD			dwByte;
DWORD			dwDiff;
DWORD			dwData[3];
DWORD			dwDriveBits;
DWORD			dwDrive;
int				iWidth;
int				iIcon;
int				iSel;
int				iMin;
int				j;
int				i;


	if(!bFirstInit)
		{
		bFirstInit=TRUE;
		cBrush1.DeleteObject();
		cBrush1.CreateSolidBrush(GetSysColor(COLOR_WINDOW));
		}


	SetCursor(IDC_WAIT);
	pListBox=GetDlgListBox(IDC_LIST1);
	sDriveNames.DataLength(sizeof(DWORD)*4);
	hImageList =(HIMAGELIST)SHGetFileInfo("",0,&sSfi,sizeof(sSfi),SHGFI_PIDL |SHGFI_SMALLICON |SHGFI_SYSICONINDEX);
	SHGetFileInfo("C:\\",FILE_ATTRIBUTE_DIRECTORY,&sSfi,sizeof(sSfi),SHGFI_SYSICONINDEX|SHGFI_USEFILEATTRIBUTES|SHGFI_SMALLICON);
	
	iIcon=sSfi.iIcon;
	iTextOffset=20;


	if(CImageList::FromHandle(hImageList)->GetImageInfo(iIcon,&sInfo))
	if(GetBitmapInfo(sInfo.hbmImage,&iWidth,0,0) && iWidth>10)
		{
		iWidth += 4;
		iMin    = pListBox->GetItemHeight(0);	
		if(iMin<iWidth)
			{
			pListBox->SetItemHeight(0,iWidth);	
			iTextOffset = iWidth;
			}
		}



//******************** Laufwerke einlesen *************************************


	memset(aLogicToPhysical,0xFF,sizeof(aLogicToPhysical));
	dwDriveBits=GetLogicalDrives();
	iDriveCount=0;

	if(iTargets!=2)							// Physikalische Laufwerke von logischen
		{
		for(i=2,iSel=-1;i<26;i++)
			{
			if(!(dwDriveBits&(1<<i)))continue;
				dwDrive = GetDriveOfVolume(i);
			if(!dwDrive)continue;
				dwDrive &= 0x7FFF;
			if( dwDrive<sizeof(aLogicToPhysical))
				{
				aLogicToPhysical[i] = (BYTE)dwDrive;
				}
			}
		}

	if(iTargets!=1)							// Logische Laufwerke
	for(i=0,iSel=-1;i<26;i++)
		{
		if(!(dwDriveBits&(1<<i)))continue;
		if(!GetDriveName(i,cBuffer,sizeof(cBuffer),&iIcon))continue;

		qwSize  = GetSectorCount(i,&dwByte);
		
		if(!dwByte)dwByte=512;
		
		dwDiff	= 0x100000;

		while(!((dwDiff|dwByte)&1))
			{
			dwDiff >>= 1;
			dwByte >>= 1;
			}

		qwSize *= dwByte;
		qwSize /= dwDiff;

		if(qwSize<8192 && qwSize>0)			// Kleiner 8GB	
			{
			dwData[2] |= 0x100;
			}

		if(dwMaxSize)						// Laufwerksgre prfen
			{
			if(dwMaxSize<qwSize)continue;
			}

		dwData[0] = i;
		dwData[1] = iIcon;
		dwData[2] = 2;
		dwData[3] = (DWORD)qwSize;

		     if(strfind(cBuffer,"CD-ROM")>0)dwData[2]=3;
		else if(strfind(cBuffer,"FAT"   )>0)dwData[2]=4;
		else if(strfind(cBuffer,"NTFS"  )>0)dwData[2]=5;

		if(bNoCdRom && dwData[2]==3)		// Keine CD-Laufwerke
			{
			continue;
			}
		
		if(bOnlyFat && dwData[2]!=4)		// Nur FAT-Laufwerke
			{
			continue;
			}
											// Kleiner 8GB	
		if(qwSize<8192 && qwSize>0 && dwData[2]!=3)			
			{
			dwData[2] |= 0x100;
			}

		iDriveCount++;
		sDriveNames.Add(cBuffer,CSC_END,dwData);
		j=pListBox->InsertString(sDriveNames.Count()-1,cText);
		if(dwDrive==dwData[0] || (i==2 && iSel<0))
			{
			pListBox->SetCurSel(j);
			iSel=j;
			}
		}

	if(iTargets!=2)							// Physikalische Laufwerke
	for(i=0,iSel=-1;i<16;i++)				
		{
		if(!GetDriveName(i|0x8000,cBuffer,sizeof(cBuffer),&iIcon))continue;

			qwSize=GetSectorCount(i|0x8000,&dwByte);
		if(!qwSize)continue;
		if(!dwByte)dwByte=512;

		dwDiff	= 0x100000;

		while(!((dwDiff|dwByte)&1))
			{
			dwDiff >>= 1;
			dwByte >>= 1;
			}

		qwSize *= dwByte;
		qwSize /= dwDiff;

		if(dwMaxSize)						// Laufwerksgre prfen
			{
			if(dwMaxSize<qwSize)continue;
			}

		dwData[0] = i|0x8000;
		dwData[1] = iIcon;
		dwData[2] = 1;
		dwData[3] = (DWORD)qwSize;

		if(qwSize<8192 && qwSize>0)			// Kleiner 8GB	
			{
			dwData[2] |= 0x100;
			}

		iDriveCount++;
		sDriveNames.Add(cBuffer,CSC_END,dwData);
		j=pListBox->InsertString(sDriveNames.Count()-1,cText);
		if(dwDrive==dwData[0])
			{
			pListBox->SetCurSel(j);
			iSel=j;
			}
		}

	if(bAddImage)							// Auch Image-Dateien anzeigen
		{
		dwData[0] = 0xC000;
		dwData[1] = GetSmallIcon("x.bin",SHGFI_USEFILEATTRIBUTES);
		dwData[2] = 0;
		dwData[3] = 0;

		iDriveCount++;
		sDriveNames.Add("Image-Datei",CSC_END,dwData);
		j=pListBox->InsertString(sDriveNames.Count()-1,cText);

		if(dwDrive==dwData[0])
			{
			pListBox->SetCurSel(j);
			iSel=j;
			}
		}


	SetCursor(IDC_ARROW);

	CDialog::OnInitDialog();


return TRUE;
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CDriveDlg::OnOK()
{
int i;


	   i=pListBox->GetCurSel();
	if(i<0)
		{
		if(pListBox->GetCount()>0)i=0;
		}

	if(i>=0)
		{
		dwDrive		= sDriveNames.DataGet(i);
		dwSize 		= sDriveNames.DataGet(i,3);
		sDriveName	= sDriveNames[i];
		}
	else{
		dwDrive		= 0xFFFFFFFF;
		sDriveName	= "<kein Laufwerk gewhlt>";
		}

	CDialog::OnOK();

}

//*****************************************************************************
//*
//*		OnDrawItem
//*
//*****************************************************************************
void CDriveDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT pDraw)
{
HDC		 hDc;
HWND	 hWnd;
CBrush	*pBrush;
COLORREF uColor;	
int		 iState;
int		 iDrive;
int		 iIcon;
int		 iType;
int		 iLen;
int		 iNr;
int		 x,y;


	iNr	   = pDraw->itemID;
	hDc	   = pDraw->hDC;
	hWnd   = pDraw->hwndItem;
	iState = pDraw->itemState;

							   pBrush=&cBrush1;		// Hintergrund Farbe
	if( iState & ODS_SELECTED )pBrush=&cBrush2;
	if( iState & ODS_FOCUS    )pBrush=&cBrush2;
	if((iState & ODS_FOCUS    )&&
	   (iState & ODS_SELECTED))pBrush=&cBrush3;


	::SelectObject(hDc,GetStockObject(NULL_PEN));	// Hintergrund zeichnen
	::SelectObject(hDc,pBrush->m_hObject);
	  Rectangle(hDc,pDraw->rcItem.left,
					pDraw->rcItem.top,
					pDraw->rcItem.right,
					pDraw->rcItem.bottom+1);

	SetBkMode(hDc,TRANSPARENT);


	if(iNr<0 || iNr>=iDriveCount)return;

	iDrive	= sDriveNames.DataGet(iNr);
	iIcon	= sDriveNames.DataGet(iNr,1);
	iType	= sDriveNames.DataGet(iNr,2);
	iLen	= sDriveNames.Len(iNr);

	x		= pDraw->rcItem.left+4;
	y		= pDraw->rcItem.top;


	switch(iType&0xFF)
		{
	case 1:	uColor=RGB(0,0,120);					// Physikalisches Laufwerk		
			break;	

	case 3:	uColor=RGB(0,100,0);					// CD-ROM
			break;	
												
	case 4:	uColor=RGB(70,00,30);					// FAT Laufwerk		
			break;	

	default:uColor=GetSysColor(COLOR_WINDOWTEXT);
			break;
		}
	
	if(iType&0x100)									// Kleiner 8GB	
		{
		uColor *= 2;
		}

	SetTextColor(hDc,uColor);


	ImageList_Draw(hImageList,iIcon,hDc,x,y+2,ILD_NORMAL|ILD_TRANSPARENT);
	TextOut(hDc,x+iTextOffset,y+4,sDriveNames[iNr],iLen);

}

//*****************************************************************************
//*
//*		OnDoubleClick
//*
//*****************************************************************************
void CDriveDlg::OnDoubleClick()
{
	OnOK();
}

//*****************************************************************************
//*
//*		GetDriveName
//*
//*****************************************************************************
BOOL CDriveDlg::GetDriveName(DWORD dwDrive,char *pBuffer,int iSize,int *pIcon)
{
SHFILEINFO	sSfi;
QWORD		qwValue;
DWORD		dwDriveBits;
DWORD		dwDummy1,dwDummy2,dwDummy3;
char		cText[32]="\\\\.\\A:\\";
char		cVolume[63],cSystem[32],cBuffer[256];
int			i,j,iNum,iLocial,iMode,iType;


	i=dwDrive&0x7FFF;
	if(i>=26)return FALSE;

	if(dwDrive&0x8000)
		{
			qwValue=GetSectorCount(i|0x8000,&dwDummy1);
		if(!qwValue)return FALSE;

		cVolume[0]=0;
		cSystem[0]=0;

		j = sprintf(cBuffer,"PhysicalDrive%i",i);

		while(dwDummy1<1024)
			{
			qwValue  /= 2;
			dwDummy1 *= 2;
			}

		while(dwDummy1>1024)
			{
			qwValue  *= 2;
			dwDummy1 /= 2;
			}

		if(qwValue<10*1024)
			{
			j+=sprintf(cBuffer+j,"   (%i.%02i MB)",(DWORD)(qwValue>>10),((DWORD)(qwValue&0x3FF)*100)>>10);
			}
		else if(qwValue<100*1024)
			{
			j+=sprintf(cBuffer+j,"   (%i.%01i MB)",(DWORD)(qwValue>>10),((DWORD)(qwValue&0x3FF)*10)>>10);
			}
		else if(qwValue<1024*1024)
			{
			j+=sprintf(cBuffer+j,"   (%i MB)",qwValue>>10);
			}
		else if(qwValue<10*1024*1024)
			{
			qwValue>>=10;
			j+=sprintf(cBuffer+j,"   (%i.%02i GB)",(DWORD)(qwValue>>10),((DWORD)(qwValue&0x3FF)*100)>>10);
			}
		else if(qwValue<100*1024*1024)
			{
			qwValue>>=10;
			j+=sprintf(cBuffer+j,"   (%i.%01i GB)",(DWORD)(qwValue>>10),((DWORD)(qwValue&0x3FF)*10)>>10);
			}
		else{
			qwValue>>=10;
			j+=sprintf(cBuffer+j,"   (%i GB)",(DWORD)(qwValue>>10));
			}

		for(iLocial=0,iNum=0;iLocial<26;iLocial++)
			{
			if(aLogicToPhysical[iLocial]!=i)continue;
			if(!iNum)j += sprintf(cBuffer+j,"    [");
			j += sprintf(cBuffer+j," %c: ",'A'+iLocial);
			iNum++;
			}
		
		if(iNum)j+=sprintf(cBuffer+j,"]");


		if(pIcon && SHGetFileInfo("C:",FILE_ATTRIBUTE_DIRECTORY,&sSfi,sizeof(sSfi),SHGFI_SYSICONINDEX|SHGFI_USEFILEATTRIBUTES|SHGFI_SMALLICON))
			{
			*pIcon=sSfi.iIcon;
			}

		}
	else{
		dwDriveBits = GetLogicalDrives();

		if(!(dwDriveBits&(1<<i)))return FALSE;

		cText[4]='A'+i;

		   iType=GetDriveType(cText);
		if(iType==DRIVE_REMOTE)return FALSE;

		cVolume[0]=0;
		cSystem[0]=0;

		GetVolumeInformation(cText+4,cVolume,sizeof(cVolume),&dwDummy1,&dwDummy2,&dwDummy3,cSystem,sizeof(cSystem));
		if(!cVolume[0])strcpy(cVolume,"Datentrger");
		Filter(cVolume);

		sprintf(cBuffer,"%s (%.2s)   ",cVolume,cText+4);
		iMode = GetDriveType(cText+4);

		switch(iMode)
			{
		case DRIVE_REMOVABLE:	strcat(cBuffer,"Disk  "    );	break;
		case DRIVE_FIXED:		strcat(cBuffer,"Harddisk  ");	break;
		case DRIVE_CDROM:		strcat(cBuffer,"CD-ROM  "  );	break;
		case DRIVE_RAMDISK:		strcat(cBuffer,"RAM-Disk  ");	break;
		default:				strcat(cBuffer,"unbekannt ");	break;
				}

		if(cSystem[0])
			{
			strcat(cBuffer,cSystem);
			}
		else if(iMode==DRIVE_REMOVABLE)
			{
			strcat(cBuffer,"---");
			}

		if(pIcon && SHGetFileInfo(cText+4,FILE_ATTRIBUTE_DIRECTORY,&sSfi,sizeof(sSfi),SHGFI_SYSICONINDEX|SHGFI_USEFILEATTRIBUTES|SHGFI_SMALLICON))
			{
			*pIcon=sSfi.iIcon;
			}

		}

	strlcpy(pBuffer,cBuffer,iSize);



return TRUE;
}
