//*****************************************************************************
//*
//*
//*		HtmlBar.h
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2009
//
#ifndef 	__HTMLBAR_H__
#define 	__HTMLBAR_H__

#include	"SizeBar.h"
#include	"HtmlCtrl.h"



//*****************************************************************************
//*
//*		Klasse CHtmlBar
//*
//*****************************************************************************
class CHtmlBar : public CSizeBar
{

	DECLARE_DYNAMIC(CHtmlBar)

public:

				CHtmlBar();
	virtual    ~CHtmlBar();

	BOOL		Create(             CWnd* pParentWnd,DWORD dwStyle=WS_CHILD|WS_VISIBLE|CBRS_RIGHT,UINT nID=33);
	BOOL		Create(LPCSTR pName,CWnd* pParentWnd,DWORD dwStyle=WS_CHILD|WS_VISIBLE|CBRS_RIGHT,UINT nID=33);

	CHtmlCtrl  *GetHtmlCtrl();

	void		Refresh();
	void		Stop();
	void 		GoBack();
	void 		GoForward();
	void 		Navigate(LPCTSTR pUrl,unsigned uDelay=0);



protected:


	//{{AFX_MSG(CHtmlBar)
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnSize (UINT nType,int iXsize,int iYsize);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	afx_msg void OnContextMenu( CWnd*, CPoint );

	DECLARE_MESSAGE_MAP()

protected:

	CHtmlCtrl		m_cHtmlClrl;
	CRect			m_sChildRect;							// Gre und Position des Fensters
	TCHAR			m_cDelayUrl[1024];
	BOOL			m_bDelayOn;
	unsigned		m_uDelay;

};

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline	CHtmlCtrl  *CHtmlBar::GetHtmlCtrl(){return &m_cHtmlClrl;}


#endif


