//*****************************************************************************
//*
//*
//*		Klasse	CHtmlCtrl
//*
//*
//*****************************************************************************
#ifndef   __HTMLCTRL_H__
#define   __HTMLCTRL_H__

#if		   _MSC_VER > 1000
#pragma		once
#endif
#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif
		  

#include	<Afx.h>
#include	<AfxMt.h>
#include	<AfxOle.h>
#include	<AfxCmn.h>
#include	<AtlConv.h>
#include	<AfxDtCtl.h>

#define 	ID_HTML_CTRL		0x1122
#define 	ID_HTML_DONE		0x6677

//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class CHtmlCtrl : public CWnd
{


//	DECLARE_EVENTSINK_MAP()

public:

			    CHtmlCtrl();
	virtual    ~CHtmlCtrl();

	CString 	GetType() const;
	long		GetLeft() const;
	void 		SetLeft(long nNewValue);
	long 		GetTop() const;
	void 		SetTop(long nNewValue);
	long 		GetHeight() const;
	void 		SetHeight(long nNewValue);
	void 		SetVisible(BOOL bNewValue);
	BOOL 		GetVisible() const;
	CString 	GetLocationName() const;
	READYSTATE 	GetReadyState() const;
	BOOL 		GetOffline() const;
	void 		SetOffline(BOOL bNewValue);
	BOOL 		GetSilent() const;
	void 		SetSilent(BOOL bNewValue);
	BOOL 		GetTopLevelContainer() const;
	CString 	GetLocationURL() const;
	BOOL 		GetBusy() const;
	LPDISPATCH 	GetApplication() const;
	LPDISPATCH 	GetParentBrowser() const;
	LPDISPATCH 	GetContainer() const;
	LPDISPATCH 	GetHtmlDocument() const;
	CString 	GetFullName() const;
	int 		GetToolBar() const;
	void 		SetToolBar(int nNewValue);
	BOOL 		GetMenuBar() const;
	void 		SetMenuBar(BOOL bNewValue);
	BOOL 		GetFullScreen() const;
	void 		SetFullScreen(BOOL bNewValue);
	OLECMDF 	QueryStatusWB(OLECMDID cmdID) const;
	BOOL 		GetRegisterAsBrowser() const;
	void 		SetRegisterAsBrowser(BOOL bNewValue);
	BOOL 		GetRegisterAsDropTarget() const;
	void 		SetRegisterAsDropTarget(BOOL bNewValue);
	BOOL 		GetTheaterMode() const;
	void 		SetTheaterMode(BOOL bNewValue);
	BOOL 		GetAddressBar() const;
	void 		SetAddressBar(BOOL bNewValue);
	BOOL 		GetStatusBar() const;
	void 		SetStatusBar(BOOL bNewValue);
	LRESULT		SaveAs(LPCTSTR pFilename,int iSaveType=0,int iOverWriteQuesion=0);
	void		GetZoomRange(int &iMin,int &iMax);
	void		SetZoom(int iZoom);
	int 		GetZoom();
	BOOL		HasFocus();
	void 		Find();

public:

	void 		GoBack();
	void 		GoForward();
	void 		GoHome();
	void 		GoSearch();
	void 		Navigate(	LPCTSTR      pUrl,DWORD dwFlags = 0,LPCTSTR     pTargetFrame = NULL, LPCTSTR pHeaders     = NULL, LPVOID  pPostData = NULL,DWORD dwPostDataLen = 0);
	void		Navigate2(	LPCTSTR      pUrl,DWORD dwFlags = 0,LPCTSTR     pTargetFrame = NULL, LPCTSTR pHeaders     = NULL, LPVOID  pPostData = NULL,DWORD dwPostDataLen = 0);
	void		Navigate2(	LPCTSTR      pUrl,DWORD dwFlags    ,CByteArray &bPostedData        , LPCTSTR pTargetFrame = NULL, LPCTSTR pHeader   = NULL);
	void 		Navigate2(	LPITEMIDLIST pIDL,DWORD dwFlags = 0,LPCTSTR     pTargetFrame = NULL);
	void		Refresh();
	void		Refresh2(int nLevel);
	void		Stop();
	void		Copy();
	void		PutProperty(LPCTSTR pProperty, const VARIANT& vValue);
	void 		PutProperty(LPCTSTR pPropertyName, double     dValue);
	void 		PutProperty(LPCTSTR pPropertyName, LPCTSTR    pValue);
	void 		PutProperty(LPCTSTR pPropertyName, long       lValue);
	void 		PutProperty(LPCTSTR pPropertyName, short      nValue);
	BOOL 		GetProperty(LPCTSTR pProperty,     CString   &sValue);
	COleVariant GetProperty(LPCTSTR pProperty);
	LRESULT		ExecWB(OLECMDID iCmdId, OLECMDEXECOPT iCmdExecOpt,VARIANT *pIn,VARIANT *pOut);
	BOOL		LoadFromResource(LPCTSTR pResource);
	BOOL 		LoadFromResource(UINT nRes);


public:

	virtual BOOL Create  (                LPCTSTR pWindowName,DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID=ID_HTML_CTRL);
	virtual BOOL CreateEx(DWORD dwExStyle,LPCTSTR pWindowName,DWORD dwStyle,const RECT &sRect,CWnd* pParentWnd,UINT nID=ID_HTML_CTRL);
	inline  BOOL Create  (                                    DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nID=ID_HTML_CTRL){return Create  (          _T(""),dwStyle,sRect,pParentWnd,nID);}
	inline  BOOL CreateEx(DWORD dwExStyle,                    DWORD dwStyle,const RECT &sRect,CWnd* pParentWnd,UINT nID=ID_HTML_CTRL){return CreateEx(dwExStyle,_T(""),dwStyle,sRect,pParentWnd,nID);}

	//{{AFX_MSG(CHtmlCtrl)
	afx_msg LRESULT OnCopyMsg(WPARAM wParam,LPARAM lParam);
	afx_msg void OnCopy();
	afx_msg void OnFilePrint();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	//}}AFX_MSG

	// Events
	virtual void OnNavigateComplete2(LPCTSTR strURL);
	virtual void OnStatusTextChange(LPCTSTR pText);
	virtual void OnProgressChange(long nProgress, long nProgressMax);
	virtual void OnCommandStateChange(long nCommand, BOOL bEnable);
	virtual void OnDownloadBegin();
	virtual void OnDownloadComplete();
	virtual void OnTitleChange(LPCTSTR pText);
	virtual void OnPropertyChange(LPCTSTR pProperty);
	virtual void OnNewWindow2(LPDISPATCH *pDisp, BOOL *pCancel);
	virtual void OnDocumentComplete(LPCTSTR pUrl);
	virtual void OnQuit();
	virtual void OnVisible(BOOL bVisible);
	virtual void OnToolBar(BOOL bToolBar);
	virtual void OnMenuBar(BOOL bMenuBar);
	virtual void OnStatusBar(BOOL bStatusBar);
	virtual void OnFullScreen(BOOL bFullScreen);
	virtual void OnTheaterMode(BOOL bTheaterMode);
	virtual void OnBeforeNavigate2(	LPCTSTR pUrl, DWORD nFlags,LPCTSTR pTargetFrame, CByteArray& bPostedData,LPCTSTR pHeaders, BOOL* pbCancel);

public:

	CWnd	m_cWndBrowser;

	#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
	#endif

protected:

	virtual void DocumentComplete (LPDISPATCH pDisp,VARIANT *pUrl);
	virtual void NavigateComplete2(LPDISPATCH pDisp,VARIANT *pUrl);
	virtual void BeforeNavigate2  (LPDISPATCH pDisp,VARIANT *pUrl,VARIANT *pFlags,VARIANT *pTargetFrame,VARIANT *pPostData,VARIANT *pHeaders,BOOL *pCancel);



	static	LRESULT CALLBACK CHtmlCtrl::CbtProc (int  nCode         ,WPARAM wParam,LPARAM lParam);
	static	LRESULT CALLBACK CHtmlCtrl::FileProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

	static	int				m_iRetDone;
	static	int				m_iOverWrite;
	static	int				m_iSaveAsMode;
	static	CString			m_sSaveAsFile;
	static	CSemaphore		m_sSaveAsSem;
	static	WNDPROC			m_pOldProc;
	static	HWND			m_hHtmlWnd;
	static	HWND			m_hHookWnd;
	static	HHOOK			m_hHook;
	IWebBrowser2		   *m_pBrowserApp;


	//{{AFX_MSG(CHtmlCtrl)
	afx_msg void OnSize(UINT nType,int iCx,int iCy);
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	DECLARE_EVENTSINK_MAP()
};



//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline void CHtmlCtrl::SetStatusBar           (BOOL bNewValue)	{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_StatusBar((short) (bNewValue ? AFX_OLE_TRUE : AFX_OLE_FALSE)); }
inline void CHtmlCtrl::SetRegisterAsBrowser	  (BOOL bNewValue)	{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_RegisterAsBrowser((short) (bNewValue ? AFX_OLE_TRUE : AFX_OLE_FALSE)); }
inline void CHtmlCtrl::SetRegisterAsDropTarget(BOOL bNewValue)	{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_RegisterAsDropTarget((short) (bNewValue ? AFX_OLE_TRUE : AFX_OLE_FALSE)); }
inline void CHtmlCtrl::SetTheaterMode         (BOOL bNewValue)	{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_TheaterMode((short) (bNewValue ? AFX_OLE_TRUE : AFX_OLE_FALSE)); }
inline void CHtmlCtrl::SetVisible(BOOL bNewValue)			  	{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_Visible((short) (bNewValue ? AFX_OLE_TRUE : AFX_OLE_FALSE)); }
inline void CHtmlCtrl::SetMenuBar(BOOL bNewValue)			  	{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_MenuBar((short) (bNewValue ? AFX_OLE_TRUE : AFX_OLE_FALSE)); }
inline void CHtmlCtrl::SetOffline(BOOL bNewValue)			  	{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_Offline((short) (bNewValue ? AFX_OLE_TRUE : AFX_OLE_FALSE)); }
inline void CHtmlCtrl::SetSilent (BOOL bNewValue)				{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_Silent((short) (bNewValue ? AFX_OLE_TRUE : AFX_OLE_FALSE)); }
inline void CHtmlCtrl::SetTop    (long nNewValue)				{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_Top(nNewValue); }
inline void CHtmlCtrl::SetLeft   (long nNewValue) 				{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_Left(nNewValue); }
inline void CHtmlCtrl::SetToolBar(int  nNewValue)			  	{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_ToolBar(nNewValue); }
inline void CHtmlCtrl::GoBack()								 	{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->GoBack(); }
inline void CHtmlCtrl::GoForward()								{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->GoForward(); }
inline void CHtmlCtrl::GoHome()									{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->GoHome(); }
inline void CHtmlCtrl::GoSearch()								{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->GoSearch(); }
inline void CHtmlCtrl::Refresh()								{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->Refresh(); }
inline void CHtmlCtrl::Refresh2(int nLevel)						{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->Refresh2(COleVariant((long) nLevel, VT_I4)); }
inline void CHtmlCtrl::Stop()									{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->Stop(); }
inline void CHtmlCtrl::Copy()									{ ASSERT(m_pBrowserApp != NULL); OnCopy(); }
inline void CHtmlCtrl::SetFullScreen(BOOL bNewValue)			{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_FullScreen((short) (bNewValue ? AFX_OLE_TRUE : AFX_OLE_FALSE)); }
inline void CHtmlCtrl::SetAddressBar(BOOL bNewValue)			{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_AddressBar((short) (bNewValue ? AFX_OLE_TRUE : AFX_OLE_FALSE)); }
inline void CHtmlCtrl::SetHeight(long nNewValue)				{ ASSERT(m_pBrowserApp != NULL); m_pBrowserApp->put_Height(nNewValue); }
inline void CHtmlCtrl::PutProperty(LPCTSTR PropertyName, LPCTSTR pValue)	{ ASSERT(m_pBrowserApp != NULL); ASSERT(m_pBrowserApp != NULL); PutProperty(PropertyName, COleVariant(pValue, VT_BSTR)); }
inline void CHtmlCtrl::PutProperty(LPCTSTR PropertyName, long lValue)		{ ASSERT(m_pBrowserApp != NULL); ASSERT(m_pBrowserApp != NULL); PutProperty(PropertyName, COleVariant(lValue,    VT_UI4 )); }
inline void CHtmlCtrl::PutProperty(LPCTSTR PropertyName, short nValue) 		{ ASSERT(m_pBrowserApp != NULL); ASSERT(m_pBrowserApp != NULL); PutProperty(PropertyName, COleVariant(nValue,    VT_UI2 )); }
inline void CHtmlCtrl::PutProperty(LPCTSTR PropertyName, double dValue)	   	{ ASSERT(m_pBrowserApp != NULL); ASSERT(m_pBrowserApp != NULL); PutProperty(PropertyName, COleVariant(dValue            )); }

#endif
