//*****************************************************************************
//*
//*
//*		HtmlDlg.cpp
//*
//*
//*****************************************************************************
//	
//	CHtmlDlg::SetUrl("...HTML-Seite...");
//	
//			Wenn die URL mit '*' beginnt, ist die HTML-Seite in den Resourcen.
//			MyPage.html   RT_HTML   "Res\MyPage.html"	(in *.rc2)
//			"*MyPage.html"								(URL)
//			res://MyExe.exe/MyPage.html					(URL gesammt)
//	
#include	"Afx.h"
#include	"HtmlDlg.h"
#include	"AfxUtility.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 IDC_LOAD_URL		0x5517
#define		 IDC_HTML			0x5518
#define		 IDC_CHECK1			1011
#define		 IDC_FRAME1			1032
#define		 IDC_FRAME2			1033
#define		 IDOK2              1034


BEGIN_MESSAGE_MAP(CHtmlDlg, CDialog)
	//{{AFX_MSG_MAP(CHtmlDlg)
	ON_WM_SIZE()		
	ON_WM_TIMER()
	ON_WM_SIZING()		
	ON_WM_DESTROY()
	ON_WM_EXITSIZEMOVE()
	ON_COMMAND   (IDC_LOAD_URL, OnLoadUrl)
	ON_BN_CLICKED(IDC_CHECK1,	OnCheck)
	ON_BN_CLICKED(IDOK2,		OnOk2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


#ifndef 	IDR_MAINFRAME
#define 	IDR_MAINFRAME	128
#endif 	

DLG_OLDSIZE(CHtmlDlg)

DLG_SIZING_SIZE(CHtmlDlg)
DLG_SIZING_ITEMS(CHtmlDlg,2,1)	
	{						
	IDC_HTML,	0, 0,   2, 1,
	IDC_CHECK1,	0, 1,   2, 0,
	IDCANCEL,	2, 1,	0, 0,	
	IDOK,		2, 1,	0, 0,	
	IDOK2,		1, 1,	0, 0,	
	};

DLG_SIZING_EX(CHtmlDlg,200,150)


HICON CHtmlDlg::m_hMainIcon;
WORD  CHtmlDlg::m_wDlgData[]=
	{
	0x0040,0x82CC,0x0000,0x0000,0x0006,0x0000,0x0000,0x019B,0x0125,0x0000,0x0000,0x0049,0x006E,0x0066,0x006F,0x0072,
	0x006D,0x0061,0x0074,0x0069,0x006F,0x006E,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,
	0x0053,0x0065,0x0072,0x0069,0x0066,0x0000,0x0001,0x5001,0x0000,0x0000,0x0131,0x0113,0x0032,0x000E,0x0001,0xFFFF,
	0x0080,0x004F,0x004B,0x0000,0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,0x0168,0x0113,0x0032,0x000E,0x0002,0xFFFF,
	0x0080,0x0043,0x0061,0x006E,0x0063,0x0065,0x006C,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x0004,0x0116,
	0x012C,0x000A,0x03F3,0xFFFF,0x0080,0x0054,0x0065,0x0078,0x0074,0x0000,0x0000,0x0000,0x0007,0x4000,0x0000,0x0000,
	0x0000,0x0000,0x019A,0x010E,0x0408,0xFFFF,0x0082,0x0000,0x0000,0x0000,0x0007,0x4000,0x0000,0x0000,0x0000,0x0009,
	0x019A,0x0119,0x0409,0xFFFF,0x0082,0x0000,0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,0x00B4,0x0113,0x0032,0x000E,
	0x040A,0xFFFF,0x0080,0x004F,0x004B,0x0000,0x0000,
	};




//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
CHtmlDlg::CHtmlDlg(CWnd *pParent): CDialog((UINT)0,pParent)
{

	//{{AFX_DATA_INIT(CHtmlDlg)
	m_bSelected = FALSE;
	//}}AFX_DATA_INIT

	m_dwFlags = CHT_HAS_OK;

	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);

}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CHtmlDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHtmlDlg)
	DDX_Check(pDX, IDC_CHECK1, m_bSelected);
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  CHtmlDlg message handlers
BOOL CHtmlDlg::OnInitDialog()
{
CRect		sRect;
BOOL		bText;


	if(m_hMainIcon==NULL)
		{
		    m_hMainIcon = ::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDR_MAINFRAME));
		if(!m_hMainIcon)m_hMainIcon=(HICON)INVALID_HANDLE_VALUE;
		}

	if(m_hMainIcon!=(HICON)INVALID_HANDLE_VALUE)
		{
		SetIcon(m_hMainIcon,FALSE);
		SetIcon(m_hMainIcon,TRUE );
		}

	
	if(m_sText.IsEmpty())
		{
		GetDlgItem(IDC_CHECK1)->ShowWindow(SW_HIDE);
		bText = FALSE;
		}	
	else{
		GetDlgItem(IDC_CHECK1)->SetWindowText(m_sText);
		bText = TRUE;
		}

	if(m_dwFlags&CHT_HAS_CANCEL)
		{
		GetDlgItem(IDOK2   )->ShowWindow(SW_HIDE);
		GetDlgItem(IDOK    )->ShowWindow((m_dwFlags&CHT_HAS_OK)? SW_SHOW:SW_HIDE);
		}
	else if(m_dwFlags&CHT_HAS_OK)
		{
		GetDlgItem(IDCANCEL)->ShowWindow(SW_HIDE);
		GetDlgItem(IDOK2   )->ShowWindow((!bText)? SW_SHOW:SW_HIDE);
		GetDlgItem(IDOK    )->ShowWindow(( bText)? SW_SHOW:SW_HIDE);
		if(bText)::MoveWindow(this,IDOK,IDCANCEL);
		}
	else{
		GetDlgItem(IDCANCEL)->ShowWindow(SW_HIDE);
		GetDlgItem(IDOK2   )->ShowWindow(SW_HIDE);
		GetDlgItem(IDOK    )->ShowWindow(SW_HIDE);
		}

	
	GetDlgPosRect(this,((m_dwFlags&(CHT_HAS_OK|CHT_HAS_CANCEL)) || bText)? IDC_FRAME1:IDC_FRAME2,&sRect);
	 
	m_cHtml.Create(_T(""),WS_CHILD|WS_VISIBLE|WS_TABSTOP,sRect,this,IDC_HTML);


	DLG_SIZING_INIT()
	SET_DLG_OLDSIZE();

	CDialog::OnInitDialog();

	if(m_dwFlags&CHT_ENABLE_OK)
		{
		OnCheck();
		}


	SetTimer(IDC_LOAD_URL,100,NULL);				// HTLM-Seite verzgert laden


return TRUE;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CHtmlDlg::OnDestroy()
{

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CHtmlDlg::OnTimer(UINT_PTR nIdEvent)
{

	if(nIdEvent==IDC_LOAD_URL)
		{
		KillTimer(IDC_LOAD_URL);
		OnLoadUrl();
		return;
		}

	CDialog::OnTimer(nIdEvent);
}

//*****************************************************************************
//*
//*		OnLoadUrl
//*
//*****************************************************************************
void CHtmlDlg::OnLoadUrl()
{
LPCTSTR		pName;


	pName = m_sUrl;

	if(*pName=='*')
			m_cHtml.LoadFromResource(pName+1);
	else	m_cHtml.Navigate2(pName);


}

//*****************************************************************************
//*
//*		OnCheck
//*
//*****************************************************************************
void CHtmlDlg::OnCheck()
{

	if(m_dwFlags&CHT_ENABLE_OK)
		{
		UpdateData();

		GetDlgItem(IDOK2)->EnableWindow(m_bSelected);
		GetDlgItem(IDOK )->EnableWindow(m_bSelected);
		}

}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CHtmlDlg::OnCancel()
{

	UpdateData();

	if(  m_dwFlags&CHT_HAS_OK)
	if(!(m_dwFlags&CHT_HAS_CANCEL))
		{
		OnOK();
		return;
		}


	GET_DLG_OLDSIZE()

	CDialog::OnCancel();

}

//*****************************************************************************
//*
//*		OnOk2
//*
//*****************************************************************************
void CHtmlDlg::OnOk2()
{

	OnOK();

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CHtmlDlg::OnOK()
{

	UpdateData();

	if(!(m_dwFlags&CHT_HAS_OK))
		{
		OnCancel();
		return;
		}

	if((m_dwFlags&CHT_ENABLE_OK) && !m_bSelected)
		{
		return;
		}

	GET_DLG_OLDSIZE()

	CDialog::OnOK();
}


