//*****************************************************************************
//*
//*		
//*		MonitorFunctions.h
//*
//*
//*****************************************************************************
#ifndef 	__MONITORFUNCTIONS_H__
#define 	__MONITORFUNCTIONS_H__


#if		   _MSC_VER >= 1000
#pragma		once
#endif

#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif


#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#ifndef	 __AFX_H__
	#include <afxwin.h>
	#endif
#else
	#include <windows.h>
#endif


#define MONAPI __stdcall


extern	UINT	uMonitorCount;
extern	RECT	aMonitorRect[];

inline	int		MONAPI MonitorCount     (){return uMonitorCount;}
		BOOL   	MONAPI MonitorMove      (CREATESTRUCT *p,unsigned uMonitor,int iMode=0);
		BOOL   	MONAPI MonitorMove      (LPRECT    pRect,unsigned uMonitor,int iMode=0);
		BOOL   	MONAPI MonitorMove      (HWND      hWnd ,unsigned uMonitor,int iMode=0);
inline	LPRECT 	MONAPI MonitorRect      (unsigned  uMonitor){if(uMonitor>=uMonitorCount)return 0;return aMonitorRect+uMonitor;}
		int    	MONAPI MonitorFrameCheck(unsigned  uMonitor,int iPosX,int iPosY,int iSizeX,int iSizeY,int iAdd=50);
		int	   	MONAPI MonitorOfPoint   (POINT     sPoint);
		int	   	MONAPI MonitorOfWindow  (HWND      hWnd);
		int	   	MONAPI MonitorOfRect    (RECT     *pRect);
		int    	MONAPI MonitorOfRect    (CREATESTRUCT *pStruct);
inline	int	   	MONAPI MonitorOfRect    (RECT     &sRect){return MonitorOfRect(&sRect);}
		int	   	MONAPI MonitorOfCoord   (int       iPosX,int iPosY);
		int	   	MONAPI MonitorInit      (BOOL      bForce=FALSE);

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
inline	BOOL    MONAPI MonitorMove      (CWnd *pWnd ,unsigned uMonitor,int iMode=0){ASSERT(pWnd);return MonitorMove(pWnd->m_hWnd,uMonitor,iMode);}
inline	int	    MONAPI MonitorOfWindow  (CWnd *pWnd){if(!pWnd)return -1;return MonitorOfWindow(pWnd->m_hWnd);}
#endif 	


#endif 	