//*****************************************************************************
//*
//*
//*		TreeListCtrlEx.h
//*
//*
//*****************************************************************************
#ifndef		__TREELISTCTRLEX_H__
#define     __TREELISTCTRLEX_H__

#if _MSC_VER > 1000
#pragma once
#endif

#include	"TreeListCtrl.h"


//*****************************************************************************
//*
//*		KLASSE	CTreeListCtrlEx
//*
//*****************************************************************************
class CTreeListCtrlEx : public CTreeListCtrl
{
public:

	BOOL		Create				(                DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nId=ID_TREELISTCTRL_DEF);
	BOOL		CreateEx			(DWORD dwExStyle,DWORD dwStyle,const RECT &sRect,CWnd *pParentWnd,UINT nId=ID_TREELISTCTRL_DEF);
	BOOL		Create  			(                DWORD dwStyle,UINT uItem,CDialog *pDlg,UINT nId=ID_TREELISTCTRL_DEF);
	BOOL		CreateEx			(DWORD dwExStyle,DWORD dwStyle,UINT uItem,CDialog *pDlg,UINT nId=ID_TREELISTCTRL_DEF);

	HTREEITEM	InsertItemEx		(UINT nMask, LPCTSTR pText,int nImage,int nSelImage,UINT nState,UINT nStateMask,LPARAM lParam,HTREEITEM    hParent=TVI_ROOT,HTREEITEM hInsertAfter=TVI_LAST);
	HTREEITEM	InsertItemEx		(UINT nMask, LPCTSTR pText,int nImage,int nSelImage,UINT nState,UINT nStateMask,LPARAM lParam,PFNTVSORTEX  pCmpProc        ,HTREEITEM hParent     =TVI_ROOT);
	HTREEITEM	InsertItemEx		(UINT nMask, LPCTSTR pText,int nImage,int nSelImage,UINT nState,UINT nStateMask,LPARAM lParam,PFNTVTEXTCMP pCmpProc        ,HTREEITEM hParent     =TVI_ROOT);
	HTREEITEM	InsertItemEx		(UINT nMask, LPCTSTR pText,int nImage,int nSelImage,UINT nState,UINT nStateMask,LPARAM lParam,PFNTVSORTEX  pCmpProc        ,HTREEITEM hParent                ,LPVOID pCbParam);
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,int nSelImg,                                            HTREEITEM    hParent=TVI_ROOT,HTREEITEM hInsertAfter=TVI_LAST);
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,int nSelImg,                                            HTREEITEM    hParent         ,HTREEITEM hInsertAfter           ,LPARAM lParam  );
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,int nSelImg,                                            PFNTVSORTEX  pCmpProc        ,HTREEITEM hParent     =TVI_ROOT  ,LPARAM lParam=0);
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,int nSelImg,                                            PFNTVSORTEX  pCmpProc        ,HTREEITEM hParent,LPVOID pCbParam,LPARAM lParam  );
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,int nSelImg,                                            PFNTVTEXTCMP pCmpProc        ,HTREEITEM hParent                ,LPARAM lParam  );
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,int nSelImg,                                            PFNTVTEXTCMP pCmpProc        ,HTREEITEM hParent     =TVI_ROOT);
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,                                                        HTREEITEM    hParent=TVI_ROOT,HTREEITEM hInsertAfter=TVI_LAST);
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,                                                        HTREEITEM    hParent         ,HTREEITEM hInsertAfter           ,LPARAM lParam  );
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,                                                        PFNTVSORTEX  pCmpProc        ,HTREEITEM hParent     =TVI_ROOT  ,LPARAM lParam=0);
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,				                                          PFNTVSORTEX  pCmpProc        ,HTREEITEM hParent,LPVOID pCbParam,LPARAM lParam  );
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,                                                        PFNTVTEXTCMP pCmpProc        ,HTREEITEM hParent                ,LPARAM lParam  );
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,int nImage,                                                        PFNTVTEXTCMP pCmpProc        ,HTREEITEM hParent     =TVI_ROOT);
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,                                                                   HTREEITEM    hParent=TVI_ROOT,HTREEITEM hInsertAfter=TVI_LAST);
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,                                                                   HTREEITEM    hParent         ,HTREEITEM hInsertAfter           ,LPARAM lParam  );
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,                                                                   PFNTVSORTEX  pCmpProc        ,HTREEITEM hParent     =TVI_ROOT  ,LPARAM lParam=0);
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,							                                          PFNTVSORTEX  pCmpProc        ,HTREEITEM hParent,LPVOID pCbParam,LPARAM lParam  );
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,                                                                   PFNTVTEXTCMP pCmpProc        ,HTREEITEM hParent                ,LPARAM lParam  );
	HTREEITEM	InsertItemEx		(            LPCTSTR pText,                                                                   PFNTVTEXTCMP pCmpProc        ,HTREEITEM hParent     =TVI_ROOT);
	HTREEITEM	InsertItemEx		(LPTVINSERTSTRUCT    pInsert);


	HTREEITEM	FindItemEx			(HTREEITEM hItem,TVFIND *pFind);
	HTREEITEM	FindItemEx			(HTREEITEM hItem,int     iFlags,int nCol,LPCTSTR pText,LPARAM lParam=0,UINT uState=0,UINT uStateMask=0);
	HTREEITEM	FindItemEx			(HTREEITEM hItem,LPCTSTR pText ,int nCol=0,int iCase=0);
	HTREEITEM	FindItemEx			(HTREEITEM hItem,LPARAM  lParam);

	INT			SetMultiItemsEx		(TV_ITEM  *pItem);
	INT			SetMultiItemsEx		(HTREEITEM hItem,int nCol,UINT nMask,LPCTSTR pText,int nImage,int nSelectedImage,UINT nState,UINT nStateMask, LPARAM lParam=0);
	COLORREF	GetItemBkColorEx	(HTREEITEM hItem,int nCol=0) const;
	COLORREF	SetItemBkColorEx	(HTREEITEM hItem,int nCol,COLORREF uColor);
	COLORREF	GetItemTextColorEx	(HTREEITEM hItem,int nCol=0) const;
	COLORREF	SetItemTextColorEx	(HTREEITEM hItem,int nCol,COLORREF uColor);
	UINT 		GetItemStateEx  	(HTREEITEM hItem,         UINT nStateMask);
	BOOL		SetItemStateEx  	(HTREEITEM hItem,         UINT nState,UINT nStateMask);
	UINT 		GetItemStateEx  	(HTREEITEM hItem,         UINT nStateMask   ,int nCol,UINT uFlags=0);
	BOOL		SetItemStateEx  	(HTREEITEM hItem,int nCol,UINT nState,UINT nStateMask,UINT uFlags=0);
	BOOL 		GetItemImageEx     	(HTREEITEM hItem, int &nImage,int &nSelectedImage);
	BOOL		SetItemImageEx		(HTREEITEM hItem ,int  nImage,int  nSelectedImage);
	BOOL		GetItemTextEx	 	(HTREEITEM hItem,LPTSTR pBuffer,int iMax,int nCol=0);
	LPCTSTR		GetItemTextEx	 	(HTREEITEM hItem,                        int nCol=0);
	BOOL		SetItemTextEx	 	(HTREEITEM hItem,LPCTSTR pText,int nCol=0);
	BOOL		SetItemDataEx		(HTREEITEM hItem,DWORD_PTR lParam);
	DWORD_PTR	GetItemDataEx		(HTREEITEM hItem) const;
	BOOL		SetItemDataPtrEx	(HTREEITEM hItem,LPCTSTR pParam);
	LPCTSTR		GetItemDataPtrEx	(HTREEITEM hItem) const;
	BOOL		GetItemEx			(TV_ITEM  *pItem);
	BOOL		SetItemEx	 		(TV_ITEM  *pItem);
	BOOL		SetItemEx			(HTREEITEM hItem,int nCol,UINT nMask,LPCTSTR pText,int nImage,int nSelectedImage,UINT nState,UINT nStateMask, LPARAM lParam=0);
	BOOL		SelectItemEx		(HTREEITEM hItem,int nCol= 0);
	BOOL		GetCheckEx			(HTREEITEM hItem,           int nCol=0);
	BOOL		SetCheckEx			(HTREEITEM hItem,BOOL bOn=1,int nCol=0);
	INT 		IsItemVisibleEx		(HTREEITEM hItem,int nCol=-1);
	INT			ExpandEx			(HTREEITEM hItem,UINT uCode);
	BOOL		ExpandAllEx		    (HTREEITEM hItem,UINT uCode);
	HTREEITEM	EnumItemsEx   	 	(HTREEITEM hLast=TVI_ROOT);
	HTREEITEM	GetItemOfRowEx      (INT       iRow ) const;
	INT			GetItemLevelEx		(HTREEITEM hItem) const;
	INT			GetRowOfItemEx      (HTREEITEM hItem) const;
	LPVOID		GetUserDataEx	 	(HTREEITEM hItem) const;
	HTREEITEM	GetRootItemEx 	 	() const;
	INT			GetFocusColumnEx	();

	BOOL 		DeleteItemEx		(HTREEITEM hItem);
	BOOL 		DeleteChildItemsEx	(HTREEITEM hItem);
	BOOL 		DeleteAllUnfixedEx	();
	BOOL 		DeleteAllItemsEx	();

	HTREEITEM	GetNextItemEx   	(HTREEITEM hItem,UINT nCode=TVGN_NEXT);
	HTREEITEM	GetChildItemEx  	(HTREEITEM hItem);
	HTREEITEM	GetLastChildEx  	(HTREEITEM hItem);
	HTREEITEM	GetParentItemEx		(HTREEITEM hItem);
	HTREEITEM	GetNextSelectedEx	(HTREEITEM hItem);
	HTREEITEM	GetNextSelectedChildEx(HTREEITEM hItem);
	HTREEITEM	GetNextSiblingItemEx(HTREEITEM hItem);
	HTREEITEM	GetPrevSiblingItemEx(HTREEITEM hItem);
	HTREEITEM	GetPrevVisibleItemEx(HTREEITEM hItem);
	HTREEITEM	GetNextVisibleItemEx(HTREEITEM hItem);
	HTREEITEM	GetFirstVisibleItemEx();
	HTREEITEM	GetFirstNoneFixedEx ();
	HTREEITEM	GetFirstSelectedEx	();
	HTREEITEM	GetSelectedItemEx   ();
	HTREEITEM	GetFirstItemEx		();
	HTREEITEM	GetFocusItemEx		();
	WNDPROC		GetWindowProc       ();

protected:

	static		WNDPROC		m_pWndProc;						// Fenster Funktion

};


//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************

inline	WNDPROC		CTreeListCtrlEx::GetWindowProc      (){return m_pWndProc;}
inline	BOOL		CTreeListCtrlEx::Create				(DWORD dwStyle,const RECT &R,CWnd *pWnd,UINT nId)  { return CreateEx(0,dwStyle,R    ,pWnd,nId);}
inline	BOOL		CTreeListCtrlEx::Create				(DWORD dwStyle,UINT uItem,CDialog *pDlg,UINT nId)  { return CreateEx(0,dwStyle,uItem,pDlg,nId);}

inline	HTREEITEM	CTreeListCtrlEx::FindItemEx  		(HTREEITEM hItem,LPCTSTR pText,int nCol,int iCase) { return FindItemEx(hItem,(iCase)? TVIF_CHILDS|TVIF_TEXT|TVIF_CASE:TVIF_CHILDS|TVIF_TEXT,nCol,pText);}
inline	HTREEITEM	CTreeListCtrlEx::FindItemEx  		(HTREEITEM hItem,LPARAM  lParam                 )  { return FindItemEx(hItem,         TVIF_CHILDS|TVIF_PARAM                               ,0,0,lParam);}
inline	HTREEITEM	CTreeListCtrlEx::FindItemEx  		(HTREEITEM hItem,      TVFIND *pFind            )  { ASSERT(::IsWindow(m_hWnd)); return (HTREEITEM)m_pWndProc(m_hWnd,TVM_FINDITEM ,(WPARAM)hItem,(LPARAM)pFind);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPTVINSERTSTRUCT pInsert						)  { ASSERT(::IsWindow(m_hWnd)); pInsert->item.mask|=TVIF_REMOTE;return (HTREEITEM)m_pWndProc(m_hWnd,TVM_INSERTITEM,0,(LPARAM)pInsert);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,int S,HTREEITEM   P,HTREEITEM A)  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE           ,I,M,S,0,0,0,P,A);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,int S,TLC_SORT_PARAMS1         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM,I,M,S,0,0,L,P,A);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,int S,TLC_SORT_PARAMS2         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM,I,M,S,0,0,L,O,P);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,int S,TLC_SORT_PARAMS3         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE           ,I,M,S,0,0,(LPARAM)O,InsertCmp,P);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,int S,TLC_SORT_PARAMS4         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM,I,M,S,0,0,L,O,P,B);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,int S,TLC_SORT_PARAMS5         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM,I,M,S,0,0,L,O,P);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,      HTREEITEM   P,HTREEITEM A)  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE           ,I,M,M,0,0,0,P,A);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,      TLC_SORT_PARAMS1         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM,I,M,M,0,0,L,P,A);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,      TLC_SORT_PARAMS2         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM,I,M,M,0,0,L,O,P);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,      TLC_SORT_PARAMS3         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE           ,I,M,M,0,0,(LPARAM)O,InsertCmp,P);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,      TLC_SORT_PARAMS4         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM,I,M,M,0,0,L,O,P,B);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,int M,      TLC_SORT_PARAMS5         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_PARAM,I,M,M,0,0,L,O,P);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,            HTREEITEM   P,HTREEITEM A)  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT                                         ,I,0,0,0,0,0,P,A);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,            TLC_SORT_PARAMS1         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT                              |TVIF_PARAM,I,0,0,0,0,L,P,A);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,            TLC_SORT_PARAMS2         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT                              |TVIF_PARAM,I,0,0,0,0,L,O,P);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,            TLC_SORT_PARAMS3         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT                                         ,I,0,0,0,0,(LPARAM)O,InsertCmp,P);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,            TLC_SORT_PARAMS4         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT                              |TVIF_PARAM,I,0,0,0,0,L,O,P,B);}
inline	HTREEITEM	CTreeListCtrlEx::InsertItemEx		(LPCTSTR I,            TLC_SORT_PARAMS5         )  { ASSERT(::IsWindow(m_hWnd)); return InsertItemEx(TVIF_TEXT                              |TVIF_PARAM,I,0,0,0,0,L,O,P);}
inline	COLORREF	CTreeListCtrlEx::SetItemBkColorEx	(HTREEITEM hItem,int nCol,COLORREF uColor       )  { ASSERT(::IsWindow(m_hWnd)); TV_ITEMCOLOR sData;sData.uColor=uColor;sData.bColumn=(BYTE)nCol;sData.bMode=2;return (BOOL)m_pWndProc(m_hWnd,TVM_SETITEMCOLOR    ,(WPARAM)hItem,(LPARAM)&sData);}
inline	COLORREF	CTreeListCtrlEx::GetItemBkColorEx	(HTREEITEM hItem,int nCol                 ) const  { ASSERT(::IsWindow(m_hWnd));                                                                               return (BOOL)m_pWndProc(m_hWnd,TVM_GETITEMBKCOLOR  ,(WPARAM)hItem,         nCol );}
inline	COLORREF	CTreeListCtrlEx::SetItemTextColorEx	(HTREEITEM hItem,int nCol,COLORREF uColor       )  { ASSERT(::IsWindow(m_hWnd)); TV_ITEMCOLOR sData;sData.uColor=uColor;sData.bColumn=(BYTE)nCol;sData.bMode=3;return (BOOL)m_pWndProc(m_hWnd,TVM_SETITEMCOLOR    ,(WPARAM)hItem,(LPARAM)&sData);}
inline	COLORREF	CTreeListCtrlEx::GetItemTextColorEx	(HTREEITEM hItem,int nCol                 ) const  { ASSERT(::IsWindow(m_hWnd));                                                                               return (BOOL)m_pWndProc(m_hWnd,TVM_GETITEMTEXTCOLOR,(WPARAM)hItem,         nCol );}
inline	BOOL		CTreeListCtrlEx::SetItemImageEx		(HTREEITEM hItem,int  nImage,int  nSelectedImage)  { ASSERT(::IsWindow(m_hWnd)); TV_ITEM sItem;sItem.mask=TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_REMOTE;sItem.hItem=hItem;sItem.iImage=nImage;sItem.iSelectedImage=nSelectedImage;return (BOOL)m_pWndProc(m_hWnd,TVM_SETITEM,0,(LPARAM)&sItem);}
inline	BOOL 		CTreeListCtrlEx::GetItemImageEx     (HTREEITEM hItem,int &nImage,int &nSelectedImage)  { ASSERT(::IsWindow(m_hWnd)); TV_ITEM sItem;sItem.mask=TVIF_IMAGE|TVIF_SELECTEDIMAGE            ;sItem.hItem=hItem;BOOL bRet;bRet = (BOOL)m_pWndProc(m_hWnd,TVM_GETITEM,0,(LPARAM)&sItem);if (bRet){nImage=sItem.iImage;nSelectedImage=sItem.iSelectedImage;}return bRet;}
inline	BOOL		CTreeListCtrlEx::SetItemStateEx		(HTREEITEM hItem,         UINT uState,UINT uMask)  { ASSERT(::IsWindow(m_hWnd)); TV_ITEM sItem;sItem.mask=TVIF_STATE|TVIF_REMOTE             ;sItem.hItem=hItem;sItem.stateMask=uMask;                     sItem.state=uState;return (BOOL)m_pWndProc(m_hWnd,TVM_SETITEM,0,(LPARAM)&sItem);                         }
inline	UINT		CTreeListCtrlEx::GetItemStateEx		(HTREEITEM hItem,                     UINT uMask)  { ASSERT(::IsWindow(m_hWnd)); TV_ITEM sItem;sItem.mask=TVIF_STATE                         ;sItem.hItem=hItem;sItem.stateMask=uMask;                     sItem.state=0;			       m_pWndProc(m_hWnd,TVM_GETITEM,0,(LPARAM)&sItem);return (UINT)sItem.state;}
inline	BOOL		CTreeListCtrlEx::SetItemStateEx		(HTREEITEM hItem,int iCol,UINT S,UINT M,UINT F  )  { ASSERT(::IsWindow(m_hWnd)); TV_ITEM sItem;sItem.mask=TVIF_STATE|TVIF_SUBITEM|TVIF_REMOTE|(F&TVIF_STATESUB);sItem.hItem=hItem;sItem.stateMask= M   ;sItem.cChildren=iCol;sItem.state=S;return (BOOL)m_pWndProc(m_hWnd,TVM_SETITEM,0,(LPARAM)&sItem);                         }
inline	UINT		CTreeListCtrlEx::GetItemStateEx		(HTREEITEM hItem,UINT uMask,int iCol,UINT uFlags)  { ASSERT(::IsWindow(m_hWnd)); TV_ITEM sItem;sItem.mask=TVIF_STATE|TVIF_SUBITEM       |(uFlags&TVIF_STATESUB);sItem.hItem=hItem;sItem.stateMask=uMask;sItem.cChildren=iCol;sItem.state=0; 		    m_pWndProc(m_hWnd,TVM_GETITEM,0,(LPARAM)&sItem);return (UINT)sItem.state;}
inline	BOOL		CTreeListCtrlEx::SetItemTextEx		(HTREEITEM hItem,LPCTSTR pText,int nCol         )  { ASSERT(::IsWindow(m_hWnd)); TV_ITEM sItem;sItem.mask=TVIF_SUBITEM|TVIF_TEXT|TVIF_REMOTE ;sItem.hItem=hItem;sItem.cChildren=nCol;sItem.pszText=(LPTSTR)pText;sItem.cchTextMax=(pText)? 256:0;return (BOOL)m_pWndProc(m_hWnd,TVM_SETITEM,0,(LPARAM)&sItem);}
inline	BOOL		CTreeListCtrlEx::GetItemTextEx 		(HTREEITEM hItem,LPTSTR  pText,int iMax,int nCol)  { ASSERT(::IsWindow(m_hWnd)); TV_ITEM sItem;sItem.mask=TVIF_SUBITEM|TVIF_TEXT             ;sItem.hItem=hItem;sItem.cChildren=nCol;sItem.pszText=pText;sItem.cchTextMax=iMax;return m_pWndProc(m_hWnd,TVM_GETITEM,0,(LPARAM)&sItem);}
inline	LPCTSTR		CTreeListCtrlEx::GetItemTextEx 		(HTREEITEM hItem		      ,int nCol         )  { ASSERT(::IsWindow(m_hWnd)); TV_ITEM sItem;sItem.mask=TVIF_SUBITEM|TVIF_TEXT|TVIF_TEXTPTR;sItem.hItem=hItem;sItem.cChildren=nCol;sItem.pszText=0;m_pWndProc(m_hWnd,TVM_GETITEM,0,(LPARAM)&sItem);return (LPCTSTR)sItem.pszText;}
inline	BOOL		CTreeListCtrlEx::SetItemDataEx		(HTREEITEM hItem,DWORD_PTR lParam				)  { ASSERT(::IsWindow(m_hWnd)); return (BOOL     )m_pWndProc(m_hWnd,TVM_SETITEMDATA,lParam        ,(LPARAM)hItem); }
inline	BOOL		CTreeListCtrlEx::SetItemDataPtrEx	(HTREEITEM hItem,LPCTSTR pParam                 )  { ASSERT(::IsWindow(m_hWnd)); return (BOOL     )m_pWndProc(m_hWnd,TVM_SETITEMDATA,(LPARAM)pParam,(LPARAM)hItem); }
inline	BOOL		CTreeListCtrlEx::GetCheckEx         (HTREEITEM hItem,         int nCol              )  { ASSERT(::IsWindow(m_hWnd)); return GetItemStateEx(hItem,TVIS_STATEIMAGEMASK,nCol)>>13;}
inline	BOOL		CTreeListCtrlEx::SetCheckEx			(HTREEITEM hItem,BOOL bOn,int nCol				)  { ASSERT(::IsWindow(m_hWnd)); return SetItemStateEx(hItem,nCol,(bOn)? 2<<12:1<<12,TVIS_STATEIMAGEMASK);}
inline	BOOL 		CTreeListCtrlEx::DeleteChildItemsEx	(HTREEITEM hItem                                )  { ASSERT(::IsWindow(m_hWnd)); return (BOOL)m_pWndProc(m_hWnd,TVM_DELETEITEM,0x8A,(LPARAM)hItem);}
inline	BOOL 		CTreeListCtrlEx::DeleteAllItemsEx	(                                               )  { ASSERT(::IsWindow(m_hWnd)); return (BOOL)m_pWndProc(m_hWnd,TVM_DELETEITEM,0x89,(LPARAM)TVI_ROOT);}
inline	BOOL 		CTreeListCtrlEx::DeleteAllUnfixedEx	(                                               )  { ASSERT(::IsWindow(m_hWnd)); return (BOOL)m_pWndProc(m_hWnd,TVM_DELETEITEM,0x89,(LPARAM)TVI_UNFIXED);}
inline	BOOL 		CTreeListCtrlEx::DeleteItemEx		(HTREEITEM hItem                                )  { ASSERT(::IsWindow(m_hWnd)); return (BOOL)m_pWndProc(m_hWnd,TVM_DELETEITEM,0x89,(LPARAM)hItem);}
inline	INT			CTreeListCtrlEx::SetMultiItemsEx	(TV_ITEM  *pItem                                )  { ASSERT(::IsWindow(m_hWnd)); pItem->mask|=TVIF_REMOTE; return (INT) m_pWndProc(m_hWnd,TVM_SETMULTIITEMS,0,(LPARAM)pItem);}
inline	BOOL		CTreeListCtrlEx::GetItemEx		    (TV_ITEM  *pItem                                )  { ASSERT(::IsWindow(m_hWnd)); pItem->mask|=TVIF_REMOTE; return (BOOL)m_pWndProc(m_hWnd,TVM_GETITEM      ,0,(LPARAM)pItem);}
inline	BOOL		CTreeListCtrlEx::SetItemEx			(HTREEITEM hItem,int C,UINT M,LPCTSTR T,int I,int S,UINT A,UINT N,LPARAM P){ASSERT(::IsWindow(m_hWnd));TV_ITEM sItem;sItem.mask=M|TVIF_REMOTE|TVIF_SUBITEM;sItem.hItem=hItem;sItem.state=A;sItem.stateMask=N;sItem.pszText=(LPTSTR)T;sItem.cchTextMax=(T)? 256:0;sItem.iImage=I;sItem.iSelectedImage=S;sItem.cChildren=C;sItem.lParam=P;return (BOOL)m_pWndProc(m_hWnd,TVM_SETITEM,0,(LPARAM)&sItem);}
inline	BOOL		CTreeListCtrlEx::SetItemEx			(TV_ITEM  *pItem								)  { ASSERT(::IsWindow(m_hWnd)); pItem->mask|=TVIF_REMOTE; return (BOOL)m_pWndProc(m_hWnd,TVM_SETITEM,0,(LPARAM)pItem);}
inline	HTREEITEM	CTreeListCtrlEx::GetNextItemEx      (HTREEITEM hItem,UINT nCode                     )  { ASSERT(::IsWindow(m_hWnd)); return (HTREEITEM)m_pWndProc(m_hWnd,TVM_GETNEXTITEM,nCode,(LPARAM)hItem); }
inline	BOOL		CTreeListCtrlEx::SelectItemEx		(HTREEITEM hItem,int  nCol                      )  { ASSERT(::IsWindow(m_hWnd)); return SetItemStateEx(hItem,TVIS_SELECTED,TVIS_SELECTED);}
inline	INT			CTreeListCtrlEx::GetItemLevelEx		(HTREEITEM hItem						  ) const  { ASSERT(::IsWindow(m_hWnd)); return (INT      )m_pWndProc(m_hWnd,TVM_GETNEXTITEM,TVGN_GETLEVEL,(LPARAM)hItem);}
inline	INT 		CTreeListCtrlEx::IsItemVisibleEx    (HTREEITEM hItem,int  nCol						)  { ASSERT(::IsWindow(m_hWnd)); return (INT      )m_pWndProc(m_hWnd,TVM_ISITEMVISIBLE,nCol,(LPARAM)hItem);}
inline	INT			CTreeListCtrlEx::ExpandEx			(HTREEITEM hItem,UINT uCode						)  { ASSERT(::IsWindow(m_hWnd)); return (BOOL     )m_pWndProc(m_hWnd,TVM_EXPAND,uCode|TVE_REMOTE,(LPARAM)hItem);}
inline	BOOL		CTreeListCtrlEx::ExpandAllEx        (HTREEITEM hItem,UINT uCode						)  { ASSERT(::IsWindow(m_hWnd)); return (BOOL     )m_pWndProc(m_hWnd,TVM_EXPAND,uCode|TVE_REMOTE|TVE_EXPAND|TVE_EXPANDRECURSIVE,(LPARAM)hItem); }
inline	HTREEITEM	CTreeListCtrlEx::EnumItemsEx		(HTREEITEM hLast                                )  { ASSERT(::IsWindow(m_hWnd)); return (HTREEITEM)m_pWndProc(m_hWnd,TVM_GETNEXTITEM,TVGN_ENUM,(LPARAM)hLast);}
inline  HTREEITEM	CTreeListCtrlEx::GetItemOfRowEx     (INT       iRow                           ) const  { ASSERT(::IsWindow(m_hWnd)); return (HTREEITEM)m_pWndProc(m_hWnd,TVM_GETITEMOFROW,0,(LPARAM)iRow );}
inline  INT			CTreeListCtrlEx::GetRowOfItemEx     (HTREEITEM hItem                          ) const  { ASSERT(::IsWindow(m_hWnd)); return (int      )m_pWndProc(m_hWnd,TVM_GETROWOFITEM,0,(LPARAM)hItem);}
inline	LPVOID		CTreeListCtrlEx::GetUserDataEx      (HTREEITEM hItem                          ) const  { ASSERT(::IsWindow(m_hWnd)); return (LPVOID   )m_pWndProc(m_hWnd,TVM_GETUSERDATA ,0,(LPARAM)hItem);}
inline	HTREEITEM	CTreeListCtrlEx::GetRootItemEx 	 	(                                         ) const  { ASSERT(::IsWindow(m_hWnd)); return (HTREEITEM)m_pWndProc(m_hWnd,TVM_GETNEXTITEM,TVGN_ROOT,0); }
inline	DWORD_PTR	CTreeListCtrlEx::GetItemDataEx		(HTREEITEM hItem						  ) const  { ASSERT(::IsWindow(m_hWnd)); return (DWORD_PTR)m_pWndProc(m_hWnd,TVM_GETITEMDATA,0             ,(LPARAM)hItem); }
inline	LPCTSTR		CTreeListCtrlEx::GetItemDataPtrEx	(HTREEITEM hItem                          ) const  { ASSERT(::IsWindow(m_hWnd)); return (LPCTSTR  )m_pWndProc(m_hWnd,TVM_GETITEMDATA,0             ,(LPARAM)hItem); }
inline	INT			CTreeListCtrlEx::GetFocusColumnEx		(											)  { return (INT)GetNextItemEx(NULL,TVGN_FOCUSSUB);}
inline	HTREEITEM	CTreeListCtrlEx::GetFirstItemEx		    (                                           )  { return GetNextItemEx(TVI_ROOT,TVGN_CHILD);}
inline	HTREEITEM	CTreeListCtrlEx::GetFirstSelectedEx	    (                                           )  { return GetNextItemEx(TVI_ROOT,TVGN_NEXTSELECTED);}
inline	HTREEITEM	CTreeListCtrlEx::GetSelectedItemEx	    (                                           )  { return GetNextItemEx(NULL    ,TVGN_CARET);}
inline	HTREEITEM	CTreeListCtrlEx::GetFocusItemEx		    (                                           )  { return GetNextItemEx(NULL    ,TVGN_FOCUS);}
inline	HTREEITEM	CTreeListCtrlEx::GetFirstNoneFixedEx    (											)  { return GetNextItemEx(NULL    ,TVGN_FIRSTNONEFIXED);}
inline	HTREEITEM	CTreeListCtrlEx::GetFirstVisibleItemEx	(											)  { return GetNextItemEx(NULL    ,TVGN_FIRSTVISIBLE);}
inline	HTREEITEM	CTreeListCtrlEx::GetNextSelectedEx		(HTREEITEM hItem							)  { return GetNextItemEx(hItem   ,TVGN_NEXTSELECTED);}
inline	HTREEITEM	CTreeListCtrlEx::GetNextSelectedChildEx	(HTREEITEM hItem							)  { return GetNextItemEx(hItem   ,TVGN_NEXTSELCHILD);}
inline	HTREEITEM	CTreeListCtrlEx::GetChildItemEx  		(HTREEITEM hItem							)  { return GetNextItemEx(hItem   ,TVGN_CHILD);}
inline	HTREEITEM	CTreeListCtrlEx::GetLastChildEx			(HTREEITEM hItem							)  { return GetNextItemEx(hItem   ,TVGN_LASTCHILD);}
inline	HTREEITEM	CTreeListCtrlEx::GetNextSiblingItemEx	(HTREEITEM hItem							)  { return GetNextItemEx(hItem   ,TVGN_NEXT);}
inline	HTREEITEM	CTreeListCtrlEx::GetPrevSiblingItemEx	(HTREEITEM hItem							)  { return GetNextItemEx(hItem   ,TVGN_PREVIOUS);}
inline	HTREEITEM	CTreeListCtrlEx::GetNextVisibleItemEx	(HTREEITEM hItem							)  { return GetNextItemEx(hItem   ,TVGN_NEXTVISIBLE);}
inline	HTREEITEM	CTreeListCtrlEx::GetPrevVisibleItemEx	(HTREEITEM hItem							)  { return GetNextItemEx(hItem   ,TVGN_PREVIOUSVISIBLE);}
inline	HTREEITEM	CTreeListCtrlEx::GetParentItemEx		(HTREEITEM hItem                            )  { return GetNextItemEx(hItem   ,TVGN_PARENT);}


//{{AFX_INSERT_LOCATION}}

#endif
