//*****************************************************************************
//*
//*
//*		AnsiDlg.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2009
//
#include  	<string.h>
#include  	<afxext.h>
#include	"../AfxUtility.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#ifndef		USE_RC

#ifdef		IDC_FONTVIEW
#undef		IDC_FONTVIEW
#endif
#ifdef		IDC_LISTBOX
#undef  	IDC_LISTBOX
#endif
#ifdef		IDC_LIST1
#undef  	IDC_LIST1
#endif
#ifdef		IDC_LIST2
#undef  	IDC_LIST2
#endif
#ifdef		IDC_EDIT1
#undef 		IDC_EDIT1
#endif
#ifdef		IDC_EDIT2
#undef  	IDC_EDIT2
#endif
#ifdef		IDC_EDIT3
#undef  	IDC_EDIT3
#endif
#ifdef		IDC_EDIT4
#undef  	IDC_EDIT4
#endif
#ifdef		IDC_RADIO1
#undef 		IDC_RADIO1
#endif
#ifdef		IDC_RADIO2
#undef 		IDC_RADIO2
#endif
#ifdef		IDC_RADIO3
#undef 		IDC_RADIO3
#endif
#ifdef		IDC_CHECK1
#undef  	IDC_CHECK1
#endif
#ifdef		IDC_CHECK2
#undef  	IDC_CHECK2
#endif
#ifdef		IDC_CHECK3
#undef  	IDC_CHECK3
#endif
#ifdef		IDC_CHECK4
#undef 		IDC_CHECK4
#endif
#ifdef		IDC_BUTTON1
#undef  	IDC_BUTTON1
#endif
#ifdef		IDC_BUTTON2
#undef  	IDC_BUTTON2
#endif
#ifdef		IDC_MARGIN_TOP
#undef  	IDC_MARGIN_TOP
#endif
#ifdef		IDC_MARGIN_LEFT
#undef  	IDC_MARGIN_LEFT
#endif
#ifdef		IDC_MARGIN_RIGHT
#undef  	IDC_MARGIN_RIGHT
#endif
#ifdef		IDC_MARGIN_BOTTOM
#undef  	IDC_MARGIN_BOTTOM
#endif
#ifdef		IDD_ANSI_COLORDLG
#undef  	IDD_ANSI_COLORDLG
#endif
#ifdef		IDD_ANSI_PRINTDLG
#undef  	IDD_ANSI_PRINTDLG
#endif


#define		IDC_FONTVIEW			1025
#define 	IDC_LISTBOX             1028
#define 	IDC_LIST1		        1052
#define 	IDC_LIST2	            1053
#define		IDC_EDIT1               1040
#define 	IDC_EDIT2               1048
#define 	IDC_EDIT3               1050
#define 	IDC_EDIT4               1041
#define		IDC_RADIO1              1034
#define		IDC_RADIO2              1035
#define		IDC_RADIO3              1047
#define 	IDC_CHECK1              1030
#define 	IDC_CHECK2              1031
#define 	IDC_CHECK3              1032
#define		IDC_CHECK4              1033
#define 	IDC_BUTTON1				1037
#define 	IDC_BUTTON2				1049
#define 	IDC_MARGIN_TOP          1043
#define 	IDC_MARGIN_LEFT         1045
#define 	IDC_MARGIN_RIGHT        1046
#define 	IDC_MARGIN_BOTTOM       1044
#define 	IDD_ANSI_COLORDLG		0
#define 	IDD_ANSI_PRINTDLG		0

#endif

#ifndef		IDD_FILENAME
#define 	IDD_FILENAME			2000
#endif
#ifndef		IDD_FILEPATH
#define 	IDD_FILEPATH			2001
#endif
#ifndef		IDD_USERNAME
#define 	IDD_USERNAME			2002
#endif
#ifndef		IDD_PAGENUMBER
#define 	IDD_PAGENUMBER			2003
#endif
#ifndef		IDD_PAGECOUNT
#define 	IDD_PAGECOUNT			2004
#endif
#ifndef		IDD_DATE
#define 	IDD_DATE				2005
#endif
#ifndef		IDD_TIME
#define 	IDD_TIME				2006
#endif
#ifndef		IDD_NEWLINE
#define 	IDD_NEWLINE				2007
#endif
#ifndef		IDD_LEFT
#define 	IDD_LEFT				2008
#endif
#ifndef		IDD_RIGHT
#define 	IDD_RIGHT				2009
#endif
#ifndef		IDD_CENTER
#define 	IDD_CENTER				2010
#endif


BEGIN_MESSAGE_MAP  (CAnsiColorDlg, CDialog)
	//{{AFX_MSG_MAP(CAnsiColorDlg)
	ON_WM_PAINT()
	ON_WM_DRAWITEM()
	ON_BN_CLICKED(IDC_CHECK1	, OnBold)
	ON_BN_CLICKED(IDC_CHECK2	, OnItalic)
	ON_BN_CLICKED(IDC_CHECK3	, OnUnterLine)
	ON_BN_CLICKED(IDC_CHECK4	, OnFormat)
	ON_BN_CLICKED(IDC_BUTTON1	, OnUserBk)
	ON_BN_CLICKED(IDC_BUTTON2	, OnUserText)
	ON_LBN_SELCHANGE(IDC_LIST1  , OnSelColor1)
	ON_LBN_SELCHANGE(IDC_LIST2  , OnSelColor2)
	ON_LBN_SELCHANGE(IDC_LISTBOX, OnSelChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP  (CAnsiPrintDlg, CDialog)
	//{{AFX_MSG_MAP(CAnsiPrintDlg)
	ON_WM_DESTROY   ()
	ON_BN_CLICKED   (IDOK			 ,OnOk)
	ON_BN_CLICKED	(IDC_BUTTON1	 ,OnSelect1)
	ON_BN_CLICKED	(IDC_BUTTON2	 ,OnSelect2)
	ON_COMMAND      (IDD_CENTER  	 ,OnMenu0)
	ON_COMMAND      (IDD_PAGENUMBER  ,OnMenu1)
	ON_COMMAND      (IDD_FILENAME	 ,OnMenu2)
	ON_COMMAND      (IDD_FILEPATH    ,OnMenu3)
	ON_COMMAND      (IDD_DATE        ,OnMenu4)
	ON_COMMAND      (IDD_TIME        ,OnMenu5)
	ON_COMMAND      (IDD_LEFT        ,OnMenu6)
	ON_COMMAND      (IDD_RIGHT       ,OnMenu7)
	ON_COMMAND      (IDD_USERNAME	 ,OnMenu8)
	ON_COMMAND      (IDD_NEWLINE  	 ,OnMenu9)
	ON_COMMAND      (IDD_PAGECOUNT	 ,OnMenuA)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


const COLORREF aDefColors[9*7]=								// Standardfarben
	{
	0xFFFFFFFF,0x00400020,0x00400040,0x00000040,0x00002040,0x00004040,0x00004000,0x00404000,0x00400000,
	0x00000000,0x00800040,0x00800080,0x00000080,0x00004080,0x00008080,0x00008000,0x00808000,0x00800000,
	0x00343434,0x00C00060,0x00C000C0,0x000000C0,0x000060C0,0x0000C0C0,0x0000C000,0x00C0C000,0x00C00000,
	0x00676767,0x00FF0080,0x00FF00FF,0x000000FF,0x000080FF,0x0000FFFF,0x0000FF00,0x00FFFF00,0x00FF0000,
	0x009A9A9A,0x00FF40A0,0x00FF40FF,0x004040FF,0x0040A0FF,0x0040FFFF,0x0040FF40,0x00FFFF40,0x00FF4040,
	0x00CDCDCD,0x00FF80C0,0x00FF80FF,0x008080FF,0x0080C0FF,0x0080FFFF,0x0080FF80,0x00FFFF80,0x00FF8080,
	0x00FFFFFF,0x00FFC0E0,0x00FFC0FF,0x00C0C0FF,0x00C0EFFF,0x00C0FFFF,0x00C0FFC0,0x00FFFFC0,0x00FFC0C0,
	};

WORD CAnsiPrintDlg::m_wDlgIcon[]=
	{
	0x0028,0x0000,0x0010,0x0000,0x000E,0x0000,0x0001,0x0004,0x0000,0x0000,0x0070,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0080,0x8000,0x0000,0x8000,0x0080,0x0080,0x0000,0x0080,0x0080,
	0x8080,0x0000,0xC0C0,0x00C0,0x8080,0x0080,0x0000,0x00FF,0xFF00,0x0000,0xFF00,0x00FF,0x00FF,0x0000,0x00FF,0x00FF,
	0xFFFF,0x0000,0xFFFF,0x00FF,0x7777,0x7777,0x7777,0x7777,0x7777,0x7777,0x7F77,0x77FF,0x7777,0x7777,0x74FF,0x778F,
	0x7777,0xFF77,0x748F,0x778F,0x7777,0x88FF,0x748F,0x778F,0xFF77,0x8888,0x748F,0x778F,0x887F,0x8888,0x748F,0x778F,
	0x8874,0x8888,0x748F,0x778F,0x4477,0x8888,0x748F,0x778F,0x7777,0x8844,0x748F,0x778F,0x7777,0x4477,0x748F,0x778F,
	0x7777,0x7777,0x744F,0x778F,0x7777,0x7777,0x7477,0x7744,0x7777,0x7777,0x7777,0x7777,
	};


#ifndef		USE_RC

WORD CAnsiColorDlg::m_wDlgData[]=
	{
	0x0001,0xFFFF,0x0000,0x0000,0x0000,0x0000,0x00C0,0x80C8,0x000E,0x0000,0x0000,0x00F7,0x0112,0x0000,0x0000,0x0046,
	0x0061,0x0072,0x0062,0x0065,0x006E,0x0020,0x0065,0x0069,0x006E,0x0073,0x0074,0x0065,0x006C,0x006C,0x0065,0x006E,
	0x0000,0x0008,0x0000,0x0100,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,
	0x0066,0x0000,0x0000,0x0000,0x0000,0x0000,0x0001,0x5001,0x0082,0x000A,0x0032,0x000E,0x0001,0x0000,0xFFFF,0x0080,
	0x004F,0x004B,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x5001,0x00BE,0x000A,0x0032,0x000E,0x0002,0x0000,
	0xFFFF,0x0080,0x0041,0x0062,0x0062,0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0103,0x50A1,0x000A,0x000A,0x006E,0x0064,0x0404,0x0000,0xFFFF,0x0083,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0003,0x5001,0x0087,0x0020,0x001C,0x000A,0x0406,0x0000,0xFFFF,0x0080,0x0046,0x0065,0x0074,0x0074,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0003,0x5001,0x0087,0x002B,0x0023,0x000A,0x0407,0x0000,0xFFFF,0x0080,
	0x004B,0x0075,0x0072,0x0073,0x0069,0x0076,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0003,0x5001,0x0087,0x0036,
	0x003E,0x000A,0x0408,0x0000,0xFFFF,0x0080,0x0055,0x006E,0x0074,0x0065,0x0072,0x0073,0x0074,0x0072,0x0065,0x0069,
	0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0003,0x5001,0x0087,0x0069,0x0057,0x000A,
	0x0409,0x0000,0xFFFF,0x0080,0x004E,0x0075,0x0072,0x0020,0x0066,0x00FC,0x0072,0x0020,0x0061,0x006B,0x0074,0x0065,
	0x006C,0x006C,0x0065,0x0073,0x0020,0x0046,0x006F,0x0072,0x006D,0x0061,0x0074,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0311,0x5091,0x0014,0x0087,0x0058,0x0069,0x041C,0x0000,0xFFFF,0x0083,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x5001,0x0019,0x00F5,0x004B,0x000F,0x040D,0x0000,0xFFFF,0x0080,0x0046,0x0061,0x0072,0x0062,
	0x0065,0x0020,0x0064,0x0065,0x0066,0x0069,0x0065,0x006E,0x0069,0x0065,0x0072,0x0065,0x006E,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0311,0x5091,0x008C,0x0087,0x0058,0x0069,0x041D,0x0000,0xFFFF,0x0083,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x5001,0x0091,0x00F5,0x004B,0x000F,0x0419,0x0000,0xFFFF,0x0080,0x0046,0x0061,
	0x0072,0x0062,0x0065,0x0020,0x0064,0x0065,0x0066,0x0069,0x006E,0x0069,0x0065,0x0072,0x0065,0x006E,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0007,0x5000,0x000A,0x0078,0x006E,0x0091,0x0402,0x0000,0xFFFF,0x0080,0x0048,0x0069,
	0x006E,0x0074,0x0065,0x0072,0x0067,0x0072,0x0075,0x006E,0x0064,0x0066,0x0061,0x0072,0x0062,0x0065,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0007,0x5000,0x0082,0x0078,0x006E,0x0091,0x0403,0x0000,0xFFFF,0x0080,0x0054,0x0065,
	0x0078,0x0074,0x0066,0x0061,0x0072,0x0062,0x0065,0x0000,0x0000,0x0000,0x0000,0x0000,0x0020,0x0002,0x1006,0x5080,
	0x0082,0x0045,0x006E,0x001F,0x0401,0x0000,0xFFFF,0x0082,0x0000,0x0000,
	};

WORD CAnsiPrintDlg::m_wDlgData[]=
	{
	0x00C0,0x80C8,0x0000,0x0000,0x001B,0x0000,0x0000,0x0106,0x008D,0x0000,0x0000,0x0053,0x0065,0x0069,0x0074,0x0065,
	0x0020,0x0065,0x0069,0x006E,0x0072,0x0069,0x0063,0x0068,0x0074,0x0065,0x006E,0x0000,0x0008,0x004D,0x0053,0x0020,
	0x0053,0x0061,0x006E,0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,0x0066,0x0000,0x0000,0x0001,0x5001,0x0000,0x0000,
	0x00C3,0x0009,0x0037,0x000F,0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,
	0x00C3,0x001D,0x0037,0x000F,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,
	0x0000,0x0000,0x0080,0x5081,0x0000,0x0000,0x002D,0x000A,0x0073,0x000C,0x0410,0xFFFF,0x0081,0x0000,0x0000,0x0000,
	0x0080,0x5001,0x0000,0x0000,0x00AA,0x0009,0x000F,0x000F,0x040D,0xFFFF,0x0080,0x0000,0x0000,0x0000,0x0080,0x5081,
	0x0000,0x0000,0x002D,0x001E,0x0073,0x000C,0x0418,0xFFFF,0x0081,0x0000,0x0000,0x0000,0x0080,0x5001,0x0000,0x0000,
	0x00AA,0x001D,0x000F,0x000F,0x0419,0xFFFF,0x0080,0x0000,0x0000,0x0000,0x2000,0x5081,0x0000,0x0000,0x002D,0x0032,
	0x0032,0x000C,0x041A,0xFFFF,0x0081,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x000D,0x0049,0x0087,0x000A,
	0x0406,0xFFFF,0x0080,0x0041,0x0075,0x0074,0x006F,0x006D,0x002E,0x0020,0x005A,0x0065,0x0069,0x006C,0x0065,0x006E,
	0x0075,0x006D,0x0062,0x0072,0x0075,0x0063,0x0068,0x0020,0x0061,0x006E,0x0020,0x0053,0x0065,0x0069,0x0074,0x0065,
	0x006E,0x0072,0x0061,0x006E,0x0064,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x00AE,0x0035,0x0047,0x000A,
	0x0409,0xFFFF,0x0080,0x0052,0x0061,0x0068,0x006D,0x0065,0x006E,0x0020,0x0064,0x0072,0x0075,0x0063,0x006B,0x0065,
	0x006E,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x00AE,0x0040,0x003F,0x000A,0x0408,0xFFFF,0x0080,0x0052,
	0x0061,0x0068,0x006D,0x0065,0x006E,0x0020,0x0066,0x00FC,0x006C,0x006C,0x0065,0x006E,0x0020,0x0000,0x0000,0x0000,
	0x0003,0x5001,0x0000,0x0000,0x00AE,0x004B,0x0046,0x000A,0x0407,0xFFFF,0x0080,0x0047,0x006C,0x0065,0x0069,0x0063,
	0x0068,0x0065,0x0020,0x0053,0x0063,0x0068,0x0072,0x0069,0x0066,0x0074,0x0061,0x0072,0x0074,0x0000,0x0000,0x0000,
	0x2000,0x5081,0x0000,0x0000,0x002E,0x0065,0x0023,0x000C,0x0413,0xFFFF,0x0081,0x0000,0x0000,0x0000,0x2000,0x5081,
	0x0000,0x0000,0x002E,0x0074,0x0023,0x000C,0x0414,0xFFFF,0x0081,0x0000,0x0000,0x0000,0x2000,0x5081,0x0000,0x0000,
	0x0074,0x0065,0x0023,0x000C,0x0415,0xFFFF,0x0081,0x0000,0x0000,0x0000,0x2000,0x5081,0x0000,0x0000,0x0074,0x0074,
	0x0023,0x000C,0x0416,0xFFFF,0x0081,0x0000,0x0000,0x0000,0x0009,0x5000,0x0000,0x0000,0x00B5,0x0065,0x003C,0x000A,
	0x040A,0xFFFF,0x0080,0x0053,0x0063,0x0068,0x0077,0x0061,0x0072,0x007A,0x002F,0x0057,0x0065,0x0069,0x0073,0x0000,
	0x0000,0x0000,0x0009,0x5000,0x0000,0x0000,0x00B5,0x006F,0x003C,0x000A,0x040B,0xFFFF,0x0080,0x0047,0x0072,0x0061,
	0x0075,0x0073,0x0074,0x0075,0x0066,0x0065,0x006E,0x0000,0x0000,0x0000,0x0009,0x5000,0x0000,0x0000,0x00B5,0x0079,
	0x003C,0x000A,0x0417,0xFFFF,0x0080,0x0046,0x0061,0x0072,0x0062,0x0065,0x0000,0x0000,0x0007,0x5000,0x0000,0x0000,
	0x000B,0x005B,0x0095,0x002D,0xFFFF,0xFFFF,0x0080,0x0052,0x00E4,0x006E,0x0064,0x0065,0x0072,0x0020,0x0028,0x006D,
	0x006D,0x0029,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x0013,0x0068,0x0012,0x0008,0xFFFF,0xFFFF,0x0082,0x004F,
	0x0062,0x0065,0x006E,0x0000,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x0013,0x0076,0x0014,0x0008,0xFFFF,0xFFFF,
	0x0082,0x0055,0x006E,0x0074,0x0065,0x006E,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x0059,0x0068,0x0012,0x0008,
	0xFFFF,0xFFFF,0x0082,0x004C,0x0069,0x006E,0x006B,0x0073,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x0059,0x0076,
	0x0018,0x0008,0xFFFF,0xFFFF,0x0082,0x0052,0x0065,0x0063,0x0068,0x0074,0x0073,0x0000,0x0000,0x0000,0x0007,0x5000,
	0x0000,0x0000,0x00AB,0x005B,0x0050,0x002D,0xFFFF,0xFFFF,0x0080,0x0044,0x0072,0x0075,0x0063,0x006B,0x0066,0x0061,
	0x0072,0x0062,0x0065,0x0000,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x000A,0x000C,0x0020,0x0008,0xFFFF,0xFFFF,
	0x0082,0x004B,0x006F,0x0070,0x0066,0x007A,0x0065,0x0069,0x006C,0x0065,0x003A,0x0000,0x0000,0x0000,0x0000,0x5002,
	0x0000,0x0000,0x000B,0x0033,0x0016,0x0008,0xFFFF,0xFFFF,0x0082,0x005A,0x0065,0x0069,0x006C,0x0065,0x006E,0x003A,
	0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x000A,0x0020,0x0020,0x0008,0xFFFF,0xFFFF,0x0082,0x0046,0x0075,0x0073,
	0x0073,0x007A,0x0065,0x0069,0x006C,0x0065,0x003A,0x0000,0x0000,
	};



	#define 	STRING(s,i)		_T(s)

#else 

static LPCTSTR GetIdString(unsigned uId)
	{
	static int		iNr=0;
	static CString 	sStr[4];

		iNr++;
		sStr[iNr&3].LoadString(uId);

	return sStr[iNr&3];
	}

	#define 	STRING(s,i)		GetIdString(i)

#endif


//*****************************************************************************
//*
//*		ColorList
//*
//*****************************************************************************
//	Erzeugt eine Tabelle fr die Schnellsuche von Farben.
//	Der Zeiger auf diese Tabelle muss mit delete  freigegeben werden.
unsigned char *ColorList(AnsiColor *pColorList)
{
unsigned char *pPtr;
int			   iPos;



	pPtr = new unsigned char[256];

	memset(pPtr,0,256);

	if(pColorList)											// Farbnummern zuweisen
		{
		for(iPos=0;pColorList[iPos].pName;iPos++)
			{
			if(iPos>256)break;
			pPtr[pColorList[iPos].iIndex]=iPos+1;
			}
		}


return pPtr;
}

//*****************************************************************************
//*
//*		ColorSerach
//*
//*****************************************************************************
//	Sucht die Farbe mit einem speziellen Index bzw. einem Namen
//	pColorList	: Ist die Farbliste
//	pName		: Ist der Name nach dem gesucht wird. (nur bei iIndex==0)
//	iIndex		: Ist der Index nach dem gesucht wird.
//				  Bei 0 wird nach einen Namen gesucht.
//	Ergibt die Position in der Farbliste wo die Farbe gefunden wurde,
//	oder -1 wenn nichts gefunden wurde.
int ColorSerach(AnsiColor *pColorList,LPCTSTR pName,int iIndex)
{
int		   iPos=0;


	if(!pColorList)return 0;

	if(iIndex)												// Index suchen
		{
		for(;;)
			{
			if(pColorList[iPos].pName ==0     )return  -1;
			if(pColorList[iPos].iIndex==iIndex)return iPos;
			iPos++;
			}
		}
	else{													// Einen Namen suchen
		if(!pName)return 0;

		for(;;)
			{
			if(              pColorList[iPos].pName ==0)return  -1;
			if(_tcscmp(pName,pColorList[iPos].pName)==0)return iPos;
			iPos++;
			}
		}


return -1;
}


//*****************************************************************************
//*
//*		ColorChange
//*
//*****************************************************************************
//	ndert eine Farbe in einer Farbtabelle.
//	pColorList	: Ist die Farbliste
//	uTextColor	: Ist die neue Textfarbe        (0xFFFFFFFF fr Standartfarbe)
//	uBkColor	: Ist die neue Hintergrundfarbe (0xFFFFFFFF fr Standartfarbe)
//	pName		: Ist der Name der Farbe die gendert werden soll. (nur bei iIndex==0)
//	iIndex		: Ist der Index der Farbe die gendert werden soll.
//				  Bei 0 wird nach einen Namen gesucht.
//	iFontMode	: Schriftart fr die Farbe (Bit0=Fett Bit1=Kursiv Bit2=Unterstreichen)
//	Ergibt 1 wenn Farbe gefunden und gendert wurde, sonst 0.
int ColorChange(AnsiColor **pColorList,COLORREF uTextColor,COLORREF uBkColor,LPCTSTR pName,int iIndex,int iFontMode)
{
AnsiColor *pList;
int		   iPos;


	pList	= *pColorList;									// Position suchen
	iPos	= ColorSerach(*pColorList,pName,iIndex);

	if(iPos==-1)return 0;

	pList[iPos].iIndex      = iIndex;						// Index fr Farbe
	pList[iPos].uColorBk	= uBkColor;						// Hintergrundfarbe
	pList[iPos].uColorText  = uTextColor;					// Textfarbe
	pList[iPos].iFontMode	= iFontMode;					// Schriftart


return 1;
}

//*****************************************************************************
//*
//*		ColorInsert
//*
//*****************************************************************************
//	Hngt eine Farbe an eine Farbliste an.
//	pColorList	: Ist die Farbliste
//	uTextColor	: Ist die neue Textfarbe        (0xFFFFFFFF fr Standartfarbe)
//	uBkColor	: Ist die neue Hintergrundfarbe (0xFFFFFFFF fr Standartfarbe)
//	pName		: Ist der Name der Farbe die angehngt werden soll. (nur bei iIndex==0)
//	iIndex		: Ist der Index der Farbe die angehngt werden soll.
//				  Bei 0 wird nach einen Namen gesucht.
//	iFontMode	: Schriftart fr die Farbe (Bit0=Fett Bit1=Kursiv Bit2=Unterstreichen)
//	Ergibt die Position der Farbe in der Farbliste eingefgt wurde.
int ColorInsert(AnsiColor **pColorList,COLORREF uTextColor,COLORREF uBkColor,LPCTSTR pName,int iIndex,int iFontMode)
{
AnsiColor  *pEntry;
AnsiColor  *pList;
LPTSTR		pPtr;
int			iLen;
int			iPos;
int			iNum;




	iPos	= 0;
	pList	= *pColorList;
	iLen	= _tcslen(pName)+1;
    pPtr	= new TCHAR[iLen];

	memcpy(pPtr,pName,iLen*sizeof(TCHAR));


	if(pList)												// Ist der Farbindex schon vorhanden
		{
		for(;pList[iPos].pName;iPos++)
			{
			if(pList[iPos].iIndex==iIndex)
				{
				iIndex=0;
				}
			}
		}


	if(!pList || !pList[iPos].pName)						// Farben umkopieren
		{
		pEntry = new AnsiColor[iPos+2];

		for(iNum=0;iNum<iPos;iNum++)
			{
			pEntry[iNum]=pList[iNum];
			}
		}
	else{
		pEntry = pList;
		pList  = 0;
		}

	pEntry[iPos].uColorBk	= uBkColor;						// Hintergrundfarbe
	pEntry[iPos].uColorText	= uTextColor;					// Textfarbe
	pEntry[iPos].pName		= pPtr;							// Zeiger auf Namen
	pEntry[iPos].iIndex		= iIndex;						// Index fr Farbe
	pEntry[iPos].iFontMode	= iFontMode;					// Schriftart

	iPos++;

	pEntry[iPos].uColorBk	= 0;							// Hintergrundfarbe
	pEntry[iPos].uColorText	= 0;							// Textfarbe
	pEntry[iPos].pName		= 0;							// Zeiger auf Namen
	pEntry[iPos].iFontMode	= 0;							// Standard Schriftart

	if(pList)delete pList;									// Alte Farben lschen

	*pColorList=pEntry;


return iPos;
}

//*****************************************************************************
//*
//*		ColorDelete
//*
//*****************************************************************************
//	Lscht alle Farben in einer Farbtabelle.
//	pColorList	: Ist der Zeiger auf den Zeiger der Farbliste,
void ColorDelete(AnsiColor **pColorList)
{
AnsiColor  *pList;
int		    iPos;


		pList = *pColorList;
	if(!pList)return;


	for(iPos=0;pList[iPos].pName;iPos++)					// Alle Farben lschen
		{
		delete pList[iPos].pName;
		}


	delete pList;
	*pColorList=0;


}


//*****************************************************************************
//*
//*
//*		Klasse	CAnsiColorDlg
//*
//*
//*****************************************************************************
CAnsiColorDlg::CAnsiColorDlg(CWnd *pParent):CDialog((UINT)IDD_ANSI_COLORDLG,pParent)
{
	m_iItemSize		= 18;
	m_pIndexList	= 0;
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CAnsiColorDlg::OnInitDialog()
{
CListBox   *pList;
CRect		sClient;
CRect		sWindow;
int			iAddX;
int			iAddY;
int			iSize;
int			iPos;


	CDialog::OnInitDialog();


	pList = (CListBox*)GetDlgItem(IDC_LIST1);					// Hintergrundliste
	pList->GetClientRect(sClient);
	pList->GetWindowRect(sWindow);

	iSize	= sClient.Height();

	if(iSize>=282)
			m_iItemSize=iSize/12;
	else	m_iItemSize=iSize/9;

	if(m_iItemSize<11)m_iItemSize=11;

	iAddX = (sClient.Width())%m_iItemSize;
	iAddY =	(iSize          )%m_iItemSize;


	pList->SetHorizontalExtent(0);
	pList->SetColumnWidth( m_iItemSize);
	pList->SetItemHeight(0,m_iItemSize);


	if(iAddX || iAddY)
		{
		if(iAddX>m_iItemSize/2)iAddX-=m_iItemSize;
		if(iAddY>m_iItemSize/2)iAddY-=m_iItemSize;
		sWindow.right  -= iAddX;
		sWindow.bottom -= iAddY;

		pList->SetWindowPos(NULL,0,0,sWindow.Width(),sWindow.Height(),SWP_NOMOVE|SWP_NOZORDER);
		}


	for(iPos=0;iPos<sizeof(aDefColors)/sizeof(aDefColors[0]);iPos++)
		{
		pList->AddString(_T(""));
		}


	pList = (CListBox*)GetDlgItem(IDC_LIST2);					// Textliste

	pList->SetHorizontalExtent(0);
	pList->SetColumnWidth( m_iItemSize);
	pList->SetItemHeight(0,m_iItemSize);
	pList->GetClientRect(sClient);
	pList->GetWindowRect(sWindow);

	iAddX = (sClient.Width ())%m_iItemSize;
	iAddY =	(sClient.Height())%m_iItemSize;

	if(iAddX || iAddY)
		{
		if(iAddX>m_iItemSize/2)iAddX-=m_iItemSize;
		if(iAddY>m_iItemSize/2)iAddY-=m_iItemSize;
		sWindow.right  -= iAddX;
		sWindow.bottom -= iAddY;

		pList->SetWindowPos(NULL,0,0,sWindow.Width(),sWindow.Height(),SWP_NOMOVE|SWP_NOZORDER);
		}


	for(iPos=0;iPos<sizeof(aDefColors)/sizeof(aDefColors[0]);iPos++)
		{
		pList->AddString(_T(""));
		}


	if(!m_pIndexList)
		{
		GetDlgItem(IDC_CHECK4)->EnableWindow(FALSE);
		}
	else{
		GetDlgItem(IDC_CHECK4)->SendMessage(BM_SETCHECK,BST_CHECKED);
		}

	
	OnFormat();
	OnSelChange();
	UpdateData(FALSE);
	AssignColors();
	DrawItems();												// Dialog neuzeichen



return TRUE;
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CAnsiColorDlg::DoDataExchange(CDataExchange *pDX)
{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CAnsiColorDlg)
	DDX_Check(pDX,IDC_CHECK1,m_bBold     );
	DDX_Check(pDX,IDC_CHECK2,m_bItalic   );
	DDX_Check(pDX,IDC_CHECK3,m_bUnterLine);
	//}}AFX_DATA_MAP

}


//*****************************************************************************
//*
//*		DoModal
//*
//*****************************************************************************
//	Dialog fr Farbnderungen aufrufen
//	pColorList	: Zeiger auf die Farbliste.
//	hFont		: Font fr die Textvorschau
//	iSelect		: Ist die Farbe die gewhlt werden soll.
//	pIndexList	: Bit-Feld mitd Indizes die zum aktuellen Format gehren
//	Ergibt IDOK wenn Farben gendert wurden.
INT_PTR	CAnsiColorDlg::DoModal(AnsiColor *pColorList,HFONT hFont,int iSelect,const LPVOID pIndexList)
{
int		iRet;
int		iCnt;
int		iPos;



	iCnt = 0;

	if(pColorList)
		{
		for(iPos=0;iPos<256;iPos++)								// Farben zhlen
			{
			if(!pColorList[iPos].pName)break;
			iCnt++;
			}
		}

	m_pTempList		= new AnsiColor[iCnt+1];
	m_pIndexList	= (LPBYTE)pIndexList;
	m_pColorList	= pColorList;
	m_iColorNumber	= iSelect;
	m_iColorCount	= iCnt;
	m_hFont         = hFont;

	if(!m_hFont)												// Kein Font angegeben
		{
		m_hFont=(HFONT)GetStockObject(ANSI_FIXED_FONT);
		}

	m_pTempList[iCnt].uColorBk   = RGB(200,200,200);
	m_pTempList[iCnt].uColorText = RGB(200,200,200);
	m_pTempList[iCnt].pName=_T("keine Farben vorhanden");


	for(iPos=0;iPos<iCnt;iPos++)								// Farbe initialisieren
		{
		m_pTempList[iPos]=pColorList[iPos];
		}


	#ifndef USE_RC
	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);
	#endif


	   iRet=CDialog::DoModal();
	if(iRet==IDOK)
		{
		for(iPos=0;iPos<iCnt;iPos++)							// Farben umkopieren
			{
			pColorList[iPos] = m_pTempList[iPos];
			}
		}

	delete m_pTempList;


return	iRet;
}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
//	Draw Felder zeichnet den Dialog neu.
void CAnsiColorDlg::OnPaint()
{
	CDialog::OnPaint();
	DrawItems();
}


//*****************************************************************************
//*
//*		DrawItems
//*
//*****************************************************************************
void CAnsiColorDlg::DrawItems()
{
PAINTSTRUCT sPaint;
DWORD		uColText;
DWORD		uColBk;
RECT		sRect;
RECT		sSize;
HWND		hWnd;
HDC			hDc;
int			iPosX;
int			iPosY;




	hWnd = ::GetDlgItem   (m_hWnd,IDC_FONTVIEW);				// Daten fr Ansichtfenster
	hDc  = ::GetDC        (hWnd);
	       ::GetClientRect(hWnd,&sRect);

	sPaint.hdc			= hDc;
    sPaint.fErase		= FALSE;
    sPaint.fRestore		= TRUE;
    sPaint.fIncUpdate	= TRUE;
	sPaint.rcPaint		= sRect;

	::BeginPaint(hWnd,&sPaint);

	uColBk	 = m_uColorBk;
	uColText = m_uColorText;

	if(uColBk  ==0xFFFFFFFF)uColBk  =GetSysColor(COLOR_WINDOW);
	if(uColText==0xFFFFFFFF)uColText=GetSysColor(COLOR_WINDOWTEXT);

	DrawText(hDc,_T("AbcXyz"),6,&sSize,DT_CALCRECT);

	iPosX  = (sRect.right +sRect.left )/2;
	iPosY  = (sRect.bottom+sRect.top  )/2;
	iPosY -= (sSize.bottom-sSize.top-4)/2;

	SelectObject(hDc,m_hFont );
	SetBkColor  (hDc,uColBk  );
	SetTextColor(hDc,uColText);
	SetTextAlign(hDc,TA_CENTER|TA_TOP);
	ExtTextOut  (hDc,iPosX,iPosY,ETO_OPAQUE|ETO_CLIPPED,&sRect,_T("AbcXyz"),6,NULL);


	::EndPaint(hWnd,&sPaint);

}

//*****************************************************************************
//*
//*		OnSelChange
//*
//*****************************************************************************
//	Es wurde eine andere Farbe gewhlt
void CAnsiColorDlg::OnSelChange()
{
CListBox   *pList;
int			iSel;

	pList			= (CListBox*)GetDlgItem(IDC_LISTBOX);
	iSel			= pList->GetCurSel();

	if(iSel<0)iSel=0;

	m_iColorNumber	= pList->GetItemData(iSel);

	if(m_iColorNumber>=m_iColorCount)m_iColorNumber=m_iColorCount-1;
	if(m_iColorNumber<0)m_iColorNumber=0;

	m_uColorBk		=  m_pTempList[m_iColorNumber].uColorBk;
	m_uColorText	=  m_pTempList[m_iColorNumber].uColorText;
	m_bUnterLine	= (m_pTempList[m_iColorNumber].iFontMode&4)? 1:0;
	m_bItalic		= (m_pTempList[m_iColorNumber].iFontMode&2)? 1:0;
	m_bBold			= (m_pTempList[m_iColorNumber].iFontMode&1)? 1:0;

	UpdateData(FALSE);
	AssignColors();
	DrawItems();

}

//*****************************************************************************
//*
//*		OnFormat
//*
//*****************************************************************************
//	Nur Farbe des aktuellen Formates anzeigen 
void CAnsiColorDlg::OnFormat()
{
CButton    *pButton;
CListBox   *pList;
int			iLast;
int			iNum;
int			iPos;
int			iOff;
int			iOn;	



	iNum	= 0;
	pButton = (CButton *)GetDlgItem(IDC_CHECK4);
	iOn		=  pButton ->GetCheck();
	pList	= (CListBox*)GetDlgItem(IDC_LISTBOX);
	pList->ResetContent();
	
	

	for(iPos=0;iPos<m_iColorCount;iPos++)						// Namen in Listbox einfgen
		{
		if(iOn && m_pIndexList && !((m_pIndexList[iPos/8]>>(iPos&7))&1))
			{
			continue;		
			}

		iLast = iPos;
		iOff  = pList->AddString(m_pTempList[iPos].pName);
		pList->SetItemData(iOff,iPos);
		iNum++;
		}

	if(iNum==0 || (iNum==1 && iLast==0))						// Alle Farben einfgen
		{
		for(iPos=0;iPos<m_iColorCount;iPos++)						
			{
			iOff = pList->AddString(m_pTempList[iPos].pName);
			pList->SetItemData(iOff,iPos);
			}
		}

	
	iPos = m_iColorNumber;

	if(iPos<0 || iPos>=m_iColorCount)iPos=0;

	pList->SelectString(-1,m_pTempList[iPos].pName);			// Eintrag auswhlen



}

//*****************************************************************************
//*
//*		OnSelColor1
//*
//*****************************************************************************
//	Es wurde ein anderer Farbewert fr den Hintergrund gewhlt
void CAnsiColorDlg::OnSelColor1()
{
CListBox   *pList;
int			iSel;


	pList	= (CListBox*)GetDlgItem(IDC_LIST1);
	iSel	= pList->GetCurSel();

	if(iSel<0)iSel=0;

	m_uColorBk = aDefColors[iSel];

	if(m_uColorBk==0xFF000000)
		{
		m_uColorBk = m_uColorUserBk;
		}

	m_pTempList[m_iColorNumber].uColorBk = m_uColorBk;

	DrawItems();

}

//*****************************************************************************
//*
//*		OnSelColor2
//*
//*****************************************************************************
//	Es wurde ein anderer Farbewert fr den Text gewhlt
void CAnsiColorDlg::OnSelColor2()
{
CListBox   *pList;
int			iSel;


	pList	= (CListBox*)GetDlgItem(IDC_LIST2);
	iSel	= pList->GetCurSel();

	if(iSel<0)iSel=0;

	m_uColorText = aDefColors[iSel];

	if(m_uColorText==0xFF000000)
		{
		m_uColorText = m_uColorUserText;
		}


	m_pTempList[m_iColorNumber].uColorText = m_uColorText;

	DrawItems();
}

//*****************************************************************************
//*
//*		OnBold
//*
//*****************************************************************************
void CAnsiColorDlg::OnBold()
{
	UpdateData();
	UpdateData(FALSE);
	SetFontMode();
}


//*****************************************************************************
//*
//*		OnItalic
//*
//*****************************************************************************
void CAnsiColorDlg::OnItalic()
{
	UpdateData();
	UpdateData(FALSE);
	SetFontMode();
}


//*****************************************************************************
//*
//*		OnUnterLine
//*
//*****************************************************************************
void CAnsiColorDlg::OnUnterLine()
{
	UpdateData();
	UpdateData(FALSE);
	SetFontMode();
}

//*****************************************************************************
//*
//*		AssignColors
//*
//*****************************************************************************
void CAnsiColorDlg::AssignColors()
{
CListBox   *pList;
COLORREF	uCol;
int			iPos;
int			iDef;



	pList	= (CListBox*)GetDlgItem(IDC_LIST1);
	iDef	= sizeof(aDefColors)/sizeof(aDefColors[0])-1;
	pList->SetCurSel(-1);

	for(iPos=0;;iPos++)
		{
		if(iPos>=sizeof(aDefColors)/sizeof(aDefColors[0]))
			{
			m_uColorUserBk = m_uColorBk;
			pList->SetCurSel(iDef);
			break;
			}

		   uCol = aDefColors[iPos];
		if(uCol==0xFF000000)
			{
			iDef=iPos;
			continue;
			}

		if(uCol==m_uColorBk)
			{
			pList->SetCurSel(iPos);
			break;
			}
		}

	pList	= (CListBox*)GetDlgItem(IDC_LIST2);
	iDef	= sizeof(aDefColors)/sizeof(aDefColors[0])-1;
	pList->SetCurSel(-1);

	for(iPos=0;;iPos++)
		{
		if(iPos>=sizeof(aDefColors)/sizeof(aDefColors[0]))
			{
			m_uColorUserText = m_uColorText;
			pList->SetCurSel(iDef);
			break;
			}

		   uCol = aDefColors[iPos];
		if(uCol==0xFF000000)
			{
			iDef=iPos;
			continue;
			}

		if(uCol==m_uColorText)
			{
			pList->SetCurSel(iPos);
			break;
			}
		}

}

//*****************************************************************************
//*
//*		SetFontMode
//*
//*****************************************************************************
void CAnsiColorDlg::SetFontMode()
{
int		iMode;


	if(!m_pTempList)return;
	if( m_iColorNumber<0)return;
	if( m_iColorNumber>=m_iColorCount)return;


	UpdateData();

					iMode =0;
	if(m_bBold     )iMode|=1;
	if(m_bItalic   )iMode|=2;
	if(m_bUnterLine)iMode|=4;

	m_pTempList[m_iColorNumber].iFontMode = iMode;

}

//*****************************************************************************
//*
//*		OnUserBk
//*
//*****************************************************************************
void CAnsiColorDlg::OnUserBk()
{
COLORREF		aCol[16];
CHOOSECOLOR		sData;
int				iPos;


	 aCol[0]				= m_uColorBk;

	 sData.lStructSize		= sizeof(sData);
     sData.hwndOwner		= m_hWnd;
     sData.hInstance		= NULL;
	 sData.rgbResult		= aCol[0];
     sData.lpCustColors		= aCol;
     sData.Flags			= CC_ANYCOLOR|CC_RGBINIT|CC_FULLOPEN;
     sData.lCustData		= NULL;
     sData.lpfnHook			= NULL;
     sData.lpTemplateName	= NULL;

	 for(iPos=0;iPos<16;iPos++)
		{
		aCol[iPos] = sData.rgbResult;
		}

	 if(!ChooseColor(&sData))return;

	 m_uColorBk    = sData.rgbResult;
	 m_pTempList[m_iColorNumber].uColorBk = m_uColorBk;

	 AssignColors();
	 DrawItems();

}

//*****************************************************************************
//*
//*		OnUserText
//*
//*****************************************************************************
void CAnsiColorDlg::OnUserText()
{
COLORREF		aCol[16];
CHOOSECOLOR		sData;
int				iPos;


	 aCol[0]				= m_uColorText;

	 sData.lStructSize		= sizeof(sData);
     sData.hwndOwner		= m_hWnd;
     sData.hInstance		= NULL;
	 sData.rgbResult		= aCol[0];
     sData.lpCustColors		= aCol;
     sData.Flags			= CC_ANYCOLOR|CC_RGBINIT|CC_FULLOPEN;
     sData.lCustData		= NULL;
     sData.lpfnHook			= NULL;
     sData.lpTemplateName	= NULL;

	 for(iPos=0;iPos<16;iPos++)
		{
		aCol[iPos] = sData.rgbResult;
		}

	 if(!ChooseColor(&sData))return;

	 m_uColorText  = sData.rgbResult;
	 m_pTempList[m_iColorNumber].uColorText = m_uColorText;

	 AssignColors();
	 DrawItems();

}

//*****************************************************************************
//*
//*		OnDrawItem
//*
//*****************************************************************************
void CAnsiColorDlg::OnDrawItem(int nIDCtl,LPDRAWITEMSTRUCT pDrawItem)
{
COLORREF	uColor;
CRect		sRect;
int			iPos;
int			iNum;
int			iDef;
int			iSub;


	iDef   = 0;
	uColor = aDefColors[pDrawItem->itemID];

	if(uColor==0xFFFFFFFF)
		{
		if(nIDCtl==IDC_LIST1)
				uColor = GetSysColor(COLOR_WINDOW);
		else	uColor = GetSysColor(COLOR_WINDOWTEXT);

		iDef = 1;
		}
	else if(uColor==0xFF000000)
		{
		if(nIDCtl==IDC_LIST1)
				uColor = m_uColorUserBk;
		else	uColor = m_uColorUserText;
		}

	SetBkColor(pDrawItem->hDC,uColor);
	ExtTextOut(pDrawItem->hDC,0,0,ETO_OPAQUE,&pDrawItem->rcItem,NULL,0,NULL);


	if(pDrawItem->itemState&ODS_SELECTED)				// Ist der Eintrag ausgewhlt
		{
		iNum  = (uColor>> 0)&0xFF;
		iNum += (uColor>> 8)&0xFF;
		iNum += (uColor>>16)&0xFF;

		if(iNum>240*3)
				SetBkColor(pDrawItem->hDC,RGB(192,192,192));
		else	SetBkColor(pDrawItem->hDC,RGB(255,255,255));

		sRect = pDrawItem->rcItem;
		sRect.right = sRect.left+2;

		ExtTextOut(pDrawItem->hDC,0,0,ETO_OPAQUE,sRect,NULL,0,NULL);

		sRect = pDrawItem->rcItem;
		sRect.bottom = sRect.top+2;

		ExtTextOut(pDrawItem->hDC,0,0,ETO_OPAQUE,sRect,NULL,0,NULL);

		iSub = 1;
		}
	else{
		SetBkColor(pDrawItem->hDC,RGB(64,64,64));
		iSub = 1;
		}



	sRect = pDrawItem->rcItem;
	sRect.left = sRect.right-iSub;

	ExtTextOut(pDrawItem->hDC,0,0,ETO_OPAQUE,sRect,NULL,0,NULL);

	sRect = pDrawItem->rcItem;
	sRect.top = sRect.bottom-iSub;

	ExtTextOut(pDrawItem->hDC,0,0,ETO_OPAQUE,sRect,NULL,0,NULL);


	if(iDef)											// Ein Kreuz bei Standartfarbe einzeichen
		{
		for(iPos=0;iPos<m_iItemSize;iPos++)
			{
			sRect.left	 = pDrawItem->rcItem.left+iPos;
			sRect.top	 = pDrawItem->rcItem.top +iPos;
			sRect.right  = sRect.left+1;
			sRect.bottom = sRect.top +1;

			ExtTextOut(pDrawItem->hDC,0,0,ETO_OPAQUE,sRect,NULL,0,NULL);

			sRect.left	 = pDrawItem->rcItem.left+m_iItemSize-2-iPos;
			sRect.right  = sRect.left+1;

			ExtTextOut(pDrawItem->hDC,0,0,ETO_OPAQUE,sRect,NULL,0,NULL);
			}
		}

	if(pDrawItem->itemState&ODS_SELECTED)				// Auswahl umrahmen
		{
		SelectObject(pDrawItem->hDC,GetStockObject(NULL_PEN));
		SelectObject(pDrawItem->hDC,CDC::GetHalftoneBrush()->m_hObject);

		PatBlt(pDrawItem->hDC,pDrawItem->rcItem.left  ,pDrawItem->rcItem.top  ,m_iItemSize  ,m_iItemSize  ,PATINVERT);
		PatBlt(pDrawItem->hDC,pDrawItem->rcItem.left+2,pDrawItem->rcItem.top+2,m_iItemSize-4,m_iItemSize-4,PATINVERT);
		}



}

//*****************************************************************************
//*
//*
//*		Klasse	CAnsiPrintDlg
//*
//*
//*****************************************************************************
CAnsiPrintDlg::CAnsiPrintDlg(CWnd *pParent) : CDialog((UINT)IDD_ANSI_PRINTDLG,pParent)
{


}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CAnsiPrintDlg::OnInitDialog()
{

	SetButtonBitmap(this,IDC_BUTTON1,m_wDlgIcon);
	SetButtonBitmap(this,IDC_BUTTON2,m_wDlgIcon);

	CDialog::OnInitDialog();


return TRUE;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CAnsiPrintDlg::OnDestroy()
{

	DelButtonBitmap(this,IDC_BUTTON1);
	DelButtonBitmap(this,IDC_BUTTON2);

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		DoModal
//*
//*****************************************************************************
INT_PTR	CAnsiPrintDlg::DoModal(AnsiPageData *pPageData)
{

	m_pPageDataPtr	=  pPageData;
	m_bPrintBlack	= (m_pPageDataPtr->uFlags&0x01) != 0;
	m_bPrintGray	= (m_pPageDataPtr->uFlags&0x03) == 2;
	m_bPrintColors	= (m_pPageDataPtr->uFlags&0x07) == 4;
	m_bSameFont		= (m_pPageDataPtr->uFlags&0x10) != 0;
	m_bWrapLines	= (m_pPageDataPtr->uFlags&0x08) != 0;
	m_bDrawMargin	= (m_pPageDataPtr->uFlags&0x20) != 0;
	m_bFillMatrgin	= (m_pPageDataPtr->uFlags&0x40) != 0;


	m_sHeaderData	= m_pPageDataPtr->pHeaderData;
	m_sFooterData	= m_pPageDataPtr->pFooterData;
	m_sMarginTop	. Format(_T("%i"),m_pPageDataPtr->uMarginTop   );
	m_sMarginLeft	. Format(_T("%i"),m_pPageDataPtr->uMarginLeft  );
	m_sMarginRight	. Format(_T("%i"),m_pPageDataPtr->uMarginRight );
	m_sMarginBottom	. Format(_T("%i"),m_pPageDataPtr->uMarginBottom);
	m_sLines		. Format(_T("%i"),m_pPageDataPtr->uLines       );

	if(!(m_pPageDataPtr->uFlags&0x07))m_bPrintBlack=1;

	#ifndef USE_RC
	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);
	#endif


return	CDialog::DoModal();
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CAnsiPrintDlg::DoDataExchange(CDataExchange *pDX)
{
CEdit	*pEdit;



	pEdit=(CEdit*)GetDlgItem(IDC_EDIT1);pEdit->LimitText(255);
	pEdit=(CEdit*)GetDlgItem(IDC_EDIT2);pEdit->LimitText(255);

	CDialog::DoDataExchange(pDX);

	DDX_Text ( pDX , IDC_EDIT1			,m_sHeaderData  );
	DDX_Text ( pDX , IDC_EDIT2			,m_sFooterData  );
	DDX_Text ( pDX , IDC_MARGIN_TOP		,m_sMarginTop	);
	DDX_Text ( pDX , IDC_MARGIN_LEFT 	,m_sMarginLeft  );
	DDX_Text ( pDX , IDC_MARGIN_RIGHT	,m_sMarginRight );
	DDX_Text ( pDX , IDC_MARGIN_BOTTOM	,m_sMarginBottom);
	DDX_Text ( pDX , IDC_EDIT3      	,m_sLines       );
	DDX_Check( pDX , IDC_CHECK1     	,m_bWrapLines	);
	DDX_Check( pDX , IDC_CHECK2     	,m_bSameFont    );
	DDX_Check( pDX , IDC_CHECK3     	,m_bFillMatrgin );
	DDX_Check( pDX , IDC_CHECK4     	,m_bDrawMargin	);
	DDX_Check( pDX , IDC_RADIO1     	,m_bPrintBlack	);
	DDX_Check( pDX , IDC_RADIO2     	,m_bPrintGray   );
	DDX_Check( pDX , IDC_RADIO3     	,m_bPrintColors );

}

//*****************************************************************************
//*
//*		OnOk
//*
//*****************************************************************************
void CAnsiPrintDlg::OnOk()
{
const int	aErrorId[]={IDC_MARGIN_TOP,IDC_MARGIN_BOTTOM,IDC_MARGIN_LEFT,IDC_MARGIN_RIGHT};
int			iError;
int			iLen;


	UpdateData();

	m_pPageDataPtr->uMarginRight  = strtoi(m_sMarginRight );
	m_pPageDataPtr->uMarginLeft   = strtoi(m_sMarginLeft  );
	m_pPageDataPtr->uMarginBottom = strtoi(m_sMarginBottom);
	m_pPageDataPtr->uMarginTop    = strtoi(m_sMarginTop   );
	m_pPageDataPtr->uLines		  = strtoi(m_sLines       );

									     iError=0;
	if(m_pPageDataPtr->uMarginRight >100)iError=4;
	if(m_pPageDataPtr->uMarginLeft  >100)iError=3;
	if(m_pPageDataPtr->uMarginBottom>100)iError=2;
	if(m_pPageDataPtr->uMarginTop   >100)iError=1;

	if(iError)
		{
		MessageBox(STRING("Die Rnder mssen zwischen 0 und 100 mm liegen !",ID_ANSI_PRINT1),0,MB_ICONERROR);
		GotoDlgCtrl(GetDlgItem(aErrorId[iError-1]));
		return;
		}

	if(m_pPageDataPtr->uLines>250 || m_pPageDataPtr->uLines<20)
		{
		MessageBox(STRING("Die Zeilenanzahl muss zwischen 20 und 250 liegen !",ID_ANSI_PRINT2),0,MB_ICONERROR);
		GotoDlgCtrl(GetDlgItem(IDC_EDIT1));
		return;
		}


			 		  m_pPageDataPtr->uFlags =0x00;
	if(m_bPrintBlack )m_pPageDataPtr->uFlags|=0x01;
	if(m_bPrintGray	 )m_pPageDataPtr->uFlags|=0x02;
	if(m_bPrintColors)m_pPageDataPtr->uFlags|=0x04;
	if(m_bWrapLines	 )m_pPageDataPtr->uFlags|=0x08;
	if(m_bSameFont	 )m_pPageDataPtr->uFlags|=0x10;
	if(m_bDrawMargin )m_pPageDataPtr->uFlags|=0x20;
	if(m_bFillMatrgin)m_pPageDataPtr->uFlags|=0x40;

	if(m_pPageDataPtr->pHeaderData)delete m_pPageDataPtr->pHeaderData;
	if(m_pPageDataPtr->pFooterData)delete m_pPageDataPtr->pFooterData;

	iLen = m_sHeaderData.GetLength()+1;
	       m_pPageDataPtr->pHeaderData = new TCHAR[iLen];
	memcpy(m_pPageDataPtr->pHeaderData,(LPCTSTR)m_sHeaderData,iLen*sizeof(TCHAR));

	iLen = m_sFooterData.GetLength()+1;
		   m_pPageDataPtr->pFooterData = new TCHAR[iLen];
	memcpy(m_pPageDataPtr->pFooterData,(LPCTSTR)m_sFooterData,iLen*sizeof(TCHAR));



	CDialog::OnOK();

}

//*****************************************************************************
//*
//*		StartMenu
//*
//*****************************************************************************
void CAnsiPrintDlg::StartMenu(RECT &sRect)
{
CMenu	sMenu;

	sMenu.CreatePopupMenu();

	sMenu.AppendMenu(MF_STRING  ,IDD_FILENAME	,STRING("&Dateiname"			,ID_ANSI_MENU_P1 ));
	sMenu.AppendMenu(MF_STRING  ,IDD_FILEPATH	,STRING("Dateiname und &Pfad"	,ID_ANSI_MENU_P2 ));
	sMenu.AppendMenu(MF_STRING  ,IDD_USERNAME	,STRING("&Benutzername"			,ID_ANSI_MENU_P3 ));
	sMenu.AppendMenu(MF_SEPARATOR												                  );
	sMenu.AppendMenu(MF_STRING  ,IDD_PAGENUMBER	,STRING("&Seitennummer"			,ID_ANSI_MENU_P4 ));
	sMenu.AppendMenu(MF_STRING  ,IDD_PAGECOUNT	,STRING("Seiten&anzahl"			,ID_ANSI_MENU_P5 ));
	sMenu.AppendMenu(MF_STRING  ,IDD_DATE		,STRING("Da&tum"				,ID_ANSI_MENU_P6 ));
	sMenu.AppendMenu(MF_STRING  ,IDD_TIME		,STRING("&Zeit"					,ID_ANSI_MENU_P7 ));
	sMenu.AppendMenu(MF_STRING  ,IDD_NEWLINE	,STRING("&Neue Zeile"			,ID_ANSI_MENU_P8 ));
	sMenu.AppendMenu(MF_SEPARATOR												                  );
	sMenu.AppendMenu(MF_STRING  ,IDD_LEFT		,STRING("&Linksbndig"			,ID_ANSI_MENU_P9 ));
	sMenu.AppendMenu(MF_STRING  ,IDD_RIGHT		,STRING("&Rechtsbndig"			,ID_ANSI_MENU_P10));
	sMenu.AppendMenu(MF_STRING  ,IDD_CENTER		,STRING("Zent&riert"			,ID_ANSI_MENU_P11));

	sMenu.TrackPopupMenu(TPM_LEFTALIGN,sRect.right,sRect.top,this);
	sMenu.DestroyMenu();

}

//*****************************************************************************
//*
//*		OnSelect1
//*
//*****************************************************************************
void CAnsiPrintDlg::OnSelect1()
{
RECT	sRect;


	GetDlgItem(IDC_BUTTON1)->GetWindowRect(&sRect);
	m_iSelect=0;
	StartMenu(sRect);

}


//*****************************************************************************
//*
//*		OnSelect2
//*
//*****************************************************************************
void CAnsiPrintDlg::OnSelect2()
{
RECT	sRect;

	GetDlgItem(IDC_BUTTON2)->GetWindowRect(&sRect);
	m_iSelect=1;
	StartMenu(sRect);

}

//*****************************************************************************
//*
//*		OnMenu?
//*
//*****************************************************************************
void CAnsiPrintDlg::OnMenu0(){OnMenu(0);}
void CAnsiPrintDlg::OnMenu1(){OnMenu(1);}
void CAnsiPrintDlg::OnMenu2(){OnMenu(2);}
void CAnsiPrintDlg::OnMenu3(){OnMenu(3);}
void CAnsiPrintDlg::OnMenu4(){OnMenu(4);}
void CAnsiPrintDlg::OnMenu5(){OnMenu(5);}
void CAnsiPrintDlg::OnMenu6(){OnMenu(6);}
void CAnsiPrintDlg::OnMenu7(){OnMenu(7);}
void CAnsiPrintDlg::OnMenu8(){OnMenu(8);}
void CAnsiPrintDlg::OnMenu9(){OnMenu(9);}
void CAnsiPrintDlg::OnMenuA(){OnMenu(10);}
void CAnsiPrintDlg::OnMenu(unsigned int uNum)
{

CEdit	*pEdit;
LPCTSTR  pText;
TCHAR 	 cBuffer[512];
TCHAR 	 cAdd   [256];
int		 iLen;
int		 iPos;
int		 iEnd;



	pEdit=(CEdit*)GetDlgItem((m_iSelect)? IDC_EDIT2:IDC_EDIT1);
	pEdit->GetWindowText(cBuffer,255);cBuffer[255]=0;
	pEdit->GetSel(iPos,iEnd);

	iLen = _tcslen(cBuffer);

	if(iPos>=iLen)iPos=iLen;
	if(iPos<    0)iPos=0;

	strlcpy(cAdd,cBuffer+iPos,sizeof(cAdd));
	cBuffer[iPos]=0;


	if(uNum<6 && iPos>0 && cBuffer[iPos-1]!=' ' )
		{
		strlcat(cBuffer,_T(" "),sizeof(cBuffer));
		}


	switch(uNum)
		{
	default:
	case 0:	pText = _T("&C" );							break;
	case 1:	pText = STRING("Seite &N",ID_ANSI_PAGE);	break;
	case 2:	pText = _T("&D" );							break;
	case 3:	pText = _T("&P" );							break;
	case 4:	pText = _T("&T" );							break;
	case 5:	pText = _T("&Z" );							break;
	case 6:	pText = _T("&L" );							break;
	case 7:	pText = _T("&R" );							break;
	case 8:	pText = _T("&U" );							break;
	case 9:	pText = _T("\\n");							break;
	case 10:pText = _T("&M" );							break;
		}


	strlcat(cBuffer,pText,sizeof(cBuffer)/sizeof(TCHAR));

	iPos = _tcslen(cBuffer);

	if(uNum<6 && cAdd[0] && cAdd[0]!=' ' )
		{
		strlcat(cBuffer,_T(" "),sizeof(cBuffer)/sizeof(TCHAR));
		}

	strlcat(cBuffer,cAdd,sizeof(cBuffer)/sizeof(TCHAR));

	pEdit->SetWindowText(cBuffer);
	pEdit->SetSel(iPos,iPos);
	pEdit->SetFocus();

}


