//*****************************************************************************
//*
//*
//*		TextDlg.cpp
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2003
//
#include	"AfxUtility.h"

typedef	struct
	{
	LPCTSTR		pText;
	int			iId;
	}MenuItem;


static MenuItem	aMenuStrings[]=
	{
		{	_T("Beliebige  Zeichen&folge"			),	 2	},
        {	_T("&Wort"								),	 3	},
        {	_T("&Zahl"								),	 4	},
        {	_T("&Leerraum"							),	 5	},
        {	_T("Leer&raum oder (null)"				),	 6	},
        {	_T(""									),	 0	},
        {	_T("Zeilen&anfang"						),	 7	},
        {	_T("Zeilen&ende"						),	 8	},
        {	_T("Wortende"							),	12	},
        {	_T("Wortanfang"							),	11	},
        {	_T(""									),	 0	},
        {	_T("Zeichen Aus&wahl"					),	14	},
        {	_T("Zeichen Auswahl oder (null)"		),	15	},
        {	_T("Zeichenketten Auswahl"				),	16	},
		{	_T("Zeichenketten ohne |...|"			),	18	},
		{	_T("Zeichen nicht aus {...}"			),	17	},
        {	_T(""									),	 0	},
        {	_T("Text via strwlen oder (null)"		),	19	},
		{	_T("Zeichen via strwchar"				),	20	},
		{	_T("Zeichen via strwchar oder (null)"	),	21	},
        {	_T(""									),	 0	},
        {	_T("Beliebiges &Zeichen"				),	 1	},
        {	_T("Buchstabe"							),	13	},
        {	_T("Einzelne Zahl"						),	 9	},
        {	_T("Zahl oder Buchstabe"				),	10	},
		{0}
	};

#define 	ID_TEXT_POS		0x1691
#define 	ID_TEXT_CNT		22

#ifdef USE_RC
static int			iMenuInit=0;
static CString		aMenuText[sizeof(aMenuStrings)/sizeof(aMenuStrings[0])-1];
#endif


#ifndef USE_RC
#ifdef		IDC_BUTTON1
#undef		IDC_BUTTON1
#endif
#ifdef		IDC_BUTTON2
#undef 		IDC_BUTTON2
#endif
#ifdef		IDC_COMBO1
#undef 		IDC_COMBO1
#endif
#ifdef		IDC_COMBO2
#undef 		IDC_COMBO2
#endif
#ifdef		IDC_CHECK1
#undef 		IDC_CHECK1
#endif
#ifdef		IDC_CHECK2
#undef 		IDC_CHECK2
#endif
#ifdef		IDC_CHECK3
#undef 		IDC_CHECK3
#endif
#ifdef		IDC_CHECK4
#undef 		IDC_CHECK4
#endif
#ifdef		IDC_CHECK5
#undef 		IDC_CHECK5
#endif
#ifdef		IDC_CHECK6
#undef 		IDC_CHECK6
#endif
#ifdef		IDC_CHECK7
#undef 		IDC_CHECK7
#endif
#ifdef		IDC_CHECK8
#undef 		IDC_CHECK8
#endif
#ifdef		IDC_CHECK9
#undef 		IDC_CHECK9
#endif
#ifdef		IDC_CHECK10
#undef 		IDC_CHECK10
#endif
#ifdef		IDC_CHECK11
#undef 		IDC_CHECK11
#endif
#ifdef		IDC_RADIO1
#undef 		IDC_RADIO1
#endif
#ifdef		IDC_RADIO2
#undef 		IDC_RADIO2
#endif
#ifdef		IDC_RADIO3
#undef 		IDC_RADIO3
#endif
#ifdef		IDC_RADIO4
#undef 		IDC_RADIO4
#endif
#ifdef		IDC_EDIT1
#undef 		IDC_EDIT1
#endif
#ifdef		IDC_WAS
#undef	 	IDC_WAS
#endif

#define 	IDC_BUTTON1				1037
#define 	IDC_BUTTON2				1049
#define 	IDC_COMBO1      		1029
#define 	IDC_COMBO2      		1036
#define 	IDC_CHECK1      		1030
#define 	IDC_CHECK2      		1031
#define 	IDC_CHECK3      		1032
#define 	IDC_CHECK4      		1033
#define 	IDC_CHECK5      		1051
#define 	IDC_CHECK6      		1059
#define		IDC_CHECK7      		1053
#define 	IDC_CHECK8      		1060
#define 	IDC_CHECK9      		1061
#define 	IDC_CHECK10     		1062
#define 	IDC_CHECK11     		1063
#define 	IDC_RADIO1      		1034
#define 	IDC_RADIO2      		1035
#define 	IDC_RADIO3      		1047
#define 	IDC_RADIO4      		1054
#define 	IDC_EDIT1       		1040
#define 	IDC_WAS         		1055


#define 	IDD_TEXT_FINDDLG		0
#define 	IDD_TEXT_CONFIGDLG		0
#define 	IDD_TEXT_CHANGEDLG		0
#define 	IDD_TEXT_QUESTIONDLG	0

#endif

#ifndef 	TEXT_WORD
#define		TEXT_WORD       		0x00000010				// Wortweise kopieren
#endif 	
#ifndef 	TEXT_NOCASE
#define 	TEXT_NOCASE				0x00001000				// Keine Gro-Klien Unterscheidung
#endif 	
#ifndef 	TEXT_IS_UTF16
#define 	TEXT_IS_UTF16			0x00000800				// Der Text ist im UTF16-Format
#endif 	


BEGIN_MESSAGE_MAP(CTextFindDlg, CDialog)
	//{{AFX_MSG_MAP(SuchenDlg)
	ON_BN_CLICKED(IDOK       	,OnFind)
	ON_BN_CLICKED(IDCANCEL     	,OnCancel)
	ON_BN_CLICKED(IDC_BUTTON1	,OnNext)
	ON_BN_CLICKED(IDC_BUTTON2	,OnSelect)
	ON_BN_CLICKED(IDC_CHECK4	,OnChanged)
	ON_CBN_EDITCHANGE(IDC_COMBO1,OnChanged) 
	ON_COMMAND_RANGE(ID_TEXT_POS,ID_TEXT_POS+ID_TEXT_CNT,OnMenu)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CTextChangeDlg, CDialog)
	//{{AFX_MSG_MAP(SuchenDlg)
	ON_BN_CLICKED(IDOK			,OnChange)
	ON_BN_CLICKED(IDCANCEL     	,OnCancel)
	ON_BN_CLICKED(IDC_BUTTON1	,OnAll)
	ON_BN_CLICKED(IDC_BUTTON2	,OnSelect)
	ON_BN_CLICKED(IDC_CHECK4	,OnChanged)
	ON_CBN_EDITCHANGE(IDC_COMBO1,OnChanged) 
	ON_COMMAND_RANGE(ID_TEXT_POS,ID_TEXT_POS+ID_TEXT_CNT,OnMenu)
	ON_WM_DESTROY()
 	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CTextConfigDlg, CDialog)
	//{{AFX_MSG_MAP(SuchenDlg)
	ON_BN_CLICKED(IDOK			,OnOk)
 	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CTextQuestionDlg, CDialog)
	//{{AFX_MSG_MAP(CTextQuestionDlg)
	ON_BN_CLICKED(IDNO       	,OnNo)
	ON_BN_CLICKED(IDYES			,OnYes)
	ON_BN_CLICKED(IDCANCEL   	,OnCancel)
 	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


#ifndef		USE_RC

WORD CTextFindDlg::m_wDlgData[]=
	{
	0x00C0,0x80C8,0x0000,0x0000,0x000E,0x0000,0x0000,0x011F,0x004D,0x0000,0x0000,0x0054,0x0065,0x0078,0x0074,0x0020,
	0x0073,0x0075,0x0063,0x0068,0x0065,0x006E,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,
	0x0053,0x0065,0x0072,0x0069,0x0066,0x0000,0x0042,0x5021,0x0000,0x0000,0x0037,0x0005,0x008C,0x0081,0x0405,0xFFFF,
	0x0085,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x0007,0x0017,0x0082,0x000A,0x0406,0xFFFF,0x0080,0x0026,
	0x0047,0x0072,0x006F,0x00DF,0x002F,0x004B,0x006C,0x0065,0x0069,0x006E,0x0073,0x0063,0x0068,0x0072,0x0065,0x0069,
	0x0062,0x0075,0x006E,0x0067,0x0020,0x0069,0x0067,0x006E,0x006F,0x0072,0x0069,0x0065,0x0072,0x0065,0x006E,0x0000,
	0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x0007,0x0021,0x0082,0x000A,0x0407,0xFFFF,0x0080,0x0047,0x0065,0x0073,
	0x0061,0x006D,0x0074,0x0065,0x006E,0x0020,0x0026,0x0054,0x0065,0x0078,0x0074,0x0020,0x0064,0x0075,0x0072,0x0063,
	0x0068,0x0073,0x0075,0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x0007,0x002B,
	0x0082,0x000A,0x0408,0xFFFF,0x0080,0x0047,0x0061,0x006E,0x007A,0x0065,0x0020,0x0026,0x0057,0x00F6,0x0072,0x0074,
	0x0065,0x0072,0x0020,0x0073,0x0075,0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,
	0x0007,0x0035,0x0082,0x000A,0x0409,0xFFFF,0x0080,0x0026,0x0052,0x0065,0x0067,0x0075,0x006C,0x00E4,0x0072,0x0065,
	0x0072,0x0020,0x0041,0x0075,0x0073,0x0064,0x0072,0x0075,0x0063,0x006B,0x0000,0x0000,0x0003,0x5801,0x0000,0x0000,
	0x0007,0x003F,0x0082,0x000A,0x041B,0xFFFF,0x0080,0x0057,0x006F,0x0072,0x0074,0x0020,0x0068,0x0065,0x0072,0x0076,
	0x006F,0x0072,0x0068,0x0065,0x0062,0x0065,0x006E,0x0000,0x0000,0x0000,0x0009,0x5001,0x0000,0x0000,0x009B,0x0028,
	0x0038,0x0008,0x040A,0xFFFF,0x0080,0x0026,0x0052,0x00FC,0x0063,0x006B,0x0077,0x00E4,0x0072,0x0074,0x0073,0x0000,
	0x0000,0x0000,0x0009,0x5001,0x0000,0x0000,0x009B,0x0032,0x0038,0x000A,0x040B,0xFFFF,0x0080,0x0026,0x0056,0x006F,
	0x0072,0x0077,0x00E4,0x0072,0x0074,0x0073,0x0000,0x0000,0x0001,0x5001,0x0000,0x0000,0x00E1,0x0005,0x0037,0x000F,
	0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,0x00E1,0x0019,0x0037,0x000F,
	0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,0x0000,0x5001,
	0x0000,0x0000,0x00E1,0x0037,0x0037,0x000F,0x040D,0xFFFF,0x0080,0x0057,0x0065,0x0069,0x0074,0x0065,0x0072,0x0026,
	0x0073,0x0075,0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,0x0080,0x5001,0x0000,0x0000,0x00C8,0x0005,0x000D,0x000D,
	0x0419,0xFFFF,0x0080,0x0000,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x0005,0x0008,0x002D,0x0008,0xFFFF,0xFFFF,
	0x0082,0x0053,0x0075,0x0063,0x0068,0x0065,0x0020,0x004E,0x0061,0x0063,0x0068,0x0020,0x003A,0x0000,0x0000,0x0000,
	0x0007,0x5002,0x0000,0x0000,0x0091,0x0019,0x0046,0x002D,0xFFFF,0xFFFF,0x0080,0x0052,0x0069,0x0063,0x0068,0x0074,
	0x0075,0x006E,0x0067,0x0000,0x0000,
	};

WORD CTextChangeDlg::m_wDlgData[]=
	{
	0x00C0,0x80C8,0x0000,0x0000,0x0013,0x0000,0x0000,0x0129,0x0074,0x0000,0x0000,0x00C4,0x006E,0x0064,0x0065,0x0072,
	0x006E,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,0x0066,
	0x0000,0x0000,0x0042,0x5021,0x0000,0x0000,0x003C,0x000F,0x008C,0x0081,0x0405,0xFFFF,0x0085,0x0000,0x0000,0x0000,
	0x0042,0x5021,0x0000,0x0000,0x003C,0x0024,0x008C,0x0081,0x040C,0xFFFF,0x0085,0x0000,0x0000,0x0000,0x0003,0x5001,
	0x0000,0x0000,0x000A,0x003A,0x0071,0x000A,0x0406,0xFFFF,0x0080,0x0026,0x0047,0x0072,0x006F,0x00DF,0x002F,0x004B,
	0x006C,0x0065,0x0069,0x006E,0x0073,0x0063,0x0068,0x0072,0x0065,0x0069,0x0062,0x0075,0x006E,0x0067,0x0020,0x0069,
	0x0067,0x006E,0x006F,0x0072,0x0069,0x0065,0x0072,0x0065,0x006E,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,
	0x000A,0x0044,0x0071,0x000A,0x0407,0xFFFF,0x0080,0x0047,0x0065,0x0073,0x0061,0x006D,0x0074,0x0065,0x006E,0x0020,
	0x0026,0x0054,0x0065,0x0078,0x0074,0x0020,0x0064,0x0075,0x0072,0x0063,0x0068,0x0073,0x0075,0x0063,0x0068,0x0065,
	0x006E,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x000A,0x004E,0x0071,0x000A,0x0408,0xFFFF,0x0080,0x0047,
	0x0061,0x006E,0x007A,0x0065,0x0020,0x0026,0x0057,0x00F6,0x0072,0x0074,0x0065,0x0072,0x0020,0x0073,0x0075,0x0063,
	0x0068,0x0065,0x006E,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x000A,0x0058,0x0071,0x000A,0x0409,0xFFFF,
	0x0080,0x0026,0x0052,0x0065,0x0067,0x0075,0x006C,0x00E4,0x0072,0x0065,0x0072,0x0020,0x0041,0x0075,0x0073,0x0064,
	0x0072,0x0075,0x0063,0x006B,0x0000,0x0000,0x0003,0x5801,0x0000,0x0000,0x000A,0x0062,0x0073,0x000A,0x041B,0xFFFF,
	0x0080,0x0057,0x006F,0x0072,0x0074,0x0020,0x0068,0x0065,0x0072,0x0076,0x006F,0x0072,0x0068,0x0065,0x0062,0x0065,
	0x006E,0x0000,0x0000,0x0000,0x0007,0x5002,0x0000,0x0000,0x0087,0x0046,0x003C,0x0023,0xFFFF,0xFFFF,0x0080,0x0052,
	0x0069,0x0063,0x0068,0x0074,0x0075,0x006E,0x0067,0x0000,0x0000,0x0000,0x0009,0x5001,0x0000,0x0000,0x0091,0x0051,
	0x0028,0x0008,0x040A,0xFFFF,0x0080,0x0041,0x0075,0x0026,0x0066,0x0077,0x00E4,0x0072,0x0074,0x0073,0x0000,0x0000,
	0x0009,0x5001,0x0000,0x0000,0x0091,0x005A,0x0029,0x000A,0x040B,0xFFFF,0x0080,0x0041,0x0026,0x0062,0x0077,0x00E4,
	0x0072,0x0074,0x0073,0x0000,0x0000,0x0000,0x0007,0x5002,0x0000,0x0000,0x00C9,0x0046,0x0050,0x0023,0x041F,0xFFFF,
	0x0080,0x0045,0x0072,0x0073,0x0065,0x0074,0x007A,0x0065,0x006E,0x0020,0x0069,0x006E,0x0000,0x0000,0x0009,0x5003,
	0x0000,0x0000,0x00D3,0x0050,0x003F,0x000A,0x0417,0xFFFF,0x0080,0x0047,0x0065,0x0073,0x0061,0x006D,0x0074,0x0065,
	0x0020,0x0044,0x0061,0x0074,0x0065,0x0069,0x0000,0x0000,0x0009,0x5001,0x0000,0x0000,0x00D3,0x005A,0x003C,0x000A,
	0x041E,0xFFFF,0x0080,0x0041,0x0075,0x0073,0x0077,0x0061,0x0068,0x006C,0x0000,0x0000,0x0001,0x5003,0x0000,0x0000,
	0x00E1,0x000A,0x0037,0x000F,0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,
	0x00E1,0x001E,0x0037,0x000F,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,
	0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,0x00E1,0x0032,0x0037,0x000F,0x040D,0xFFFF,0x0080,0x0026,0x0041,0x006C,
	0x006C,0x0065,0x0073,0x0020,0x00E4,0x006E,0x0064,0x0065,0x0072,0x006E,0x0000,0x0000,0x0080,0x5001,0x0000,0x0000,
	0x00CD,0x000F,0x000D,0x000D,0x0419,0xFFFF,0x0080,0x0000,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x000A,0x0012,
	0x002D,0x0008,0xFFFF,0xFFFF,0x0082,0x0053,0x0075,0x0063,0x0068,0x0065,0x0020,0x004E,0x0061,0x0063,0x0068,0x0020,
	0x003A,0x0000,0x0000,0x0000,0x0000,0x5002,0x0000,0x0000,0x000A,0x0027,0x002D,0x0008,0xFFFF,0xFFFF,0x0082,0x00C4,
	0x006E,0x0064,0x0065,0x0072,0x006E,0x0020,0x0069,0x006E,0x0020,0x003A,0x0000,0x0000,
	};

WORD CTextConfigDlg::m_wDlgData[]=
	{
	0x00C0,0x80C8,0x0000,0x0000,0x0015,0x0000,0x0000,0x00A7,0x00F6,0x0000,0x0000,0x004B,0x006F,0x006E,0x0066,0x0069,
	0x0067,0x0075,0x0072,0x0061,0x0074,0x0069,0x006F,0x006E,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,
	0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,0x0066,0x0000,0x2000,0x5081,0x0000,0x0000,0x0064,0x0005,0x0030,0x000C,
	0x0410,0xFFFF,0x0081,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x000F,0x0024,0x005A,0x000A,0x0406,0xFFFF,
	0x0080,0x0026,0x0056,0x0069,0x0072,0x0074,0x0075,0x0065,0x006C,0x006C,0x0065,0x0020,0x0044,0x0061,0x0072,0x0073,
	0x0074,0x0065,0x006C,0x006C,0x0075,0x006E,0x0067,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x000F,0x002E,
	0x0055,0x000A,0x0407,0xFFFF,0x0080,0x0026,0x004C,0x0069,0x006E,0x0069,0x0065,0x006E,0x0077,0x0065,0x0069,0x0073,
	0x0065,0x0020,0x006D,0x0061,0x0072,0x006B,0x0069,0x0065,0x0072,0x0065,0x006E,0x0000,0x0000,0x0000,0x0003,0x5001,
	0x0000,0x0000,0x000F,0x0038,0x0055,0x000A,0x0408,0xFFFF,0x0080,0x0056,0x006F,0x0072,0x0020,0x0026,0x0043,0x0075,
	0x0072,0x0073,0x006F,0x0072,0x0020,0x0065,0x0069,0x006E,0x0066,0x00FC,0x0067,0x0065,0x006E,0x0000,0x0000,0x0000,
	0x0003,0x5001,0x0000,0x0000,0x000F,0x0042,0x005B,0x000A,0x0409,0xFFFF,0x0080,0x004E,0x0061,0x0063,0x0068,0x0020,
	0x004B,0x006C,0x0061,0x006D,0x006D,0x0065,0x0072,0x006E,0x0020,0x0073,0x0075,0x0063,0x0068,0x0065,0x006E,0x0000,
	0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x000F,0x004B,0x007E,0x000A,0x0423,0xFFFF,0x0080,0x004B,0x006C,0x0061,
	0x006D,0x006D,0x0065,0x0072,0x006E,0x0020,0x0062,0x0065,0x0072,0x0065,0x0069,0x0063,0x0068,0x0073,0x0077,0x0065,
	0x0069,0x0073,0x0065,0x0020,0x006D,0x0061,0x0072,0x006B,0x0069,0x0065,0x0072,0x0065,0x006E,0x0000,0x0000,0x0000,
	0x0003,0x5001,0x0000,0x0000,0x000F,0x0055,0x0067,0x000A,0x041B,0xFFFF,0x0080,0x004D,0x0061,0x0072,0x006B,0x0065,
	0x006E,0x0020,0x0062,0x0069,0x0073,0x0020,0x007A,0x0075,0x006D,0x0020,0x005A,0x0065,0x0069,0x006C,0x0065,0x006E,
	0x0065,0x006E,0x0064,0x0065,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x000F,0x005F,0x005F,0x000A,0x041D,0xFFFF,
	0x0080,0x005A,0x0065,0x0069,0x006C,0x0065,0x006E,0x006E,0x0075,0x006D,0x006D,0x0065,0x0072,0x006E,0x0020,0x0061,
	0x006E,0x007A,0x0065,0x0069,0x0067,0x0065,0x006E,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x000F,0x007E,
	0x0077,0x000A,0x0424,0xFFFF,0x0080,0x0041,0x0075,0x0063,0x0068,0x0020,0x0064,0x0069,0x0076,0x0065,0x0072,0x0073,
	0x0065,0x006E,0x0020,0x005A,0x0065,0x0069,0x0063,0x0068,0x0065,0x006E,0x0020,0x0061,0x006E,0x0068,0x0061,0x006C,
	0x0074,0x0065,0x006E,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x000F,0x0088,0x008C,0x000A,0x0425,0xFFFF,
	0x0080,0x004E,0x0075,0x0072,0x0020,0x0061,0x006D,0x0020,0x0042,0x0065,0x0067,0x0069,0x006E,0x006E,0x0020,0x0065,
	0x0069,0x006E,0x0065,0x0073,0x0020,0x0042,0x0065,0x0072,0x0065,0x0069,0x0063,0x0068,0x0073,0x0020,0x0061,0x006E,
	0x0068,0x0061,0x006C,0x0074,0x0065,0x006E,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x000F,0x0092,0x0088,0x000A,
	0x0426,0xFFFF,0x0080,0x0041,0x0075,0x0063,0x0068,0x0020,0x0047,0x0072,0x006F,0x00DF,0x002F,0x004B,0x006C,0x0065,
	0x0069,0x006E,0x00FC,0x0062,0x0065,0x0072,0x0067,0x00E4,0x006E,0x0067,0x0065,0x006E,0x0020,0x0061,0x006E,0x0068,
	0x0061,0x006C,0x0074,0x0065,0x006E,0x0000,0x0000,0x0000,0x0003,0x5001,0x0000,0x0000,0x000F,0x009C,0x008D,0x000A,
	0x0427,0xFFFF,0x0080,0x0044,0x0061,0x0073,0x0020,0x0027,0x005F,0x0027,0x0020,0x006E,0x0069,0x0063,0x0068,0x0074,
	0x0020,0x0061,0x006C,0x0073,0x0020,0x0042,0x0075,0x0063,0x0068,0x0073,0x0074,0x0061,0x0062,0x0065,0x006E,0x0020,
	0x0062,0x0065,0x0074,0x0072,0x0061,0x0063,0x0068,0x0074,0x0065,0x006E,0x0000,0x0000,0x0001,0x5001,0x0000,0x0000,
	0x005F,0x00E1,0x0032,0x000F,0x0001,0xFFFF,0x0080,0x004F,0x004B,0x0000,0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,
	0x0014,0x00E1,0x0032,0x000F,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,
	0x0000,0x0000,0x0000,0x5000,0x0000,0x0000,0x000A,0x0007,0x0033,0x0008,0xFFFF,0xFFFF,0x0082,0x0054,0x0061,0x0062,
	0x0075,0x006C,0x0061,0x0074,0x006F,0x0072,0x002D,0x0042,0x0072,0x0065,0x0069,0x0074,0x0065,0x0000,0x0000,0x0000,
	0x0007,0x5000,0x0000,0x0000,0x0005,0x0073,0x009B,0x0037,0xFFFF,0xFFFF,0x0080,0x0057,0x006F,0x0072,0x0074,0x0073,
	0x0070,0x0072,0x00FC,0x006E,0x0067,0x0065,0x0020,0x006D,0x0069,0x0074,0x0020,0x0053,0x0074,0x0072,0x0067,0x002B,
	0x004C,0x0069,0x006E,0x006B,0x0073,0x002F,0x0052,0x0065,0x0063,0x0068,0x0074,0x0073,0x0000,0x0000,0x0007,0x5000,
	0x0000,0x0000,0x0005,0x0014,0x009B,0x005A,0xFFFF,0xFFFF,0x0080,0x0044,0x0069,0x0076,0x0065,0x0072,0x0073,0x0065,
	0x0020,0x0045,0x0069,0x006E,0x0073,0x0074,0x0065,0x006C,0x006C,0x0075,0x006E,0x0067,0x0065,0x006E,0x0000,0x0000,
	0x0007,0x5000,0x0000,0x0000,0x0005,0x00AF,0x009B,0x002D,0xFFFF,0xFFFF,0x0080,0x0057,0x006F,0x0072,0x0074,0x006D,
	0x0061,0x0072,0x006B,0x0069,0x0065,0x0072,0x0075,0x006E,0x0067,0x0065,0x006E,0x0000,0x0000,0x0000,0x0009,0x5002,
	0x0000,0x0000,0x000F,0x00B9,0x0058,0x000A,0x040A,0xFFFF,0x0080,0x004B,0x0065,0x0069,0x006E,0x0065,0x0020,0x0057,
	0x006F,0x0072,0x0074,0x0065,0x0020,0x006D,0x0061,0x0072,0x006B,0x0069,0x0065,0x0072,0x0065,0x006E,0x0000,0x0000,
	0x0009,0x5000,0x0000,0x0000,0x000F,0x00C3,0x0075,0x000A,0x040B,0xFFFF,0x0080,0x0044,0x0061,0x0073,0x0020,0x0057,
	0x006F,0x0072,0x0074,0x0020,0x0062,0x0065,0x0069,0x006D,0x0020,0x0043,0x0075,0x0072,0x0073,0x006F,0x0072,0x0020,
	0x006D,0x0061,0x006B,0x0069,0x0065,0x0072,0x0065,0x006E,0x0020,0x0000,0x0000,0x0000,0x0009,0x5000,0x0000,0x0000,
	0x000F,0x00CD,0x007B,0x000A,0x0417,0xFFFF,0x0080,0x004E,0x0075,0x0072,0x0020,0x0061,0x0075,0x0073,0x0067,0x0065,
	0x0077,0x00E4,0x0068,0x006C,0x0074,0x0065,0x0020,0x0057,0x006F,0x0072,0x0074,0x0065,0x0020,0x006D,0x0061,0x0072,
	0x006B,0x0069,0x0065,0x0072,0x0065,0x006E,0x0000,0x0000,
	};

WORD CTextQuestionDlg::m_wDlgData[]=
	{
	0x00C0,0x80C8,0x0000,0x0000,0x0004,0x0000,0x0000,0x00AC,0x0029,0x0000,0x0000,0x0054,0x0065,0x0078,0x0074,0x0020,
	0x00E4,0x006E,0x0064,0x0065,0x0072,0x006E,0x0020,0x003F,0x0000,0x0008,0x004D,0x0053,0x0020,0x0053,0x0061,0x006E,
	0x0073,0x0020,0x0053,0x0065,0x0072,0x0069,0x0066,0x0000,0x0001,0x5001,0x0000,0x0000,0x0005,0x0014,0x0032,0x000E,
	0x0006,0xFFFF,0x0080,0x004A,0x0061,0x0000,0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,0x003C,0x0014,0x0032,0x000E,
	0x0007,0xFFFF,0x0080,0x004E,0x0065,0x0069,0x006E,0x0000,0x0000,0x0000,0x0000,0x5001,0x0000,0x0000,0x0073,0x0014,
	0x0032,0x000E,0x0002,0xFFFF,0x0080,0x0041,0x0062,0x0062,0x0072,0x0065,0x0063,0x0068,0x0065,0x006E,0x0000,0x0000,
	0x0000,0x5002,0x0000,0x0000,0x0005,0x0005,0x0073,0x0008,0xFFFF,0xFFFF,0x0082,0x0054,0x0065,0x0078,0x0074,0x0020,
	0x0077,0x0075,0x0072,0x0064,0x0065,0x0020,0x0067,0x0065,0x0066,0x0075,0x006E,0x0064,0x0065,0x006E,0x002C,0x0020,
	0x006A,0x0065,0x0074,0x007A,0x0074,0x0020,0x00E4,0x006E,0x0064,0x0065,0x0072,0x006E,0x0020,0x003F,0x0000,0x0000,
	};

#endif 	

WORD CTextFindDlg::m_wDlgIcon[]=
	{
	0x0028,0x0000,0x0010,0x0000,0x000E,0x0000,0x0001,0x0004,0x0000,0x0000,0x0070,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0080,0x8000,0x0000,0x8000,0x0080,0x0080,0x0000,0x0080,0x0080,
	0x8080,0x0000,0xC0C0,0x00C0,0x8080,0x0080,0x0000,0x00FF,0xFF00,0x0000,0xFF00,0x00FF,0x00FF,0x0000,0x00FF,0x00FF,
	0xFFFF,0x0000,0xFFFF,0x00FF,0x7777,0x7777,0x7777,0x7777,0x7777,0x7777,0x7F77,0x77FF,0x7777,0x7777,0x74FF,0x778F,
	0x7777,0xFF77,0x748F,0x778F,0x7777,0x88FF,0x748F,0x778F,0xFF77,0x8888,0x748F,0x778F,0x887F,0x8888,0x748F,0x778F,
	0x8874,0x8888,0x748F,0x778F,0x4477,0x8888,0x748F,0x778F,0x7777,0x8844,0x748F,0x778F,0x7777,0x4477,0x748F,0x778F,
	0x7777,0x7777,0x744F,0x778F,0x7777,0x7777,0x7477,0x7744,0x7777,0x7777,0x7777,0x7777,
	};

WORD CTextChangeDlg::m_wDlgIcon[]=
	{
	0x0028,0x0000,0x0010,0x0000,0x000E,0x0000,0x0001,0x0004,0x0000,0x0000,0x0070,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0080,0x8000,0x0000,0x8000,0x0080,0x0080,0x0000,0x0080,0x0080,
	0x8080,0x0000,0xC0C0,0x00C0,0x8080,0x0080,0x0000,0x00FF,0xFF00,0x0000,0xFF00,0x00FF,0x00FF,0x0000,0x00FF,0x00FF,
	0xFFFF,0x0000,0xFFFF,0x00FF,0x7777,0x7777,0x7777,0x7777,0x7777,0x7777,0x7F77,0x77FF,0x7777,0x7777,0x74FF,0x778F,
	0x7777,0xFF77,0x748F,0x778F,0x7777,0x88FF,0x748F,0x778F,0xFF77,0x8888,0x748F,0x778F,0x887F,0x8888,0x748F,0x778F,
	0x8874,0x8888,0x748F,0x778F,0x4477,0x8888,0x748F,0x778F,0x7777,0x8844,0x748F,0x778F,0x7777,0x4477,0x748F,0x778F,
	0x7777,0x7777,0x744F,0x778F,0x7777,0x7777,0x7477,0x7744,0x7777,0x7777,0x7777,0x7777,
	};


//*****************************************************************************
//*
//*		Alte Dialog Position
//*
//*****************************************************************************

int CTextQuestionDlg	::m_iScreenSizeX=0;			// Alte Dialog Position
int CTextChangeDlg		::m_iScreenSizeX=0;			// Alte Dialog Position
int CTextFindDlg		::m_iScreenSizeX=0;			// Alte Dialog Position

int CTextQuestionDlg	::m_iScreenSizeY=0;			// Alte Dialog Position
int CTextChangeDlg		::m_iScreenSizeY=0;			// Alte Dialog Position
int CTextFindDlg		::m_iScreenSizeY=0;			// Alte Dialog Position

int CTextQuestionDlg	::m_iScreenOn=0;			// Alte Dialog Position
int CTextChangeDlg		::m_iScreenOn=0;			// Alte Dialog Position
int CTextFindDlg		::m_iScreenOn=0;			// Alte Dialog Position

#define	GET_OLDPOS()															\
	{																			\
	CRect		   sOldPos;														\
	GetWindowRect(&sOldPos);													\
	m_iScreenSizeX=sOldPos.left;												\
	m_iScreenSizeY=sOldPos.top;													\
	m_iScreenOn=1;																\
	}

#define	SET_OLDPOS()															\
	{																			\
	if(m_iScreenOn)																\
	if(m_iScreenSizeX>-100 && m_iScreenSizeX<GetSystemMetrics(SM_CXSCREEN)-100)	\
	if(m_iScreenSizeY>-10  && m_iScreenSizeY<GetSystemMetrics(SM_CYSCREEN)-100)	\
		{																		\
		SetWindowPos(0,m_iScreenSizeX,m_iScreenSizeY,0,0,SWP_NOOWNERZORDER|SWP_NOSIZE|SWP_NOZORDER);	\
		}																		\
	}

//*****************************************************************************
//*
//*		GetIdString
//*
//*****************************************************************************
#ifdef		USE_RC

static LPCTSTR GetIdString(unsigned uId)
	{
	static int		iNr=0;
	static CString 	sStr[4];

		iNr++;
		sStr[iNr&3].LoadString(uId);

	return sStr[iNr&3];
	}

	#define 	STRING(s,i)		GetIdString(i)

#else

	#define 	STRING(s,i)		_T(s)

#endif

//*****************************************************************************
//*
//*		Konstruktor ... Grundeinstellung der Variabeln
//*
//*****************************************************************************
CTextFindDlg::CTextFindDlg(CWnd *pParent) : CDialog((UINT)IDD_TEXT_FINDDLG,pParent)
{
#if USE_RC

	if(!iMenuInit)
		{
		iMenuInit = 1;

		aMenuText[ 0].LoadString(ID_FIND_MENU_00);
		aMenuText[ 1].LoadString(ID_FIND_MENU_01);
		aMenuText[ 2].LoadString(ID_FIND_MENU_02);
		aMenuText[ 3].LoadString(ID_FIND_MENU_03);
		aMenuText[ 4].LoadString(ID_FIND_MENU_04);
		aMenuText[ 5].LoadString(ID_FIND_MENU_05);
		aMenuText[ 6].LoadString(ID_FIND_MENU_06);
		aMenuText[ 7].LoadString(ID_FIND_MENU_07);
		aMenuText[ 8].LoadString(ID_FIND_MENU_08);
		aMenuText[ 9].LoadString(ID_FIND_MENU_09);
		aMenuText[10].LoadString(ID_FIND_MENU_10);
		aMenuText[11].LoadString(ID_FIND_MENU_11);
		aMenuText[12].LoadString(ID_FIND_MENU_12);
		aMenuText[13].LoadString(ID_FIND_MENU_13);
		aMenuText[14].LoadString(ID_FIND_MENU_14);
		aMenuText[15].LoadString(ID_FIND_MENU_15);
		aMenuText[16].LoadString(ID_FIND_MENU_16);
		aMenuText[17].LoadString(ID_FIND_MENU_17);
		aMenuText[18].LoadString(ID_FIND_MENU_18);
		aMenuText[19].LoadString(ID_FIND_MENU_19);
		aMenuText[20].LoadString(ID_FIND_MENU_20);
		aMenuText[21].LoadString(ID_FIND_MENU_21);

		for(int i=0;i<sizeof(aMenuStrings)/sizeof(aMenuStrings[0])-1;i++)
			{
			aMenuStrings[i].pText=aMenuText[i];
			}
		}

#endif
}

//*****************************************************************************
//*
//*		DoModal
//*
//*****************************************************************************
// Ausfhren des Dialoges
// Ergibt IDOK wenn Text gesucht wurde
INT_PTR	CTextFindDlg::DoModal(CWnd *pTextWnd,LPTSTR pText,int iTextSize,int iFlags,LPCTSTR pSelction)
{
int		iRet;


	m_bFullDocument			= (iFlags&FLAG_FIND_ALL		  )? 1:0;
	m_bIgnoreCase			= (iFlags&FLAG_FIND_CASE	  )? 1:0;
	m_bFullWords			= (iFlags&FLAG_FIND_WORD	  )? 1:0;
	m_bSeachUpwards			= (iFlags&FLAG_FIND_UPWARDS	  )? 0:1;
	m_bSeachDown			= (iFlags&FLAG_FIND_UPWARDS	  )? 1:0;
	m_bWordHighLight		= (iFlags&FLAG_FIND_HIGHLIGHT )? 1:0;
	m_bSpecialExpression	= (iFlags&FLAG_FIND_EXPRESSION)? 1:0;



	strlcpy(m_cSeachText,pText,sizeof(m_cSeachText));
	m_pSelection = pSelction;
	m_pTextWnd	 = pTextWnd;

	if(!pSelction)pSelction=_T("");
	if(!m_cSeachText[0])
		{
		strlcpy(m_cSeachText,pSelction,sizeof(m_cSeachText));;
		}

	m_lpDialogTemplate = NULL;

	#ifndef USE_RC
    CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);
	#endif

	iRet = CDialog::DoModal();

	strlcpy(pText,m_cSeachText,iTextSize);



return	iRet;
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CTextFindDlg::DoDataExchange(CDataExchange *pDX)
{
CWnd	   *pWnd;
LPCTSTR		pPtr;
HWND		hCombo;
int	        i;


	CDialog::DoDataExchange(pDX);


	pWnd   = GetDlgItem(IDC_COMBO1);
	hCombo = pWnd->m_hWnd;


	if(m_pSelection && !::SendMessage(hCombo,LB_GETCOUNT,0,0))
		{
		i    = 0;
		pPtr = m_pSelection;

		if(pPtr)
			{
			while(*pPtr)
				{
				::SendMessage(hCombo,CB_INSERTSTRING,i,(LPARAM)pPtr);
				pPtr+=_tcslen(pPtr)+1;
				i++;
				}
			}
		}

	DDX_Text (pDX,IDC_COMBO1, m_cSeachText,sizeof(m_cSeachText));
	DDX_Check(pDX,IDC_CHECK1, m_bIgnoreCase		  );
	DDX_Check(pDX,IDC_CHECK2, m_bFullDocument     );
	DDX_Check(pDX,IDC_CHECK3, m_bFullWords        );
	DDX_Check(pDX,IDC_CHECK4, m_bSpecialExpression);
	DDX_Check(pDX,IDC_CHECK5, m_bWordHighLight    );
	DDX_Check(pDX,IDC_RADIO1 ,m_bSeachDown        );
	DDX_Check(pDX,IDC_RADIO2, m_bSeachUpwards	  );


}

//*****************************************************************************
//*
//*		OnChanged
//*
//*****************************************************************************
//	Der Text in der Eingabe hat sich verndert
void CTextFindDlg::OnChanged()
{
TCHAR	cText[256];
int		iLen;	


 	if(!m_bHasHighLight)
		{
		EnableDlgItem(IDC_CHECK5,FALSE);
		}
	else if(!GetDlgButton(IDC_CHECK4)->GetCheck())		// Regulren Ausdruck suchen	
		{
		EnableDlgItem(IDC_CHECK5,TRUE);
		}
	else{
		iLen = GetDlgItemText(IDC_COMBO1,cText,sizeof(cText));
		EnableDlgItem(IDC_CHECK5,strcwfind(cText,0x01900000,iLen)<0);
		}

}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
//	Benden des Dialoges
void CTextFindDlg::OnCancel()
{

	UpdateData();
	
	if(m_bWordHlInit!=m_bWordHighLight)
		{
		WND_SETFLAGS(m_pTextWnd,(m_bWordHighLight)? FLAG_FIND_HIGHLIGHT:0,FLAG_FIND_HIGHLIGHT);
		}
	
	GET_OLDPOS();
	EndDialog(IDCANCEL);
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CTextFindDlg::OnDestroy()
{

	DelButtonBitmap(this,IDC_BUTTON2);

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		OnFind
//*
//*****************************************************************************
//	Suchen mit beenden des Dialoges
void CTextFindDlg::OnFind()
{
LPTSTR	    pMem;
CWnd	   *pWnd;
TextInfo	sInfo;
CRect	 	sText;
CRect	 	sRect;
CSize	 	sSize;
CPoint	 	sTop;
CPoint	 	sMark;
CPoint	 	sCursor;
CPoint	 	sScroll;
HWND     	hCombo;
int			iSizeY;
int			iPosY;
int			iMask;
int			iLen;
int	  		i,j;


	i=0;
	SetDefID(IDC_BUTTON1);
	pWnd=GetDlgItem(IDC_COMBO1);
	hCombo=pWnd->m_hWnd;
	UpdateData();




	iMask =		FLAG_FIND_ALL|							// Flags einstellen
				FLAG_FIND_CASE|
				FLAG_FIND_WORD|
				FLAG_FIND_UPWARDS|
				FLAG_FIND_HIGHLIGHT|
				FLAG_FIND_EXPRESSION;

							 j=0;
	if(m_bFullDocument		)j|=FLAG_FIND_ALL;
	if(m_bIgnoreCase		)j|=FLAG_FIND_CASE;
	if(m_bFullWords			)j|=FLAG_FIND_WORD;
	if(m_bSeachDown			)j|=FLAG_FIND_UPWARDS;
	if(m_bWordHighLight		)j|=FLAG_FIND_HIGHLIGHT;
	if(m_bSpecialExpression	)j|=FLAG_FIND_EXPRESSION;


	WND_SETFLAGS(m_pTextWnd,j,iMask);					// Flags speichern


		iLen=::SendMessage(hCombo,WM_GETTEXTLENGTH,0,0);
	if(!iLen)											// Text Lnge prfen
		{
		MessageBeep(MB_ICONASTERISK);
		return;
		}


	pMem=new TCHAR[iLen+1];
	::SendMessage(hCombo,WM_GETTEXT,iLen+1,(LPARAM)pMem);

														// Suchwrter hervorheben erlaubt
	if(m_bWordHighLight && (!m_bSpecialExpression || strcwfind(pMem,0x01900000,iLen)<0))
		{
		sInfo.pText = pMem;
		sInfo.iMode = (sizeof(TCHAR)==1)? 0:TEXT_IS_UTF16;
		if(m_bIgnoreCase)sInfo.iMode|=TEXT_NOCASE;
		if(m_bFullWords )sInfo.iMode|=TEXT_WORD;
		WND_HIGHLIGHT(m_pTextWnd,&sInfo);
		}

	sInfo.iMode = 0;
	sInfo.pText = pMem;
	SetCursor(IDC_WAIT);
	j=WND_FIND(m_pTextWnd,&sInfo);
	SetCursor(IDC_ARROW);

	if(!j)
		{
		MessageBox(STRING("Text wurde nicht gefunden !",ID_FINDDLG_00),0,MB_ICONERROR);
		GotoDlgCtrl(GetDlgItem(IDC_COMBO1));
		delete pMem;
		return;
		}

	sSize      = WND_GETFONTSIZE(m_pTextWnd);			// Fenster verschieben
	sCursor    = WND_GETCURSOR  (m_pTextWnd);
	sScroll    = WND_GETSCROLL  (m_pTextWnd);
	sMark      = WND_GETMARK    (m_pTextWnd);
	sMark     -= sScroll;
	sCursor   -= sScroll;

	sCursor.x *= sSize.cx;
	sCursor.y *= sSize.cy;
	sMark  .x *= sSize.cx;
	sMark  .y *= sSize.cy;

	m_pTextWnd->GetWindowRect(sText);					// Schirmkoordinaten
	GetWindowRect(sRect);

	sTop	= sText.TopLeft();
	sText	= CRect(sCursor,sMark);
	sText.InflateRect(0,0,sSize.cx,sSize.cy);
	sText  += sTop;
	iPosY	= GetSystemMetrics(SM_CYSCREEN)/2;

	do	{
		if(sRect.PtInRect(sText.TopLeft    ())){i=sText.top   +sSize.cy/2;break;}
		if(sRect.PtInRect(sText.CenterPoint())){i=sText.bottom-sSize.cy/2;break;}
		if(sRect.PtInRect(sText.BottomRight())){i=sText.bottom-sSize.cy/2;break;}
		iPosY=0;
		}while(0);

	if(iPosY)											// Dialog Verschieben
		{
		iSizeY=sRect.bottom-sRect.top;
		if(i>iPosY)SetWindowPos(0,sRect.left,i-sSize.cy-10-iSizeY,0,0,SWP_NOSIZE|SWP_NOREPOSITION);
		else	   SetWindowPos(0,sRect.left,i+sSize.cy+10       ,0,0,SWP_NOSIZE|SWP_NOREPOSITION);
		}


	delete pMem;

	GET_OLDPOS();

	EndDialog(IDOK);
}

//*****************************************************************************
//*
//*		OnNext
//*
//*****************************************************************************
//	Suchen ohne Beenden des Dialoges
void CTextFindDlg::OnNext()
{
LPTSTR		pMem;
CWnd	   *pWnd;
CRect		sText;
CRect		sRect;
CSize		sSize;
CPoint		sCursor;
CPoint		sScroll;
CPoint		sMark;
CPoint		sTop;
HWND		hCombo;
TextInfo	sInfo;
int	  		iSizeY;
int	  		iPosY;
int	  		iMask;
int	  		iLen;
int	  		i,j;


	i=0;
	SetDefID(IDC_BUTTON1);
	pWnd=GetDlgItem(IDC_COMBO1);
	hCombo=pWnd->m_hWnd;
	UpdateData();

	iMask	=   FLAG_FIND_ALL|							// Flags einstellen
				FLAG_FIND_CASE|
				FLAG_FIND_WORD|
				FLAG_FIND_UPWARDS|
				FLAG_FIND_HIGHLIGHT|
				FLAG_FIND_EXPRESSION;


							 j =0;
	if(m_bFullDocument		)j|=FLAG_FIND_ALL;
	if(m_bIgnoreCase		)j|=FLAG_FIND_CASE;
	if(m_bFullWords			)j|=FLAG_FIND_WORD;
	if(m_bSeachDown			)j|=FLAG_FIND_UPWARDS;
	if(m_bWordHighLight 	)j|=FLAG_FIND_HIGHLIGHT;
	if(m_bSpecialExpression	)j|=FLAG_FIND_EXPRESSION;


	WND_SETFLAGS(m_pTextWnd,j,iMask);					// Flags speichern

		iLen=::SendMessage(hCombo,WM_GETTEXTLENGTH,0,0);
	if(!iLen)
		{
		MessageBeep(MB_ICONASTERISK);
		return;
		}

	pMem=new TCHAR[iLen+1];
	::SendMessage(hCombo,WM_GETTEXT,iLen+1,(LPARAM)pMem);

														// Suchwrter hervorheben erlaubt
	if(m_bWordHighLight && (!m_bSpecialExpression || strcwfind(pMem,0x01900000,iLen)<0))
		{
		sInfo.pText = pMem;
		sInfo.iMode = (sizeof(TCHAR)==1)? 0:TEXT_IS_UTF16;
		if(m_bIgnoreCase)sInfo.iMode|=TEXT_NOCASE;
		if(m_bFullWords )sInfo.iMode|=TEXT_WORD;
		WND_HIGHLIGHT(m_pTextWnd,&sInfo);
		}


	sInfo.iMode = 4;
	sInfo.pText	= pMem;
	SetCursor(IDC_WAIT);
	j			= WND_FIND(m_pTextWnd,&sInfo);
	SetCursor(IDC_ARROW);

	if(!j)
		{
		MessageBox(STRING("Text wurde nicht gefunden !",ID_FINDDLG_00),0,MB_ICONERROR);
		GotoDlgCtrl(GetDlgItem(IDC_COMBO1));
		delete pMem;
		return;
		}

	sSize      = WND_GETFONTSIZE(m_pTextWnd);			// Fenster verschieben
	sCursor    = WND_GETCURSOR  (m_pTextWnd);
	sScroll    = WND_GETSCROLL  (m_pTextWnd);
	sMark      = WND_GETMARK    (m_pTextWnd);
	sMark     -= sScroll;
	sCursor   -= sScroll;

	sCursor.x *= sSize.cx;
	sCursor.y *= sSize.cy;
	sMark  .x *= sSize.cx;
	sMark  .y *= sSize.cy;

	m_pTextWnd->GetWindowRect(sText);					// Schirmkoordinaten
	GetWindowRect(sRect);

	sTop	= sText.TopLeft();
	sText	= CRect(sCursor,sMark);
	sText.InflateRect(0,0,sSize.cx,sSize.cy);
	sText  += sTop;
	iPosY   = GetSystemMetrics(SM_CYSCREEN)/2;

	do	{
		if(sRect.PtInRect(sText.TopLeft    ())){i=sText.top   +sSize.cy/2;break;}
		if(sRect.PtInRect(sText.CenterPoint())){i=sText.bottom-sSize.cy/2;break;}
		if(sRect.PtInRect(sText.BottomRight())){i=sText.bottom-sSize.cy/2;break;}
		iPosY=0;
		}while(0);

	if(iPosY)											// Dialog Verschieben
		{
		iSizeY = sRect.bottom-sRect.top;
		if(i>iPosY)SetWindowPos(0,sRect.left,i-sSize.cy-10-iSizeY,0,0,SWP_NOSIZE|SWP_NOREPOSITION);
		else	   SetWindowPos(0,sRect.left,i+sSize.cy+10       ,0,0,SWP_NOSIZE|SWP_NOREPOSITION);
		}


delete pMem;
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CTextFindDlg::OnInitDialog()
{

	SetButtonBitmap(this,IDC_BUTTON2,m_wDlgIcon);

	SET_OLDPOS();
	SubclassComboBox(this,IDC_COMBO1,SCB_COLORMSG);

	m_bHasHighLight = WND_GETFLAGS(m_pTextWnd)&FLAG_HAS_HIGHLIGHT;
	m_bWordHlInit   = m_bWordHighLight;
	
	OnChanged();


return CDialog::OnInitDialog();
}
//*****************************************************************************
//*
//*		OnSelect
//*
//*****************************************************************************
void CTextFindDlg::OnSelect()
{
RECT	sRect;
CMenu	sMenu;
int		i;


	sMenu.CreatePopupMenu();


	for(i=0;aMenuStrings[i].pText;i++)
		{
		if(aMenuStrings[i].iId)
				sMenu.AppendMenu(MF_STRING,ID_TEXT_POS+aMenuStrings[i].iId-1,aMenuStrings[i].pText);
		else	sMenu.AppendMenu(MF_SEPARATOR);
		}

	GetDlgItem(IDC_BUTTON2)->GetWindowRect(&sRect);
	sMenu.TrackPopupMenu(TPM_LEFTALIGN,sRect.right,sRect.top,this);
	sMenu.DestroyMenu();

}

//*****************************************************************************
//*
//*		OnMenu
//*
//*****************************************************************************
void CTextFindDlg::OnMenu(UINT iMode)
{
CComboBox  *pCombo;
TCHAR 		cBuffer[256];
TCHAR		cText  [280];
int			iLen;
int			iPos;


	iMode -= ID_TEXT_POS-1;

	pCombo = (CComboBox*)GetDlgItem(IDC_COMBO1);
	pCombo->GetWindowText(cBuffer,255);cBuffer[255]=0;
	iPos   = pCombo->GetEditSel()&0xFFFF;



	   iLen=_tcslen(cBuffer);
	if(iLen<iPos)iPos=iLen;

	memcpy(cText,cBuffer,iPos*sizeof(TCHAR));

	switch(iMode)
			{
	case 1:	_tcscpy(cText+iPos,_T("?"   ));		break;
	case 2:	_tcscpy(cText+iPos,_T("*"   ));		break;
	case 3:	_tcscpy(cText+iPos,_T("\\w" ));		break;
	case 4:	_tcscpy(cText+iPos,_T("\\z" ));		break;
	case 5:	_tcscpy(cText+iPos,_T("\\_" ));		break;
	case 6:	_tcscpy(cText+iPos,_T("\\." ));		break;
	case 7:	_tcscpy(cText+iPos,_T("\\a" ));		break;
	case 8:	_tcscpy(cText+iPos,_T("\\e" ));		break;
	case 9:	_tcscpy(cText+iPos,_T("\\p" ));		break;
	case 10:_tcscpy(cText+iPos,_T("\\o" ));		break;
	case 11:_tcscpy(cText+iPos,_T("\\g" ));		break;
	case 12:_tcscpy(cText+iPos,_T("\\f" ));		break;
	case 13:_tcscpy(cText+iPos,_T("\\m" ));		break;
	case 14:_tcscpy(cText+iPos,_T("\\[]"));		break;
	case 15:_tcscpy(cText+iPos,_T("\\()"));		break;
	case 16:_tcscpy(cText+iPos,_T("\\<>"));		break;
	case 17:_tcscpy(cText+iPos,_T("\\{}"));		break;
	case 18:_tcscpy(cText+iPos,_T("\\||"));		break;
	case 19:_tcscpy(cText+iPos,_T("\\##"));		break;
	case 20:_tcscpy(cText+iPos,_T("\\&&"));		break;
	case 21:_tcscpy(cText+iPos,_T("\\$$"));		break;
			}

	iLen = _tcslen(cText+iPos)+iPos;
	_tcscpy(cText+iLen,cBuffer+iPos);

	if(iMode>=14)iLen--;

	UpdateData(FALSE);

	pCombo->SetWindowText(cText);
	pCombo->SetFocus();
	pCombo->SetEditSel(iLen,iLen);


	m_bSpecialExpression = 1;
	GetDlgItem(IDC_CHECK4)->SendMessage(BM_SETCHECK,1);

}

//*****************************************************************************
//*
//*		DIALOGFELD FR KONFIGURATION
//*
//*		Konstruktor ... Grundeinstellung der Variabeln
//*
//*****************************************************************************
CTextConfigDlg::CTextConfigDlg(CWnd *pParent):CDialog((UINT)IDD_TEXT_CONFIGDLG,pParent)
{
}

//*****************************************************************************
//*
//*		DoModal
//*
//*****************************************************************************
//	Ausfhren des Dialoges
//	Ergibt IDOK wenn Text gesucht wurde
INT_PTR	CTextConfigDlg::DoModal(CWnd *pTextWnd,int iFlags,int iTabWidth)
{
int		iRet;


	m_iInitFlags		=  iFlags;
	m_bVirtual			= (iFlags&FLAG_VIRTUAL_SCREEN)? 1:0;
	m_bBracketArea		= (iFlags&FLAG_BRACKET_MODE  )? 1:0;
	m_bInsertBefore		= (iFlags&FLAG_INSERT_BEFOR  )? 1:0;
	m_bMarkUntilEnd		= (iFlags&FLAG_MARK_TO_END   )? 1:0;
	m_bFindBrackets		= (iFlags&FLAG_BRACKET       )? 1:0;
	m_bMarkFullLines	= (iFlags&FLAG_LINE_MARK	 )? 1:0;
	m_bShowLineNumbers	= (iFlags&FLAG_LINENUMBERS   )? 1:0;
	m_bJumpMisc			= (iFlags&FLAG_WORD_JMP_MISC )? 1:0;
	m_bJumpFirst		= (iFlags&FLAG_WORD_JMP_FIRST)? 1:0;
	m_bJumpUpper		= (iFlags&FLAG_WORD_JMP_UPPER)? 1:0;
	m_bJumpUnter		= (iFlags&FLAG_WORD_JMP_UNTER)? 1:0;
	
	switch(iFlags&FLAG_WORDMARK_TYPE)
		{
	default:											m_iMarkMode = 0;	break;
	case (FLAG_WORDMARK_TYPE&(FLAG_WORDMARK_TYPE>>1)):	m_iMarkMode = 1;	break;
	case (FLAG_WORDMARK_TYPE&(FLAG_WORDMARK_TYPE<<1)):	m_iMarkMode = 2;	break;
	case  FLAG_WORDMARK_TYPE:							m_iMarkMode = 3;	break;
		}


	m_iTabWidth		    =  iTabWidth;
	m_pTextWnd			=  pTextWnd;
	m_lpDialogTemplate  =  NULL;

	#ifndef USE_RC
	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);
	#endif

	iRet = CDialog::DoModal();


return	iRet;
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CTextConfigDlg::DoDataExchange(CDataExchange *pDX)
{

	CDialog::DoDataExchange(pDX);

	DDX_Text (pDX,IDC_EDIT1 , m_iTabWidth	    );
	DDX_Check(pDX,IDC_CHECK1, m_bVirtual		);
	DDX_Check(pDX,IDC_CHECK2, m_bMarkFullLines  );
	DDX_Check(pDX,IDC_CHECK3, m_bInsertBefore   );
	DDX_Check(pDX,IDC_CHECK4, m_bFindBrackets   );
	DDX_Check(pDX,IDC_CHECK5, m_bMarkUntilEnd   );
	DDX_Check(pDX,IDC_CHECK6, m_bBracketArea    );
	DDX_Check(pDX,IDC_CHECK7, m_bShowLineNumbers);
	DDX_Check(pDX,IDC_CHECK8, m_bJumpMisc       );
	DDX_Check(pDX,IDC_CHECK9, m_bJumpFirst      );
	DDX_Check(pDX,IDC_CHECK10,m_bJumpUpper      );
	DDX_Check(pDX,IDC_CHECK11,m_bJumpUnter      );
	DDX_Radio(pDX,IDC_RADIO1 ,m_iMarkMode		);

}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CTextConfigDlg::OnInitDialog()
{

	if(m_iMarkMode==3 || !(m_iInitFlags&FLAG_HAS_WORDMARK))
		{
		GetDlgItem(IDC_RADIO1)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO2)->EnableWindow(FALSE);
		GetDlgItem(IDC_RADIO3)->EnableWindow(FALSE);
		}


return CDialog::OnInitDialog();
}

//*****************************************************************************
//*
//*		OnOk
//*
//*****************************************************************************
void CTextConfigDlg::OnOk()
{
int		iFlags=0;
int		iMask;



	UpdateData();

	if(m_bShowLineNumbers)iFlags|=FLAG_LINENUMBERS;
	if(m_bVirtual	     )iFlags|=FLAG_VIRTUAL_SCREEN;
	if(m_bBracketArea	 )iFlags|=FLAG_BRACKET_MODE;
	if(m_bInsertBefore   )iFlags|=FLAG_INSERT_BEFOR;
	if(m_bMarkUntilEnd	 )iFlags|=FLAG_MARK_TO_END;
	if(m_bMarkFullLines	 )iFlags|=FLAG_LINE_MARK;
	if(m_bFindBrackets   )iFlags|=FLAG_BRACKET;
	if(m_bJumpMisc       )iFlags|=FLAG_WORD_JMP_MISC;
	if(m_bJumpFirst      )iFlags|=FLAG_WORD_JMP_FIRST;
	if(m_bJumpUpper      )iFlags|=FLAG_WORD_JMP_UPPER;
	if(m_bJumpUnter      )iFlags|=FLAG_WORD_JMP_UNTER;

	switch(m_iMarkMode)
		{
	case 1:	iFlags|=(FLAG_WORDMARK_TYPE&(FLAG_WORDMARK_TYPE>>1));	break;
	case 2:	iFlags|=(FLAG_WORDMARK_TYPE&(FLAG_WORDMARK_TYPE<<1));	break;
	case 3:	iFlags|= FLAG_WORDMARK_TYPE;							break;
		}


	if(m_iTabWidth<1 || m_iTabWidth>32)
		{
		MessageBox(STRING("Tabulator muss zwischen 1 und 32 liegen !",ID_CFGDLG_00),0,MB_ICONERROR);
		GotoDlgCtrl(GetDlgItem(IDC_EDIT1));
		return;
		}


	iMask  = FLAG_LINENUMBERS;
	iMask |= FLAG_VIRTUAL_SCREEN;
	iMask |= FLAG_BRACKET_MODE;
	iMask |= FLAG_INSERT_BEFOR;
	iMask |= FLAG_MARK_TO_END;
	iMask |= FLAG_LINE_MARK;
	iMask |= FLAG_BRACKET;
	iMask |= FLAG_WORD_JMP_MISC;
	iMask |= FLAG_WORD_JMP_FIRST;
	iMask |= FLAG_WORD_JMP_UPPER;
	iMask |= FLAG_WORD_JMP_UNTER;
	
	if(m_iMarkMode!=3 && (m_iInitFlags&FLAG_HAS_WORDMARK))
		{
		iMask |= FLAG_WORDMARK_TYPE;
		}

	WND_SETFLAGS    (m_pTextWnd,iFlags,iMask);
	WND_SETTABWIDTH(m_pTextWnd,m_iTabWidth);

	EndDialog(IDOK);
}





//*****************************************************************************
//*
//*
//*		Dialog CTextQuestionDlg
//*
//*
//*****************************************************************************
CTextQuestionDlg::CTextQuestionDlg(CWnd *pParent):CDialog((UINT)IDD_TEXT_QUESTIONDLG,pParent)
{

}

//*****************************************************************************
//*
//*		DoModal
//*
//*****************************************************************************
//	Ausfhren des Dialoges
//	Ergibt IDYES/IDNO/IDCANCEL
INT_PTR	CTextQuestionDlg::DoModal()
{

	m_lpDialogTemplate = NULL;

	#ifndef USE_RC
    CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);
	#endif


return CDialog::DoModal();
}

//*****************************************************************************
//*
//*		Move
//*
//*****************************************************************************
void CTextQuestionDlg::Move()
{
CPoint	 sCursor;
CPoint	 sScroll;
CPoint	 sMark;
CPoint	 sTop;
CRect	 sText;
CRect	 sRect;
CSize	 sSize;
int		 iSizeY;
int		 iPosY;
int		 i;

	i		   = 0;
	sSize	   = WND_GETFONTSIZE(m_pTextWnd);			// Fenster verschieben
	sCursor    = WND_GETCURSOR  (m_pTextWnd);
	sScroll    = WND_GETSCROLL  (m_pTextWnd);
	sMark      = WND_GETMARK    (m_pTextWnd);
	sMark     -= sScroll;
	sCursor   -= sScroll;

	sCursor.x *= sSize.cx;
	sCursor.y *= sSize.cy;
	sMark  .x *= sSize.cx;
	sMark  .y *= sSize.cy;

	m_pTextWnd->GetWindowRect(sText);					// Schirmkoordinaten
	GetWindowRect(sRect);

	sTop	= sText.TopLeft();
	sText	= CRect(sCursor,sMark);
	sText.InflateRect(0,0,sSize.cx,sSize.cy);
	sText  += sTop;
	iPosY   = GetSystemMetrics(SM_CYSCREEN)/2;

	do	{
		if(sRect.PtInRect(sText.TopLeft    ())){i=sText.top   +sSize.cy/2;break;}
		if(sRect.PtInRect(sText.CenterPoint())){i=sText.bottom-sSize.cy/2;break;}
		if(sRect.PtInRect(sText.BottomRight())){i=sText.bottom-sSize.cy/2;break;}
		iPosY = 0;
		}while(0);

	if(iPosY)								// Dialog Verschieben
		{
		iSizeY=sRect.bottom-sRect.top;
		if(i>iPosY)SetWindowPos(0,sRect.left,i-sSize.cy-10-iSizeY,0,0,SWP_NOSIZE|SWP_NOREPOSITION);
		else	   SetWindowPos(0,sRect.left,i+sSize.cy+10       ,0,0,SWP_NOSIZE|SWP_NOREPOSITION);
		}

}

//*****************************************************************************
//*
//*		OnYes/OnNo/OnCancel
//*
//*****************************************************************************
void CTextQuestionDlg ::OnYes   (){Move();GET_OLDPOS();EndDialog(IDYES   );}
void CTextQuestionDlg ::OnNo    (){Move();GET_OLDPOS();EndDialog(IDNO    );}
void CTextQuestionDlg ::OnCancel(){Move();GET_OLDPOS();EndDialog(IDCANCEL);}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CTextQuestionDlg::OnInitDialog()
{

	SET_OLDPOS();


return CDialog::OnInitDialog();
}





//*****************************************************************************
//*
//*		DIALOGFELD FR TEXT NDERN
//*
//*		Konstruktor ... Grundeinstellung der Variabeln
//*
//*****************************************************************************
CTextChangeDlg::CTextChangeDlg(CWnd *pParent) : CDialog((UINT)IDD_TEXT_CHANGEDLG, pParent)
{
#if USE_RC

	if(!iMenuInit)
		{
		iMenuInit=1;

		aMenuText[ 0].LoadString(ID_FIND_MENU_00);
		aMenuText[ 1].LoadString(ID_FIND_MENU_01);
		aMenuText[ 2].LoadString(ID_FIND_MENU_02);
		aMenuText[ 3].LoadString(ID_FIND_MENU_03);
		aMenuText[ 4].LoadString(ID_FIND_MENU_04);
		aMenuText[ 5].LoadString(ID_FIND_MENU_05);
		aMenuText[ 6].LoadString(ID_FIND_MENU_06);
		aMenuText[ 7].LoadString(ID_FIND_MENU_07);
		aMenuText[ 8].LoadString(ID_FIND_MENU_08);
		aMenuText[ 9].LoadString(ID_FIND_MENU_09);
		aMenuText[10].LoadString(ID_FIND_MENU_10);
		aMenuText[11].LoadString(ID_FIND_MENU_11);
		aMenuText[12].LoadString(ID_FIND_MENU_12);
		aMenuText[13].LoadString(ID_FIND_MENU_13);
		aMenuText[14].LoadString(ID_FIND_MENU_14);
		aMenuText[15].LoadString(ID_FIND_MENU_15);
		aMenuText[16].LoadString(ID_FIND_MENU_16);
		aMenuText[17].LoadString(ID_FIND_MENU_17);
		aMenuText[18].LoadString(ID_FIND_MENU_18);
		aMenuText[19].LoadString(ID_FIND_MENU_19);
		aMenuText[20].LoadString(ID_FIND_MENU_20);

		for(int i=0;i<sizeof(aMenuStrings)/sizeof(aMenuStrings[0])-1;i++)
			{
			aMenuStrings[i].pText = aMenuText[i];
			}
		}

#endif
}

//*****************************************************************************
//*
//*		DoModal
//*
//*****************************************************************************
// Ausfhren des Dialoges
// Ergibt IDOK wenn Text gesucht wurde
INT_PTR	CTextChangeDlg::DoModal(CWnd *pTextWnd,LPTSTR pText,int iTextSize,LPTSTR pChange,int iChangeSize,int iFlags,LPCTSTR pSelction)
{
TCHAR   cBuffer[256];
int		iRet;


	m_bFullDocument			= (iFlags&FLAG_FIND_ALL			)? 1:0;
	m_bIgnoreCase			= (iFlags&FLAG_FIND_CASE		)? 1:0;
	m_bFullWords			= (iFlags&FLAG_FIND_WORD		)? 1:0;
	m_bWordHighLight		= (iFlags&FLAG_FIND_HIGHLIGHT   )? 1:0;
	m_bSpecialExpression	= (iFlags&FLAG_FIND_EXPRESSION	)? 1:0;
	m_bSeachUpwards			= (iFlags&FLAG_FIND_UPWARDS		)? 0:1;
	m_bSeachDown			= (iFlags&FLAG_FIND_UPWARDS		)? 1:0;
	m_bFullModeOn			= (iFlags&FLAG_CHANGE_SELECTION	)? 1:0;

	cBuffer[0] = 0;
	
	if(!pSelction)pSelction="";
	if(!pChange)pChange=cBuffer;

	strlcpy(m_cSeachText,pText  ,sizeof(m_cSeachText));
	strlcpy(m_cNewText  ,pChange,sizeof(m_cNewText  ));

	if(!m_cSeachText[0])
		{
		strlcpy(m_cSeachText,pSelction,sizeof(m_cSeachText));
		}

	m_pSelection				= pSelction;
	m_pTextWnd					= pTextWnd;
	m_sQuestionDlg.m_pTextWnd	= pTextWnd;
	m_bFullMode					= 0;


	m_lpDialogTemplate = NULL;

	#ifndef USE_RC
	CDialog::InitModalIndirect((LPCDLGTEMPLATE)m_wDlgData);
	#endif

	iRet = CDialog::DoModal();

	strlcpy(pText  ,m_cSeachText,iTextSize  );
	strlcpy(pChange,m_cNewText  ,iChangeSize);



return	iRet;
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CTextChangeDlg::DoDataExchange(CDataExchange *pDX)
{
LPCTSTR		pPtr;
HWND		hBox1;
HWND		hBox2;
int	        i;


	CDialog::DoDataExchange(pDX);


	hBox1 = GetDlgItem(IDC_COMBO1)->m_hWnd;
	hBox2 = GetDlgItem(IDC_COMBO2)->m_hWnd;

	if(m_pSelection && !::SendMessage(hBox1,LB_GETCOUNT,0,0))
		{
		i    = 0;
		pPtr = m_pSelection;

		if(pPtr)
			{
			while(*pPtr)
				{
				::SendMessage(hBox1,CB_INSERTSTRING,i,(LPARAM)pPtr);
				::SendMessage(hBox2,CB_INSERTSTRING,i,(LPARAM)pPtr);
				pPtr+=_tcslen(pPtr)+1;
				i++;
				}
			}
		}

	DDX_Text (pDX,IDC_COMBO1, m_cSeachText  ,sizeof(m_cSeachText));
	DDX_Text (pDX,IDC_COMBO2, m_cNewText	,sizeof(m_cNewText  ));
	DDX_Check(pDX,IDC_CHECK1, m_bIgnoreCase			);
	DDX_Check(pDX,IDC_CHECK2, m_bFullDocument       );
	DDX_Check(pDX,IDC_CHECK3, m_bFullWords          );
	DDX_Check(pDX,IDC_CHECK4, m_bSpecialExpression  );
	DDX_Check(pDX,IDC_CHECK5, m_bWordHighLight      );
	DDX_Check(pDX,IDC_RADIO1, m_bSeachDown          );
	DDX_Check(pDX,IDC_RADIO2, m_bSeachUpwards		);
	DDX_Radio(pDX,IDC_RADIO3, m_bFullMode           );


}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
//	Benden des Dialoges
void CTextChangeDlg::OnCancel()
{
	GET_OLDPOS();
	EndDialog(IDCANCEL);
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CTextChangeDlg::OnDestroy()
{

	DelButtonBitmap(this,IDC_BUTTON2);

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		OnChange
//*
//*****************************************************************************
//	Suchen mit beenden des Dialoges
void CTextChangeDlg::OnChange()
{
LPTSTR	    pMem1;
LPTSTR		pMem2;
HWND		hBox1;
HWND		hBox2;
TextInfo	sInfo;
int			iFlags;
int			iFlag;
int			iMask;
int			iLen;
int			i,j;



	hBox1 = GetDlgItem(IDC_COMBO1)->m_hWnd;
	hBox2 = GetDlgItem(IDC_COMBO2)->m_hWnd;

	UpdateData();

	iMask =	FLAG_FIND_ALL|								// Flags einstellen
			FLAG_FIND_CASE|			
			FLAG_FIND_WORD|
			FLAG_FIND_UPWARDS|
			FLAG_FIND_HIGHLIGHT|
			FLAG_FIND_EXPRESSION;

							 iFlags =0;
	if(m_bFullDocument		)iFlags|=FLAG_FIND_ALL;
	if(m_bIgnoreCase		)iFlags|=FLAG_FIND_CASE;
	if(m_bFullWords			)iFlags|=FLAG_FIND_WORD;
	if(m_bSeachDown			)iFlags|=FLAG_FIND_UPWARDS;
	if(m_bWordHighLight     )iFlags|=FLAG_FIND_HIGHLIGHT;
	if(m_bSpecialExpression	)iFlags|=FLAG_FIND_EXPRESSION;


	WND_SETFLAGS(m_pTextWnd,iFlags,iMask);				// Flags speichern

		iLen=::SendMessage(hBox1,WM_GETTEXTLENGTH,0,0);
	if(!iLen)											// Textlnge prfen
		{											
		MessageBeep(MB_ICONASTERISK);
		return;
		}


	pMem1=new TCHAR[iLen+1];	::SendMessage(hBox1,WM_GETTEXT,iLen+1,(LPARAM)pMem1); iLen=::SendMessage(hBox2,WM_GETTEXTLENGTH,0,0);
	pMem2=new TCHAR[iLen+1];	::SendMessage(hBox2,WM_GETTEXT,iLen+1,(LPARAM)pMem2);

	ShowWindow(SW_HIDE);

														// Suchwrter hervorheben erlaubt
	if(m_bWordHighLight && (!m_bSpecialExpression || strcwfind(pMem1,0x01900000,iLen)<0))
		{
		sInfo.pText = pMem1;
		sInfo.iMode = (sizeof(TCHAR)==1)? 0:TEXT_IS_UTF16;
		if(m_bIgnoreCase)sInfo.iMode|=TEXT_NOCASE;
		if(m_bFullWords )sInfo.iMode|=TEXT_WORD;
		WND_HIGHLIGHT(m_pTextWnd,&sInfo);
		}

	j     = 0;
	iFlag = 0;

	for(;;)
		{
		sInfo.iMode  =  (m_bFullMode)? 8:0;
		sInfo.iMode |=  iFlag;
		sInfo.pText  =  pMem1;

		SetCursor(IDC_WAIT);
		i=WND_FIND(m_pTextWnd,&sInfo);
		SetCursor(IDC_ARROW);

		if(!i)
			{
			if(j)break;
			MessageBox(STRING("Text wurde nicht gefunden !",ID_FINDDLG_00),0,MB_ICONINFORMATION);
			break;
			}

		j++;

		   i=m_sQuestionDlg.DoModal();
		if(i==IDCANCEL)break;
 		if(i==IDYES)									// Text ndern ?
			{
			sInfo.iMode   = 0;
			sInfo.pText   = pMem1;
			sInfo.pChange = pMem2;
			i = WND_CHANGE(m_pTextWnd,&sInfo);
			iFlag = 0x00;
			}
		else{
			iFlag = 0x10;
			}
		}

	delete pMem1;
	delete pMem2;

	GET_OLDPOS();

	EndDialog(IDOK);

}

//*****************************************************************************
//*
//*		OnAll
//*
//*****************************************************************************
// Suchen ohne beenden des Dialoges
void CTextChangeDlg::OnAll()
{
TCHAR		cBuffer[256];
LPTSTR		pMem1;
LPTSTR		pMem2;
HWND		hBox1;
HWND		hBox2;
TextInfo	sInfo;
int			iFlags;
int			iMask;
int			iLen;
int			i;



	hBox1 = GetDlgItem(IDC_COMBO1)->m_hWnd;
	hBox2 = GetDlgItem(IDC_COMBO2)->m_hWnd;

	UpdateData();

	iMask =	FLAG_FIND_ALL|									// Flags einstellen
			FLAG_FIND_CASE|				
			FLAG_FIND_WORD|
			FLAG_FIND_UPWARDS|
			FLAG_FIND_HIGHLIGHT|
			FLAG_FIND_EXPRESSION;

							 iFlags =0;
	if(m_bFullDocument		)iFlags|=FLAG_FIND_ALL;
	if(m_bIgnoreCase		)iFlags|=FLAG_FIND_CASE;
	if(m_bFullWords			)iFlags|=FLAG_FIND_WORD;
	if(m_bSeachDown			)iFlags|=FLAG_FIND_UPWARDS;
	if(m_bWordHighLight     )iFlags|=FLAG_FIND_HIGHLIGHT;
	if(m_bSpecialExpression	)iFlags|=FLAG_FIND_EXPRESSION;



	WND_SETFLAGS(m_pTextWnd,iFlags,iMask);					// Flags speichern


	    iLen=::SendMessage(hBox1,WM_GETTEXTLENGTH,0,0);
	if(!iLen)												// Textlnge prfen	
		{ 
		MessageBeep(MB_ICONASTERISK);
		return;
		}

	pMem1 = new TCHAR[iLen+1];	::SendMessage(hBox1,WM_GETTEXT,iLen+1,(LPARAM)pMem1); iLen=::SendMessage(hBox2,WM_GETTEXTLENGTH,0,0);
	pMem2 = new TCHAR[iLen+1];	::SendMessage(hBox2,WM_GETTEXT,iLen+1,(LPARAM)pMem2);

															// Suchwrter hervorheben erlaubt
	if(m_bWordHighLight && (!m_bSpecialExpression || strcwfind(pMem1,0x01900000,iLen)<0))
		{
		sInfo.pText = pMem1;
		sInfo.iMode = (sizeof(TCHAR)==1)? 0:TEXT_IS_UTF16;
		if(m_bIgnoreCase)sInfo.iMode|=TEXT_NOCASE;
		if(m_bFullWords )sInfo.iMode|=TEXT_WORD;
		WND_HIGHLIGHT(m_pTextWnd,&sInfo);
		}

	sInfo.iMode   = (m_bFullMode)?	0xC002:2;
	sInfo.pText   =  pMem1;
	sInfo.pChange =  pMem2;

	i=WND_CHANGE(m_pTextWnd,&sInfo);

	delete pMem1;
	delete pMem2;

	if(!i)
		{
		MessageBox(STRING("Text wurde nicht gefunden !",ID_FINDDLG_00),0,MB_ICONINFORMATION);
		}
	else{
		sprintf(cBuffer,STRING("Es wurden  %i  nderung(en) durchgefhrt !     ",ID_CHANGEDLG_00),i);
		MessageBox(cBuffer,0,MB_ICONINFORMATION);
		//EndDialog(IDOK);
		}

	::SetFocus(hBox1);

}


//*****************************************************************************
//*
//*		OnSelect
//*
//*****************************************************************************
void CTextChangeDlg::OnSelect()
{
CMenu	sMenu;
RECT	sRect;
int		i;



	sMenu.CreatePopupMenu();


	for(i=0;aMenuStrings[i].pText;i++)
		{
		if(aMenuStrings[i].iId)
				sMenu.AppendMenu(MF_STRING,ID_TEXT_POS+aMenuStrings[i].iId-1,aMenuStrings[i].pText);
		else	sMenu.AppendMenu(MF_SEPARATOR);
		}

	GetDlgItem(IDC_BUTTON2)->GetWindowRect(&sRect);
	sMenu.TrackPopupMenu(TPM_LEFTALIGN,sRect.right,sRect.top,this);
	sMenu.DestroyMenu();


}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CTextChangeDlg::OnInitDialog()
{

	SetButtonBitmap(this,IDC_BUTTON2,m_wDlgIcon);


	SET_OLDPOS();

	SubclassComboBox(this,IDC_COMBO1,SCB_COLORMSG);


	if(!m_bFullModeOn)										// Keine Auswahl ?
		{
		GetDlgItem(IDC_RADIO3)->EnableWindow(0);
		GetDlgItem(IDC_RADIO4)->EnableWindow(0);
		}
	else{
		m_bFullMode=1;
		}

	m_bHasHighLight = WND_GETFLAGS(m_pTextWnd)&FLAG_HAS_HIGHLIGHT;

	OnChanged();


return CDialog::OnInitDialog();
}

//*****************************************************************************
//*
//*		OnChanged
//*
//*****************************************************************************
//	Der Text in der Eingabe hat sich verndert
void CTextChangeDlg::OnChanged()
{
TCHAR	cText[256];
int		iLen;	
	
	
	if(!m_bHasHighLight)
		{
		EnableDlgItem(IDC_CHECK5,FALSE);
		}
	else if(!GetDlgButton(IDC_CHECK4)->GetCheck())		// Regulren Ausdruck suchen	
		{
		EnableDlgItem(IDC_CHECK5,TRUE);
		}
	else{
		iLen = GetDlgItemText(IDC_COMBO1,cText,sizeof(cText));
		EnableDlgItem(IDC_CHECK5,strcwfind(cText,0x01900000,iLen)<0);
		}

}

//*****************************************************************************
//*
//*		OnMenu
//*
//*****************************************************************************
void CTextChangeDlg::OnMenu(UINT iMode)
{
CComboBox  *pCombo;
TCHAR 		cBuffer[256];
TCHAR		cText  [280];
int			iLen;
int			iPos;


	iMode -= ID_TEXT_POS-1;


	pCombo=(CComboBox*)GetDlgItem(IDC_COMBO1);
	pCombo->GetWindowText(cBuffer,255);cBuffer[255]=0;
	iPos=pCombo->GetEditSel()&0xFFFF;



	   iLen=_tcslen(cBuffer);
	if(iLen<iPos)iPos=iLen;

	memcpy(cText,cBuffer,iPos*sizeof(TCHAR));

	switch(iMode)
			{
	case 1:	_tcscpy(cText+iPos,_T("?"   ));		break;
	case 2:	_tcscpy(cText+iPos,_T("*"   ));		break;
	case 3:	_tcscpy(cText+iPos,_T("\\w" ));		break;
	case 4:	_tcscpy(cText+iPos,_T("\\z" ));		break;
	case 5:	_tcscpy(cText+iPos,_T("\\_" ));		break;
	case 6:	_tcscpy(cText+iPos,_T("\\." ));		break;
	case 7:	_tcscpy(cText+iPos,_T("\\a" ));		break;
	case 8:	_tcscpy(cText+iPos,_T("\\e" ));		break;
	case 9:	_tcscpy(cText+iPos,_T("\\p" ));		break;
	case 10:_tcscpy(cText+iPos,_T("\\o" ));		break;
	case 11:_tcscpy(cText+iPos,_T("\\g" ));		break;
	case 12:_tcscpy(cText+iPos,_T("\\f" ));		break;
	case 13:_tcscpy(cText+iPos,_T("\\m" ));		break;
	case 14:_tcscpy(cText+iPos,_T("\\[]"));		break;
	case 15:_tcscpy(cText+iPos,_T("\\()"));		break;
	case 16:_tcscpy(cText+iPos,_T("\\<>"));		break;
	case 17:_tcscpy(cText+iPos,_T("\\{}"));		break;
	case 18:_tcscpy(cText+iPos,_T("\\||"));		break;
			}

	iLen = _tcslen(cText+iPos)+iPos;
	_tcscpy(cText+iLen,cBuffer+iPos);

	if(iMode>=14)iLen--;

	UpdateData(FALSE);

	pCombo->SetWindowText(cText);
	pCombo->SetFocus();
	pCombo->SetEditSel(iLen,iLen);

	m_bSpecialExpression=1;
	GetDlgItem(IDC_CHECK4)->SendMessage(BM_SETCHECK,1);
}

