//******************************************************************************
//*
//*		DebugMemLeaks.h
//*
//******************************************************************************
//
//	Mit diesem Code wird das aufzeigen von Memory-Leaks aktiviert
//
#ifdef	   _MSC_VER
#ifdef	   _DEBUG
#ifndef		NO_DEBUG_NEW


#if			_MSC_VER >= 1900
#define		DBG_STATIC
#else
#define		DBG_STATIC			static
#endif

#ifdef		__cplusplus
#ifdef		_DLL
#define		DEGUG_API			extern "C"	__declspec(dllimport)
#else
#define		DEGUG_API			extern "C"	
#endif 	
#else
#ifdef		_DLL
#define		DEGUG_API			__declspec(dllimport)
#else
#define		DEGUG_API			
#endif 	
#endif

#ifdef		_NORMAL_BLOCK
#define 	DBG_NORMAL_BLOCK	_NORMAL_BLOCK
#else
#define 	DBG_NORMAL_BLOCK	1	
#endif 	


DEGUG_API	int    _cdecl		_CrtDumpMemoryLeaks();
DEGUG_API	void * _cdecl		_malloc_dbg (            size_t iSize,int iType,const char *pFile,int iLine);
DEGUG_API	void * _cdecl		_calloc_dbg	(size_t iNum,size_t iSize,int iType,const char *pFile,int iLine);
DEGUG_API	void * _cdecl		_expand_dbg (void *pData,size_t iSize,int iType,const char *pFile,int iLine);
DEGUG_API	void * _cdecl		_realloc_dbg(void *pData,size_t iSize,int iType,const char *pFile,int iLine);
DEGUG_API	size_t _cdecl		_msize_dbg  (void *pData,int iType);
DEGUG_API	void   _cdecl		_free_dbg   (void *pData,int iType);


#ifdef		new
#undef		new
#endif 	

#ifdef		free
#undef		free
#endif 	

#ifdef		malloc
#undef		malloc
#endif 	

#ifdef		calloc
#undef		calloc
#endif 	

#ifdef		realloc
#undef		realloc
#endif 	

#ifdef		_expand
#undef		_expand
#endif 	

#ifdef		_msize
#undef		_msize
#endif 	

#ifdef		DEBUG_NEW
#undef		DEBUG_NEW
#endif 	

#ifdef		__cplusplus
#pragma		warning(push)
#pragma		warning(disable:4211)
DBG_STATIC	inline void *		operator new(size_t iSize,const char *pFile,int iLine){return _malloc_dbg(iSize,DBG_NORMAL_BLOCK,pFile,iLine);}
DBG_STATIC	inline void			operator delete(void *pData){_free_dbg(pData,DBG_NORMAL_BLOCK);}
#pragma		warning(pop)
#endif


#undef		DBG_STATIC
#undef		DEGUG_API

#define		DEBUG_NEW			new(__FILE__,__LINE__)
#define		new					DEBUG_NEW
#define		malloc(s)			_malloc_dbg (  s,DBG_NORMAL_BLOCK,__FILE__,__LINE__)
#define		calloc(c,s)			_calloc_dbg (c,s,DBG_NORMAL_BLOCK,__FILE__,__LINE__)
#define	   _expand(p,s)			_expand_dbg (p,s,DBG_NORMAL_BLOCK,__FILE__,__LINE__)
#define		realloc(p,s)		_realloc_dbg(p,s,DBG_NORMAL_BLOCK,__FILE__,__LINE__)
#define	   _msize(p)			_msize_dbg  (p  ,DBG_NORMAL_BLOCK)
#define		free(p)				_free_dbg   (p  ,DBG_NORMAL_BLOCK)
	   
#pragma		warning(disable:4291)

#endif
#endif
#endif
