//*****************************************************************************
//*
//*
//*		IconEncoder.h
//*
//*
//*****************************************************************************
#ifndef __ICONENCODER_H__
#define __ICONENCODER_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#include "BitmapImage.h"
#include "Icon.h"

#define 	ICO_CURSOR(x,y)		(2|(((unsigned char)(x))<<16)|(((unsigned char)(x))<<24))


//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class IconEncoder : public BitmapImageEncoder
{
public:
			     IconEncoder () ;
	virtual     ~IconEncoder () ;
	virtual void WriteImage (const wchar_t *pFilename,const BitmapImage &sImageXor);
	virtual void WriteImage (const char    *pFilename,const BitmapImage &sImageXor);
	virtual void WriteImage (CFileBuffer   *pFile    ,const BitmapImage &sImageXor);
	virtual void WriteImage (const wchar_t *pFilename,const BitmapImage *pImageXor,int iBits=8,int iNew=0,int iMask=-1    ,int iType=1);
	virtual void WriteImage (const char    *pFilename,const BitmapImage *pImageXor,int iBits=8,int iNew=0,int iMask=-1    ,int iType=1);
	virtual void WriteImage (CFileBuffer   *pFile    ,const BitmapImage *pImageXor,int iBits=8,int iNew=0,int iMask=-1    ,int iType=1);
	virtual void WriteImage (const wchar_t *pFilename,const BitmapImage *pImageXor,const BitmapImage *pImageAnd,int iNew=0,int iType=1);
	virtual void WriteImage (const char    *pFilename,const BitmapImage *pImageXor,const BitmapImage *pImageAnd,int iNew=0,int iType=1);
	virtual void WriteImage (CFileBuffer   *pFile    ,const BitmapImage *pImageXor,const BitmapImage *pImageAnd,int iNew=0,int iType=1);
  
protected:


};



#endif
