//*****************************************************************************
//*
//*
//*		PnmDecoder.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2011
//
#ifndef __PNMDECODER_H__
#define __PNMDECODER_H__

#if _MSC_VER >= 1000
#pragma once
#endif

#include	"Pnm.h"
#include	"BitmapImage.h"
#include	"GrException.h"
#include	"..\FileBuffer.h"
  
//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class PnmDecoder : public BitmapImageDecoder
{
public:

					PnmDecoder();
	virtual        ~PnmDecoder();

	virtual void	ReadImage(const wchar_t *pName,BitmapImage &sImage);
	virtual void	ReadImage(const char    *pName,BitmapImage &sImage);
	virtual void	ReadImage(CFileBuffer   *pFile,BitmapImage &sImage);

protected:
	
	void			CallProgressFunction(unsigned uPercent);

};


#endif
