//*****************************************************************************
//*
//*
//*		PnmEncoder.h
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2011
//
#ifndef		__PNMENCODER_H__
#define		__PNMENCODER_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#include	"Pnm.h"
#include	"BitmapImage.h"


//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class PnmEncoder : public BitmapImageEncoder
{
public:
					PnmEncoder();
	virtual        ~PnmEncoder();
	
	virtual void	WriteImage(const wchar_t *pName,const BitmapImage &sImage);
	virtual void	WriteImage(const char    *pName,const BitmapImage &sImage);
	virtual void	WriteImage(CFileBuffer   *pFile,const BitmapImage &sImage);

private:
	
	void			CallProgressFunction(unsigned uPercent);

};



#endif
