//*****************************************************************************
//*
//*
//*		XwdEncoder.h
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2011
//
#ifndef		__XWDENCODER_H__
#define		__XWDENCODER_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#include	"Xwd.h"
#include	"BitmapImage.h"


//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class XwdEncoder : public BitmapImageEncoder
{
public:
					XwdEncoder();
	virtual        ~XwdEncoder();
	virtual void	WriteImage(const wchar_t *pName,const BitmapImage &sImage);
	virtual void	WriteImage(const char    *pName,const BitmapImage &sImage);
	virtual void	WriteImage(CFileBuffer   *pFile,const BitmapImage &sImage);

private:
	
	void			CallProgressFunction(unsigned uPercent);

};



#endif
