//*****************************************************************************
//*
//*
//*		Konfiguration fr die Registry
//*
//*
//*****************************************************************************
//	
//	Diverse Funktionen um registrierte Dateitypen in der Registry zu bearbeiten.
//
#ifndef __REGCONFIG_H__	
#define __REGCONFIG_H__	


#define 	ALL_COMMAND		((LPCTSTR)-1)
 	    
int  ConfigFileQuery		(LPCTSTR   pType);
bool ConfigFileRefresh		(LPCTSTR   pType);
bool ConfigFileDelete		(LPCTSTR   pType,bool	   bRemoveCommands=true);
bool ConfigFileType			(LPCTSTR   pType,LPCTSTR   pTypeName);
bool ConfigFileIcon			(LPCTSTR   pType,LPCTSTR   pFilename   ,int		iIconNr     =0,LPCTSTR pTypeName=0,LPCTSTR   pGroupName=0);
bool ConfigFileCommand		(LPCTSTR   pType,LPCTSTR   pFilename =0,LPCTSTR pCommand    =0,LPCTSTR pSwitches=0);
bool ConfigFileCmdIcon		(LPCTSTR   pType,LPCTSTR   pCommand  =0,LPCTSTR pFilename   =0,int	   iIconNr  =0);
bool ConfigFileCmdChange	(LPCTSTR   pType,LPCTSTR   pFilenameOld,LPCTSTR pFilenameNew  ,LPCTSTR pCommand =0,LPCTSTR   pSwitches =0);
bool ConfigFileIconChange	(LPCTSTR   pType,LPCTSTR   pFilenameOld,LPCTSTR pFilenameNew  ,int	   iIconNr  =0);
bool ConfigFileCmdDelete	(LPCTSTR   pType,LPCTSTR   pCommand  =0,LPCTSTR pFilenameOld=0);
bool ConfigFileDeleteIf		(LPCTSTR   pType,LPCTSTR   pFilenameCmd,LPCTSTR pFilenameIcon=0);
bool ConfigFileDeleteCmd	(LPCTSTR   pType,LPCTSTR   pCommand  =0);
bool ConfigFileCmdGet		(LPCTSTR   pType,LPTSTR	   pBuffer     ,int		iSize,LPCTSTR pCommand=0);
bool ConfigFileIconGet		(LPCTSTR   pType,LPTSTR	   pBuffer     ,int		iSize,int	 *pIconNr =0);
bool ConfigFileTypeGet		(LPCTSTR   pType,LPTSTR	   pBuffer     ,int		iSize);


#endif 	