//*****************************************************************************
//*
//*
//*		SrtmFunctions.h
//*
//*
//*****************************************************************************
#ifndef 	__SRTMFUNCTIONS_H__
#define 	__SRTMFUNCTIONS_H__

#if _MSC_VER >= 1000
#pragma once
#endif


#define 	SRTM_ERR_NO_MEMORY			-10000
#define 	SRTM_ERR_WRONG_FORMAT		-10001
#define 	SRTM_ERR_CANT_OPEN			-10002
#define 	SRTM_ERR_CANT_FIND			-10003
#define 	SRTM_ERR_READ				-10004
#define 	SRTM_ERR_NOT_INIT			-10005


int			SrtmExit();
int    		SrtmInit(const char *pCachePath=0);
int  		SrtmIsLoaded (double dCoorX,double dCoorY);
double 		SrtmGetHeight(double dCoorX,double dCoorY);
const char *SrtmPath();
const char *SrtmFile();




#endif 	