//*****************************************************************************
//*
//*
//*		ExchangeUtility.c
//*
//*
//*****************************************************************************
//
//	Module with several atomic exchange functions for X86,X64,ARM
//
//	(C) Copyright Anton Zechner 2015
//
//	unsigned char	ExchangeByte    (ptr,val)
//	unsigned short 	ExchangeWord    (ptr,val)
//	unsigned int 	ExchangeDword   (ptr,val)
//	void           *ExchangePointer (ptr,val)
//
//	unsigned char	ExchangeAddByte (ptr,val)
//	unsigned short 	ExchangeAddWord (ptr,val)
//	unsigned int 	ExchangeAddDword(ptr,val)
//
//	unsigned char	ExchangeSubByte (ptr,val)
//	unsigned short 	ExchangeSubWord (ptr,val)
//	unsigned int 	ExchangeSubDword(ptr,val)
//
//	unsigned char	ExchangeIncByte (ptr)
//	unsigned short 	ExchangeIncWord (ptr)
//	unsigned int 	ExchangeIncDword(ptr)
//
//	unsigned char	ExchangeDecByte (ptr)
//	unsigned short 	ExchangeDecWord (ptr)
//	unsigned int 	ExchangeDecDword(ptr)
//
#ifdef		GLOBAL_CONFIG
#define 	EXCHANGEUTILITY_C
#include	<GlobalConfig.h>
#undef 		EXCHANGEUTILITY_C
#endif

#include	"ExchangeUtility.h"

