//*****************************************************************************
//*
//*
//*		WinDebug.h
//*
//*
//*****************************************************************************
#ifndef __WINDEBUG_H__
#define __WINDEBUG_H__

#ifdef	D
#undef	D
#endif 	

#ifdef  __cplusplus
#define D(a)	a
#else		
#define D(a)
#endif



#if linux

	static inline	WinInitCoreDumpInfo(int **pEnabled D(=0)){};
	#define			WinIsProcessDumped(a)	0
	#define			WinRaiseException()
	#define			WinSetExChain(unsigned uBase);
	#define			WinDelExChain();

#else

	#ifdef  __cplusplus
	extern "C" {
	#endif
					
	void			WinInitCoreDumpInfo(int **pEnabled D(=0));
	int 			WinIsProcessDumped (unsigned long ulPid);
	void			WinRaiseException();
	void			WinSetExChain(unsigned uBase);
	unsigned 		WinDelExChain();

	#ifdef  __cplusplus
	}
	#endif


#endif

#undef	D

#endif
