//*****************************************************************************
//*
//*
//*		AZ_Conrols.h
//*
//*
//*****************************************************************************
//	Die Bibliothek aller AZ Funktionen
//	Ist AZ_LIB_CODE		definiert so ist die Bibliothek auch
//						debug-bar
//	Mit AZ_LIB_NODUMMYS	knnen die Dummys fr strlen,memcpy...
//						entfernt werden.
//	Mit AZ_LIB_ADDAFX	kann der Bibliothek Afx-Funktionen
//						zugefgt werden
//	Mit AZ_LIB_PRINT	kann beim Kompilieren eine Information
//						ber die benutze Bibliothek augegeben
//						werden
//	Unter dem Menpunkt
//				Extras/Optionen/Verzeichnisse/Include-Dateien
//				solter der Pfad dieser Header-Datei eingetragen sein
//	Unter dem Menpunkt
//				Extras/Optionen/Verzeichnisse/Bibliothek-Dateien
//	 			solter der Pfad des AL_Lib-Projektes eingetragen sein

#ifndef		__AZ_CONROLS_H__
#define 	__AZ_CONROLS_H__

#if _MSC_VER >= 1000
#pragma once
#endif



#if	!defined(_MFC_VER) && defined(AZ_LIB_ADDAFX)
#define	_MFC_VER	0
#define	_MFC_VER_CLEAR
#endif



#if defined(UNICODE) || defined(_UNICODE)


//*****************************************************************************
//*
//*		Allgemein Unicode Single Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifndef	_MT

	#ifdef	_DLL
	#error	AZ-Lib falsche Konfiguration  (_DLL ist nicht erlaubt)
	#endif

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_DU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DU.lib     UNICODE,DEBUG,CODE,single Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_DCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DCU.lib    UNICODE,DEBUG,no CODE,single Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_RU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_RU.lib     UNICODE,RELEASE,no CODE,single Thread,no MFC" )
	#endif
	#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Muli Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifndef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_MDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_MDU.lib    UNICODE,DEBUG,CODE,multi Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_MDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_MDCU.lib   UNICODE,DEBUG,no CODE,multi Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_MRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_MRU.lib    UNICODE,RELEASE,no CODE,multi Thread,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Muli Thread ohne Afx mit Dll
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifdef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_DMDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DDCU.lib   UNICODE,DEBUG,CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_DMDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DMDCU.lib  UNICODE,DEBUG,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_DMRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DMRU.lib   UNICODE,RELEASE,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Multi Thread mit Afx in statischer Bibeliothek
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifndef _AFXDLL

#ifdef	_DLL
#ifndef	_MT
	#error	AZ-Lib untersttzt nicht  _DLL ohne _MT , Multithread einschalten
#endif
#endif

#ifdef	_DLL
#ifdef	_MT

	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SDRU.lib   UNICODE,RELEASE,no CODE,multi Thread DLL,static MFC" )
	#endif

	#error Building MFC application with /MD[d] (CRT dll version) requires MFC shared dll version. Please #define _AFXDLL or do not use /MD[d]

#endif
#endif


#ifndef	_DLL
#ifdef	_MT

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_SMDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SMDU.lib   UNICODE,DEBUG,CODE,multi Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_SMDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SMDCU.lib  UNICODE,DEBUG,no CODE,multi Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_SMRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SMRU.lib   UNICODE,RELEASE,no CODE,multi Thread,static MFC" )
	#endif
	#endif

#endif
#endif


#ifndef	_DLL
#ifndef	_MT
	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_SDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SDU.lib    UNICODE,DEBUG,CODE,single Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_SDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SDCU.lib   UNICODE,DEBUG,no CODE,single Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_SRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SRU.lib    UNICODE,RELEASE,no CODE,single Thread,static MFC" )
	#endif
	#endif
#endif
#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Multi Thread mit Afx in DLL
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifdef  _AFXDLL

#if	(defined(_DLL)) && (defined(_MT))

	#if (defined(_DEBUG) && defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_DDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DDU.lib    UNICODE,DEBUG,CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_DDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DDCU.lib   UNICODE,DEBUG,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_DRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DRU.lib    UNICODE,RELEASE,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif
#else
	#error	AZ-Lib falsche Konfiguration  (_DLL ohne _MT ist nicht erlaubt)
#endif


#endif
#endif


#else	// UNICODE

//*****************************************************************************
//*
//*		Allgemein Single Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifndef	_MT

	#ifdef	_DLL
	#error	AZ-Lib falsche Konfiguration  (_DLL ist nicht erlaubt)
	#endif

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_D.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_D.lib     DEBUG,CODE,single Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_DC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DC.lib    DEBUG,no CODE,single Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_R.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_R.lib     RELEASE,no CODE,single Thread,no MFC" )
	#endif
	#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Muli Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifndef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_MD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_MD.lib    DEBUG,CODE,multi Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_MDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_MDC.lib   DEBUG,no CODE,multi Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_MR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_MR.lib    RELEASE,no CODE,multi Thread,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Muli Thread ohne Afx mit Dll
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifdef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_DMD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DDC.lib   DEBUG,CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_DMDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DMDC.lib  DEBUG,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_DMR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DMR.lib   RELEASE,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Multi Thread mit Afx in statischer Bibeliothek
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifndef _AFXDLL

#ifdef	_DLL
#ifndef	_MT
	#error	AZ-Lib untersttzt nicht  _DLL ohne _MT , Multithread einschalten
#endif
#endif

#ifdef	_DLL
#ifdef	_MT

	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SDR.lib   RELEASE,no CODE,multi Thread DLL,static MFC" )
	#endif

	#error Building MFC application with /MD[d] (CRT dll version) requires MFC shared dll version. Please #define _AFXDLL or do not use /MD[d]

#endif
#endif


#ifndef	_DLL
#ifdef	_MT

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_SMD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SMD.lib   DEBUG,CODE,multi Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_SMDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SMDC.lib  DEBUG,no CODE,multi Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_SMR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SMR.lib   RELEASE,no CODE,multi Thread,static MFC" )
	#endif
	#endif

#endif
#endif


#ifndef	_DLL
#ifndef	_MT
	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_SD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SD.lib    DEBUG,CODE,single Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_SDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SDC.lib   DEBUG,no CODE,single Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_SR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_SR.lib    RELEASE,no CODE,single Thread,static MFC" )
	#endif
	#endif
#endif
#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Multi Thread mit Afx in DLL
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifdef  _AFXDLL

#if	(defined(_DLL)) && (defined(_MT))

	#if (defined(_DEBUG) && defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_DD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DD.lib    DEBUG,CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Controls_DDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DDC.lib   DEBUG,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Controls_DR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Controls_DR.lib    RELEASE,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif
#else
	#error	AZ-Lib falsche Konfiguration  (_DLL ohne _MT ist nicht erlaubt)
#endif


#endif
#endif



#endif	// UNICODE


//******************************************************************************
//*
//*		printf,sprintf,fprintf auf ProcPrintf.cpp umleiten
//*
//******************************************************************************

#ifdef	AZ_NO_PRINTF
#ifndef	PP_NO_COMMON
#define	PP_NO_COMMON
#endif
#endif

//*****************************************************************************
//*
//*		Include Dateien
//*
//*****************************************************************************

#ifndef	 _MFC_VER

#error 	"AZ_Controls need MFC"

#else

#include "Controls/EditEx.h"
#include "Controls/ComboEx.h"
#include "Controls/SizeBar.h"
#include "Controls/ChildBar.h"
#include "Controls/PathDlg.h"
#include "Controls/HtmlCtrl.h"
#include "Controls/PathCtrl.h"
#include "Controls/LabelCtrl.h"
#include "Controls/BitmapWnd.h"
#include "Controls/AfxMacros.h"
#include "Controls/AfxDialog.h"
#include "Controls/VersionDlg.h"
#include "Controls/ToolBarNew.h"
#include "Controls/AfxUtility.h"
#include "Controls/BrowserCtrl.h"
#include "Controls/ColorDialog.h"
#include "Controls/ProgressDlg.h"
#include "Controls/ColorListBox.h"
#include "Controls/FastListCtrl.h"
#include "Controls/TreeListCtrl.h"
#include "Controls/FileListCtrl.h"
#include "Controls/AlternateList.h"
#include "Controls/TreeListCtrlEx.h"
#include "Controls/FolderTreeCtrl.h"
#include "Controls/MonitorFunctions.h"

#endif

#include "AZ_Macros.h"
#include "ProcPrintf.h"
#include "StringChain.h"
#include "MemFunctions.h"
#include "BitFunctions.h"
#include "WinExtension.h"
#include "FileFunctions.h"
#include "StringFunctions.h"


#ifndef	AZ_LIB_NODUMMYS
#ifdef _DEBUG
#include "Dummys.h"
#else
#if defined(_MSC_VER) && (_MSC_VER>1000)
#pragma warning( disable :4164)
#pragma intrinsic( strcmp)
#pragma intrinsic( strcpy)
#pragma intrinsic( strlen)
#pragma intrinsic(_strset)
#pragma intrinsic( memset)
#pragma intrinsic( memcmp)
#pragma intrinsic( memcpy)
#pragma intrinsic( labs	 )
#pragma intrinsic(_inp	 )
#pragma intrinsic(_inpw	 )
#pragma intrinsic(_rotl	 )
#pragma intrinsic(_rotr	 )
#pragma intrinsic(_lrotl )
#endif
#endif
#endif



#ifdef	_MFC_VER_CLEAR
#undef	_MFC_VER_CLEAR
#undef	_MFC_VER
#endif

#if    _MFC_VER >= 0x0700
#ifndef Enable3dControls
#define	Enable3dControls()
#endif
#ifndef Enable3dControlsStatic
#define	Enable3dControlsStatic()
#endif
#endif

#endif
