//*****************************************************************************
//*
//*
//*		AZ_Image
//*
//*
//*****************************************************************************
//	Die Bibliothek aller AZ Funktionen
//	Ist AZ_LIB_CODE		definiert so ist die Bibliothek auch
//						debug-bar
//	Mit AZ_LIB_NODUMMYS	knnen die Dummys fr strlen,memcpy...
//						entfernt werden.
//	Mit AZ_LIB_ADDAFX	kann der Bibliothek Afx-Funktionen
//						zugefgt werden
//	Mit AZ_LIB_PRINT	kann beim Kompilieren eine Information
//						ber die benutze Bibliothek augegeben
//						werden
//	Unter dem Menpunkt
//				Extras/Optionen/Verzeichnisse/Include-Dateien
//				solter der Pfad dieser Header-Datei eingetragen sein
//	Unter dem Menpunkt
//				Extras/Optionen/Verzeichnisse/Bibliothek-Dateien
//	 			solter der Pfad des AL_Lib-Projektes eingetragen sein

#ifndef		__AZ_Image_H__
#define 	__AZ_Image_H__

#if _MSC_VER >= 1000
#pragma once
#endif



#if	!defined(_MFC_VER) && defined(AZ_LIB_ADDAFX)
#define	_MFC_VER	0
#define	_MFC_VER_CLEAR
#endif

#pragma comment( exestr , "AZ_Image wurde verwendet Copyrigtht Anton Zechner (C) 2008 ")


#if defined(UNICODE) || defined(_UNICODE)


//*****************************************************************************
//*
//*		Allgemein Unicode Single Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifndef	_MT

	#ifdef	_DLL
	#error	AZ-Lib falsche Konfiguration  (_DLL ist nicht erlaubt)
	#endif

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_DU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DU.lib     UNICODE,DEBUG,CODE,single Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_DCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_CDU.lib    UNICODE,DEBUG,no CODE,single Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_RU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_RU.lib     UNICODE,RELEASE,no CODE,single Thread,no MFC" )
	#endif
	#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Muli Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifndef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_MDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_MDU.lib    UNICODE,DEBUG,CODE,multi Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_MDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_MDCU.lib   UNICODE,DEBUG,no CODE,multi Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_MRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_MRU.lib    UNICODE,RELEASE,no CODE,multi Thread,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Muli Thread ohne Afx mit Dll
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifdef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_DMDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DDCU.lib   UNICODE,DEBUG,CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_DMDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DMDCU.lib  UNICODE,DEBUG,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_DMRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DMRU.lib   UNICODE,RELEASE,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Multi Thread mit Afx in statischer Bibeliothek
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifndef _AFXDLL

#ifdef	_DLL
#ifndef	_MT
	#error	AZ-Lib untersttzt nicht  _DLL ohne _MT , Multithread einschalten
#endif
#endif

#ifdef	_DLL
#ifdef	_MT

	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SDRU.lib   UNICODE,RELEASE,no CODE,multi Thread DLL,static MFC" )
	#endif

	#error Building MFC application with /MD[d] (CRT dll version) requires MFC shared dll version. Please #define _AFXDLL or do not use /MD[d]

#endif
#endif


#ifndef	_DLL
#ifdef	_MT

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_SMDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SMDU.lib   UNICODE,DEBUG,CODE,multi Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_SMDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SMDCU.lib  UNICODE,DEBUG,no CODE,multi Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_SMRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SMRU.lib   UNICODE,RELEASE,no CODE,multi Thread,static MFC" )
	#endif
	#endif

#endif
#endif


#ifndef	_DLL
#ifndef	_MT
	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_SDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SDU.lib    UNICODE,DEBUG,CODE,single Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_SDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SDCU.lib   UNICODE,DEBUG,no CODE,single Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_SRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SRU.lib    UNICODE,RELEASE,no CODE,single Thread,static MFC" )
	#endif
	#endif
#endif
#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Unicode Multi Thread mit Afx in DLL
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifdef  _AFXDLL

#if	(defined(_DLL)) && (defined(_MT))

	#if (defined(_DEBUG) && defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_DDU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DDU.lib    UNICODE,DEBUG,CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_DDCU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DDCU.lib   UNICODE,DEBUG,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_DRU.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DRU.lib    UNICODE,RELEASE,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif
#else
	#error	AZ-Lib falsche Konfiguration  (_DLL ohne _MT ist nicht erlaubt)
#endif


#endif
#endif


#else	// UNICODE

//*****************************************************************************
//*
//*		Allgemein Single Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifndef	_MT

	#ifdef	_DLL
	#error	AZ-Lib falsche Konfiguration  (_DLL ist nicht erlaubt)
	#endif

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_D.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_D.lib     DEBUG,CODE,single Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_DC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_CD.lib    DEBUG,no CODE,single Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_R.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_R.lib     RELEASE,no CODE,single Thread,no MFC" )
	#endif
	#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Muli Thread ohne Afx
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifndef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_MD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_MD.lib    DEBUG,CODE,multi Thread,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_MDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_MDC.lib   DEBUG,no CODE,multi Thread,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_MR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_MR.lib    RELEASE,no CODE,multi Thread,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Muli Thread ohne Afx mit Dll
//*
//*****************************************************************************
#ifndef	_MFC_VER
#ifdef	_MT
#ifdef	_DLL

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_DMD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DDC.lib   DEBUG,CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_DMDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DMDC.lib  DEBUG,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_DMR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DMR.lib   RELEASE,no CODE,multi Thread DLL,no MFC" )
	#endif
	#endif

#endif
#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Multi Thread mit Afx in statischer Bibeliothek
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifndef _AFXDLL

#ifdef	_DLL
#ifndef	_MT
	#error	AZ-Lib untersttzt nicht  _DLL ohne _MT , Multithread einschalten
#endif
#endif

#ifdef	_DLL
#ifdef	_MT

	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SDR.lib   RELEASE,no CODE,multi Thread DLL,static MFC" )
	#endif

	#error Building MFC application with /MD[d] (CRT dll version) requires MFC shared dll version. Please #define _AFXDLL or do not use /MD[d]

#endif
#endif


#ifndef	_DLL
#ifdef	_MT

	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_SMD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SMD.lib   DEBUG,CODE,multi Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_SMDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SMDC.lib  DEBUG,no CODE,multi Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_SMR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SMR.lib   RELEASE,no CODE,multi Thread,static MFC" )
	#endif
	#endif

#endif
#endif


#ifndef	_DLL
#ifndef	_MT
	#if (defined(_DEBUG) &&  defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_SD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SD.lib    DEBUG,CODE,single Thread,static MFC" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_SDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SDC.lib   DEBUG,no CODE,single Thread,static MFC" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_SR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_SR.lib    RELEASE,no CODE,single Thread,static MFC" )
	#endif
	#endif
#endif
#endif

#endif
#endif

//*****************************************************************************
//*
//*		Allgemein Multi Thread mit Afx in DLL
//*
//*****************************************************************************
#ifdef	_MFC_VER
#ifdef  _AFXDLL

#if	(defined(_DLL)) && (defined(_MT))

	#if (defined(_DEBUG) && defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_DD.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DD.lib    DEBUG,CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#if (defined(_DEBUG) && !defined(AZ_LIB_CODE))
	#pragma comment(lib, "AZ_Image_DDC.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DDC.lib   DEBUG,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif

	#ifndef _DEBUG
	#pragma comment(lib, "AZ_Image_DR.lib")
	#ifdef	AZ_LIB_PRINT
	#pragma message( "AZ_Image_DR.lib    RELEASE,no CODE,multi Thread,MFC_DLL" )
	#endif
	#endif
#else
	#error	AZ-Lib falsche Konfiguration  (_DLL ohne _MT ist nicht erlaubt)
#endif


#endif
#endif



#endif	// UNICODE

//*****************************************************************************
//*
//*		Include Dateien
//*
//*****************************************************************************

#ifndef	 _MFC_VER

#include <windows.h>

#else


#endif

#include "Image/BitmapImage.h"
#include "Image/BmpDecoder.h"
#include "Image/BmpEncoder.h"
#include "Image/EpsDecoder.h"
#include "Image/EpsEncoder.h"
#include "Image/GifDecoder.h"
#include "Image/GifEncoder.h"
#include "Image/IconDecoder.h"
#include "Image/IconEncoder.h"
#include "Image/ImageLoader.h"
#include "Image/ImageSaver.h"
#include "Image/ImageTable.h"
#include "Image/JpegDecoder.h"
#include "Image/JpegEncoder.h"
#include "Image/PngDecoder.h"
#include "Image/PngEncoder.h"
#include "Image/PnmDecoder.h"
#include "Image/PnmEncoder.h"
#include "Image/TiffDecoder.h"
#include "Image/TiffEncoder.h"
#include "Image/XpmDecoder.h"
#include "Image/XpmEncoder.h"
#include "Image/XwdDecoder.h"
#include "Image/XwdEncoder.h"
#include "Image/ImageSaver.h"
#include "Image/ImageLoader.h"
#include "Image/ImageTable.h"


#ifndef	AZ_LIB_NODUMMYS
#ifdef _DEBUG
#include "Dummys.h"
#endif
#endif



#ifdef	_MFC_VER_CLEAR
#undef	_MFC_VER_CLEAR
#undef	_MFC_VER
#endif

#endif
