//*****************************************************************************
//*
//*
//*		Crc64.h
//*
//*
//*****************************************************************************
//	
//		Crc64 Prfsumme berechnen
//
#ifndef		__CRC64_H__
#define 	__CRC64_H__


#if	_MSC_VER >= 1000
#pragma once
#endif

#ifdef	__cplusplus
extern "C" {	
#endif 	


#ifdef		_MSC_VER
#define 	Crc64uint		unsigned __int64
#define		CRC64_INIT_VAL	((Crc64uint)0xFFFFFFFFFFFFFFFF)
#else
#define 	Crc64uint		unsigned long long 
#define		CRC64_INIT_VAL	0xFFFFFFFFFFFFFFFFull
#ifndef		_cdecl
#define 	_cdecl
#endif 	
#endif 	


	Crc64uint _cdecl Crc64  (Crc64uint  uCrc,const void *pMem,int iLen);
	void      _cdecl Crc64Ex(Crc64uint *pCrc,const void *pMem,int iLen);
	#define   Crc64Calc(pMem,iLen) (~Crc64(CRC64_INIT_VAL,pMem,iLen))


#ifdef	__cplusplus
}
#endif 	

#endif
