//*****************************************************************************
//*
//*
//*		AfxDialog.h : Header-Datei
//*
//*
//*****************************************************************************
#ifndef AFX_DIALOG_H__31588923_43AF_11D3_9273_C0544BC10000__INCLUDED_
#define AFX_DIALOG_H__31588923_43AF_11D3_9273_C0544BC10000__INCLUDED_

#ifdef	   _MSC_VER
#pragma 	once
#pragma 	warning( disable :4996 )
#endif
   
#if		   _MSC_VER > 1299
#ifndef		WINVER				  
#define		WINVER 	0x0501
#endif
#endif

#define 	IDX_TEXT_SORT	-12345
#define 	IDX_VALUE_SORT	-12346

#ifdef		DWORD_PTR
#define 	DPARAM			DWORD_PTR
#else
#define 	DPARAM			DWORD
#endif

class		CTreeListCtrl;


		
//*****************************************************************************
//*
//*		Dialogfeld CTextDlg
//*
//*****************************************************************************
class CTextDlg : public CDialog
{
public:

	CTextDlg(CWnd *pParent=NULL,BOOL bPassword=FALSE);

	//{{AFX_DATA(CTextDlg)
	CString	m_sText;
	//}}AFX_DATA

	void	SetTextTitle(LPCTSTR pText );				// berschrift der Textzeile einstellen
	void	SetTitle    (LPCTSTR pTitle);				// Dialog Titel einstellen
	void	SetText     (LPCTSTR pText );
	LPCTSTR	GetText();
	int		GetText(LPTSTR pText,int iMax);
	void	SetPassword  ();
	void	SetValueFocus();
	void	AddSizeX(int iSize);						// Gre verndern
	void	SetSizeX(int iSize);						// Gre einstellen

	//{{AFX_VIRTUAL(CTextDlg)
	protected:
	virtual void DoDataExchange(CDataExchange *pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CTextDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	CString	m_sTitle;
	CString	m_sTitle1;
	BOOL	m_bPassword;
	BOOL	m_bValueFocus;
	int		m_iSizeX;									// Grennderung

};


inline void CTextDlg::SetPassword  (){m_bPassword=1;}
inline void CTextDlg::SetValueFocus(){m_bValueFocus=1;}
inline void CTextDlg::AddSizeX (int iSize){m_iSizeX=iSize;}
inline void CTextDlg::SetSizeX (int iSize){m_iSizeX=iSize|0x12340000;}

//*****************************************************************************
//*
//*		Dialogfeld CValueDlg
//*
//*****************************************************************************
class CValueDlg : public CDialog
{
public:

	CValueDlg(CWnd *pParent=NULL);

	//{{AFX_DATA(CValueDlg)
	CString	m_sText;
	//}}AFX_DATA

	int		m_iValue;

	void	SetTextTitle(LPCTSTR pText );				// berschrift der Textzeile einstellen
	void	SetTitle    (LPCTSTR pTitle);				// Dialog Titel einstellen
	void	SetValue(int iValue,int iMode=0);
	int		GetValue();
	void	SetValueFocus();
	void	AddSizeX(int iSize);						// Gre verndern
	void	SetSizeX(int iSize);						// Gre einstellen

	//{{AFX_VIRTUAL(CValueDlg)
	protected:
	virtual void DoDataExchange(CDataExchange *pDX);    // DDX/DDV-Untersttzung
	virtual void OnOK( );
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CValueDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	CString	m_sTitle;
	CString	m_sTitle1;
	BOOL	m_bValueFocus;
	int		m_iSizeX;									// Grennderung


};

inline	void CValueDlg::SetValueFocus(){m_bValueFocus=1;}
inline	void CValueDlg::AddSizeX (int iSize){m_iSizeX=iSize;}
inline	void CValueDlg::SetSizeX (int iSize){m_iSizeX=iSize|0x12340000;}

//*****************************************************************************
//*
//*		Dialogfeld CComboDlg
//*
//*****************************************************************************
class CComboDlg : public CDialog
{
public:

	CComboDlg(CWnd *pParent=NULL);
   ~CComboDlg();

	//{{AFX_DATA(CComboDlg)
	//}}AFX_DATA


	void	SetTextTitle(LPCTSTR pText);				// ComboBox Titel einstellen
	void	SetTitle    (LPCTSTR pTitle);				// Dialog Titel einstellen

	void	SetMode(BOOL bEditOn,BOOL bCancel=1);		// ComboText editierbar
	int		SetSelect(LPCTSTR pText,int iMode=0);		// Auswahl via Text einstellen
	void 	SetSelect(int iSelect);						// Auswahlnummer setzen
	int		GetSelect();								// Auswahlnummer abfragen
	DPARAM  GetData(int iIndex);
	DPARAM  SetData(int iIndex,DPARAM uData);
	DPARAM  GetData();
	int     GetCount();
	void	ResetContent();								// Alles lschen
	void	AddSizeX(int iSize);						// Gre verndern
	void	SetSizeX(int iSize);						// Gre einstellen

	int		InsertString(int iIndex,DPARAM uData,LPCTSTR pText,BOOL bSelect=FALSE); // Sortiert einfgen mit Daten
	int		InsertString(int iIndex,             LPCTSTR pText,BOOL bSelect=FALSE); // Bei Position einfgen
	int		AddString(              DPARAM uData,LPCTSTR pText,BOOL bSelect=FALSE);	// Am Ende anhngen	mit Daten
	int		AddString(                           LPCTSTR pText,BOOL bSelect=FALSE);	// Am Ende anhngen

	void	SetValueFocus();
	void	SetText(LPCTSTR pText);						// ComboText einstellen
	int		GetText(LPTSTR  pText,int iMax);
	LPCTSTR	GetText();

	//{{AFX_VIRTUAL(CComboDlg)
	protected:
	virtual void DoDataExchange(CDataExchange *pDX);
	virtual void OnOK( );
	virtual void OnCancel( );
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CComboDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	CString	m_sText;
	CString	m_sTitle;
	CString	m_sTitle1;

	DPARAM	m_uData;
	BOOL	m_iMode;									// 1=editerbar
	BOOL	m_bCancel;									// 1=bCancel anzeigen
	int		m_iSelect;
	LPTSTR *m_pStrText;
	int		m_iStrCount;
	int		m_iStrMax;
	int		m_iSizeX;									// Grennderung
	BOOL	m_bValueFocus;

	static	WORD m_wDlgData[];

};

inline	int	   CComboDlg::AddString    (             LPCTSTR pText,BOOL bSelect){return InsertString(-1    ,0,pText,bSelect);}
inline	int	   CComboDlg::AddString    (DPARAM uData,LPCTSTR pText,BOOL bSelect){return InsertString(-1,uData,pText,bSelect);}
inline	int	   CComboDlg::InsertString (int iIndex  ,LPCTSTR pText,BOOL bSelect){return InsertString(iIndex,0,pText,bSelect);}
inline	int    CComboDlg::GetCount     (){return m_iStrCount;}
inline	DPARAM CComboDlg::GetData      (){return m_uData    ;}
inline	int	   CComboDlg::GetSelect    (){return m_iSelect  ;}
inline	void   CComboDlg::SetSelect    (int      iSelect){m_iSelect=iSelect;}
inline	void   CComboDlg::SetMode      (BOOL     bEditOn,BOOL bCancel){m_iMode=bEditOn;m_bCancel=bCancel;}
inline	void   CComboDlg::SetText      (LPCTSTR  pText){m_sText=pText;}
inline	void   CComboDlg::SetValueFocus(){m_bValueFocus=1;}
inline	void   CComboDlg::AddSizeX     (int iSize){m_iSizeX=iSize;}
inline	void   CComboDlg::SetSizeX     (int iSize){m_iSizeX=iSize|0x12340000;}

//*****************************************************************************
//*
//*		Dialogfeld CListDlg
//*
//*****************************************************************************
class CListDlg : public CDialog
{
public:

	CListDlg(CWnd *pParent=NULL);
   ~CListDlg();

	//{{AFX_DATA(CListDlg)
	//}}AFX_DATA


	void	SetTextTitle(LPCTSTR pText );				// ComboBox Titel einstellen
	void	SetTitle    (LPCTSTR pTitle);				// Dialog Titel einstellen

	void	SetMode  (int iMode,BOOL bCancel=TRUE);		// Dialog Modus: 0=Single 1=Multi 2=Hckchen
	void 	SetSelect(int iSelect);						// Auswahlnummer setzen
	int		SetSelect(LPCTSTR pText,int iMode=0);		// Auswahl via Text  einstellen
	int		GetSelect(int iIndex);						// Auswahl eines Strings abfragen
	int		GetSelect();								// Auswahlnummer abfragen

	int		AddString   (                        LPCTSTR pText,BOOL bSelect=FALSE);
	int		AddString   (           DPARAM uData,LPCTSTR pText,BOOL bSelect=FALSE);
	int		InsertString(int iIndex,             LPCTSTR pText,BOOL bSelect=FALSE);
	int		InsertString(int iIndex,DPARAM uData,LPCTSTR pText,BOOL bSelect=FALSE);
	void 	SelectString(int iIndex                           ,BOOL bSelect=FALSE);	// Auswahl eines Strings
	void	ResetContent();

	LPCTSTR	GetText();
	int		GetText(LPTSTR  pText,int iMax);
	LPCTSTR	GetText(int     iIndex);
	int		GetText(int     iIndex,LPTSTR *pText,int iMax);
	DPARAM  SetData(int     iIndex,DPARAM  uData);
	DPARAM  GetData(int     iIndex);
	DPARAM  GetData();
	int     GetCount();
	void	SetValueFocus();

	void	AddSizeX(int iSize);						// Gre verndern
	void	AddSizeY(int iSize);						// Gre verndern
	void	SetSizeX(int iSize);						// Gre einstellen
	void	SetSizeY(int iSize);						// Gre einstellen
	void	SetSize (int iSizeX,int iSizeY);			// Gre einstellen
	void	SelectNone();								// Nichts auswhlen	

	static	int __cdecl NameCompare (const void *pElem1, const void *pElem2 );
	static	int __cdecl ValueCompare(const void *pElem1, const void *pElem2 );
	static	LRESULT CALLBACK ListBoxProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

	#define CLD_NAME	CListDlg::NameCompare
	#define CLD_VALUE	CListDlg::ValueCompare

	void	Sort(int (__cdecl *pCompare)(const void*,const void*) = CLD_NAME );


	//{{AFX_VIRTUAL(CListDlg)
	protected:
	virtual void DoDataExchange(CDataExchange *pDX);	// DDX/DDV-Untersttzung
	virtual void OnOK( );
	virtual void OnCancel( );
	//}}AFX_VIRTUAL

protected:

	//{{AFX_MSG(CListDlg)
	virtual BOOL OnInitDialog();
	BOOL OnMouseWheel(UINT nFlags,short sDelta,CPoint sPoint);
	void OnChar(UINT nChar,UINT nRepCnt,UINT nFlags);
	void OnDrawItem(int iId, LPDRAWITEMSTRUCT pDraw);
	void OnSize(UINT nType,int iSizeX,int iSizeY);
	void OnSizing(UINT nSide,LPRECT pRect);
	void OnRightClick();
	void OnDblclkList();
	void OnSelNone();
	void OnSelAll();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

	CString	m_sText;
	CString	m_sTitle;
	CString	m_sTitle1;

	DPARAM	m_uData;
	int		m_iMode;								// 0=Single 1=Multi 2=Hckchen 3=Hckchen+Multi Bit2=Kein Alternieren Bit3=Nicht sortieren Bit4=Einfgen
	BOOL	m_bCancel;								// 1=Cancel anzeigen
	int		m_iListId;
	int		m_iSelect;
	LPTSTR *m_pStrText;
	int		m_iStrCount;
	int		m_iStrMax;
	int		m_iSizeX;
	int		m_iSizeY;								// Grennderung
	int		m_iSizeBtX;
	int		m_iSizeMinX;
	int		m_iSizeMinY;
	int		m_iFrameBtX;
	int		m_iFrameBtY;
	int		m_iFrameBtZ;
	int		m_iFrameListX;
	int		m_iFrameListY;
	int		m_iFrameListZ;
	BOOL	m_bValueFocus;
	UINT	m_uKeyLast;
	UINT	m_uKeyPos;
	TCHAR	m_cKeyData[16];
	INT		m_iOldSizeX;
	INT		m_iOldSizeY;
	BOOL	m_bOldSize;

	static	WORD m_wDlgData[];
	static	INT	 m_iOldPosX;
	static	INT	 m_iOldPosY;
	static	BOOL m_bOldPos;
	static	HPEN m_hPen1;
	static	HPEN m_hPen2;

};

inline	int	   CListDlg::AddString   (             LPCTSTR pText,BOOL bSelect){return InsertString(-1,0    ,pText,bSelect);}
inline	int	   CListDlg::AddString   (DPARAM uData,LPCTSTR pText,BOOL bSelect){return InsertString(-1,uData,pText,bSelect);}
inline	int	   CListDlg::InsertString(int   iIndex,LPCTSTR pText,BOOL bSelect){return InsertString(iIndex,0,pText,bSelect);}
inline	int	   CListDlg::GetCount    (){return m_iStrCount;}
inline	int	   CListDlg::GetSelect   (){return m_iSelect;}
inline	void   CListDlg::SetSelect   (int iSelect){m_iSelect=iSelect;}
inline	void   CListDlg::SelectNone	 (){m_iSelect=-2;}
inline	void   CListDlg::SetMode     (int iMode,BOOL bCancel){m_iMode=iMode;m_bCancel=bCancel;}
inline	DPARAM CListDlg::GetData     (){return m_uData;}
inline	void   CListDlg::AddSizeX    (int iSize){m_iSizeX=iSize;}
inline	void   CListDlg::AddSizeY    (int iSize){m_iSizeY=iSize;}
inline	void   CListDlg::SetSizeX    (int iSize){m_iSizeX=iSize|0x12340000;}
inline	void   CListDlg::SetSizeY    (int iSize){m_iSizeY=iSize|0x12340000;}
inline	void   CListDlg::SetSize     (int iSizeX,int iSizeY){m_iSizeX=iSizeX|0x12340000;m_iSizeY=iSizeY|0x12340000;}
inline	void   CListDlg::SetValueFocus(){m_bValueFocus=1;}

//*****************************************************************************
//*
//*		Dialogfeld CColumnDlg
//*
//*****************************************************************************
class CColumnDlg : public CDialog
{
public:

	CColumnDlg(CWnd *pParent=NULL);
   ~CColumnDlg();

	//{{AFX_DATA(CColumnDlg)
	//}}AFX_DATA


	void	SetTextTitle(LPCTSTR pText );				// ComboBox Titel einstellen
	void	SetTitle    (LPCTSTR pTitle);				// Dialog Titel einstellen

	void	SetMode  (int iMode,BOOL bCancel=TRUE);		// Dialog Modus: 0=Single 1=Multi 2=Hckchen 3=Hckchen+Multi Bit2=Kein Alternieren Bit3=Nicht sortieren Bit4=Einfgen Bit5=Lschen Bit6=EmptyLine
	void 	SetSelect(int iSelect);						// Auswahlnummer setzen
	int		SetSelect(LPCTSTR pText,int iMode=0);		// Auswahl via Text  einstellen
	int		GetSelect(int iIndex);						// Auswahl eines Strings abfragen
	int		GetSelect();								// Auswahlnummer abfragen

	int		AddColumn(LPCTSTR pText,int iWidth=-1,BYTE bAlign=0,BOOL bEdit=FALSE);	// Eine Spalte einfgen
	int		SetText  (int iIndex,LPCTSTR pText,int iCol);//Einen Spalten Text einstellen	
	int		SetText  (int iIndex,LPCTSTR pText);		

	int		AddString   (                        LPCTSTR pText,BOOL bSelect=FALSE);
	int		AddString   (           DPARAM uData,LPCTSTR pText,BOOL bSelect=FALSE);
	int		InsertString(int iIndex,             LPCTSTR pText,BOOL bSelect=FALSE);
	int		InsertString(int iIndex,DPARAM uData,LPCTSTR pText,BOOL bSelect=FALSE);
	void 	SelectString(int iIndex                           ,BOOL bSelect=FALSE);	// Auswahl eines Strings
	void	ResetContent();

	LPCTSTR	GetText();
	int		GetText(LPTSTR  pText,int iMax);
	LPCTSTR	GetText(int     iIndex);
	int		GetText(int     iIndex,         LPTSTR pText,int iMax);
	int		GetText(int     iIndex,int iCol,LPTSTR pText,int iMax);
	LPCTSTR	GetText(int     iIndex,int iCol);
	DPARAM  SetData(int     iIndex,DPARAM  uData);
	DPARAM  GetData(int     iIndex);
	DPARAM  GetData();
	int     GetCount();
	void	SetValueFocus();

	void	AddSizeX(int iSize);						// Gre verndern
	void	AddSizeY(int iSize);						// Gre verndern
	void	SetSizeX(int iSize);						// Gre einstellen
	void	SetSizeY(int iSize);						// Gre einstellen
	void	SetSize (int iSizeX,int iSizeY);			// Gre einstellen
	void	SelectNone();								// Nichts auswhlen	

	static	int __cdecl NameCompare (const void *pElem1, const void *pElem2);
	static	int __cdecl ValueCompare(const void *pElem1, const void *pElem2);

	#define CCD_NAME	CColumnDlg::NameCompare
	#define CCD_VALUE	CColumnDlg::ValueCompare

	void	Sort(int (__cdecl *pCompare)(const void*,const void*) = CCD_NAME );


	//{{AFX_VIRTUAL(CColumnDlg)
	protected:
	virtual void DoDataExchange(CDataExchange *pDX);	// DDX/DDV-Untersttzung
	virtual void OnOK( );
	virtual void OnCancel( );
	//}}AFX_VIRTUAL

protected:

	typedef	struct
		{
		LPTSTR	pName;
		short 	sSize;
		BYTE	bAlign;
		BYTE	bEdit;
		}ColData;

	//{{AFX_MSG(CColumnDlg)
	virtual BOOL OnInitDialog();
	LRESULT OnExitSize  (WPARAM wParam,LPARAM lParam);				
	void OnRightClick   (NMHDR *pNmHdr,LRESULT *pResult);
	void OnDoubleClick  (NMHDR *pNmHdr,LRESULT *pResult);
	void OnColumnClick  (NMHDR *pNmHdr,LRESULT *pResult);
	void OnEndLabelEdit (NMHDR *pNmHdr,LRESULT *pResult);
	void OnStartLabeEdit(NMHDR *pNmHdr,LRESULT *pResult);
	void OnKeyDownNotify(NMHDR *pNmHdr,LRESULT *pResult);
	void OnSize(UINT nType,int iSizeX,int iSizeY);
	void OnSizing(UINT nSide,LPRECT pRect);
	void OnDblclkList();
	void OnSelNone();
	void OnSelAll();
	void OnDoCopy();
	void OnDelete();
	//}}AFX_MSG

	static int CALLBACK SortProc(HWND hTree,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParamSort);

	DECLARE_MESSAGE_MAP()

	CString	m_sText;
	CString	m_sTitle;
	CString	m_sTitle1;

	DPARAM	m_uData;
	int		m_iMode;								// 0=Single 1=Multi 2=Hckchen 3=Hckchen+Multi
	BOOL	m_bCancel;								// 1=bCancel anzeigen
	BOOL	m_bSized;								// Wurde die Gre verndert 
	int		m_iSelect;
	ColData*m_pColData;
	ColData*m_pColText;
	LPTSTR *m_pStrText;
	int		m_iNewCode;
	int		m_iStrCount;
	int		m_iStrMax;
	int		m_iSizeX;
	int		m_iSizeY;								// Grennderung
	int		m_iSizeBtX;
	int		m_iSizeMinX;
	int		m_iSizeMinY;
	int		m_iFrameBtX;
	int		m_iFrameBtY;
	int		m_iFrameBtZ;
	int		m_iFrameListX;
	int		m_iFrameListY;
	int		m_iFrameListZ;
	int		m_iColTextMax;
	int		m_iColText;
	int		m_iColumnsMax;
	int		m_iColumns;
	BOOL	m_bValueFocus;
	INT		m_iOldSizeX;
	INT		m_iOldSizeY;
	BOOL	m_bOldSize;
	LPVOID	m_hCopyItem;  
	int 	m_iCopyCol;


	CTreeListCtrl  *m_pList;
	static	WORD	m_wDlgData[];
	static	INT	 	m_iOldPosX;
	static	INT	 	m_iOldPosY;
	static	BOOL 	m_bOldPos;
	static	BOOL	m_bSortDir;
	static	BYTE	m_bSortCol;

};


inline	int	   CColumnDlg::AddString   (             LPCTSTR pText,BOOL bSelect){return InsertString(-1,0    ,pText,bSelect);}
inline	int	   CColumnDlg::AddString   (DPARAM uData,LPCTSTR pText,BOOL bSelect){return InsertString(-1,uData,pText,bSelect);}
inline	int	   CColumnDlg::InsertString(int   iIndex,LPCTSTR pText,BOOL bSelect){return InsertString(iIndex,0,pText,bSelect);}
inline	int	   CColumnDlg::GetCount    (){return m_iStrCount;}
inline	int	   CColumnDlg::GetSelect   (){return m_iSelect;}
inline	void   CColumnDlg::SetSelect   (int iSelect){m_iSelect=iSelect;}
inline	void   CColumnDlg::SelectNone  (){m_iSelect=-2;}
inline	void   CColumnDlg::SetMode     (int iMode,BOOL bCancel){m_iMode=iMode;m_bCancel=bCancel;}
inline	DPARAM CColumnDlg::GetData     (){return m_uData;}
inline	void   CColumnDlg::AddSizeX    (int iSize){m_iSizeX=iSize;}
inline	void   CColumnDlg::AddSizeY    (int iSize){m_iSizeY=iSize;}
inline	void   CColumnDlg::SetSizeX    (int iSize){m_iSizeX=iSize|0x12340000;}
inline	void   CColumnDlg::SetSizeY    (int iSize){m_iSizeY=iSize|0x12340000;}
inline	void   CColumnDlg::SetSize     (int iSizeX,int iSizeY){m_iSizeX=iSizeX|0x12340000;m_iSizeY=iSizeY|0x12340000;}
inline	void   CColumnDlg::SetValueFocus(){m_bValueFocus=1;}

//{{AFX_INSERT_LOCATION}}



#endif



