//*****************************************************************************
//*
//*
//*		AlternateList.h
//*
//*
//*****************************************************************************
#ifndef 	__ALTERNATELIST_H__
#define 	__ALTERNATELIST_H__

#define 	CAL_COLUMNS		16

//*****************************************************************************
//*
//*		AlternateList
//*
//*****************************************************************************
class CAlternateList : public CListCtrl
{
public:

	CAlternateList();

	BOOL	Attach(HWND	    hWnd);
	BOOL	Attach(CWnd	   *pWnd){ASSERT(pWnd);return Attach(pWnd->m_hWnd);}
	BOOL	Attach(CDialog *pDlg,unsigned uId){return Attach(pDlg->GetDlgItem(uId));}
	HWND	Detach();


protected:

	
	//{{AFX_MSG(CAlternateList)
	afx_msg void DrawItem(LPDRAWITEMSTRUCT pDraw);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	
	DECLARE_MESSAGE_MAP()
	
	CImageList *m_pImages; 
	BOOL		m_iIsAttached;
	INT			m_iColumnCount;
	INT			m_iGroupViewSize;
	INT			m_aGroupSize[CAL_COLUMNS];
	INT			m_aGroupMode[CAL_COLUMNS];

};


//{{AFX_INSERT_LOCATION}}

#endif 	