//*****************************************************************************
//*
//*
//*		ChildBar.h
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
//	Ist das ein Toolbar-Fenster das Gren vernderbar ist, und in dem 
//	verscheidenste Kinder-Fenster angedockte werden knnen. ber Laschen 
//	knnen dann diese Fenster ausgewhlt werdnen.
//
//	CFrameWnd.h:
//
//		class CFrameWnd
//			{
//			...
//			CChildBar	m_wndChildBar;
//			...
//			}
//	
//	CFrameWnd.cpp:
//
//		int CMainFrame::OnCreate(LPCREATESTRUCT pCreateStruct)
//			{
//			...
//									    
//			if(!m_wndChildBar.Create(this,CBRS_BOTTOM|CBRS_GRIPPER|CBRS_CLOSEBUTTON))
//				{							// --"-- wo darf das Fenster angedock werden
//				return -1;					// Fehler beim Erzeugen
//				}
//
//											// Ein Kindfenster einfgen
//			m_MyChildWnd.Create(... , &m_wndChildBar , ... )
//			m_wndChildBar.AttachWnd(&m_wndData);
//
//											// Optinen einstellen
//			m_wndChildBar.SetBarStyle(m_wndChildBar.GetBarStyle()|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC|CBRS_ALIGN_BOTTOM);
//	
//											// Das Andocken freigeben
//			m_wndChildBar.EnableDocking(CBRS_ALIGN_ANY);
//
//											// Das Fenster ans Hauptfenster andocken  
//			DockControlBar(&m_wndChildBar ,AFX_IDW_DOCKBAR_BOTTOM);
//
//			...
//			}
//
//		void CMainFrame::OnDataviewOn()		// Fenster ein/ausblenden
//			{
//			ShowControlBar(&m_wndChildBar,!m_wndChildBar .IsVisible(),0);
//			}
//
//		void CMainFrame::OnDataviewOnMenu(CCmdUI *pCmdUI)
//			{
//			pCmdUI->SetCheck(m_wndChildBar.IsVisible());
//			}
//
//		void CMainFrame::OnUpdateDataMenu(CCmdUI *pCmdUI)
//			{
//			pCmdUI->Enable(m_wndChildBar.IsVisible());
//			}


		
			
#ifndef 	__CHILDBAR_H__
#define 	__CHILDBAR_H__

#include	"SizeBar.h"

//*****************************************************************************
//*
//*		Klasse CChildBar
//*
//*****************************************************************************
class CChildBar : public CSizeBar
{

	DECLARE_DYNAMIC(CChildBar)

public:

			 CChildBar();
	virtual ~CChildBar();

	BOOL	 Create(              CWnd* pParentWnd,DWORD dwStyle=WS_CHILD|WS_VISIBLE|CBRS_BOTTOM,UINT nID=18);
	BOOL	 Create(LPCTSTR pName,CWnd* pParentWnd,DWORD dwStyle=WS_CHILD|WS_VISIBLE|CBRS_BOTTOM,UINT nID=18);


	CWnd    *AttachWnd(CWnd *pNewWnd);
	CWnd    *DetachWnd();



protected:


	//{{AFX_MSG(CChildBar)
	afx_msg void OnSize (UINT nType,int iXsize,int iYsize);
	afx_msg void OnDestroy();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()


protected:

	CWnd   *pChildWnd;							// Zeiger auf angedocktes Fenster
	CRect	sChildRect;							// Gre und Position Child Fenster
};



#endif
