/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*   Copy Funktionen                                                         */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
//	INT_PTR	 DoModal(char *Pfad,				Vorgang Starten
//				 CStringChain *Dateien,
//				 char *Von,
//				 int Flags=CF_COPY);
//
//	Flags:	CF_COPY		: Dateien kopieren
//			CF_MOVE		: Dateien verschieben
//			CF_REMOVE	: Dateien lschen

#include	"CopyDlg.h"


BEGIN_MESSAGE_MAP(CCopyDlg, CDialog)
	//{{AFX_MSG_MAP(CCopyDlg)
	ON_BN_CLICKED(IDABORT      ,OnAbbrechen)
 	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/*****************************************************************************/
/*                                                                           */
/*   Kon-/Destruktor                                                         */
/*                                                                           */
/*****************************************************************************/
CCopyDlg:: CCopyDlg(CWnd *pParent) : CDialog(CCopyDlg::IDD,pParent){};
CCopyDlg::~CCopyDlg(){};
/*****************************************************************************/
/*                                                                           */
/*   DlgProc                                                                */
/*                                                                           */
/*****************************************************************************/
// Call Back Funktion fr Dialog
int	CCopyDlg::DLG_ID[]={	IDABORT,
							IDNIE,
							IDIMMER,
							IDIGNORE,
							IDRETRY,
							IDNO,
							IDYES,
							IDOK,
							-1};

BOOL CALLBACK CCopyDlg::DlgProc(HWND Dlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
int			 art,id,x,y,z,flag;
char		*text;
struct		 dlg_struct *ds;
HICON		 icon1,icon2;
HIMAGELIST	 imagelist;
SHFILEINFO	 sfi;
CWnd		 wnd;
HWND		 hwnd;
RECT		 rect,rect1;
char		 puffer[256];

switch(msg)
	{
case WM_INITDIALOG:



	ds=(dlg_struct*)lParam;
	text=ds->datei1;

	imagelist = (HIMAGELIST)SHGetFileInfo( "",0,&sfi,sizeof(sfi),SHGFI_PIDL |SHGFI_SYSICONINDEX|SHGFI_SYSICONINDEX );


	//****************** Icons setzen *****************************************
	if(ds->datei1)
		{
		z =(ds->find1)? ds->find1->attrib:0;
		z&=_A_SUBDIR;
		if   (ds->art&MB_SUBDIR)z|=_A_SUBDIR;
		flag=(ds->art&MB_ATTRIB)? SHGFI_USEFILEATTRIBUTES:0;

		SHGetFileInfo(ds->datei1,z,&sfi,sizeof(sfi),SHGFI_SYSICONINDEX|flag);
		icon1=ImageList_ExtractIcon(NULL, imagelist,sfi.iIcon);
		hwnd =::GetDlgItem(Dlg,IDC_ICON1);
		::SendMessage(hwnd, STM_SETICON, (WPARAM)icon1, 0L);
		::SetDlgItemText(Dlg,IDC_DATEI1,ds->datei1);
		}
	if(ds->datei2)
		{
		z =(ds->find1)? ds->find2->attrib:0;
		z&=_A_SUBDIR;
		   if(ds->art&MB_SUBDIR)z|=_A_SUBDIR;
		flag=(ds->art&MB_ATTRIB)? SHGFI_USEFILEATTRIBUTES:0;

		SHGetFileInfo(ds->datei2,z,&sfi,sizeof(sfi),SHGFI_SYSICONINDEX|SHGFI_SYSICONINDEX|flag);
		icon2=ImageList_ExtractIcon(NULL, imagelist,sfi.iIcon);
		hwnd =::GetDlgItem(Dlg,IDC_ICON2);
		::SendMessage(hwnd, STM_SETICON, (WPARAM)icon2, 0L);
		::SetDlgItemText(Dlg,IDC_DATEI2,ds->datei2);
		}
	//****************** Infos setzen *****************************************
	if((ds->find1)&&(ds->datei1))
		{
		strcpy(puffer,"Gre: ");
		strcat(puffer,itoa(ds->find1->size,puffer+100,10));
		strcat(puffer," Byte   letzte nderung:  ");
		//strcat(puffer,ctime(&ds->find1->time_write));
		strtimeset(puffer+strlen(puffer),ds->find1->time_write,STR_ALL);
		::SetDlgItemText(Dlg,IDC_INFO1,puffer);
		}
	if((ds->find2)&&(ds->datei2))
		{
		strcpy(puffer,"Gre: ");
		strcat(puffer,itoa(ds->find2->size,puffer+100,10));
		strcat(puffer," Byte   letzte nderung:  ");
		strtimeset(puffer+strlen(puffer),ds->find2->time_write,STR_ALL);
		::SetDlgItemText(Dlg,IDC_INFO2,puffer);
		}

	//*************** Tasten ein/aus schalten *********************************
	switch(ds->art&0x07)
		{
	case MB_ABORTRETRYIGNORE:  x=0x0019;break;
	case MB_OK 				:  x=0x0080;break;
	case MB_OKCANCEL 		:  x=0x0081;break;
	case MB_RETRYCANCEL 	:  x=0x0011;break;
	case MB_YESNO 			:  x=0x0060;break;
	case MB_YESNOCANCEL 	:  x=0x0061;break;
	case MB_YESNOIMMER		:  x=0x0067;break;
		}

	::GetClientRect(Dlg,&rect);
	if(!ds->datei2)							// Dialog verkleinern
		{
		rect.bottom -=40;
		::SetWindowPos(Dlg,HWND_TOP,0,0,rect.right,rect.bottom,SWP_NOMOVE);
		hwnd=::GetDlgItem(Dlg,IDC_INFO2 );::ShowWindow(hwnd,SW_HIDE);
		hwnd=::GetDlgItem(Dlg,IDC_ICON2 );::ShowWindow(hwnd,SW_HIDE);
		hwnd=::GetDlgItem(Dlg,IDC_DATEI2);::ShowWindow(hwnd,SW_HIDE);
		}

	::GetClientRect(Dlg,&rect);
	rect.right  -=14;
	rect.bottom -=35;

	for(y=0;y<32;y++)
		{
		if(DLG_ID[x]==-1)break;
		hwnd=::GetDlgItem(Dlg,DLG_ID[y]);
		if(!(x&(1<<y))){::ShowWindow(hwnd,SW_HIDE);continue;}

		::GetClientRect(hwnd,&rect1 );rect.right-=rect1.right;
		::SetWindowPos (hwnd,HWND_TOP,rect.right,rect.bottom,0,0,SWP_NOSIZE);
		rect.right-=8;
		}

	//*************** Augabe Fehler *******************************************

	switch(ds->art&0x00F8)
		{
	case MB_UEBERSCHREIBEN:	text="Datei existiert bereits. berschreiben ?"					;break;
	case MB_COPYFEHLER:		text="Fehler beim Kopieren von:"								;break;
	case MB_DATEIISTVERS:	text="Datei ist ein Verzeichnis und kann nicht kopiert werden !";break;
	case MB_SELBSTCOPY:		text="Datei kann nicht in sich selbst kopieren !"				;break;
	case MB_ZULANG:			text="Dateiname ist zu lang !"									;break;
	case MB_VERZUEBERSCHR:	text="Kann Verzeichnis nicht berschrieben !"					;break;
	case MB_VERZERZEUGEN:	text="Kann Verzeichnis nicht erzeugen !"						;break;
	case MB_NICHTGEFUNDEN:	text="Datei wurde nicht gefunden !"								;break;
	case MB_NICHTVERSCH:	text="Datei kann nicht verschoben werden !"						;break;
	case MB_NICHTLOESCHEN:	text="Datei kann nicht gelscht werden."						;break;
	case MB_KEINSPEICHER:	text="Zuwenig feier Speicher fr's erstellen von:"				;break;
	case MB_WIRKLICHDEL:	text="Soll die Datei wirklich gelscht werden ?"				;break;
		}

	::SetDlgItemText(Dlg,IDC_FEHLER,text);
	return 1;


//******************* Tastendruck *********************************************

case WM_COMMAND:

	id  = LOWORD(wParam);
	art = HIWORD(wParam);

	if(!art)::EndDialog(Dlg,id);

	}

return 0;
}
/*****************************************************************************/
/*                                                                           */
/*   Frage                                                                   */
/*                                                                           */
/*****************************************************************************/
// Text ist der Text des Fehlers
// Art: MB_ABORTRETRYIGNORE
//		MB_OK
//		MB_OKCANCEL
//		MB_RETRYCANCEL
//		MB_YESNO
//		MB_YESNOCANCEL
//		MB_YESNOIMMER

int	CCopyDlg::Frage(int Art,char *Datei1,char *Datei2,_finddata_t *Find1,_finddata_t *Find2)
{
int x;

if(Art&MB_SPEZIAL)
	{
	struct dlg_struct ds;

	ds.art		=Art;
	ds.datei1	=Datei1;
	ds.datei2	=Datei2;
	ds.find1	=Find1;
	ds.find2	=Find2;

	x= DialogBoxParam(	AfxGetInstanceHandle(),
						MAKEINTRESOURCE(IDD_FRAGE),
						AfxGetMainWnd()->m_hWnd,
						(DLGPROC)&DlgProc,
						(int)&ds);
	}
else x=MessageBox(Datei1,"Fehler",Art);

if(x==IDCANCEL)flags|=CF_ABBRUCH;
if(x==IDABORT )flags|=CF_ABBRUCH;

return x;
}
/*****************************************************************************/
/*                                                                           */
/*   OnAbbrechen                                                             */
/*                                                                           */
/*****************************************************************************/
// Setzt CF_ABBRUCH Flag
void CCopyDlg::OnAbbrechen()
{
flags|=CF_ABBRUCH;
}
/*****************************************************************************/
/*                                                                           */
/*   Copy_Datei                                                              */
/*                                                                           */
/*****************************************************************************/
// Kopiert eine einzelne Datei nach pfad
// Verzeichnisse knnen nicht kopiert werden
// Werte fr flags:	CF_IMMER		Datei wird immer berschrieben
//					CF_NIE			Datei wird nie   berschrieben
//					CF_ABBRUCH		Vorgang wurde abgebrochen (Nur Rckgabe)
//					CF_KEINE_VERZ	Keine Fehlerausgabe wenn Datei Verzeichnis ist
//					CF_TEST			Nur geprfen ob die Datei ein Verzeichnis ist
//
// Ergibt 	 0 : Wenn nur dateien kopiert wurden
//			 1 : dateien ist ein Verzeichnis
//			 2 : dateien wurde nicht kopiert
//			-1 : Bei einem Fehler
int	CCopyDlg::Copy_Datei(char *Pfad,char *Datei)
{
int			x,y,z,len,end;
char		ziel[MAX_PATH+ 16];
_finddata_t	find,datei;


len=strlen  (Datei);
end=strcspnr(Datei,"\\/:",len)+1;			// Suche Dateinamen

//******************** Ist Datei vorhanden ************************************

y=_findfirst(Datei,&datei);				// Datei forhanden ?
if(y!=-1)
	{
	_findclose(y);
	if(datei.attrib&_A_SUBDIR)			// Verzeichnis gefunden ?
		{
		if(  flags&CF_TEST       )return 1;
		if(!(flags&CF_KEINE_VERZ))
			Frage(MB_OKCANCEL|MB_DATEIISTVERS|MB_SUBDIR,Datei);
		return 1;
		}
	}

if(flags&CF_TEST)return (y==-1)? -1:0;
if(y==-1)
	{
	Frage(MB_OKCANCEL|MB_NICHTGEFUNDEN|MB_ATTRIB,Datei);
	return -1;
	}

//******************** Prfe Pfad *********************************************
x=strlen(Pfad);

if(!strnicmp(Pfad,Datei,x) && (Datei[x]=='\\'))
	{
	y=x;
	if(Datei[y]=='\\')y++;
	z=strcspn(Datei+y,"\\");
	if(!Datei[y+z])
		{
		Frage(MB_OKCANCEL|MB_SELBSTCOPY,Datei,0,&datei);
		return -1;
		}
	}

//******************** Dateiname fr Zieldatei ********************************

if(x+len-end>MAX_PATH)
	{
	Frage(MB_OKCANCEL|MB_ZULANG,Datei);
	return -1;
	}

memcpy(ziel,Pfad,x);
if(x&&(ziel[x-1]!='\\')){ziel[x]='\\';x++;}
strcpy(ziel+x,datei.name);

y=_findfirst(ziel,&find);				// Datei forhanden ?
if(y!=-1)
do	{
	_findclose(y);
	if(find.attrib&_A_SUBDIR)			// Verzeichnis gefunden ?
		{
		if(!(flags&CF_KEINE_VERZ))
			Frage(MB_OKCANCEL|MB_VERZUEBERSCHR,Datei,ziel,&datei,&find);
		return -1;
		}

	if(flags&CF_IMMER )break;
	if(flags&CF_NIE   )return 2;

	x=Frage(MB_UEBERSCHREIBEN|MB_YESNOIMMER,Datei,ziel,&datei,&find);
	if(x==IDIMMER )flags|=CF_IMMER;
	if(x==IDNIE   )flags|=CF_NIE;
	if(x!=IDYES   )return 2;
	}while(0);

//***************** Datei kopieren ********************************************

errno=0;
x=CopyFile(Datei,ziel,0);
if(!x)
	{
	if(errno==ENOMEM)
		   {Frage(MB_OK      |MB_KEINSPEICHER,Datei);flags|=CF_ABBRUCH;}
	else	Frage(MB_OKCANCEL|MB_COPYFEHLER  ,Datei);
	return -1;
	}


flags|=CF_DATEI;

return 0;
}
/*****************************************************************************/
/*                                                                           */
/*   Check_Datei                                                             */
/*                                                                           */
/*****************************************************************************/
// Ergibt die Artiener Datei wenn Datei!=0 ist ergibt sich
// der Dateiname aus Pfad+Datei
// Ergibt 	 0 : Wenn Datei existiert
//			 1 : Wenn Datei ein Verzeichnis ist
//			-1 : Wenn Datei nicht vorhanden
int	CCopyDlg::Check_Datei(char *Pfad,char *Datei)
{
int			x,y,len;
char		puffer[MAX_PATH+ 16];
_finddata_t	find;



if(Datei)
	{
	len=strlen(Pfad);
	if(len>MAX_PATH)return -1;

	memcpy(puffer,Pfad,len);
	if(len && (puffer[len]!='\\'))
		{
		puffer[len]='\\';
		len++;
		}

	x=strlen(Pfad);
	if(len+x>MAX_PATH)return -1;
	memcpy(puffer+len,Datei,x+1);

	Pfad=puffer;
	}


//******************** Ist Datei vorhanden ************************************

y=_findfirst(Pfad,&find);				// Datei forhanden ?
if(y==-1)return -1;

_findclose(y);
if(find.attrib&_A_SUBDIR)return 1;		// Verzeichnis gefunden ?

return 0;
}
/*****************************************************************************/
/*                                                                           */
/*   Copy                                                                    */
/*                                                                           */
/*****************************************************************************/
// Kopiert die angegeben dateien zum Data.pfad
// Ist Data.von !=0 enthlt Data.dateien nur die Dateinamen ohne Pfade
void CCopyDlg::Copy(copy_data	*Data)
{
int				x,y,z,nr,len,anz,pos;
char			puffer[MAX_PATH+16],ziel[MAX_PATH+16],*name;
char		   *pfad,*von;
CStringChain   *dateien,copy,namen;
_finddata_t		find;
copy_data		data;


von		=Data->von;					// Start Daten
pfad	=Data->pfad;
dateien	=Data->dateien;



if(ebene>32)return;

if(!von)pos=0;						// puffer[pos] ist der Ausgangspfad
else	{
		pos=strlen(von);
		if(pos>MAX_PATH+2)pos=MAX_PATH+2;
		memcpy(puffer,von,pos);
		if(pos && (puffer[pos-1]!='\\'))
			 {     puffer[pos  ] ='\\';pos++;}
				   puffer[pos  ] = 0;
		}

anz=dateien->Count();

//*************** Kopiere Verzeichnisse ***************************************
for(nr=0;nr<anz;nr++)
	{
	if(flags&CF_ABBRUCH)break;
	name=dateien->Get(nr);
	len =strlen(name);

	if(pos+len>MAX_PATH)				// Ist Pfad zu lang ?
		{
		Frage(MB_OKCANCEL|MB_ZULANG|MB_SUBDIR,ziel);
		continue;
		}

	memcpy(puffer+pos,name,len+1);		// Dateinamen an Pfad anhngen
	len+=pos;

	if(len && (puffer[len-1]=='\\'))
		{
		puffer[len-1]=0;
		len--;
		}

	y=Check_Datei(puffer);				// Ist Datei ein Verzeichnis ?
	if(y!=1)
		{
		copy.Add(dateien->Get(nr));
		continue;
		}

	x=(len && (puffer[len-1]!='\\'));	// Dateien im Verzeichnis suchen
	strcpy(puffer+len,(x)? "\\*.*":"*.*");if(!x)len--;
	y=_findfirst(puffer,&find);

	z=0;
	while(z!=-1)
		{
		if(find.name[0]=='.')
			{
			if(find.name[1]== 0 ){z=_findnext(y,&find);continue;}
			if(find.name[1]=='.')
			if(find.name[2]== 0 ){z=_findnext(y,&find);continue;}
			}
		namen.Add(find.name);
		z=_findnext(y,&find);
		}
	if(y!=-1)_findclose(y);


	puffer[len]=0;						// Verzeichnisnamen erzeugen
	y=strlen(pfad);
	z=strcspnr(puffer,"\\/",len)+1;

	if(y+len>MAX_PATH)
		{
		Frage(MB_OKCANCEL|MB_ZULANG|MB_SUBDIR,pfad);
		continue;
		}

	memcpy(ziel,pfad,y);
	if(y&&(ziel[y-1]!='\\')){ziel[y]='\\';y++;}
	strcpy(ziel+y,puffer+z);

	y=_findfirst(ziel,&find);		// Neues Verzeichnis erzeugen
	if(y!=-1)
		{
		_findclose(y);
		if(  flags&CF_VNIE   )continue;
		if(!(flags&CF_VIMMER))
			{
			x=Frage(MB_YESNOIMMER|MB_UEBERSCHREIBEN|MB_SUBDIR,ziel);
			if(x==IDIMMER )flags|=CF_VIMMER;
			if(x==IDNIE   )flags|=CF_VNIE;
			if(x!=IDYES   )continue;
			}
		}
	else{
		errno=0;
		y=mkdir(ziel);
		if(y==-1)
			{
			if(errno==ENOMEM)
				   {Frage(MB_OK      |MB_KEINSPEICHER|MB_SUBDIR,ziel);flags|=CF_ABBRUCH;}
			else	Frage(MB_OKCANCEL|MB_VERZERZEUGEN|MB_SUBDIR,ziel);
			continue;
			}
		}

	flags|=CF_VERZ;
	if(!namen.Count())continue;

	ebene++;					// Verzeichnis Dateien kopieren
	data.pfad	= ziel;
	data.von	= puffer;
	data.dateien=&namen;
	Copy(&data);
	namen.Del();
	ebene--;
	}

//*************** Dateien kopieren ********************************************

anz=copy.Count();
progress->SetRange(0,anz);
progress->SetPos(0);

if(anz && !(flags&CF_ABBRUCH))
	{
	for(nr=0;nr<anz;nr++)
		{
		if(flags&CF_ABBRUCH)break;
		name=copy.Get(nr);
		y=strlen(name);

		if(pos+y>MAX_PATH)					// Dateiname ist zulang ?
			{
			Frage(MB_OKCANCEL|MB_ZULANG|MB_SUBDIR,ziel);
			continue;
			}

		strcpy(puffer+pos,name);
		name=puffer;

		if(flags&CF_ABBRUCH)break;
		SetDlgItemText(IDC_VON ,name);
		SetDlgItemText(IDC_NACH,pfad);
		flags&=~CF_TEST;
		flags|= CF_KEINE_VERZ;
		y=Copy_Datei(pfad,name);
		progress->SetPos(nr+1);
		}
	}

if(ebene<=0)EndDialog(flags);

return;
}
/*****************************************************************************/
/*                                                                           */
/*   Move                                                                    */
/*                                                                           */
/*****************************************************************************/
// Verschiebt die angegeben Dateien zum Data.pfad
// Ist Data.von !=0 enthlt Data.namen nur die Dateinamen ohne Pfade
void CCopyDlg::Move(copy_data	*Data)
{
int				x,y,nr,len,anz,pos,lw;
char			puffer[MAX_PATH+16],ziel[MAX_PATH+16],*name;
char		   *pfad,*von;
CStringChain   *dateien,namen;
copy_data		data;

von		=Data->von;					// Start Daten
pfad	=Data->pfad;
dateien	=Data->dateien;




if(!von)pos=0;
else	{
		pos=strlen(von);
		if(pos>MAX_PATH+2)pos=MAX_PATH+2;
		memcpy(puffer,von,pos);
		if(pos && (puffer[pos-1]!='\\'))
			 {     puffer[pos  ] ='\\';pos++;}
				   puffer[pos  ] = 0;
		}

anz=dateien->Count();
lw =strcspn(pfad,":");if(pfad[lw]==':')lw++;
len=strlen (pfad);
memcpy(ziel,pfad,len);
if(len && (ziel[len-1]!='\\')){ziel[len]='\\';len++;}
ziel[len]=0;

//*************** Verschiebe Dateien ******************************************
for(nr=0;nr<anz;nr++)
	{
	if(flags&CF_ABBRUCH)break;
	name=dateien->Get(nr);
	if(pos)
		{
		strncpy(puffer+pos,name,MAX_PATH+2-pos);
		name=puffer;
		}


	y=Check_Datei(name);				// Ist Datei ein Verzeichnis ?
	x=strnicmp(ziel,name,lw);

	SetDlgItemText(IDC_VON ,name);
	SetDlgItemText(IDC_NACH,ziel);

	if(y==-1)							// Datei existiert nicht ?
		{
		Frage(MB_OKCANCEL|MB_NICHTGEFUNDEN|MB_ATTRIB,name);
		continue;
		}
	if((y==1) && !x)					// Verzeichnis nach oben ?
		{
		if(strnicmp(ziel,name,len))
			{
			Frage(MB_OKCANCEL|MB_NICHTVERSCH|MB_SUBDIR,name,ziel);
			continue;
			}
		}
	if(!x)									// Im gleichen LW
		{
		x=strlen  (name);
		y=strcspnr(name,"\\/:",x)+1;

		if(len+x-y>MAX_PATH)
			{
			Frage(MB_OKCANCEL|MB_ZULANG|MB_SUBDIR,ziel);
			continue;
			}
		strcpy(ziel+len,name+y);
		flags|=CF_TEST;
		y=Copy_Datei("",ziel);				// Datei berschreiben ?
		if(y!=-1)
			{
			namen.Add(name);
			continue;
			}
		errno=0;
		x=MoveFile(name,ziel);
		if(!x)
			{
			if(errno==ENOMEM)
				   {Frage(MB_OK      |MB_KEINSPEICHER,ziel);flags|=CF_ABBRUCH;}
			else	Frage(MB_OKCANCEL|MB_NICHTVERSCH ,name,ziel);
			continue;
			}
		if(y==1)flags|=CF_VERZ;
				flags|=CF_DATEI;

		continue;
		}

	namen.Add(name);
	}

//*************** Kopiere Dateien *********************************************

anz=namen.Count();
progress->SetRange(0,anz);
progress->SetPos(0);
if(anz && !(flags&CF_ABBRUCH))
	{
	ziel[len]   =0;
	data.pfad	= ziel;
	data.von	= "";
	data.dateien=&namen;

	ebene++;
	Copy(&data);
	ebene--;
	if(!(flags&CF_ABBRUCH))Remove(&data);
	progress->SetPos(nr+1);
	}


EndDialog(flags);
}
/*****************************************************************************/
/*                                                                           */
/*   Remove                                                                  */
/*                                                                           */
/*****************************************************************************/
// Lscht die angegeben dateien zum Data.pfad
// Ist Data.von !=0 enthlt Data.namen nur die Dateinamen ohne Pfade
void CCopyDlg::Remove(copy_data	*Data)
{
int				x,y,z,nr,len,anz,pos;
char			puffer[MAX_PATH+16],*name;
char		   *von;
CStringChain   *dateien,namen,dateien1;
_finddata_t		find;
copy_data		data;


von		=Data->von;					// Start Daten
dateien	=Data->dateien;


if( ebene>32)return;
if(!ebene)
	{
	SetDlgItemText(IDC_STATIC1,"Datei:");
	SetDlgItemText(IDC_STATIC2,""      );
	}

if(!von)pos=0;
else	{
		pos=strlen(von);
		if(pos>MAX_PATH+2)pos=MAX_PATH+2;
		memcpy(puffer,von,pos);
		if(pos && (puffer[pos-1]!='\\'))
			 {     puffer[pos  ] ='\\';pos++;}
				   puffer[pos  ] = 0;
		}

anz=dateien->Count();

//*************** Lsche Verzeichnisse ****************************************
for(nr=0;nr<anz;nr++)
	{
	if(flags&CF_ABBRUCH)break;
	name=dateien->Get(nr);
	if(pos)
		{
		strncpy(puffer+pos,name,MAX_PATH+2-pos);
		name=puffer;
		}

	y=Check_Datei(name);			// Ist Datei ein Verzeichnis ?
	if(y!=1)
		{
		dateien1.Add(dateien->Get(nr));
		continue;
		}

	SetDlgItemText(IDC_VON ,name);
	SetDlgItemText(IDC_NACH,""  );

	if(flags&CF_FRAGE)				// Einmalige Sicherheitsabfrage
		{
		x=Frage(MB_OKCANCEL|MB_WIRKLICHDEL|MB_SUBDIR,name);
		flags&=~CF_FRAGE;
		if(flags&CF_ABBRUCH)break;
		}

	if(!pos)
		{
		strncpy(puffer,name,MAX_PATH+2-pos);
		name=puffer;
		}

	len=strlen(puffer+pos)+pos;
	if(len && (puffer[len-1]!='\\')){puffer[len]='\\';len++;}

	strcpy(puffer+len,"*.*");
	y=_findfirst(puffer,&find);
	if(y==-1)continue;

	z=0;
	while(z!=-1)						// Dateien im Verzeichnis suchen
		{
		if(find.name[0]=='.')
			{
			if(find.name[1]== 0 ){z=_findnext(y,&find);continue;}
			if(find.name[1]=='.')
			if(find.name[2]== 0 ){z=_findnext(y,&find);continue;}
			}
		namen.Add(find.name);
		z=_findnext(y,&find);
		}
	_findclose(y);

	puffer[len-1]=0;					// Verzeichnisnamen erzeugen
	y=strlen  (puffer);
	z=strcspnr(puffer,"\\:/",len);
	if(y+len-z>MAX_PATH)continue;

	flags|=CF_VERZ;
	if(namen.Count())						// Verzeichniseintrge lschen
		{
		ebene++;
		data.pfad	= "";
		data.von	= puffer;
		data.dateien=&namen;
		Remove(&data);
		namen.Del();
		ebene--;
		}

	if(flags&CF_ABBRUCH)break;
	rmdir(name);						// Verzeichnis lschen
	}

//*************** Dateien lschen *********************************************

anz=dateien1.Count();
progress->SetRange(0,anz);
progress->SetPos(0);
if(anz && !(flags&CF_ABBRUCH))
	{
	for(nr=0;nr<anz;nr++)
		{
		if(flags&CF_ABBRUCH)break;
		name=dateien1.Get(nr);
		if(pos)
			{
			strncpy(puffer+pos,name,MAX_PATH+2-pos);
			name=puffer;
			}
		SetDlgItemText(IDC_VON ,name);
		SetDlgItemText(IDC_NACH,""  );

		if(flags&CF_FRAGE)				// Einmalige Sicherheitsabfrage
			{
			x=Frage(MB_OKCANCEL|MB_WIRKLICHDEL,name);
			flags&=~CF_FRAGE;
			}

		if(flags&CF_ABBRUCH)break;
		x=remove(name);
		progress->SetPos(nr+1);
		if(x)
			{
			Frage(MB_OKCANCEL|MB_NICHTLOESCHEN,name);
			continue;
			}
		flags|=CF_DATEI;
		}
	}

if(ebene<=0)EndDialog(flags);

return;
}
/*****************************************************************************/
/*                                                                           */
/*   Start Funktionen fr Threads                                            */
/*                                                                           */
/*****************************************************************************/
DWORD WINAPI CCopyDlg::StartRemvThread(LPVOID copy_class)
{
CCopyDlg	*copy;

copy=(CCopyDlg*) copy_class;
copy->Remove(&copy->data);

return 0;
}
DWORD WINAPI CCopyDlg::StartMoveThread(LPVOID copy_class)
{
CCopyDlg	*copy;

copy=(CCopyDlg*) copy_class;
copy->Move(&copy->data);

return 0;
}
DWORD WINAPI CCopyDlg::StartCopyThread(LPVOID copy_class)
{
CCopyDlg	*copy;

copy=(CCopyDlg*) copy_class;
copy->Copy(&copy->data);

return 0;
}
/*****************************************************************************/
/*                                                                           */
/*   DoModal                                                                 */
/*                                                                           */
/*****************************************************************************/
// Kopiert oder Verschiebt die angegeben Dateien zum Pfad
// Ist Von!=0 enthlt *Dateien nur die Dateinamen ohne Pfade
// Ergibt 	 dir Flags
INT_PTR CCopyDlg::DoModal(char *Pfad,CStringChain *Dateien,char *Von,int Flags)
{

data.von	= Von;
data.pfad	= Pfad;
data.dateien= Dateien;

flags	=Flags;
ebene	=0;
init	=0;

CDialog::DoModal();

TerminateThread(copy_thread,0);					// Thread beenden
CloseHandle    (copy_thread  );
				copy_thread=0;


return flags;
}

/*****************************************************************************/
/*                                                                           */
/*   DoDataExchange                                                          */
/*                                                                           */
/*****************************************************************************/
void CCopyDlg::DoDataExchange( CDataExchange *pDX )
{

if(!init)
	{
	init=1;

	progress=(CProgressCtrl*)GetDlgItem(IDC_PROGRESS1);

	switch(flags&0x0F)
		{
	case CF_COPY:	SetWindowText("Kopiere");
					copy_thread=CreateThread(0,0,StartCopyThread,this,0,&copy_thread_id); break;
	case CF_MOVE:	SetWindowText("Verschiebe");
					copy_thread=CreateThread(0,0,StartMoveThread,this,0,&copy_thread_id); break;
	case CF_REMOVE:	SetWindowText("Lsche");
					copy_thread=CreateThread(0,0,StartRemvThread,this,0,&copy_thread_id); break;
	default:		EndDialog(0);
		}
	}


CDialog::DoDataExchange(pDX);
}
