//*****************************************************************************
//*
//*		
//*		DriveDlg.h : Header-Datei
//*
//*
//*****************************************************************************
#ifndef 	AFX_DRIVEDLG_H__8FFA39B8_1FD3_4A3F_B474_E45B3DB5F313__INCLUDED_
#define     AFX_DRIVEDLG_H__8FFA39B8_1FD3_4A3F_B474_E45B3DB5F313__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif


#include	<Afx.h>
#include	<AfxWin.h>
#include	<StringChain.h>


//*****************************************************************************
//*
//*		Dialogfeld CDriveDlg 
//*
//*****************************************************************************
class CDriveDlg : public CDialog
{
public:

	CDriveDlg(CWnd *pParent = NULL);			// Standardkonstruktor

	//{{AFX_DATA(CDriveDlg)
	//}}AFX_DATA

	DWORD			dwSize;						// Gre des gewhlten Laufwerks in MB
	DWORD			dwDrive;					// Ist das gewhlte Laufwerk
	DWORD			dwMaxSize;					// Maximale Gre eines Laufwerkes (in MB)
	CString			sDriveName;					// Name des gewhlten Laufwerks
	int				iTargets;					// 0=alles  1=nur Physisch 2=nur Logische LW
	BOOL			bAddImage;					// Auch Images auswhlen
	BOOL			bNoCdRom;					// Keine CD-Laufwerke
	BOOL			bOnlyFat;					// Nur FAT-Laufwerke

	static BOOL		GetDriveName(DWORD dwDrive,char *pBuffer,int iSize,int *pIcon=0);

	//{{AFX_VIRTUAL(CDriveDlg)
protected:
	virtual void DoDataExchange(CDataExchange *pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

protected:

	HIMAGELIST		hImageList;					// ImageList mit den Icons
	int				iTextOffset;				// Offset fr den Listentext
	int				iDriveCount;				// Anzahl der Gefunden Laufwerke
	CStringChain	sDriveNames;				// Namen der Laufwerke
	static BYTE		aLogicToPhysical[32];		// Logische Laufwerke zu pysische
	static CBrush	cBrush1,cBrush2,cBrush3;	// Farben fr Fenster
	static BOOL		bFirstInit;					// Wurde der Dialog schon initialisiert
	CListBox	   *pListBox;					// Zeiger auf Laufwerks Liste
	
	static	void	Filter(char *pStr);
	static	WORD	wDlgData[];

	//{{AFX_MSG(CDriveDlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	afx_msg void OnDoubleClick();
	//}}AFX_MSG
	
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}

#endif
