//*****************************************************************************
//*
//*
//*		Klasse	CHtmlCtrl
//*
//*
//*****************************************************************************
#include	"HtmlCtrl.h"
#include	"WinExtension.h"


DWORD		 AFXAPI				AfxRelease( LPUNKNOWN* plpUnknown);
#define		 RELEASE(pUnk)		AfxRelease((LPUNKNOWN*)&pUnk)
#define 	 HTMLID_FIND		1

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#ifndef 	 OLECMDID_OPTICAL_ZOOM	
#define 	 OLECMDID_OPTICAL_ZOOM			(OLECMDID)63
#endif 	

#ifndef 	 OLECMDID_OPTICAL_GETZOOMRANGE
#define 	 OLECMDID_OPTICAL_GETZOOMRANGE  (OLECMDID)64
#endif 	


BEGIN_MESSAGE_MAP(CHtmlCtrl, CWnd)
	//{{AFX_MSG_MAP(CHtmlCtrl)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_MESSAGE(WM_COPY,			OnCopyMsg)
	ON_COMMAND(ID_EDIT_COPY,	OnCopy)
	ON_COMMAND(ID_FILE_PRINT,   OnFilePrint)
	ON_COMMAND(ID_FILE_SAVE,    OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
END_MESSAGE_MAP()



BEGIN_EVENTSINK_MAP(CHtmlCtrl,CWnd)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 102/* StatusTextChange   */, OnStatusTextChange	,	VTS_BSTR)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 108/* ProgressChange     */, OnProgressChange	,	VTS_I4 VTS_I4)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 105/* CommandStateChange */, OnCommandStateChange,	VTS_I4 VTS_BOOL)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 106/* DownloadBegin      */, OnDownloadBegin	,	VTS_NONE)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 104/* DownloadComplete   */, OnDownloadComplete	,	VTS_NONE)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 113/* TitleChange        */, OnTitleChange		,	VTS_BSTR)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 252/* NavigateComplete2  */, NavigateComplete2	,	VTS_DISPATCH  VTS_PVARIANT)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 250/* BeforeNavigate2    */, BeforeNavigate2	,	VTS_DISPATCH  VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PVARIANT VTS_PBOOL)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 112/* PropertyChange	 */, OnPropertyChange	,	VTS_BSTR)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 251/* NewWindow2         */, OnNewWindow2		,	VTS_PDISPATCH VTS_PBOOL)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 259/* DocumentComplete   */, DocumentComplete	,	VTS_DISPATCH  VTS_PVARIANT)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 253/* OnQuit             */, OnQuit				,	VTS_NONE)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 254/* OnVisible          */, OnVisible			,	VTS_BOOL)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 255/* OnToolBar          */, OnToolBar			,	VTS_BOOL)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 256/* OnMenuBar          */, OnMenuBar			,	VTS_BOOL)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 257/* OnStatusBar        */, OnStatusBar		,	VTS_BOOL)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 258/* OnFullScreen       */, OnFullScreen		,	VTS_BOOL)
	ON_EVENT(CHtmlCtrl, AFX_IDW_PANE_FIRST, 260/* OnTheaterMode      */, OnTheaterMode		,	VTS_BOOL)
END_EVENTSINK_MAP()


int			CHtmlCtrl::m_iRetDone;
int			CHtmlCtrl::m_iOverWrite;
int			CHtmlCtrl::m_iSaveAsMode;
CString		CHtmlCtrl::m_sSaveAsFile;
CSemaphore	CHtmlCtrl::m_sSaveAsSem;
WNDPROC		CHtmlCtrl::m_pOldProc = NULL;
HWND		CHtmlCtrl::m_hHtmlWnd = NULL;
HWND		CHtmlCtrl::m_hHookWnd = NULL;
HHOOK		CHtmlCtrl::m_hHook    = NULL;


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CHtmlCtrl::CHtmlCtrl()
{

	m_pBrowserApp = NULL;

}


//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CHtmlCtrl::~CHtmlCtrl()
{
	if(m_pBrowserApp!=NULL)
		{
		m_pBrowserApp->Release();
		}
}



//*****************************************************************************
//*
//*		OnFilePrint
//*
//*****************************************************************************
void CHtmlCtrl::OnFilePrint()
{
LPOLECOMMANDTARGET pTarget;
LPDISPATCH		   pDisp;


	if(m_pBrowserApp!=NULL)
		{
		pTarget = NULL;
		pDisp   = GetHtmlDocument();

		if(pDisp!=NULL)
			{
			// the control will handle all printing UI

			if(SUCCEEDED(pDisp->QueryInterface(IID_IOleCommandTarget,(LPVOID*)&pTarget)))
				{
				pTarget->Exec(NULL,OLECMDID_PRINT,0,NULL,NULL);
				pTarget->Release();
				}

			pDisp->Release();
			}
		}
}


//*****************************************************************************
//*
//*		OnFileSave
//*
//*****************************************************************************
void CHtmlCtrl::OnFileSave()
{

	if(m_pBrowserApp!=NULL)
		{
		ExecWB(OLECMDID_SAVE,OLECMDEXECOPT_DODEFAULT,NULL,NULL);
		}


}


//*****************************************************************************
//*
//*		OnFileSaveAs
//*
//*****************************************************************************
void CHtmlCtrl::OnFileSaveAs()
{

	if(m_pBrowserApp!=NULL)
		{
		ExecWB(OLECMDID_SAVEAS,OLECMDEXECOPT_DODEFAULT,NULL,NULL);
		}


}

//*****************************************************************************
//*
//*		OnCopyMsg
//*
//*****************************************************************************
LRESULT CHtmlCtrl::OnCopyMsg(WPARAM wParam,LPARAM lParam)
{

	if(m_pBrowserApp!=NULL)
		{
		ExecWB(OLECMDID_COPY,OLECMDEXECOPT_DODEFAULT,NULL,NULL);
		}


return 0;
}


//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
void CHtmlCtrl::OnCopy()
{

	if(m_pBrowserApp!=NULL)
		{
		ExecWB(OLECMDID_COPY,OLECMDEXECOPT_DODEFAULT,NULL,NULL);
		}


}


//*****************************************************************************
//*
//*		Debug-Funktionen
//*
//*****************************************************************************
#ifdef		_DEBUG
void CHtmlCtrl::AssertValid()		   const{	CWnd::AssertValid();}
void CHtmlCtrl::Dump(CDumpContext& dc) const{	CWnd::Dump(dc);		}
#endif


//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CHtmlCtrl::OnDestroy()
{
LPUNKNOWN  *pUnknown;
DWORD		dwRef;


	if(!m_pBrowserApp)return;


		pUnknown=(LPUNKNOWN*)&m_pBrowserApp;
	if(*pUnknown != NULL)
		{
		dwRef	  = (*pUnknown)->Release();
		*pUnknown = NULL;
		}

}


//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CHtmlCtrl::OnSize(UINT nType, int cx, int cy)
{
CRect sRect;


	CWnd::OnSize(nType, cx, cy);

	if(::IsWindow(m_cWndBrowser.m_hWnd))
		{
		// need to push non-client borders out of the client area

		GetClientRect(sRect);
		::AdjustWindowRectEx(sRect,m_cWndBrowser.GetStyle(), FALSE, WS_EX_CLIENTEDGE);
		m_cWndBrowser.SetWindowPos(NULL, sRect.left, sRect.top,sRect.Width(), sRect.Height(), SWP_NOACTIVATE| SWP_NOZORDER);
		}
}


//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
void CHtmlCtrl::OnPaint()
{

	Default();

}


//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
BOOL CHtmlCtrl::Create(LPCTSTR pWindowName,DWORD dwStyle, const RECT &sRect,CWnd* pParentWnd,UINT nID)
{
RECT		sClient;
LPUNKNOWN	pUnk;
HRESULT		lRet;


	if(!CWnd::Create(_T("STATIC"),pWindowName,dwStyle|SS_WHITEFRAME,sRect,pParentWnd,nID,0))
		{
		return FALSE;
		}

	AfxEnableControlContainer();
	GetClientRect(&sClient);

	if(!m_cWndBrowser.CreateControl(CLSID_WebBrowser,pWindowName,WS_VISIBLE|WS_CHILD|SS_BLACKFRAME,sClient,this,AFX_IDW_PANE_FIRST))
		{
		DestroyWindow();
		return FALSE;
		}

	pUnk = m_cWndBrowser.GetControlUnknown();
	lRet = pUnk->QueryInterface(IID_IWebBrowser2,(void**)&m_pBrowserApp);

	if(!SUCCEEDED(lRet))
		{
		m_pBrowserApp = NULL;
		m_cWndBrowser.DestroyWindow();
		DestroyWindow();
		return FALSE;
		}


	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,NULL);


return TRUE;
}


//*****************************************************************************
//*
//*		CreateEx
//*
//*****************************************************************************
BOOL CHtmlCtrl::CreateEx(DWORD dwExStyle,LPCTSTR pWindowName,DWORD dwStyle, const RECT &sRect,CWnd* pParentWnd,UINT nID)
{
RECT		sClient;
LPUNKNOWN	pUnk;
HRESULT		lRet;


	if(!CWnd::CreateEx(dwExStyle,_T("STATIC"),pWindowName,dwStyle|SS_WHITEFRAME,sRect,pParentWnd,nID,0))
		{
		return FALSE;
		}

	AfxEnableControlContainer();
	GetClientRect(&sClient);

	if(!m_cWndBrowser.CreateControl(CLSID_WebBrowser,pWindowName,WS_VISIBLE|WS_CHILD|SS_BLACKFRAME,sClient,this,AFX_IDW_PANE_FIRST))
		{
		DestroyWindow();
		return FALSE;
		}

	pUnk = m_cWndBrowser.GetControlUnknown();
	lRet = pUnk->QueryInterface(IID_IWebBrowser2,(void**)&m_pBrowserApp);

	if(!SUCCEEDED(lRet))
		{
		m_pBrowserApp = NULL;
		m_cWndBrowser.DestroyWindow();
		DestroyWindow();
		return FALSE;
		}

	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,NULL);


return TRUE;
}


//*****************************************************************************
//*
//*		GetType
//*
//*****************************************************************************
CString CHtmlCtrl::GetType() const
{
BSTR bStr;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Type(&bStr);



return CString(bStr);
}


//*****************************************************************************
//*
//*		GetLeft
//*
//*****************************************************************************
long CHtmlCtrl::GetLeft() const
{
long	lResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Left(&lResult);

return lResult;
}



//*****************************************************************************
//*
//*		GetTop
//*
//*****************************************************************************
long CHtmlCtrl::GetTop() const
{
long lResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Top(&lResult);


return lResult;
}


//*****************************************************************************
//*
//*		GetToolBar
//*
//*****************************************************************************
int CHtmlCtrl::GetToolBar() const
{
int  iResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_ToolBar(&iResult);

return iResult;
}


//*****************************************************************************
//*
//*		GetHeight
//*
//*****************************************************************************
long CHtmlCtrl::GetHeight() const
{
long lResult;

	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Height(&lResult);

return lResult;
}


//*****************************************************************************
//*
//*		GetVisible
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetVisible() const
{
VARIANT_BOOL bResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Visible(&bResult);


return bResult;
}


//*****************************************************************************
//*
//*		GetLocationName
//*
//*****************************************************************************
CString CHtmlCtrl::GetLocationName() const
{
BSTR	bStr;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_LocationName(&bStr);


return CString(bStr);
}


//*****************************************************************************
//*
//*		GetLocationURL
//*
//*****************************************************************************
CString CHtmlCtrl::GetLocationURL() const
{
BSTR	bStr;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_LocationURL(&bStr);


return CString(bStr);;
}


//*****************************************************************************
//*
//*		GetBusy
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetBusy() const
{
VARIANT_BOOL bResult;

	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Busy(&bResult);

return bResult;
}


//*****************************************************************************
//*
//*		GetReadyState
//*
//*****************************************************************************
READYSTATE CHtmlCtrl::GetReadyState() const
{
READYSTATE	iResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_ReadyState(&iResult);


return iResult;
}


//*****************************************************************************
//*
//*		GetOffline
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetOffline() const
{
VARIANT_BOOL bResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Offline(&bResult);

return bResult;
}


//*****************************************************************************
//*
//*		GetOffline
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetSilent() const
{
VARIANT_BOOL bResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Silent(&bResult);


return bResult;
}


//*****************************************************************************
//*
//*		GetApplication
//*
//*****************************************************************************
LPDISPATCH CHtmlCtrl::GetApplication() const
{
LPDISPATCH pDispatch;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Application(&pDispatch);


return pDispatch;
}



//*****************************************************************************
//*
//*		GetParentBrowser
//*
//*****************************************************************************
LPDISPATCH CHtmlCtrl::GetParentBrowser() const
{
LPDISPATCH		pDispatch;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Parent(&pDispatch);


return pDispatch;
}


//*****************************************************************************
//*
//*		GetContainer
//*
//*****************************************************************************
LPDISPATCH CHtmlCtrl::GetContainer() const
{
LPDISPATCH pDispatch;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Container(&pDispatch);


return pDispatch;
}


//*****************************************************************************
//*
//*		GetHtmlDocument
//*
//*****************************************************************************
LPDISPATCH CHtmlCtrl::GetHtmlDocument() const
{
LPDISPATCH pDispatch;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_Document(&pDispatch);

return pDispatch;
}


//*****************************************************************************
//*
//*		GetTopLevelContainer
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetTopLevelContainer() const
{
VARIANT_BOOL bResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_TopLevelContainer(&bResult);


return bResult;
}


//*****************************************************************************
//*
//*		GetMenuBar
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetMenuBar() const
{
VARIANT_BOOL bResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_MenuBar(&bResult);


return bResult;
}


//*****************************************************************************
//*
//*		GetFullScreen
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetFullScreen() const
{
VARIANT_BOOL	bResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_FullScreen(&bResult);


return bResult;
}


//*****************************************************************************
//*
//*		GetStatusBar
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetStatusBar() const
{
VARIANT_BOOL	bResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_StatusBar(&bResult);


return bResult;
}


//*****************************************************************************
//*
//*		QueryStatusWB
//*
//*****************************************************************************
OLECMDF CHtmlCtrl::QueryStatusWB(OLECMDID iCmdId) const
{
OLECMDF	lResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->QueryStatusWB(iCmdId, &lResult);


return lResult;
}


//*****************************************************************************
//*
//*		ExecWB
//*
//*****************************************************************************
LRESULT CHtmlCtrl::ExecWB(OLECMDID iCmdId,OLECMDEXECOPT iCmdExecOpt,VARIANT *pIn,VARIANT *pOut)
{
LRESULT		lRet;

	ASSERT(m_pBrowserApp != NULL);
	lRet = m_pBrowserApp->ExecWB(iCmdId,iCmdExecOpt,pIn,pOut);

return lRet;
}


//*****************************************************************************
//*
//*		GetRegisterAsBrowser
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetRegisterAsBrowser() const
{
VARIANT_BOOL bResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_RegisterAsBrowser(&bResult);


return bResult;
}


//*****************************************************************************
//*
//*		GetRegisterAsDropTarget
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetRegisterAsDropTarget() const
{
VARIANT_BOOL bResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_RegisterAsDropTarget(&bResult);


return bResult;
}


//*****************************************************************************
//*
//*		GetTheaterMode
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetTheaterMode() const
{
VARIANT_BOOL bResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_TheaterMode(&bResult);

return bResult;
}


//*****************************************************************************
//*
//*		GetAddressBar
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetAddressBar() const
{
VARIANT_BOOL bResult;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_AddressBar(&bResult);


return bResult;
}



//*****************************************************************************
//*
//*		LoadFromResource
//*
//*****************************************************************************
//	Ld eine Web-Seite aus den Resurecen der eigenen EXE-Datei.
//	z.B.:
//				MyPage.html   RT_HTML   "Res\MyPage.html"	(in *.rc2)
//				res://MyExe.exe/MyPage.html					(URL)
//				"MyPage.html"								(pResource)
//
//				MyPage.html   HTML   "Res\MyPage.html"		(in *.rc2)
//				res://MyExe.exe/MyPage.html					(URL)
//				"Html/MyPage.html"							(pResource)

BOOL CHtmlCtrl::LoadFromResource(LPCTSTR pResource)
{
BOOL		bRetVal;
LPTSTR		pModule;
HINSTANCE	hInstance;
CString		sResourceUrl;


	hInstance = AfxGetResourceHandle();

	ASSERT(hInstance != NULL);

	pModule   = new TCHAR[_MAX_PATH];
	bRetVal   = TRUE;

	if(GetModuleFileName(hInstance, pModule, _MAX_PATH))
		{
		sResourceUrl.Format(_T("res://%s/%s"), pModule, pResource);
		Navigate(sResourceUrl, 0, 0, 0);
		}
	else{
		bRetVal = FALSE;
		}

	delete pModule;


return bRetVal;
}


//*****************************************************************************
//*
//*		LoadFromResource
//*
//*****************************************************************************
BOOL CHtmlCtrl::LoadFromResource(UINT nRes)
{
CString		sResourceUrl;
HINSTANCE	hInstance;
LPTSTR		pModule;
BOOL		bRetVal;





	hInstance = AfxGetResourceHandle();
	pModule   = new TCHAR[_MAX_PATH];
	bRetVal   = TRUE;

	ASSERT(hInstance!=NULL);

	if(GetModuleFileName(hInstance, pModule, _MAX_PATH))
		{
		sResourceUrl.Format(_T("res://%s/%d"), pModule, nRes);
		Navigate(sResourceUrl, 0, 0, 0);
		}
	else{
		bRetVal = FALSE;
		}


	delete pModule;



return bRetVal;
}


//*****************************************************************************
//*
//*		Navigate
//*
//*****************************************************************************
void CHtmlCtrl::Navigate(LPCTSTR pUrl, DWORD dwFlags,LPCTSTR pTargetFrame,LPCTSTR pHeaders,LPVOID pPostData,DWORD dwPostDataLen)
{
COleSafeArray	vPostData;
CString			sStrUrl(pUrl);
BSTR			bStrUrl;



	bStrUrl = sStrUrl.AllocSysString();

	if(pPostData != NULL)
		{
		if(dwPostDataLen == 0)
			{
			dwPostDataLen = lstrlen((LPCTSTR) pPostData);
			}

		vPostData.CreateOneDim(VT_UI1, dwPostDataLen, pPostData);
		}

	m_pBrowserApp->Navigate(bStrUrl,COleVariant((long)dwFlags,VT_I4),COleVariant(pTargetFrame,VT_BSTR),vPostData,COleVariant(pHeaders,VT_BSTR));

}


//*****************************************************************************
//*
//*		Navigate2
//*
//*****************************************************************************
void CHtmlCtrl::Navigate2(LPITEMIDLIST pIdl,DWORD dwFlags,LPCTSTR pTargetFrame)
{
	ASSERT(m_pBrowserApp != NULL);

	COleVariant vPIDL(pIdl);
	COleVariant vEmpty;

	m_pBrowserApp->Navigate2(vPIDL,COleVariant((long) dwFlags, VT_I4),COleVariant(pTargetFrame, VT_BSTR),vEmpty, vEmpty);
}


//*****************************************************************************
//*
//*		Navigate2
//*
//*****************************************************************************
void CHtmlCtrl::Navigate2(LPCTSTR pUrl,DWORD dwFlags,LPCTSTR pTargetFrame,LPCTSTR pHeaders,LPVOID pPostData,DWORD dwPostDataLen)
{
COleSafeArray vPostData;


	ASSERT(m_pBrowserApp != NULL);

	if(pPostData != NULL)
		{
		if(dwPostDataLen == 0)
			{
			dwPostDataLen = lstrlen((LPCTSTR) pPostData);
			}

		vPostData.CreateOneDim(VT_UI1, dwPostDataLen, pPostData);
		}

	COleVariant vURL(pUrl,VT_BSTR);
	COleVariant vHeaders(pHeaders,VT_BSTR);
	COleVariant vTargetFrameName(pTargetFrame,VT_BSTR);
	COleVariant vFlags((long)dwFlags,VT_I4);

	m_pBrowserApp->Navigate2(vURL,vFlags,vTargetFrameName,vPostData,vHeaders);
}


//*****************************************************************************
//*
//*		Navigate2
//*
//*****************************************************************************
void CHtmlCtrl::Navigate2(LPCTSTR pUrl,DWORD dwFlags,CByteArray &bPostData,LPCTSTR pTargetFrame,LPCTSTR pHeaders)
{
	ASSERT(m_pBrowserApp != NULL);

	COleVariant vPostData = bPostData;
	COleVariant vURL(pUrl, VT_BSTR);
	COleVariant vHeaders(pHeaders, VT_BSTR);
	COleVariant vTargetFrameName(pTargetFrame, VT_BSTR);
	COleVariant vFlags((long) dwFlags, VT_I4);

	ASSERT(m_pBrowserApp != NULL);

	m_pBrowserApp->Navigate2(vURL, vFlags, vTargetFrameName,vPostData, vHeaders);
}


//*****************************************************************************
//*
//*		PutProperty
//*
//*****************************************************************************
void CHtmlCtrl::PutProperty(LPCTSTR pProperty, const VARIANT& vtValue)
{
BSTR bStrProp;

	ASSERT(m_pBrowserApp != NULL);

	CString sStrProp(pProperty);

	bStrProp = sStrProp.AllocSysString();
	m_pBrowserApp->PutProperty(bStrProp, vtValue);
	::SysFreeString(bStrProp);
}


//*****************************************************************************
//*
//*		GetProperty
//*
//*****************************************************************************
BOOL CHtmlCtrl::GetProperty(LPCTSTR pProperty, CString& strValue)
{
HRESULT lRet;
VARIANT vReturn;
BSTR	bStrProperty;
BOOL	bResult;


	ASSERT(m_pBrowserApp != NULL);

	CString sStrProperty(pProperty);

	bResult			= FALSE;
	vReturn.vt		= VT_BSTR;
	vReturn.bstrVal = NULL;
	bStrProperty	= sStrProperty.AllocSysString();
	lRet			= m_pBrowserApp->GetProperty(bStrProperty,&vReturn);

	if(SUCCEEDED(lRet))
		{
		strValue	= CString(vReturn.bstrVal);
		bResult 	= TRUE;
		}

	::SysFreeString(bStrProperty);


return bResult;
}


//*****************************************************************************
//*
//*		GetProperty
//*
//*****************************************************************************
COleVariant CHtmlCtrl::GetProperty(LPCTSTR pProperty)
{
COleVariant		lResult;
static BYTE		bParms[] = VTS_BSTR;


	m_cWndBrowser.InvokeHelper(0x012F, DISPATCH_METHOD,VT_VARIANT,(void*)&lResult, bParms, pProperty);


return lResult;
}


//*****************************************************************************
//*
//*		GetFullName
//*
//*****************************************************************************
CString CHtmlCtrl::GetFullName() const
{
BSTR bStr;


	ASSERT(m_pBrowserApp != NULL);
	m_pBrowserApp->get_FullName(&bStr);


return CString(bStr);
}


//*****************************************************************************
//*
//*		NavigateComplete2
//*
//*****************************************************************************
void CHtmlCtrl::NavigateComplete2(LPDISPATCH /* pDisp */, VARIANT* URL)
{

	ASSERT(V_VT(URL) == VT_BSTR);
	USES_CONVERSION;

	CString sStr = OLE2T(V_BSTR(URL));
	OnNavigateComplete2(sStr);
}


//*****************************************************************************
//*
//*		BeforeNavigate2
//*
//*****************************************************************************
void CHtmlCtrl::BeforeNavigate2(LPDISPATCH/* pDisp */, VARIANT *pUrl,VARIANT *pFlags,VARIANT *pTargetFrame,VARIANT* pPostData, VARIANT* pHeaders, BOOL* pCancel)
{
VARIANT		   *pPostedData;
CByteArray		sArray;
DWORD			nFlags;
DWORD			dwSize;
LPBYTE			pByte;
LPVOID			pVoid;


	ASSERT(V_VT(pUrl        ) ==  VT_BSTR);
	ASSERT(V_VT(pTargetFrame) ==  VT_BSTR);
	ASSERT(V_VT(pPostData   ) == (VT_VARIANT | VT_BYREF));
	ASSERT(V_VT(pHeaders    ) ==  VT_BSTR);
	ASSERT(pCancel != NULL);

	USES_CONVERSION;

	pPostedData = V_VARIANTREF(pPostData);


	if(V_VT(pPostedData) & VT_ARRAY)
		{
		// must be a vector of bytes
		ASSERT(pPostedData->parray->cDims == 1 && pPostedData->parray->cbElements == 1);

		pPostedData->vt |= VT_UI1;

		COleSafeArray sSave(pPostedData);

		dwSize = sSave.GetOneDimSize();
		sSave .AccessData(&pVoid);
		sArray.SetSize(dwSize);
		pByte  = sArray.GetData();

		memcpy(pByte, pVoid, dwSize);
		sSave.UnaccessData();
		}

	// make real parameters out of the notification

	CString sTargetFrameName(V_BSTR(pTargetFrame));
	CString sHeaders = V_BSTR(pHeaders);
	CString sStrUrl  = V_BSTR(pUrl);

	nFlags = V_I4(pFlags);

	// notify the user's class
	OnBeforeNavigate2(sStrUrl, nFlags, sTargetFrameName,sArray, sHeaders, pCancel);
}


//*****************************************************************************
//*
//*		DocumentComplete
//*
//*****************************************************************************
void CHtmlCtrl::DocumentComplete(LPDISPATCH pDisp, VARIANT* pUrl)
{
	UNUSED_ALWAYS(pDisp);
	ASSERT(V_VT(pUrl) == VT_BSTR);

	CString sStr(V_BSTR(pUrl));
	OnDocumentComplete(sStr);
}



//*****************************************************************************
//*
//*		OnProgressChange
//*
//*****************************************************************************
void CHtmlCtrl::OnProgressChange(long lProgress, long lProgressMax)
{
	// user will override to handle this notification
	UNUSED_ALWAYS(lProgress);
	UNUSED_ALWAYS(lProgressMax);
}


//*****************************************************************************
//*
//*		OnCommandStateChange
//*
//*****************************************************************************
void CHtmlCtrl::OnCommandStateChange(long lCommand, BOOL bEnable)
{
	// user will override to handle this notification
	UNUSED_ALWAYS(lCommand);
	UNUSED_ALWAYS(bEnable);
}


//*****************************************************************************
//*
//*		OnDownloadBegin
//*
//*****************************************************************************
void CHtmlCtrl::OnDownloadBegin()
{
	// user will override to handle this notification
}


//*****************************************************************************
//*
//*		OnDownloadComplete
//*
//*****************************************************************************
void CHtmlCtrl::OnDownloadComplete()
{
	// user will override to handle this notification
}


//*****************************************************************************
//*
//*		OnTitleChange
//*
//*****************************************************************************
void CHtmlCtrl::OnTitleChange(LPCTSTR pText)
{
	// user will override to handle this notification
	UNUSED_ALWAYS(pText);
}


//*****************************************************************************
//*
//*		OnPropertyChange
//*
//*****************************************************************************
void CHtmlCtrl::OnPropertyChange(LPCTSTR pProperty)
{
	// user will override to handle this notification
	UNUSED_ALWAYS(pProperty);
}


//*****************************************************************************
//*
//*		OnNewWindow2
//*
//*****************************************************************************
void CHtmlCtrl::OnNewWindow2(LPDISPATCH *ppDisp,BOOL *bCancel)
{
	// default to continuing
	bCancel = FALSE;

	// user will override to handle this notification
	UNUSED_ALWAYS(ppDisp);
}


//*****************************************************************************
//*
//*		OnDocumentComplete
//*
//*****************************************************************************
void CHtmlCtrl::OnDocumentComplete(LPCTSTR pUrl)
{
	// user will override to handle this notification
	UNUSED_ALWAYS(pUrl);
}


//*****************************************************************************
//*
//*		OnQuit
//*
//*****************************************************************************
void CHtmlCtrl::OnQuit()
{
	// user will override to handle this notification
}


//*****************************************************************************
//*
//*		OnVisible
//*
//*****************************************************************************
void CHtmlCtrl::OnVisible(BOOL bVisible)
{
	// user will override to handle this notification
	UNUSED_ALWAYS(bVisible);
}


//*****************************************************************************
//*
//*		OnToolBar
//*
//*****************************************************************************
void CHtmlCtrl::OnToolBar(BOOL bToolBar)
{
	// user will override to handle this notification
	UNUSED_ALWAYS(bToolBar);
}


//*****************************************************************************
//*
//*		OnMenuBar
//*
//*****************************************************************************
void CHtmlCtrl::OnMenuBar(BOOL bMenuBar)
{
	// user will override to handle this notification
	UNUSED_ALWAYS(bMenuBar);
}


//*****************************************************************************
//*
//*		OnStatusBar
//*
//*****************************************************************************
void CHtmlCtrl::OnStatusBar(BOOL bStatusBar)
{
	// user will override to handle this notification
	UNUSED_ALWAYS(bStatusBar);
}


//*****************************************************************************
//*
//*		OnFullScreen
//*
//*****************************************************************************
void CHtmlCtrl::OnFullScreen(BOOL bFullScreen)
{
	// user will override to handle this notification
	UNUSED_ALWAYS(bFullScreen);
}


//*****************************************************************************
//*
//*		OnTheaterMode
//*
//*****************************************************************************
void CHtmlCtrl::OnTheaterMode(BOOL bTheaterMode)
{
	// user will override to handle this notification
	UNUSED_ALWAYS(bTheaterMode);
}


//*****************************************************************************
//*
//*		OnNavigateComplete2
//*
//*****************************************************************************
void CHtmlCtrl::OnNavigateComplete2(LPCTSTR pUrl)
{
CWnd	*pWnd;
	// user will override to handle this notification


	   pWnd = GetParent();
	if(pWnd)pWnd->PostMessage(WM_COMMAND,ID_HTML_DONE);

	UNUSED_ALWAYS(pUrl);
}


//*****************************************************************************
//*
//*		OnBeforeNavigate2
//*
//*****************************************************************************
void CHtmlCtrl::OnBeforeNavigate2(LPCTSTR pUrl,DWORD nFlags,LPCTSTR pTargetFrame,CByteArray &bPostData,LPCTSTR pHeaders,BOOL* bCancel)
{
	// default to continuing
	bCancel = FALSE;

	// user will override to handle this notification
	UNUSED_ALWAYS(pUrl);
	UNUSED_ALWAYS(nFlags);
	UNUSED_ALWAYS(pTargetFrame);
	UNUSED_ALWAYS(bPostData);
	UNUSED_ALWAYS(pHeaders);
}


//*****************************************************************************
//*
//*		OnStatusTextChange
//*
//*****************************************************************************
void CHtmlCtrl::OnStatusTextChange(LPCTSTR pszText)
{
CFrameWnd	*pFrame;

	// try to set the status bar text via the frame

	   pFrame = GetParentFrame();
	if(pFrame != NULL)
		{
		pFrame->SetMessageText(pszText);
		}
}



//*****************************************************************************
//*
//*		CbtProc
//*
//*****************************************************************************
//	Hook Funktion fr die SaveAs Funktion
LRESULT CALLBACK CHtmlCtrl::CbtProc(int nCode,WPARAM wParam,LPARAM lParam)
{
HWND			hWnd;
LPCBT_CREATEWND pCbt;
LPCREATESTRUCT	pCs;

    switch (nCode)
	    {

	case HCBT_CREATEWND:

			hWnd = (HWND)wParam;
            pCbt = (LPCBT_CREATEWND)lParam;
            pCs  = pCbt->lpcs;

            if((DWORD)pCs->lpszClass == 0x00008002)
				{
				if(!m_hHookWnd)
					{
					m_hHookWnd = hWnd;
					m_pOldProc = (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
										  SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)FileProc);

					pCs->x = -2 * pCs->cx;  // Move dialog off screen
					break;
					}

				if(m_hHookWnd && pCs->hwndParent==m_hHookWnd && m_iRetDone)
					{
					if(!m_iOverWrite)
						{
						m_hHookWnd = hWnd;
						m_pOldProc = (WNDPROC)GetWindowLongPtr(hWnd,GWL_WNDPROC);
											  SetWindowLongPtr(hWnd,GWL_WNDPROC,(LPARAM)FileProc);

						pCs->x = -2 * pCs->cx;  // Move dialog off screen
						}
					else{
						pCs->x = (GetSystemMetrics(SM_CXSCREEN)-pCs->cx)/2;
						pCs->y = (GetSystemMetrics(SM_CYSCREEN)-pCs->cy)/2;
						}

					break;
					}
				}

            break;

        }


return CallNextHookEx(m_hHook, nCode, wParam, lParam);
}


//*****************************************************************************
//*
//*		FileProc
//*
//*****************************************************************************
//	Callback Funktion fr die SaveAs Funktion
LRESULT CALLBACK CHtmlCtrl::FileProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
HWND	hItem;
LRESULT	lRet;



	if(uMsg==WM_INITDIALOG)
		{
		lRet  = CallWindowProc(m_pOldProc,hWnd,uMsg,wParam,lParam);

		if(!m_iRetDone)
			{
			hItem = ::GetDlgItem(hWnd,0x047C);

			::SendMessage  (hItem,CB_SETCURSEL,-1,0);
			::SetWindowText(hItem,m_sSaveAsFile);

			CallWindowProc(m_pOldProc,hWnd,CBN_EDITCHANGE,0x047C,(LPARAM)hItem);

			hItem = ::GetDlgItem(hWnd,0x0470);

			::SendMessage  (hItem,CB_SETCURSEL,m_iSaveAsMode+1,0);
			::SendMessage  (hItem,WM_COMMAND, MAKEWPARAM(0x0470,CBN_CLOSEUP),(LPARAM)hItem);

			CallWindowProc(m_pOldProc,hWnd,CBN_SELCHANGE,0x0470,(LPARAM)hItem);

			m_iRetDone = 1;

			hItem = ::GetDlgItem(hWnd,IDOK);
			::PostMessage(hWnd,BN_CLICKED,IDOK,(LPARAM)hItem);
			::PostMessage(hWnd,WM_COMMAND,IDOK,0);
			}
		else{
			hItem = ::GetDlgItem(hWnd,IDYES);
			::PostMessage(hWnd,BN_CLICKED,IDYES,(LPARAM)hItem);
			::PostMessage(hWnd,WM_COMMAND,IDYES,0);
			}

		return lRet;
		}



return CallWindowProc(m_pOldProc,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*		SaveAs
//*
//*****************************************************************************
//	Speichert eine Webseite unter einem spezielen Namen ohne Dialog
//	pFilename			: Ist der Name der HTML Datei
//	iSaveType			: Ist die Speicherungsart (0=alles 2=nur Html-Datei 3=Nur-Text)
//	iOverWriteQuesion	: Soll vor einem berschreiben gefragt werden ? (0=Nein 1=Ja)
//	Ergibt 0 wenn alles OK war oder -1 bei Fehlern
LRESULT CHtmlCtrl::SaveAs(LPCTSTR pFilename,int iSaveType,int iOverWriteQuesion)
{


	m_sSaveAsSem.Lock();

	m_sSaveAsFile	= pFilename;
	m_iSaveAsMode	= iSaveType;
	m_iOverWrite	= iOverWriteQuesion;
	m_hHtmlWnd		= m_hWnd;
	m_hHookWnd		= NULL;
	m_iRetDone		= 0;

		m_hHook = SetWindowsHookEx(WH_CBT,CbtProc,NULL,GetCurrentThreadId());
	if(!m_hHook)
		{
		m_sSaveAsSem.Unlock();
		return -1;
		}

	ExecWB(OLECMDID_SAVEAS,OLECMDEXECOPT_DODEFAULT,NULL,NULL);

	UnhookWindowsHookEx(m_hHook);
	m_hHook = NULL;
	m_sSaveAsSem.Unlock();



return 0;
}

//*****************************************************************************
//*
//*		HasFocus
//*
//*****************************************************************************
//	Prft ob das Fenster oder ein unter Fenster den Fokus hat.
//	Ergibt TRUE wenn ja, ansonsten FALSE.
BOOL CHtmlCtrl::HasFocus()
{
CWnd   *pWnd;


	pWnd = GetFocus();

	while(pWnd)
		{
		if(pWnd->m_hWnd==m_hWnd)return TRUE;
		pWnd = pWnd->GetParent();
		}

return FALSE;
}

//*****************************************************************************
//*
//*		Find
//*
//*****************************************************************************
//	Sucht einen Text in der aktuellen Web-Siete
void CHtmlCtrl::Find()
{
GUID				sIidWebBrowser={0xED016940,0xBD5B,0x11CF,0xBA,0x4E,0x00,0xC0,0x4F,0xD7,0x08,0x16};
LPOLECOMMANDTARGET  pTarget;
LPDISPATCH		    pDisp;



	if(m_pBrowserApp!=NULL)
		{
		pTarget = NULL;
		pDisp	= GetHtmlDocument();

		if(pDisp!=NULL)
			{
			if(SUCCEEDED(pDisp->QueryInterface(IID_IOleCommandTarget,(LPVOID*)&pTarget)))
				{
				pTarget->Exec(&sIidWebBrowser,HTMLID_FIND,0,NULL,NULL);
				pTarget->Release();
				}

			pDisp->Release();
			}
		}

}


//*****************************************************************************
//*
//*		SetZoom
//*
//*****************************************************************************
void CHtmlCtrl::SetZoom(int iZoom)
{
VARIANT		vValue;


	if(m_pBrowserApp==NULL)return;
	

	vValue.vt	= VT_I4;
	vValue.lVal	= iZoom;


	ExecWB(OLECMDID_OPTICAL_ZOOM,OLECMDEXECOPT_DONTPROMPTUSER,&vValue,NULL);

}


//*****************************************************************************
//*
//*		GetZoom
//*
//*****************************************************************************
int CHtmlCtrl::GetZoom()
{
VARIANT		vValue;


	if(m_pBrowserApp==NULL)return 

		
	vValue.vt		= VT_I4;
	vValue.lVal		= 0;

	ExecWB(OLECMDID_OPTICAL_ZOOM,OLECMDEXECOPT_DONTPROMPTUSER,NULL,&vValue);
	


return (vValue.vt==VT_I4 && vValue.lVal>0)? vValue.lVal:100;
}

//*****************************************************************************
//*
//*		GetZoomRange
//*
//*****************************************************************************
void CHtmlCtrl::GetZoomRange(int &iMin,int &iMax)
{
VARIANT		vValue;


	if(m_pBrowserApp==NULL)return; 

		
	vValue.vt		= VT_I4;
	vValue.lVal		= 0;

	ExecWB(OLECMDID_OPTICAL_GETZOOMRANGE,OLECMDEXECOPT_DONTPROMPTUSER,NULL,&vValue);
	

	if(vValue.vt==VT_I4 && vValue.lVal>0)
		{
		iMin = LOWORD(vValue.lVal);
		iMax = HIWORD(vValue.lVal);
		return;
		}

	iMin = 10;
	iMax = 1000;

}
