//*****************************************************************************
//*
//*
//*		Dummys.cpp	
//*
//*
//*****************************************************************************
//
//	Dummys fr besseres Debugging
//	


#ifdef	_MSC_VER
#ifndef	_WIN64

#pragma warning( disable : 4035 )

//*****************************************************************************
//*
//*		strlen_dummy
//*
//*****************************************************************************
unsigned  __cdecl strlen_dummy( const char *string )
{
_asm	{

        mov     ecx,string              ;//  ecx -> string
        test    ecx,3                   ;//  test if string is aligned on 32 bits
        je      short main_loop

str_misaligned:
										;//  simple byte loop until string is aligned
        mov     al,byte ptr [ecx]
        inc     ecx
        test    al,al
        je      short byte_3
        test    ecx,3
        jne     short str_misaligned

        add     eax,dword ptr 0         ;//  5 byte nop to align label below

        align   16                      ;//  should be redundant

main_loop:
        mov     eax,dword ptr [ecx]     ;//  read 4 bytes
        mov     edx,7efefeffh
        add     edx,eax
        xor     eax,-1
        xor     eax,edx
        add     ecx,4
        test    eax,81010100h
        je      short main_loop
        ; found zero byte in the loop
        mov     eax,[ecx - 4]
        test    al,al                   ;//  is it byte 0
        je      short byte_0
        test    ah,ah                   ;//  is it byte 1
        je      short byte_1
        test    eax,00ff0000h           ;//  is it byte 2
        je      short byte_2
        test    eax,0ff000000h          ;//  is it byte 3
        je      short byte_3
        jmp     short main_loop         ;//  taken if bits 24-30 are clear and bit
                                        ;//  31 is set

byte_3:
        lea     eax,[ecx - 1]
        mov     ecx,string
        sub     eax,ecx
        jmp		ende
byte_2:
        lea     eax,[ecx - 2]
        mov     ecx,string
        sub     eax,ecx
        jmp		ende
byte_1:
        lea     eax,[ecx - 3]
        mov     ecx,string
        sub     eax,ecx
        jmp		ende
byte_0:
        lea     eax,[ecx - 4]
        mov     ecx,string
        sub     eax,ecx
ende:
	}

}


//*****************************************************************************
//*
//*		strcmp_dummy
//*
//*****************************************************************************
int __cdecl strcmp_dummy( const char *src , const char *dst)
{
_asm	{
        mov     edx, src
        mov     ecx, dst

        test    edx,3
        jnz     short dopartial

        align   4
dodwords:
        mov     eax,[edx]

        cmp     al,[ecx]
        jne     short donene
        or      al,al
        jz      short doneeq
        cmp     ah,[ecx + 1]
        jne     short donene
        or      ah,ah
        jz      short doneeq

        shr     eax,16

        cmp     al,[ecx + 2]
        jne     short donene
        or      al,al
        jz      short doneeq
        cmp     ah,[ecx + 3]
        jne     short donene
        add     ecx,4
        add     edx,4
        or      ah,ah
        jnz     short dodwords

        align   4
doneeq:
        xor     eax,eax
        jmp		ende

        align   4
donene:
        ;// The instructions below should place -1 in eax if src < dst,
        ;// and 1 in eax if src > dst.

        sbb     eax,eax
        sal     eax,1
        inc     eax
        jmp		ende

        align   4
dopartial:
        test    edx,1
        jz      short doword

        mov     al,[edx]
        inc     edx
        cmp     al,[ecx]
        jne     short donene
        inc     ecx
        or      al,al
        jz      short doneeq

        test    edx,2
        jz      short dodwords


        align   4
doword:
        mov     ax,[edx]
        add     edx,2
        cmp     al,[ecx]
        jne     short donene
        or      al,al
        jz      short doneeq
        cmp     ah,[ecx + 1]
        jne     short donene
        or      ah,ah
        jz      short doneeq
        add     ecx,2
        jmp     short dodwords

ende:
		}

}

//*****************************************************************************
//*
//*		stricmp_dummy
//*
//*****************************************************************************
int __cdecl stricmp_dummy( const char *src , const char *dst)
{
_asm	{        
        mov     esi, src
        mov     edi, dst

        mov     al,-1           ;//  fall into loop

chk_null:
        or      al,ah
        jz      short done

        mov     al,[esi]        ;//  al = next source byte
        inc     esi
        mov     ah,[edi]        ;//  ah = next dest byte
        inc     edi

        cmp     ah,al           ;//  src try case-sensitive comparision
        je      short chk_null  ;//  match

        sub     al,'A'
        cmp     al,'Z'-'A'+1
        sbb     cl,cl
        and     cl,'a'-'A'
        add     al,cl
        add     al,'A'          ;//  tolower(*dst)

        xchg    ah,al           ;//  operations on AL are shorter than AH

        sub     al,'A'
        cmp     al,'Z'-'A'+1
        sbb     cl,cl
        and     cl,'a'-'A'
        add     al,cl
        add     al,'A'          ;//  tolower(*src)

        cmp     al,ah           ;//  inverse of above comparison -- AL & AH are swapped
        je      short chk_null
		mov		al, 1
		jb		done
		mov		al,-1
done:	movsx   eax,al          ;//  extend al to eax
		}
}

//*****************************************************************************
//*
//*		strncmp_dummy
//*
//*****************************************************************************
int __cdecl strncmp_dummy( const char *src , const char *dst,unsigned count)
{

_asm	{

        mov     ecx,[count]     ;// cx=max number of bytes to compare
        jecxz   short toend     ;// it's as if strings are equal

        mov     ebx,ecx         ;// bx saves count

        mov     edi,[src]       ;// di=src pointer (es=segment part)

        mov     esi,edi         ;// si saves src pointer
        xor     eax,eax         ;// ax=0
repne   scasb                   ;// count bytes
        neg     ecx             ;// cx=count - strlen
        add     ecx,ebx         ;// strlen + count - strlen

;okay:
        mov     edi,esi         ;// restore src pointer
        mov     esi,[dst]       ;// si = dst pointer
repe    cmpsb                   ;// compare strings
        mov     al,[esi-1]
        xor     ecx,ecx         ;// set return value = 0

        cmp     al,[edi-1]      ;// dst-src
        ja      short lastbig   ;// <dst is bigger>
        je      short toend     ;// <equal>
        ;jb     short firstbig  ;// <src is bigger>

;firstbig:
        dec     ecx             ;// src string is bigger
        dec     ecx             ;// make FFFE so 'not' will give 0001

lastbig:                        ;// dst string is bigger
        not     ecx             ;// return -1

toend:
        mov     eax,ecx         ;// return value

		}
}

//*****************************************************************************
//*
//*		strnicmp_dummy
//*
//*****************************************************************************
int __cdecl strnicmp_dummy( const char *src , const char *dst,unsigned count)
{
_asm	{
        mov     ecx,[count]     ;// cx = byte count
        or      ecx,ecx
        jz      toend           ;// if count = 0, we are done

        mov     esi,[src]       ;// si = src string
        mov     edi,[dst]       ;// di = dst string

        mov     bh,'A'
        mov     bl,'Z'
        mov     dh,'a'-'A'      ;// add to cap to make lower

        align   4

lupe:
        mov     ah,[esi]        ;// *src
        or      ah,ah           ;// see if *src is null
        mov     al,[edi]        ;// *dst
        jz      short eject     ;//   jump if *src is null

        or      al,al           ;// see if *dst is null
        jz      short eject     ;//   jump if so
        inc     esi             ;// src++
        inc     edi             ;// dst++

        cmp     ah,bh           ;// 'A'
        jb      short skip1
        cmp     ah,bl           ;// 'Z'
        ja      short skip1
        add     ah,dh           ;// make lower case

skip1:
        cmp     al,bh           ;// 'A'
        jb      short skip2

        cmp     al,bl           ;// 'Z'
        ja      short skip2

        add     al,dh           ;// make lower case

skip2:
        cmp     ah,al           ;// *src == *dst ??
        jne     short differ

        dec     ecx
        jnz     short lupe

eject:
        xor     ecx,ecx
        cmp     ah,al           ;// compare the (possibly) differing bytes
        je      toend           ;// both zero; return 0

differ:
        mov     ecx,-1          ;// assume dst is bigger (* can't use 'or' *)
        jb      toend           ;// dst is, in fact, bigger (return -1)
        neg     ecx             ;// src is bigger (return 1)

        jmp     toend

toend:
        mov     eax,ecx
		}
}
//*****************************************************************************
//*
//*		strcpy_dummy
//*
//*****************************************************************************
char * __cdecl strcpy_dummy( char *dest, const char *source )
{

_asm	{
        push    edi                 ;// preserve edi
        mov     edi,dest            ;// edi points to dest string

        mov     ecx,source          ;// ecx -> sorc string
        test    ecx,3               ;// test if string is aligned on 32 bits
        je      short main_loop_entrance

src_misaligned:                     ;// simple byte loop until string is aligned
        mov     dl,byte ptr [ecx]
        inc     ecx
        test    dl,dl
        je      short byte_0
        mov     [edi],dl
        inc     edi
        test    ecx,3
        jne     short src_misaligned
        jmp     short main_loop_entrance

main_loop:                          ;// edx contains src dword of sorc string
        mov     [edi],edx           ;// store one more dword
        add     edi,4               ;// kick dest pointer
main_loop_entrance:
        mov     edx,7efefeffh
        mov     eax,dword ptr [ecx] ;// read 4 bytes

        add     edx,eax
        xor     eax,-1

        xor     eax,edx
        mov     edx,[ecx]           ;// it's in cache now

        add     ecx,4               ;// kick dest pointer
        test    eax,81010100h

        je      short main_loop
        ; found zero byte in the loop
; main_loop_end:
        test    dl,dl               ;// is it byte 0
        je      short byte_0
        test    dh,dh               ;// is it byte 1
        je      short byte_1
        test    edx,00ff0000h       ;// is it byte 2
        je      short byte_2
        test    edx,0ff000000h      ;// is it byte 3
        je      short byte_3
        jmp     short main_loop     ;// taken if bits 24-30 are clear and bit
                                    ;// 31 is set
byte_3:
        mov     [edi],edx
		pop     edi
        mov     eax,dest	        ;// return in eax pointer to dest string
        jmp		ende
byte_2:
        mov     [edi],dx
        mov     byte ptr [edi+2],0
        pop     edi
        mov     eax,dest	        ;// return in eax pointer to dest string
        jmp		ende
byte_1:
        mov     [edi],dx
        pop     edi
        mov     eax,dest	        ;// return in eax pointer to dest string
        jmp		ende
byte_0:
        mov     [edi],dl
        pop     edi
		mov     eax,dest	        ;// return in eax pointer to dest string

ende:
		}

}

//*****************************************************************************
//*
//*		strncpy_dummy
//*
//*****************************************************************************
char * __cdecl  strncpy_dummy( char *dest, const char *source, unsigned count )
{

_asm	{
        mov     ecx,count		    ;//  ecx = count
        push    edi                 ;//  preserve edi
        test    ecx,ecx
        jz      short finish        ;//  leave if count is zero

        push    esi                 ;//  preserve edi
        push    ebx                 ;//  preserve ebx
        mov     ebx,ecx             ;//  store count for tail loop
        mov     esi,source			;//  esi -> source string
        test    esi,3               ;//  test if source string is aligned on 32 bits
        mov     edi,dest	        ;//  edi -> dest string
        jnz     short src_misaligned;//  (almost always source is aligned)

        shr     ecx,2               ;//  convert ecx to dword count
        jnz     short main_loop_entrance
        jmp     short copy_tail_loop;//  0 < count < 4

									;//  simple byte loop until string is aligned

src_misaligned:
        mov     al,byte ptr [esi]   ;//  copy a byte from source to dest
        inc     esi
        mov     [edi],al
        inc     edi
        dec     ecx
        jz      fill_tail_end1      ;//  if count == 0, leave
        test    al,al               ;//  was dst copied byte zero?
        jz      short align_dest    ;//  if so, go align dest and pad it out
                                    ;//  with zeros
        test    esi,3               ;//  esi already aligned ?
        jne     short src_misaligned
        mov     ebx,ecx             ;//  store count for tail loop
        shr     ecx,2
        jnz     short main_loop_entrance

tail_loop_start:
        and     ebx,3               ;//  ebx = count_before_main_loop%4
        jz      short fill_tail_end1;//  if ebx == 0 then leave without
                                    ;//  appending a null byte

;//  while ( EOS (end-of-string) not found and count > 0 ) copy bytes

copy_tail_loop:
        mov     al,byte ptr [esi]   ;//  load byte from source
        inc     esi
        mov     [edi],al            ;//  store byte to dest
        inc     edi
        test    al,al               ;//  EOS found?
        je      short fill_tail_zero_bytes  ;//  '\0' was already copied
        dec     ebx
        jnz     copy_tail_loop
fill_tail_end1:
        mov     eax,dest			;//  prepare return value
        pop     ebx
        pop     esi
        pop     edi
        jmp		ende

;//  EOS found. Pad with null characters to length count
 
align_dest:
        test    edi,3               ;//  dest string aligned?
        jz      dest_align_loop_end
dest_align_loop:
        mov     [edi],al
        inc     edi
        dec     ecx                 ;//  count == 0?
        jz      fill_tail_end       ;//  if so, finished
        test    edi,3               ;//  is edi aligned ?
        jnz     dest_align_loop
dest_align_loop_end:
        mov     ebx,ecx             ;//  ebx > 0
        shr     ecx,2               ;//  convert ecx to count of dwords
        jnz     fill_dwords_with_EOS
        ; pad tail bytes
finish_loop:                        ;//  0 < ebx < 4
        mov     [edi],al
        inc     edi
fill_tail_zero_bytes:
        dec     ebx
        jnz     finish_loop
        pop     ebx
        pop     esi
finish:
        mov     eax,dest		   ;//  return in eax pointer to dest string
        pop     edi
        jmp		ende

;//  copy (source) string to (dest). Also look for end of (source) string

main_loop:                          ;//  edx contains src dword of source string
        mov     [edi],edx           ;//  store one more dword
        add     edi,4               ;//  kick dest pointer
        dec     ecx
        jz      tail_loop_start

main_loop_entrance:
        mov     edx,7efefeffh
        mov     eax,dword ptr [esi] ;//  read 4 bytes (dword)
        add     edx,eax
        xor     eax,-1
        xor     eax,edx
        mov     edx,[esi]           ;//  it's in cache now
        add     esi,4               ;//  kick dest pointer
        test    eax,81010100h
        je      short main_loop

        ; may have found zero byte in the dword

        test    dl,dl               ;//  is it byte 0
        je      short byte_0
        test    dh,dh               ;//  is it byte 1
        je      short byte_1
        test    edx,00ff0000h       ;//  is it byte 2
        je      short byte_2
        test    edx,0ff000000h      ;//  is it byte 3
        jne     short main_loop     ;//  taken if bits 24-30 are clear and bit
                                    ;//  31 is set

;//  a null character was found, so dest needs to be padded out with null chars
;//  to count length.

        mov     [edi],edx
        jmp     short fill_with_EOS_dwords

byte_2:
        and     edx,0ffffh          ;//  fill high 2 bytes with 0
        mov     [edi],edx
        jmp     short fill_with_EOS_dwords

byte_1:
        and     edx,0ffh            ;//  fill high 3 bytes with 0
        mov     [edi],edx
        jmp     short fill_with_EOS_dwords

byte_0:
        xor     edx,edx             ;//  fill whole dword with 0
        mov     [edi],edx

;//  End of string was found. Pad out dest string with dwords of 0

fill_with_EOS_dwords:               ;//  ecx > 0   (ecx is dword counter)
        add     edi,4
        xor     eax,eax             ;//  it is instead of ???????????????????
        dec     ecx
        jz      fill_tail           ;//  we filled all dwords

fill_dwords_with_EOS:
        xor     eax,eax
fill_with_EOS_loop:
        mov     [edi],eax
        add     edi,4
        dec     ecx
        jnz     short fill_with_EOS_loop
fill_tail:                          ;//  let's pad tail bytes with zero
        and     ebx,3               ;//  ebx = ebx % 4
        jnz     short finish_loop   ;//  taken, when there are some tail bytes
fill_tail_end:
        mov     eax,dest
        pop     ebx
        pop     esi
        pop     edi
ende:
		}
}


//*****************************************************************************
//*
//*		strcat_dummy
//*
//*****************************************************************************
char * __cdecl strcat_dummy( char *dest, const char *source )
{

_asm	{
        mov     ecx,dest            ;// ecx -> dest string
        push    edi                 ;// preserve edi
        test    ecx,3               ;// test if string is aligned on 32 bits
        je      short find_end_of_dest_string_loop

dest_misaligned:           
							        ;// simple byte loop until string is aligned
        mov     al,byte ptr [ecx]
        inc     ecx
        test    al,al
        je      short start_byte_3
        test    ecx,3
        jne     short dest_misaligned

        align   4

find_end_of_dest_string_loop:
        mov     eax,dword ptr [ecx] ; read 4 bytes
        mov     edx,7efefeffh
        add     edx,eax
        xor     eax,-1
        xor     eax,edx
        add     ecx,4
        test    eax,81010100h
        je      short find_end_of_dest_string_loop
        ; found zero byte in the loop
        mov     eax,[ecx - 4]
        test    al,al               ;// is it byte 0
        je      short start_byte_0
        test    ah,ah               ;// is it byte 1
        je      short start_byte_1
        test    eax,00ff0000h       ;// is it byte 2
        je      short start_byte_2
        test    eax,0ff000000h      ;// is it byte 3
        je      short start_byte_3
        jmp     short find_end_of_dest_string_loop
                                    ;// taken if bits 24-30 are clear and bit
                                    ;// 31 is set
start_byte_3:
        lea     edi,[ecx - 1]
        jmp     short copy_start
start_byte_2:
        lea     edi,[ecx - 2]
        jmp     short copy_start
start_byte_1:
        lea     edi,[ecx - 3]
        jmp     short copy_start
start_byte_0:
        lea     edi,[ecx - 4]
;       jmp     short copy_start

;       edi points to the end of dest string.
copy_start:
        mov     ecx,source          ;// ecx -> sorc string
        test    ecx,3               ;// test if string is aligned on 32 bits
        je      short main_loop_entrance

src_misaligned:                     ;// simple byte loop until string is aligned
        mov     dl,byte ptr [ecx]
        inc     ecx
        test    dl,dl
        je      short byte_0
        mov     [edi],dl
        inc     edi
        test    ecx,3
        jne     short src_misaligned
        jmp     short main_loop_entrance

main_loop:                          ;// edx contains src dword of sorc string
        mov     [edi],edx           ;// store one more dword
        add     edi,4               ;// kick dest pointer
main_loop_entrance:
        mov     edx,7efefeffh
        mov     eax,dword ptr [ecx] ; read 4 bytes

        add     edx,eax
        xor     eax,-1

        xor     eax,edx
        mov     edx,[ecx]           ;// it's in cache now

        add     ecx,4               ;// kick dest pointer
        test    eax,81010100h

        je      short main_loop
        ; found zero byte in the loop
; main_loop_end:
        test    dl,dl               ;// is it byte 0
        je      short byte_0
        test    dh,dh               ;// is it byte 1
        je      short byte_1
        test    edx,00ff0000h       ;// is it byte 2
        je      short byte_2
        test    edx,0ff000000h      ;// is it byte 3
        je      short byte_3
        jmp     short main_loop     ;// taken if bits 24-30 are clear and bit 31 is set
                                    
byte_3:
        mov     [edi],edx
		pop     edi
        mov     eax,dest	        ;// return in eax pointer to dest string
        jmp		ende
byte_2:
        mov     [edi],dx
        mov     byte ptr [edi+2],0
        pop     edi					 
        mov     eax,dest	        ;// return in eax pointer to dest string
        jmp		ende
byte_1:
        mov     [edi],dx
        pop     edi
        mov     eax,dest	        ;// return in eax pointer to dest string
        jmp		ende
byte_0:
        mov     [edi],dl
        pop     edi
		mov     eax,dest	        ;// return in eax pointer to dest string

ende:
		}

}

//*****************************************************************************
//*
//*		strncat_dummy
//*
//*****************************************************************************
char * __cdecl strncat_dummy( char *dest, const char *source ,unsigned count)
{

_asm	{

        mov     ecx,count		    ;// ecx = count
        push    edi                 ;// preserve edi
        test    ecx,ecx
        jz      finish              ;// leave if count is zero

        mov     edi,dest            ;// edi -> front string
        push    esi                 ;// preserve esi
        test    edi,3               ;// is string aligned on dword (4 bytes)
        push    ebx                 ;// preserve ebx
        je      short find_end_of_front_string_loop

        ; simple byte loop until string is aligned

front_misaligned:
        mov     al,byte ptr [edi]
        inc     edi
        test    al,al
        je      short start_byte_3
        test    edi,3
        jne     short front_misaligned

find_end_of_front_string_loop:
        mov     eax,dword ptr [edi] ; read dword (4 bytes)
        mov     edx,7efefeffh
        add     edx,eax
        xor     eax,-1
        xor     eax,edx
        add     edi,4
        test    eax,81010100h
        je      short find_end_of_front_string_loop

; found zero byte in the loop
        mov     eax,[edi - 4]
        test    al,al               ;// is it byte 0
        je      short start_byte_0
        test    ah,ah               ;// is it byte 1
        je      short start_byte_1
        test    eax,00ff0000h       ;// is it byte 2
        je      short start_byte_2
        test    eax,0ff000000h      ;// is it byte 3
        jne     short find_end_of_front_string_loop
                                    ;// taken if bits 24-30 are clear and bit 31 is set
                                     
start_byte_3:
        dec     edi
        jmp     short copy_start
start_byte_2:
        sub     edi,2
        jmp     short copy_start
start_byte_1:
        sub     edi,3
        jmp     short copy_start
start_byte_0:
        sub     edi,4

; edi now points to the end of front string.

copy_start:
        mov     esi,source          ;// esi -> back string
        test    esi,3               ;// is back string is dword aligned?
        jnz     back_misaligned

        mov     ebx,ecx             ;// store count for tail loop

        shr     ecx,2
        jnz     short main_loop_entrance
        jmp     short tail_loop_start   ; 0 < counter < 4

; simple byte loop until back string is aligned

back_misaligned:
        mov     dl,byte ptr [esi]
        inc     esi
        test    dl,dl
        je      short byte_0
        mov     [edi],dl
        inc     edi
        dec     ecx
        jz      empty_counter
        test    esi,3
        jne     short back_misaligned
        mov     ebx,ecx             ;// store count for tail loop
        shr     ecx,2               ;// convert ecx to dword count
        jnz     short main_loop_entrance

tail_loop_start:
        mov     ecx,ebx
        and     ecx,3               ;// ecx = count of leftover bytes after the
                                    ;// dwords have been concatenated
        jz      empty_counter

tail_loop:
        mov     dl,byte ptr [esi]
        inc     esi
        mov     [edi],dl
        inc     edi
        test    dl,dl
        je      short finish1       ;// '\0' was already copied
        dec     ecx
        jnz     tail_loop

empty_counter:
        mov     [edi],cl            ;// cl=0;
finish1:
        pop     ebx
        pop     esi
finish:
        mov     eax,dest            ;// return in eax pointer to front string
        pop     edi
        jmp		ende                ;// _cdecl return


byte_0:
        mov     [edi],dl
        mov     eax,dest		    ;// return in eax pointer to front string
        pop     ebx
        pop     esi
        pop     edi
        jmp		ende                ;// _cdecl return


main_loop:                          ;// edx contains src dword of back string
        mov     [edi],edx           ;// store one more dword
        add     edi,4               ;// kick pointer to front string

        dec     ecx
        jz      tail_loop_start
main_loop_entrance:
        mov     edx,7efefeffh
        mov     eax,dword ptr [esi] ;// read 4 bytes

        add     edx,eax
        xor     eax,-1

        xor     eax,edx
        mov     edx,[esi]           ;// it's in cache now

        add     esi,4               ;// kick pointer to back string
        test    eax,81010100h

        je      short main_loop

; may be found zero byte in the loop
        test    dl,dl               ;// is it byte 0
        je      short byte_0
        test    dh,dh               ;// is it byte 1
        je      short byte_1
        test    edx,00ff0000h       ;// is it byte 2
        je      short byte_2
        test    edx,0ff000000h      ;// is it byte 3
        jne short main_loop         ;// taken if bits 24-30 are clear and bit 31 is set
                                     
;byte_3:
        mov     [edi],edx
        mov     eax,dest		    ;// return in eax pointer to front string
        pop     ebx
        pop     esi
        pop     edi
        jmp		ende                ;// _cdecl return

byte_2:
        mov     [edi],dx
        xor     edx,edx
        mov     eax,dest            ;// return in eax pointer to front string
        mov     [edi + 2],dl
        pop     ebx
        pop     esi
        pop     edi
        jmp		ende                ;// _cdecl return

byte_1:
        mov     [edi],dx
        mov     eax,dest            ;// return in eax pointer to front string
        pop     ebx
        pop     esi
        pop     edi
ende:
		}
}



//*****************************************************************************
//*
//*		strspn_dummy
//*
//*****************************************************************************
unsigned  __cdecl strspn_dummy( const char *string, const char *control )
{
_asm	{
		
;        uses esi, 
;        string:ptr byte, 
;        control:ptr byte

; create and zero out char bit map

        xor     eax,eax
        push    eax             ;// 32
        push    eax
        push    eax
        push    eax             ;// 128
        push    eax
        push    eax
        push    eax
        push    eax             ;// 256

; Set control char bits in map

        mov     edx,control     ;// si = control string

listnext:						;// init char bit map
        mov     al,[edx]
        or      al,al
        jz      short listdone
        inc     edx
        bts     [esp],eax
        jmp     short listnext

listdone:

; Loop through comparing source string with control bits

        mov    esi,string		;// si = string
		or     ecx,-1			;// set ecx to -1

dstnext:

		inc    ecx

        mov     al,[esi]
        or      al,al
        jz      short dstdone
        inc     esi
        bt      [esp], eax

        jc      short dstnext   ;// strspn: found char, continue

; Return code

dstdone:

		mov     eax,ecx			;// strspn/strcspn: return index
        add     esp,32
		}
}

//*****************************************************************************
//*
//*		strcspn_dummy
//*
//*****************************************************************************
unsigned  __cdecl strcspn_dummy( const char *string, const char *control )
{
_asm	{
		
;        uses esi, 
;        string:ptr byte, 
;        control:ptr byte

; create and zero out char bit map

        xor     eax,eax
        push    eax             ;// 32
        push    eax
        push    eax
        push    eax             ;// 128
        push    eax
        push    eax
        push    eax
        push    eax             ;// 256

; Set control char bits in map

        mov     edx,control     ;// si = control string

listnext:						;// init char bit map
        mov     al,[edx]
        or      al,al
        jz      short listdone
        inc     edx
        bts     [esp],eax
        jmp     short listnext

listdone:

; Loop through comparing source string with control bits

        mov    esi,string		;// si = string
		or     ecx,-1			;// set ecx to -1

dstnext:

		inc    ecx

        mov     al,[esi]
        or      al,al
        jz      short dstdone
        inc     esi
        bt      [esp], eax

        jnc     short dstnext   ;// strspn: found char, continue

; Return code

dstdone:

		mov     eax,ecx			;// strspn/strcspn: return index
        add     esp,32
		}
}



//*****************************************************************************
//*
//*		memcpy_dummy
//*
//*****************************************************************************
void *  __cdecl memcpy_dummy( void *Dst, const void *Src, unsigned  Count )
{
		 void *ret =        Dst;
register char *dst = (char*)Dst;
register char *src = (char*)Src;
register unsigned count=Count;


	if(dst <= src || dst >= (src + count)) 
		{
		//	Non-Overlapping Buffers
		//	copy from lower addresses to higher addresses
		while(count>=4)       
			{
			*(int*)dst = *(int*)src;
			count-=4;
			dst  +=4;
			src  +=4;
			}
		while(count--)*dst++ = *src++;
		}
	else{
		//	Overlapping Buffers
		//	copy from higher addresses to lower addresses
		
		dst += count;
		src += count;
		
		while(count>=4)       
			{
			dst  -=4;
			src  -=4;
			count-=4;
			*(int*)dst = *(int*)src;
			}
		while(count)
			{
			dst  --;
			src  --;
			count--;
			*dst=*src;
			}

		}

return ret;
}


//*****************************************************************************
//*
//*		memset_dummy
//*
//*****************************************************************************
void * __cdecl memset_dummy( void *dst, int c, unsigned  count )
{
__asm	{


        mov     edx,[count]		;// edx = "count"
        mov     ecx,[dst]       ;// ecx points to "dst"

        test    edx,edx         ;// 0?
        jz      short toend     ;// if so, nothing to do
        xor     eax,eax
        mov     al,byte ptr [c]	;// the byte "value" to be stored


; Align address on dword boundary

        push    edi             ;// preserve edi
        mov     edi,ecx         ;// edi = dest pointer

        cmp     edx,4           ;// if it's less then 4 bytes
        jb      tail            ;// tail needs edi and edx to be initialized

        neg     ecx
        and     ecx,3           ;// ecx = # bytes before dword boundary
        jz      short dwords    ;// jump if address already aligned

        sub     edx,ecx         ;// edx = adjusted count (for later)
adjust_loop:
        mov     [edi],al
        inc     edi
        dec     ecx
        jnz     adjust_loop

dwords:
; set all 4 bytes of eax to [value]
        mov     ecx,eax         ;// ecx=0/0/0/value
        shl     eax,8           ;// eax=0/0/value/0
        add     eax,ecx         ;// eax=0/0val/val
        mov     ecx,eax         ;// ecx=0/0/val/val
        shl     eax,10h         ;// eax=val/val/0/0
        add     eax,ecx         ;// eax = all 4 bytes = [value]

; Set dword-sized blocks
        mov     ecx,edx         ;// move original count to ecx
        and     edx,3           ;// prepare in edx byte count (for tail loop)
        shr     ecx,2           ;// adjust ecx to be dword count
        jz      tail            ;// jump if it was less then 4 bytes

        rep     stosd
;main_loop_tail:
        test    edx,edx         ;// if there is no tail bytes,
        jz      finish          ;// we finish, and it's time to leave
; Set remaining bytes

tail:
        mov     [edi],al        ;// set remaining bytes
        inc     edi

        dec     edx             ;// if there is some more bytes
        jnz     tail            ;// continue to fill them

; Done
finish:
        pop     edi             ;// restore edi
toend:
        mov     eax,dst			;// return dest pointer
		}
}



//*****************************************************************************
//*
//*		memcmp_dummy
//*
//*****************************************************************************
int	__cdecl  memcmp_dummy( const void *dst, const void *src, unsigned  count )
{

__asm	{

        mov     eax,[count]     ;// eax = counter
        test    eax,eax         ;// test if counter is zero
        jz      short retnull   ;// return 0

        mov     edx,[dst]       ;// edx = buf1
        push    esi
        push    edi
        mov     esi,edx         ;// esi = buf1
        mov     edi,[src]		;// edi = buf2

;// Check for dword (32 bit) alignment
        or      edx,edi
        and     edx,3           ;// edx=0 iff buf1 are buf2 are aligned
        jz      short dwords

;// Strings are not aligned. If the caller knows the strings (buf1 and buf2) are
;// different, the function may be called with length like -1. The difference
;// may be found in the last dword of aligned string, and because the other
;// string is misaligned it may cause page fault. So, to be safe. the comparison
;// must be done byte by byte.
        test    eax,1
        jz      short main_loop

        mov     cl,[esi]
        cmp     cl,[edi]
        jne     short not_equal
        inc     esi
        inc     edi
        dec     eax
        jz      short done      ;// eax is already 0

main_loop:
        mov     cl,[esi]
        mov     dl,[edi]
        cmp     cl,dl
        jne     short not_equal

        mov     cl,[esi+1]
        mov     dl,[edi+1]
        cmp     cl,dl
        jne     short not_equal

        add     edi,2
        add     esi,2

        sub     eax,2
        jnz     short main_loop
done:
        pop     edi
        pop     esi
retnull:
        jmp	    ende


dwords:
        mov     ecx,eax
        and     eax,3           ;// eax= counter for tail loop

        shr     ecx,2
        jz      short tail_loop_start
                                ;// counter was >=4 so may check one dword
        rep     cmpsd

        jz      short tail_loop_start

;// in last dword was difference
        mov     ecx,[esi-4]     ;// load last dword from buf1 to ecx
        mov     edx,[edi-4]     ;// load last dword from buf2 to edx
        cmp     cl,dl           ;// test first bytes
        jne     short difference_in_tail
        cmp     ch,dh           ;// test seconds bytes
        jne     short difference_in_tail
        shr     ecx,10h
        shr     edx,10h
        cmp     cl,dl           ;// test third bytes
        jne     short difference_in_tail
        cmp     ch,dh           ;// they are different, but each one is bigger?
;       jmp     short difference_in_tail

difference_in_tail:
        mov     eax,0
                                ;// buf1 < buf2 buf1 > buf2
not_equal:
        sbb     eax,eax         ;// AX=-1, CY=1 AX=0, CY=0
        pop     edi             ;// counter
        sbb     eax,-1          ;// AX=-1 AX=1
        pop     esi
        jmp	    ende

;// in tail loop we test last three bytes (esi and edi are aligned on dword boundary)
tail_loop_start:

        test    eax,eax         ;// eax is counter%4 (number of bytes for tail
                                ;// loop)
        jz      short done      ;// taken if there is no tail bytes
        mov     edx,[esi]       ;// load dword from buf1
        mov     ecx,[edi]       ;// load dword from buf2
        cmp     dl,cl           ;// test first bytes
        jne     short difference_in_tail
        dec     eax             ;// counter--
        jz      short tail_done
        cmp     dh,ch           ;// test second bytes
        jne     short difference_in_tail
        dec     eax             ;// counter--
        jz      short tail_done
        and     ecx,00ff0000h   ;// test third bytes
        and     edx,00ff0000h
        cmp     edx,ecx
        jne     short difference_in_tail
        dec     eax
tail_done:
        pop     edi
        pop     esi
ende:
		}
}

//*****************************************************************************
//*
//*		memicmp_dummy
//*
//*****************************************************************************
int	__cdecl  memicmp_dummy( const void *dst, const void *src, unsigned  count )
{
__asm	{
        mov     ecx,[count]     ;// cx = count
        jecxz   ende            ;// if count=0, nothing to do

        mov     esi,[dst]       ;// si = first
        mov     edi,[src]       ;// di = last

        ; C locale

        mov     bh,'A'
        mov     bl,'Z'
        mov     dh,'a'-'A'      ;// add to cap to make lower

        align   4

lupe:
        mov     ah,[esi]        ;// ah = *first
        inc     esi             ;// first++
        mov     al,[edi]        ;// al = *last
        inc     edi             ;// last++

        cmp     ah,al           ;// test for equality BEFORE converting case
        je      short dolupe

        cmp     ah,bh           ;// ah < 'A' ??
        jb      short skip1

        cmp     ah,bl           ;// ah > 'Z' ??
        ja      short skip1

        add     ah,dh           ;// make lower case

skip1:
        cmp     al,bh           ;// al < 'A' ??
        jb      short skip2

        cmp     al,bl           ;// al > 'Z' ??
        ja      short skip2

        add     al,dh           ;// make lower case

skip2:
        cmp     ah,al           ;// *first == *last ??
        jne     short differ    ;// nope, found mismatched chars

dolupe:
        dec     ecx
        jnz     short lupe

        jmp     ende            ;// cx = 0, return 0

differ:
        mov     ecx,-1          ;// assume last is bigger
                                ;// *** can't use "or ecx,-1" due to flags ***
        jb      ende            ;// last is, in fact, bigger (return -1)
        neg     ecx             ;// first is bigger (return 1)

ende:   mov     eax,ecx         ;// move return value to ax

		}
}

//*****************************************************************************
//*
//*		memchr_dummy 
//*
//*****************************************************************************
void  *	__cdecl  memchr_dummy ( const void *dst, int c, unsigned  count )
{

_asm	{
        mov     eax,[count]     ;// eax = count
        push    ebx             ;// Preserve ebx

        test    eax,eax         ;// check if count=0
        jz      short retnull   ;// if count=0, leave

        mov     edx,[dst]       ;// edx = buffer
        xor     ebx,ebx

        mov     bl,byte ptr[c]  ;// bl = search char

        test    edx,3           ;// test if string is aligned on 32 bits
        jz      short main_loop_start

str_misaligned:                 ;// simple byte loop until string is aligned
        mov     cl,byte ptr [edx]
        inc     edx
        xor     cl,bl
        je      short found
        dec     eax             ;// counter--
        jz      short retnull
        test    edx,3           ;// already aligned ?
        jne     short str_misaligned

main_loop_start:
        sub     eax,4
        jb      short tail_less_then_4

; set all 4 bytes of ebx to [value]
        push    edi             ;// Preserve edi
        mov     edi,ebx         ;// edi=0/0/0/char
        shl     ebx,8           ;// ebx=0/0/char/0
        add     ebx,edi         ;// ebx=0/0/char/char
        mov     edi,ebx         ;// edi=0/0/char/char
        shl     ebx,10h         ;// ebx=char/char/0/0
        add     ebx,edi         ;// ebx = all 4 bytes = [search char]
        jmp     short main_loop_entry   ;// ecx >=0

return_from_main:
        pop     edi

tail_less_then_4:
        add     eax,4
        jz      retnull

tail_loop:                      ;// 0 < eax < 4
        mov     cl,byte ptr [edx]
        inc     edx
        xor     cl,bl
        je      short found
        dec     eax
        jnz     short tail_loop
retnull:
        pop     ebx
        jmp	    ende

main_loop:
        sub     eax,4
        jb      short return_from_main
main_loop_entry:
        mov     ecx,dword ptr [edx]     ;// read 4 bytes

        xor     ecx,ebx         ;// ebx is byte\byte\byte\byte
        mov     edi,7efefeffh

        add     edi,ecx
        xor     ecx,-1

        xor     ecx,edi
        add     edx,4

        and     ecx,81010100h
        je      short main_loop

; found zero byte in the loop?
;char_is_found:
        mov     ecx,[edx - 4]
        xor     cl,bl           ;// is it byte 0
        je      short byte_0
        xor     ch,bl           ;// is it byte 1
        je      short byte_1
        shr     ecx,10h         ;// is it byte 2
        xor     cl,bl
        je      short byte_2
        xor     ch,bl           ;// is it byte 3
        je      short byte_3
        jmp     short main_loop ;// taken if bits 24-30 are clear and bit 31 is set
                                

byte_3:
        pop     edi             ;// restore edi
found:
        lea     eax,[edx - 1]
        pop     ebx             ;// restore ebx
        jmp	    ende

byte_2:
        lea     eax,[edx - 2]
        pop     edi
        pop     ebx
        jmp	    ende

byte_1:
        lea     eax,[edx - 3]
        pop     edi
        pop     ebx
        jmp	    ende

byte_0:
        lea     eax,[edx - 4]
        pop     edi             ;// restore edi
        pop     ebx             ;// restore ebx
ende:
		}
}
#pragma warning( default : 4035 )


#endif
#endif