//*****************************************************************************
//*
//*
//*		ff_integer.h
//*
//*
//*****************************************************************************
#ifndef __FF_INTEGER_H__
#define __FF_INTEGER_H__

#ifndef _FF_UNICODE	
#ifndef _UNICODE
#define _FF_UNICODE			0
#else 			
#define _FF_UNICODE			1
#endif 	
#endif 	

#if _FF_UNICODE
typedef unsigned short		XCHAR;
typedef unsigned short		ZCHAR;
#else
typedef unsigned char		XCHAR;
typedef			 char		ZCHAR;
#endif 	
	
#ifndef _WINDOWS_

/* These types must be 16-bit, 32-bit or larger integer */
typedef int					INT;
typedef unsigned int		UINT;

/* These types must be 8-bit integer */
typedef signed char			CHAR;
typedef unsigned char		UCHAR;
typedef unsigned char		BYTE;

/* These types must be 16-bit integer */
typedef short				SHORT;
typedef unsigned short		USHORT;
typedef unsigned short		WORD;
typedef unsigned short		WCHAR;

/* These types must be 32-bit integer */
typedef long				LONG;
typedef unsigned long		ULONG;
typedef unsigned long		DWORD;

/* Boolean type */
typedef enum { FALSE = 0, TRUE } BOOL;

#endif

/* These types must be 64-bit integer */
#ifndef	QWORD_DEFINED
#define	QWORD_DEFINED	
typedef	unsigned __int64	QWORD;
#endif		


#endif 	