//*****************************************************************************
//*
//*
//*		ImageLoader.h
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#ifndef 	__IMAGELOADER_H__
#define 	__IMAGELOADER_H__

#include	"BitmapImage.h"


#ifdef		UNICODE

	int			   ImageLoader(const void    *pMem,int iSize,BitmapImage *pImage,void *pComment=0);
	int			   ImageLoader(const wchar_t *pName         ,BitmapImage *pImage,void *pComment=0);
	int			   ImageLoaderTransparency();
	const wchar_t *ImageLoaderError();

#else
	int			   ImageLoader(const void *pMem,int iSize,BitmapImage *pImage,void *pComment=0);
	int			   ImageLoader(const char *pName         ,BitmapImage *pImage,void *pComment=0);
	int			   ImageLoaderTransparency();
	const char    *ImageLoaderError();

#endif



	 
#endif 	