//*****************************************************************************
//*
//*
//*		XpmDecoder
//*
//*
//*****************************************************************************
#ifndef __XPMDECODER_H__
#define __XPMDECODER_H__

#include	"Xpm.h"
#include	"BitmapImage.h"
#include	"..\FileBuffer.h"

			  

//*****************************************************************************
//*
//*		Klasse XpmDecoder
//*
//*****************************************************************************
class XpmDecoder : public BitmapImageDecoder
{
public:

			 XpmDecoder();
	virtual ~XpmDecoder();
	virtual  void ReadImage(const wchar_t *pName,BitmapImage &sImage);
	virtual  void ReadImage(const char    *pName,BitmapImage &sImage);
	virtual  void ReadImage(CFileBuffer   *pFile,BitmapImage &sImage);

protected:

	bool ReadColor(const char *pPtr,int iCharsPerPixel);
	int	 ReadLine(CFileBuffer *pFile,char *pBuffer,int iMax);
	void SetColorLineRgb(BitmapImage &sImage,int iLine,const char *pBuffer,int iCharsPerPixel);
	void SetColorLine8  (BitmapImage &sImage,int iLine,const char *pBuffer,int iCharsPerPixel);
	void CallProgressFunction(unsigned int iProzent);


	int		m_aColorMask[MAX_XPM_COLORS];
	int		m_aColorVal [MAX_XPM_COLORS];
	int		m_aColorRgb [MAX_XPM_COLORS];
	int		m_iColorCnt;


};


#endif
