//*****************************************************************************
//*
//*
//*		XpmEncoder.h
//*
//*
//*****************************************************************************
#ifndef __XPNENCODER_H__
#define __XPNENCODER_H__

#include	"Xpm.h"	
#include	"BitmapImage.h"
#include	"..\FileBuffer.h"


//*****************************************************************************
//*
//*		Klasse XpmEncoder 
//*
//*****************************************************************************
class XpmEncoder : public BitmapImageEncoder
{
public:

				XpmEncoder();
	virtual    ~XpmEncoder();
	virtual		void WriteImage(const wchar_t *pName,const BitmapImage &sImage);
	virtual		void WriteImage(const char    *pName,const BitmapImage &sImage);
	virtual		void WriteImage(CFileBuffer   *pFile,const BitmapImage &sImage);



protected:

	char	cName[64];
	static	const char *pChars;
	void	CallProgressFunction(unsigned int iProzent);

};

#endif


