//*****************************************************************************
//*
//*
//*		XwdDecoder.h
//*
//*
//*****************************************************************************
//
//	Copyright Anton Zechner (C) 2011
//
#ifndef __XWDDECODER_H__
#define __XWDDECODER_H__

#if _MSC_VER >= 1000
#pragma once
#endif

#include	"Xwd.h"
#include	"BitmapImage.h"
#include	"GrException.h"
#include	"..\FileBuffer.h"
  
//*****************************************************************************
//*
//*		Klasse
//*
//*****************************************************************************
class XwdDecoder : public BitmapImageDecoder
{
public:

					XwdDecoder();
	virtual        ~XwdDecoder();
	virtual void	ReadImage(const wchar_t *pName,BitmapImage &sImage);
	virtual void	ReadImage(const char    *pName,BitmapImage &sImage);
	virtual void	ReadImage(CFileBuffer   *pFile,BitmapImage &sImage);

protected:
	
	void			CallProgressFunction(unsigned uPercent);

};


#endif
