//*****************************************************************************
//*
//*
//*		LicenseTools.h
//*
//*
//*****************************************************************************
#ifndef 	__LICENSETOOLS_H__
#define 	__LICENSETOOLS_H__

#include	"System/MacAddrUtility.h"


int  		LicenseLastError();
void 		LicenseSetTime  (unsigned int   uUtcTime);
void 		LicenseMinTime  (unsigned int   uUtcTime);
int			LicenseMake     (const unsigned char *pMac,unsigned uDisk,unsigned uKey,unsigned uBits,TCHAR *pText,int iSize,const TCHAR *pName=0,unsigned uUntil=0,const unsigned *pExtension=0,unsigned uExSize=0);
int			LicenseCheckEx  (const TCHAR   *pLicense,unsigned uKey,const unsigned char *pMac,unsigned uDisk,TCHAR *pName=0,int iSize=0,unsigned *pUntil=0,unsigned *pExtension=0,unsigned uExSize=0);
int			LicenseCheck    (const TCHAR   *pLicense,unsigned uKey                                         ,TCHAR *pName=0,int iSize=0,unsigned *pUntil=0,unsigned *pExtension=0,unsigned uExSize=0);
int			LicenseOfReg    (const TCHAR   *pRegPath,const TCHAR *pRegKey,unsigned uKey                    ,TCHAR *pName=0,int iSize=0,unsigned *pUntil=0,unsigned *pExtension=0,unsigned uExSize=0);
int			LicenseOfFile   (const TCHAR   *pPath   ,const TCHAR *pItem  ,unsigned uKey                    ,TCHAR *pName=0,int iSize=0,unsigned *pUntil=0,unsigned *pExtension=0,unsigned uExSize=0);
int			LicenseMinOfReg (const TCHAR   *pRegPath,const TCHAR *pRegKey,unsigned *pMinTime=0);
unsigned	LicenseCrc	    (const char    *pText,int iSize=-1,unsigned uCrc=0);
unsigned	LicenseCrc      (const wchar_t *pText,int iSize=-1,unsigned uCrc=0);
unsigned	LicenseCrcFile  (FILE          *pFile);
unsigned	LicenseCrcFile  (const char    *pFileName);
unsigned	LicenseCrcFile  (const wchar_t *pFileName);
int			LicenseSetCrc   (char          *pBuffer,unsigned uCrc,unsigned uToCrc=0,const char    *pPre= "");
int			LicenseSetCrc   (wchar_t       *pBuffer,unsigned uCrc,unsigned uToCrc=0,const wchar_t *pPre=L"");
int			LicenseCheckIp  (unsigned       uAddr  ,unsigned uCrc,FILE          *pFile);
int			LicenseCheckIp  (unsigned       uAddr  ,unsigned uCrc,const char    *pListFile);
int			LicenseCheckIp  (unsigned       uAddr  ,unsigned uCrc,const wchar_t *pListFile);
int			LicenseCheckIp  (const char    *pAddr  ,unsigned uCrc,const char    *pListFile);
int			LicenseCheckIp  (const wchar_t *pAddr  ,unsigned uCrc,const wchar_t *pListFile);
unsigned	DiskGetId       (unsigned char *pBuffer=0);
						    
						    
#endif
