//*****************************************************************************
//*
//*
//*		SemaphoreEx.h
//*
//*
//*****************************************************************************
//
//	CSemaphoreEx	=   Maximal Count 0x7F000000   Minimal Count 1
//	CSemaphoreNull	=   Maximal Count 0x7F000000   Minimal Count 0	
//
//	Copyright Anton Zechner (C) 2014
//	
#ifndef __SEMAPHOREEX_H__
#define __SEMAPHOREEX_H__

#if _MSC_VER >= 1000
#pragma once
#endif

#include <AfxMt.h>


//*****************************************************************************
//*
//*		CSemaphoreEx
//*
//*****************************************************************************
class CSemaphoreEx : public CSemaphore
{
public:

	CSemaphoreEx(LONG lInitialCount=1,LONG lMaxCount=0x7F000000,LPCTSTR pName=NULL,LPSECURITY_ATTRIBUTES pAttrib=NULL) : CSemaphore(lInitialCount,lMaxCount,pName,pAttrib){}

};

//*****************************************************************************
//*
//*		CSemaphoreNull
//*
//*****************************************************************************
class CSemaphoreNull : public CSemaphore
{
public:

	CSemaphoreNull(LONG lInitialCount=0,LONG lMaxCount=0x7F000000,LPCTSTR pName=NULL,LPSECURITY_ATTRIBUTES pAttrib=NULL) : CSemaphore(lInitialCount,lMaxCount,pName,pAttrib){}

};


#endif 	