//*****************************************************************************
//*
//*
//*		ShortCuts.h	
//*
//*
//*****************************************************************************
//	
//	Konfiguration fr Shortcuts
//	Copyright Anton Zechner (C) 2008
//	
//	Anmekung:
//
//		In "StdAfx.h" einfgen
//
//		#include <afxole.h>			// MFC-OLE-Klassen
//		#include <afxodlgs.h>		// MFC OLE-Dialogfeldklassen


#ifndef		__SHORTCUTS_H__
#define 	__SHORTCUTS_H__

#define 	GFP_DESKTOP				1
#define 	GFP_STARTMENU			2
#define 	GFP_STARTUP 			3
#define 	GFP_SENDTO				4
#define 	GFP_PROGRAMS			5
#define 	GFP_COMMON_DESKTOP		6
#define 	GFP_COMMON_STARTMENU	7
#define 	GFP_COMMON_STARTUP 		8
#define 	GFP_COMMON_PROGRAMS		9

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
#include	<afx.h>
#endif


#ifdef	_MSC_VER
#pragma warning( disable :4996 )
#endif


#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include	<wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif




#ifdef		zchar
#undef 		zchar
#endif

#ifdef		UNICODE
#define 	zchar		wchar_t
#else
#define 	zchar		char
#endif



	int	 GetFolderPath(int iFolder,zchar   *pBuffer,const zchar *pSubPath=0);

#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)

	int	 GetFolderPath(int iFolder,CString &sBuffer,const zchar *pSubPath=0);

#endif

	int  ShortCutCreate( const zchar *pScPath,		// Shortcut-Pfad
						 const zchar *pPath,		// File pPath
						 const zchar *pName=0,		// Shortcut-Name
						 const zchar *pArgv=0,		// File-Argumments
						 const zchar *pDir =0);		// File-Working-Directory
													
	int  ShortCutCreate( int		  iSkPath,		// Shortcut-Pfad
						 const zchar *pPath,		// File pPath
						 const zchar *pName=0,		// Shortcut-Name
						 const zchar *pArgv=0,		// File-Argumments
						 const zchar *pDir =0);		// File-Working-Directory
													
	int  ShortCutSetIcon(int		  iScPath,		// Shortcut-Pfad
						 const zchar *pPath,		// Icon File pPath
						 const zchar *pName=0,		// Shortcut-Name
						 int		  iIcon=0);		// Icon Number
													
	int  ShortCutSetIcon(const zchar *pScPath,		// Shortcut-Pfad
						 const zchar *pPath,		// Icon File pPath
						 const zchar *pName=0,		// Shortcut-Name
						 int		  iIcon=0);		// Icon Number
													
	int  ShortCutRemove( int		  iScPath,		// Shortcut-Pfad
						 const zchar *pName=0);		// Shortcut-Name
													
	int  ShortCutRemove( const zchar *pScPath,		// Shortcut-Pfad
						 const zchar *pName=0);		// Shortcut-Name
													
	int  ShortCutQuery(	 int		  iScPath,		// Shortcut-Pfad
						 const zchar *pName,		// Shortcut-Name
						 zchar	     *pBuffer,		// Zielpuffer
						 int		  iMax);		// Pufferlnge
													
	int  ShortCutQuery(	 const zchar *pScPath,		// Shortcut-Pfad
						 const zchar *pName,		// Shortcut-Name
						 zchar	     *pBuffer,		// Zielpuffer
						 int		  iMax);		// Pufferlnge

#endif
