//*****************************************************************************
//*
//*
//*		ProcessUtility.h
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#ifndef 	__PROCESSUTILITY_H__
#define 	__PROCESSUTILITY_H__

#ifdef		GLOBAL_CONFIG
#define 	PROCESSUTILITY_H
#include	<GlobalConfig.h>
#undef		PROCESSUTILITY_H
#endif

#ifdef		_MSC_VER
#pragma     once
#pragma 	warning( disable :4035 )
#pragma 	warning( disable :4996 )
#pragma 	warning( disable :4514 )
#endif

#ifdef		__cplusplus
extern		"C" {
#define 	D(a)	a
#else
#define 	D(a)
#endif


	int				ProcessGetExePath(char *pPath,int iSize);
	int				ProcessGetExeName(char *pPath,int iSize);
	int				ProcessRunningOwn();
	int				ProcessKill         (unsigned uId);
	int				ProcessExists		(unsigned uId);
	int				ProcessExeNameFormId(unsigned uId,char *pPath,int iSize);
	unsigned		ProcessEnum         (unsigned uId,char *pPath,int iSize);
	unsigned		ProcessIdFromExeName(const char *pPath);
	unsigned		ProcessStart(int iWait,const char *pPath,const char *pArgs D(=0),int *pError D(=0),const char *pWorkingDir D(=0),int *pExitCode D(=0));
	unsigned		ProcessOwnId();


#ifdef	__cplusplus
}
#endif

#undef D




#endif


