//*****************************************************************************
//*
//*
//*		ShmUtility.h
//*
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
//
//	This API is for the access to shared memory areas
//
#ifndef	  __SHMUTILITY_H__
#define   __SHMUTILITY_H__

#ifdef		GLOBAL_CONFIG
#define 	SHMUTILITY_H
#include	<GlobalConfig.h>
#undef		SHMUTILITY_H
#endif

#ifdef		_MSC_VER
#pragma     once
#pragma 	warning( disable :4035 )
#pragma 	warning( disable :4996 )
#pragma 	warning( disable :4514 )
#endif

#ifdef	__cplusplus
extern "C" {
#endif


	#define		SHM_WRITE	0x0001
	#define		SHM_EXECUTE	0x0002


	void  *ShmCreate    (unsigned uKey,unsigned uSize,unsigned uAccess);
	void  *ShmOpen      (unsigned uKey,unsigned uSize,unsigned uAccess);
	int    ShmClose     (unsigned uKey);
	int    ShmLockMemory();


#ifdef	__cplusplus
}
#endif

#endif
